var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var deleteCounterStorageCommand = (function (_super) {
        __extends(deleteCounterStorageCommand, _super);
        function deleteCounterStorageCommand(counterStorageName, isHardDelete) {
            var _this = _super.call(this) || this;
            _this.counterStorageName = counterStorageName;
            _this.isHardDelete = isHardDelete;
            return _this;
        }
        deleteCounterStorageCommand.prototype.execute = function () {
            var _this = this;
            this.reportInfo("Deleting " + this.counterStorageName + "...");
            var url = "/counterstorage/admin/" + encodeURIComponent(this.counterStorageName) + "?hard-delete=" + this.isHardDelete;
            var deleteTask = this.del(url, null, null, { dataType: undefined });
            deleteTask.done(function () { return _this.reportSuccess("Deleted " + _this.counterStorageName); });
            deleteTask.fail(function (response) { return _this.reportError("Failed to delete counter storage", response.responseText, response.statusText); });
            return deleteTask;
        };
        return deleteCounterStorageCommand;
    }(commandBase));
    return deleteCounterStorageCommand;
});

//# sourceMappingURL=deleteCounterStorageCommand.js.map
