var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var deleteCountersByGroupCommand = (function (_super) {
        __extends(deleteCountersByGroupCommand, _super);
        function deleteCountersByGroupCommand(group, cs) {
            var _this = _super.call(this) || this;
            _this.group = group;
            _this.cs = cs;
            return _this;
        }
        deleteCountersByGroupCommand.prototype.execute = function () {
            var _this = this;
            var args = {
                groupName: this.group.isAllGroupsGroup ? "" : this.group.name
            };
            var url = "/delete-by-group/" + this.urlEncodeArgs(args);
            var deleteTask = this.del(url, null, this.cs, { dataType: undefined }, (9000 * this.group.countersCount()) / 2);
            deleteTask.done(function (numOfDeletedCounters) { return _this.reportSuccess("Successfully deleted " + numOfDeletedCounters + " counters in '" + _this.group.name + "'"); });
            deleteTask.fail(function (response) { return _this.reportError("Failed to delete '" + _this.group.name + "'", response.responseText, response.statusText); });
            return deleteTask;
        };
        return deleteCountersByGroupCommand;
    }(commandBase));
    return deleteCountersByGroupCommand;
});

//# sourceMappingURL=deleteCountersByGroupCommand.js.map
