var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var deleteCountersCommand = (function (_super) {
        __extends(deleteCountersCommand, _super);
        function deleteCountersCommand(groupAndNames, cs) {
            var _this = _super.call(this) || this;
            _this.groupAndNames = groupAndNames;
            _this.cs = cs;
            return _this;
        }
        deleteCountersCommand.prototype.execute = function () {
            var _this = this;
            var deletionTasks = new Array();
            ;
            for (var i = 0; i < this.groupAndNames.length; i++) {
                var deleteCommand = this.deleteCounter(this.groupAndNames[i]);
                deletionTasks.push(deleteCommand);
            }
            var successMessage = "Deleted " + (this.groupAndNames.length > 1 ? +this.groupAndNames.length + " counters" : this.getCounterDeleteText(this.groupAndNames[0]));
            var failMessage = "Failed to delete " + (this.groupAndNames.length > 1 ? this.groupAndNames.length + " counters" : this.getCounterDeleteText(this.groupAndNames[0]));
            var combinedTask = $.when.apply($, deletionTasks)
                .done(function () { return _this.reportSuccess(successMessage); })
                .fail(function (response) { return _this.reportError(failMessage, response.responseText, response.statusText); });
            return combinedTask;
        };
        deleteCountersCommand.prototype.deleteCounter = function (groupAndName) {
            var url = "/delete/" + this.urlEncodeArgs(groupAndName);
            return this.del(url, null, this.cs, { dataType: undefined }, 9000);
        };
        deleteCountersCommand.prototype.getCounterDeleteText = function (groupAndName) {
            return "counter name: " + groupAndName.counterName + ", group: " + groupAndName.groupName;
        };
        return deleteCountersCommand;
    }(commandBase));
    return deleteCountersCommand;
});

//# sourceMappingURL=deleteCountersCommand.js.map
