var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "models/counter/counterSummary", "common/pagedResultSet"], function (require, exports, commandBase, counterSummary, pagedResultSet) {
    "use strict";
    var getCountersCommand = (function (_super) {
        __extends(getCountersCommand, _super);
        /**
        * @param counterStorage - the counter storage that is being used
        * @param skip - number of entries to skip
        * @param take - number of entries to take
        * @param counterGroupName - the counter group to take the entries from
        */
        function getCountersCommand(cs, skip, take, group) {
            if (group === void 0) { group = null; }
            var _this = _super.call(this) || this;
            _this.cs = cs;
            _this.skip = skip;
            _this.take = take;
            _this.group = group;
            return _this;
        }
        getCountersCommand.prototype.execute = function () {
            var _this = this;
            var args = {
                skip: this.skip,
                take: this.take,
                group: this.group
            };
            var url = "/counters";
            var doneTask = $.Deferred();
            var selector = function (dtos) { return dtos.map(function (d) { return new counterSummary(d, _this.group == null); }); };
            var task = this.query(url, args, this.cs, selector);
            task.done(function (summaries) { return doneTask.resolve(new pagedResultSet(summaries, summaries.length)); });
            task.fail(function (xhr) { return doneTask.reject(xhr); });
            return doneTask;
        };
        return getCountersCommand;
    }(commandBase));
    return getCountersCommand;
});

//# sourceMappingURL=getCountersCommand.js.map
