var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var resetCounterCommand = (function (_super) {
        __extends(resetCounterCommand, _super);
        function resetCounterCommand(cs, groupName, counterName) {
            var _this = _super.call(this) || this;
            _this.cs = cs;
            _this.groupName = groupName;
            _this.counterName = counterName;
            return _this;
        }
        resetCounterCommand.prototype.execute = function () {
            var _this = this;
            var args = {
                groupName: this.groupName,
                counterName: this.counterName
            };
            var url = "/reset" + this.urlEncodeArgs(args);
            var action = this.post(url, args, this.cs, { dataType: undefined });
            action.done(function () { return _this.reportSuccess("Successfully reset counter!"); });
            action.fail(function (response) { return _this.reportError("Failed to reset counter!", response.responseText, response.statusText); });
            return action;
        };
        return resetCounterCommand;
    }(commandBase));
    return resetCounterCommand;
});

//# sourceMappingURL=resetCounterCommand.js.map
