var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var updateCounterCommand = (function (_super) {
        __extends(updateCounterCommand, _super);
        function updateCounterCommand(cs, group, counterName, delta, isNew) {
            var _this = _super.call(this) || this;
            _this.cs = cs;
            _this.group = group;
            _this.counterName = counterName;
            _this.delta = delta;
            _this.isNew = isNew;
            return _this;
        }
        updateCounterCommand.prototype.execute = function () {
            var _this = this;
            var args = {
                groupName: this.group,
                counterName: this.counterName,
                delta: this.delta
            };
            var url = "/change/" + this.urlEncodeArgs(args);
            var action = this.post(url, null, this.cs, { dataType: undefined });
            var successMessage = this.isNew ? "Successfully created a new counter!" : "Successfully updated a counter!";
            action.done(function () { return _this.reportSuccess(successMessage); });
            var failMessage = this.isNew ? "Failed to create a new counter!" : "Successfully to update counter!";
            action.fail(function (response) { return _this.reportError(failMessage, response.responseText, response.statusText); });
            return action;
        };
        return updateCounterCommand;
    }(commandBase));
    return updateCounterCommand;
});

//# sourceMappingURL=updateCounterCommand.js.map
