var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var extendRaftClusterCommand = (function (_super) {
        __extends(extendRaftClusterCommand, _super);
        function extendRaftClusterCommand(db, connectionInfo, create, force) {
            var _this = _super.call(this) || this;
            _this.db = db;
            _this.connectionInfo = connectionInfo;
            _this.create = create;
            _this.force = force;
            return _this;
        }
        extendRaftClusterCommand.prototype.execute = function () {
            var _this = this;
            if (this.create) {
                return this.post("/admin/cluster/create", ko.toJSON(this.connectionInfo), this.db, { dataType: undefined }) //TODO: use endpoints
                    .done(function () { return _this.reportSuccess("Cluster was created"); })
                    .fail(function (response) { return _this.reportError("Failed to create cluster", response.responseText, response.statusText); });
            }
            else {
                var url = "/admin/cluster/join"; //TODO: use endpoints
                if (this.force) {
                    url += "?force=true";
                }
                return this.post(url, ko.toJSON(this.connectionInfo), this.db, { dataType: undefined })
                    .done(function () { return _this.reportSuccess("Server was added to cluster."); })
                    .fail(function (response) { return _this.reportError("Unable to add server to cluster", response.responseText, response.statusText); });
            }
        };
        return extendRaftClusterCommand;
    }(commandBase));
    return extendRaftClusterCommand;
});

//# sourceMappingURL=extendRaftClusterCommand.js.map
