var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "models/database/replication/topology"], function (require, exports, commandBase, topology) {
    "use strict";
    var getClusterTopologyCommand = (function (_super) {
        __extends(getClusterTopologyCommand, _super);
        function getClusterTopologyCommand(ownerDb) {
            var _this = _super.call(this) || this;
            _this.ownerDb = ownerDb;
            if (!_this.ownerDb) {
                throw new Error("Must specify a database.");
            }
            return _this;
        }
        getClusterTopologyCommand.prototype.execute = function () {
            var task = $.Deferred();
            this.query("/cluster/topology", null, this.ownerDb, function (x) { return new topology(x); }) //TODO: use endpoints
                .done(function (result) {
                task.resolve(result);
            })
                .fail(function (result) {
                if (result.status === 200 && !result.responseText) {
                    task.resolve(null);
                }
                else {
                    task.reject(result);
                }
            });
            return task;
        };
        return getClusterTopologyCommand;
    }(commandBase));
    return getClusterTopologyCommand;
});

//# sourceMappingURL=getClusterTopologyCommand.js.map
