var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var saveClusterConfigurationCommand = (function (_super) {
        __extends(saveClusterConfigurationCommand, _super);
        function saveClusterConfigurationCommand(dto, db) {
            var _this = _super.call(this) || this;
            _this.dto = dto;
            _this.db = db;
            return _this;
        }
        saveClusterConfigurationCommand.prototype.execute = function () {
            var _this = this;
            this.reportInfo("Saving Cluster configuration.");
            return this.saveSetup()
                .done(function () { return _this.reportSuccess("Saved Cluster configuration."); })
                .fail(function (response) { return _this.reportError("Failed to save cluster configuration.", response.responseText, response.statusText); });
        };
        saveClusterConfigurationCommand.prototype.saveSetup = function () {
            var putArgs = JSON.stringify(this.dto);
            return this.put("/admin/cluster/commands/configuration", putArgs, this.db, { dataType: undefined }); //TODO: use endpoints
        };
        return saveClusterConfigurationCommand;
    }(commandBase));
    return saveClusterConfigurationCommand;
});

//# sourceMappingURL=saveClusterConfigurationCommand.js.map
