var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var adminLogsConfigureCommand = (function (_super) {
        __extends(adminLogsConfigureCommand, _super);
        function adminLogsConfigureCommand(ownerDb, logConfig, eventsId) {
            var _this = _super.call(this) || this;
            _this.ownerDb = ownerDb;
            _this.logConfig = logConfig;
            _this.eventsId = eventsId;
            if (!_this.ownerDb) {
                throw new Error("Must specify a database.");
            }
            return _this;
        }
        adminLogsConfigureCommand.prototype.execute = function () {
            var args = {
                'watch-category': $.map(this.logConfig, function (item) { return item.category + ":" + item.level + ":" + (item.includeStackTrace ? "watch-stack" : "no-watch-stack"); }),
                id: this.eventsId
            };
            var url = "/admin/logs/configure" + this.urlEncodeArgs(args); //TODO: use endpoints
            return this.query(url, null, this.ownerDb);
        };
        return adminLogsConfigureCommand;
    }(commandBase));
    return adminLogsConfigureCommand;
});

//# sourceMappingURL=adminLogsConfigureCommand.js.map
