var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "d3"], function (require, exports, commandBase, d3) {
    "use strict";
    var getDeletionBatchStatsCommand = (function (_super) {
        __extends(getDeletionBatchStatsCommand, _super);
        function getDeletionBatchStatsCommand(db, lastId) {
            var _this = _super.call(this) || this;
            _this.db = db;
            _this.lastId = lastId;
            return _this;
        }
        getDeletionBatchStatsCommand.prototype.execute = function () {
            var url = "/debug/deletion-batch-stats"; //TODO: use endpoints
            var args = { lastId: this.lastId };
            var parser = d3.time.format.iso;
            return this.query(url, args, this.db, function (result) {
                result.forEach(function (item) {
                    item.StartedAtDate = parser.parse(item.StartedAt);
                });
                return result;
            });
        };
        return getDeletionBatchStatsCommand;
    }(commandBase));
    return getDeletionBatchStatsCommand;
});

//# sourceMappingURL=getDeletionBatchStatsCommand.js.map
