var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "common/pagedResultSet", "commands/commandBase"], function (require, exports, pagedResultSet, commandBase) {
    "use strict";
    var getDocRefsCommand = (function (_super) {
        __extends(getDocRefsCommand, _super);
        function getDocRefsCommand(ownerDb, docId, skip, take) {
            var _this = _super.call(this) || this;
            _this.ownerDb = ownerDb;
            _this.docId = docId;
            _this.skip = skip;
            _this.take = take;
            if (!_this.ownerDb) {
                throw new Error("Must specify a database.");
            }
            return _this;
        }
        getDocRefsCommand.prototype.execute = function () {
            var args = {
                id: this.docId,
                start: this.skip,
                pageSize: this.take
            };
            var url = "/debug/docrefs"; //TODO: use endpoints
            var docRefsTask = $.Deferred();
            this.query(url, args, this.ownerDb).
                fail(function (response) { return docRefsTask.reject(response); }).
                done(function (docRefs) {
                var items = $.map(docRefs.Results, function (r) {
                    return {
                        getId: function () { return r; },
                        getDocumentPropertyNames: function () { return ["Id"]; }
                    };
                });
                var resultsSet = new pagedResultSet(items, docRefs.TotalCount);
                docRefsTask.resolve(resultsSet);
            });
            return docRefsTask;
        };
        return getDocRefsCommand;
    }(commandBase));
    return getDocRefsCommand;
});

//# sourceMappingURL=getDocRefsCommand.js.map
