var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "common/pagedResultSet", "commands/commandBase"], function (require, exports, pagedResultSet, commandBase) {
    "use strict";
    var getIdentitiesCommand = (function (_super) {
        __extends(getIdentitiesCommand, _super);
        function getIdentitiesCommand(ownerDb, skip, take) {
            var _this = _super.call(this) || this;
            _this.ownerDb = ownerDb;
            _this.skip = skip;
            _this.take = take;
            if (!_this.ownerDb) {
                throw new Error("Must specify a database.");
            }
            return _this;
        }
        getIdentitiesCommand.prototype.execute = function () {
            var args = {
                start: this.skip,
                pageSize: this.take
            };
            var url = "/debug/identities"; //TODO: use endpoints
            var identitiesTask = $.Deferred();
            this.query(url, args, this.ownerDb).
                fail(function (response) { return identitiesTask.reject(response); }).
                done(function (identities) {
                var items = $.map(identities.Identities, function (r) {
                    return {
                        getId: function () { return r.Key; },
                        getUrl: function () { return r.Key; },
                        'Value': r.Value,
                        'Key': r.Key,
                        getDocumentPropertyNames: function () { return ["Key", "Value"]; }
                    };
                });
                var resultsSet = new pagedResultSet(items, identities.TotalCount);
                identitiesTask.resolve(resultsSet);
            });
            return identitiesTask;
        };
        return getIdentitiesCommand;
    }(commandBase));
    return getIdentitiesCommand;
});

//# sourceMappingURL=getIdentitiesCommand.js.map
