var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "jszip-utils", "common/appUrl", "d3", "commands/auth/getSingleAuthTokenCommand"], function (require, exports, commandBase, zipUtils, appUrl, d3, getSingleAuthTokenCommand) {
    "use strict";
    var getInfoPackage = (function (_super) {
        __extends(getInfoPackage, _super);
        function getInfoPackage(db, withStackTrace) {
            var _this = _super.call(this) || this;
            _this.db = db;
            _this.withStackTrace = withStackTrace;
            return _this;
        }
        getInfoPackage.prototype.execute = function () {
            var _this = this;
            var task = $.Deferred();
            var getTokenTask = new getSingleAuthTokenCommand(this.db).execute();
            getTokenTask
                .done(function (tokenObject) {
                var token = tokenObject.Token;
                var isSystem = true;
                var url = appUrl.forResourceQuery(_this.db) + (isSystem ? '/admin/debug/info-package' : '/debug/info-package'); //TODO: use endpoints
                url += '?singleUseAuthToken=' + token;
                if (_this.withStackTrace && isSystem) {
                    url += "&stacktrace=true";
                }
                var now = d3.time.format("%Y-%m-%d_%H:%M:%S")(new Date());
                var filename = isSystem ? "Admin-Debug-Info-" + now + ".zip" : "Debug-Info-" + _this.db.name + "-" + now + ".zip";
                zipUtils.getBinaryContent(url, function (err, data) {
                    if (err) {
                        task.reject(err);
                    }
                    else {
                        task.resolve(data, filename);
                    }
                });
            })
                .fail(function (response) {
                _this.reportError("Failed to get token!", response.responseText, response.statusText);
                task.reject(response);
            });
            return task.promise();
        };
        return getInfoPackage;
    }(commandBase));
    return getInfoPackage;
});

//# sourceMappingURL=getInfoPackage.js.map
