var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "d3"], function (require, exports, commandBase, d3) {
    "use strict";
    var getReducingBatchStatsCommand = (function (_super) {
        __extends(getReducingBatchStatsCommand, _super);
        function getReducingBatchStatsCommand(db, lastId) {
            var _this = _super.call(this) || this;
            _this.db = db;
            _this.lastId = lastId;
            return _this;
        }
        getReducingBatchStatsCommand.prototype.execute = function () {
            var url = "/debug/reducing-batch-stats"; //TODO: use endpoints
            var args = { lastId: this.lastId };
            var inlinePerfStats = function (entry) {
                var result = [];
                d3.map(entry).entries().forEach(function (e) {
                    e.value.forEach(function (s) {
                        result.push({
                            indexName: e.key,
                            stats: s
                        });
                    });
                });
                return result;
            };
            var parser = d3.time.format.iso;
            return this.query(url, args, this.db, function (result) {
                var mappedResult = result.map(function (item) {
                    return {
                        Id: item.Id,
                        IndexesToWorkOn: item.IndexesToWorkOn,
                        TotalDurationMs: item.TotalDurationMs,
                        StartedAt: item.StartedAt,
                        StartedAtDate: parser.parse(item.StartedAt),
                        PerfStats: inlinePerfStats(item.PerformanceStats),
                        TimeSinceFirstReduceInBatchCompletedMs: item.TimeSinceFirstReduceInBatchCompletedMs
                    };
                });
                mappedResult.forEach(function (r) {
                    r.PerfStats.forEach(function (s) {
                        s.stats.LevelStats.forEach(function (l) {
                            l.Operations.filter(function (x) { return !("Name" in x); }).forEach(function (o) {
                                o.BatchedOperations.forEach(function (b) {
                                    b.Operations.forEach(function (x) {
                                        x.ParallelParent = b;
                                    });
                                    b.Parent = o;
                                });
                            });
                            l.parent = s;
                        });
                        s.parent = r;
                    });
                });
                return mappedResult;
            });
        };
        return getReducingBatchStatsCommand;
    }(commandBase));
    return getReducingBatchStatsCommand;
});

//# sourceMappingURL=getReducingBatchStatsCommand.js.map
