var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "commands/operations/getOperationStatusCommand"], function (require, exports, commandBase, getOperationStatusCommand) {
    "use strict";
    var getSlowDocCountsCommand = (function (_super) {
        __extends(getSlowDocCountsCommand, _super);
        function getSlowDocCountsCommand(db, updateProgress) {
            var _this = _super.call(this) || this;
            _this.db = db;
            _this.updateProgress = updateProgress;
            _this.calculationCompleted = $.Deferred();
            return _this;
        }
        getSlowDocCountsCommand.prototype.execute = function () {
            var _this = this;
            var url = "/debug/sl0w-d0c-c0unts"; //TODO: use endpoints
            return this.query(url, null, this.db)
                .done(function (response) {
                _this.monitorOperation(response.OperationId);
            })
                .fail(function (response) { return _this.reportError("Failed to compute document counts", response.responseText, response.statusText); });
        };
        getSlowDocCountsCommand.prototype.monitorOperation = function (operationId) {
            new getOperationStatusCommand(this.db, operationId)
                .execute();
            /* TODO .done((result: debugDocumentStatsStateDto) => {
                this.updateProgress(result.State.Progress);

                if (result.Completed) {
                    if (result.Faulted || result.Canceled) {
                        this.reportError("Calculation failed", result.State.Error);
                        this.calculationCompleted.reject();
                    } else {
                        this.reportSuccess("Calculation completed");
                        this.calculationCompleted.resolve(new debugDocumentStats(result.Stats));
                    }
                } else {
                    setTimeout(() => this.monitorOperation(operationId), 500);
                }
            });*/
        };
        getSlowDocCountsCommand.prototype.getCalculationCompletedTask = function () {
            return this.calculationCompleted.promise();
        };
        return getSlowDocCountsCommand;
    }(commandBase));
    return getSlowDocCountsCommand;
});

//# sourceMappingURL=getSlowDocCountsCommand.js.map
