var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "commands/operations/getOperationStatusCommand"], function (require, exports, commandBase, getOperationStatusCommand) {
    "use strict";
    var ioTestCommand = (function (_super) {
        __extends(ioTestCommand, _super);
        function ioTestCommand(db, testParameters, onStatus) {
            var _this = _super.call(this) || this;
            _this.db = db;
            _this.testParameters = testParameters;
            _this.onStatus = onStatus;
            _this.operationIdTask = $.Deferred();
            return _this;
        }
        ioTestCommand.prototype.execute = function () {
            var _this = this;
            var promise = $.Deferred();
            var url = '/admin/ioTest'; //TODO: use endpoints
            this.post(url, ko.toJSON(this.testParameters), null)
                .done(function (result) {
                _this.operationIdTask.resolve(result.OperationId);
                _this.monitorIoTest(promise, result.OperationId);
            })
                .fail(function (response) {
                _this.reportError("Failed to start disk IO test!", response.responseText, response.statusText);
                promise.reject();
            });
            return promise;
        };
        ioTestCommand.prototype.monitorIoTest = function (parentPromise, operationId) {
            new getOperationStatusCommand(null, operationId)
                .execute();
            /* TODO.done((result: operationStatusDto) => {
                if (result.Completed) {
                    if (result.Faulted || result.Canceled) {
                        this.reportError("Failed to perform disk IO test!", result.State.Error);
                        parentPromise.reject();
                    } else {
                        this.reportSuccess("Disk IO test completed");
                        parentPromise.resolve();
                    }
                } else {
                    this.onStatus(result.State);
                    setTimeout(() => this.monitorIoTest(parentPromise, operationId), 500);
                }
            });*/
        };
        return ioTestCommand;
    }(commandBase));
    return ioTestCommand;
});

//# sourceMappingURL=ioTestCommand.js.map
