var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "endpoints"], function (require, exports, commandBase, endpoints) {
    "use strict";
    var deleteDocsMatchingQueryCommand = (function (_super) {
        __extends(deleteDocsMatchingQueryCommand, _super);
        function deleteDocsMatchingQueryCommand(indexName, queryText, db) {
            var _this = _super.call(this) || this;
            _this.indexName = indexName;
            _this.queryText = queryText;
            _this.db = db;
            return _this;
        }
        deleteDocsMatchingQueryCommand.prototype.execute = function () {
            var _this = this;
            this.reportInfo("Deleting docs matching query...");
            var args = {
                query: this.queryText,
                pageSize: 128,
                allowStale: false
            };
            var url = endpoints.databases.batch.bulk_docs + "/" + this.indexName + this.urlEncodeArgs(args);
            var task = this.del(url, null, this.db);
            task.done(function () { return _this.reportSuccess("Docs deleted"); });
            task.fail(function (response) { return _this.reportError("Error deleting docs matching query", response.responseText, response.statusText); });
            return task;
        };
        return deleteDocsMatchingQueryCommand;
    }(commandBase));
    return deleteDocsMatchingQueryCommand;
});

//# sourceMappingURL=deleteDocsMatchingQueryCommand.js.map
