var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/database/documents/executeBulkDocsCommand"], function (require, exports, executeBulkDocsCommand) {
    "use strict";
    var deleteDocumentsCommand = (function (_super) {
        __extends(deleteDocumentsCommand, _super);
        function deleteDocumentsCommand(docIds, db) {
            var _this;
            var bulkDocs = docIds.map(function (id) { return deleteDocumentsCommand.createDeleteDocument(id); });
            _this = _super.call(this, bulkDocs, db) || this;
            return _this;
        }
        deleteDocumentsCommand.prototype.execute = function () {
            var _this = this;
            var docCount = this.docs.length;
            var docsDescription = docCount === 1 ? this.docs[0].Key : docCount + " docs";
            var deleteTask = _super.prototype.execute.call(this);
            deleteTask.done(function () { return _this.reportSuccess("Deleted " + docsDescription); });
            deleteTask.fail(function (response) { return _this.reportError("Failed to delete " + docsDescription, response.responseText, response.statusText); });
            return deleteTask;
        };
        deleteDocumentsCommand.createDeleteDocument = function (id) {
            return {
                Key: id,
                Method: "DELETE",
                Etag: null,
                AdditionalData: null
            };
        };
        return deleteDocumentsCommand;
    }(executeBulkDocsCommand));
    return deleteDocumentsCommand;
});

//# sourceMappingURL=deleteDocumentsCommand.js.map
