var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "endpoints"], function (require, exports, commandBase, endpoints) {
    "use strict";
    var generateClassCommand = (function (_super) {
        __extends(generateClassCommand, _super);
        function generateClassCommand(db, docId, lang) {
            var _this = _super.call(this) || this;
            _this.db = db;
            _this.docId = docId;
            _this.lang = lang;
            _this.isGeneratingCode = ko.observable(true);
            return _this;
        }
        generateClassCommand.prototype.execute = function () {
            var _this = this;
            var url = endpoints.databases.document.docsClass;
            var args = {
                id: this.docId,
                lang: this.lang
            };
            return this.query(url, args, this.db, null, { dataType: "text" })
                .fail(function (response) { return _this.reportError("Failed to create class code", response.responseText, response.statusText); })
                .always(function () { return _this.isGeneratingCode(false); });
        };
        return generateClassCommand;
    }(commandBase));
    return generateClassCommand;
});

//# sourceMappingURL=generateClassCommand.js.map
