var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "models/database/documents/collectionsStats", "endpoints"], function (require, exports, commandBase, collectionsStats, endpoints) {
    "use strict";
    var getCollectionsStatsCommand = (function (_super) {
        __extends(getCollectionsStatsCommand, _super);
        function getCollectionsStatsCommand(ownerDb) {
            var _this = _super.call(this) || this;
            _this.ownerDb = ownerDb;
            if (!_this.ownerDb) {
                throw new Error("Must specify a database.");
            }
            return _this;
        }
        getCollectionsStatsCommand.prototype.execute = function () {
            var _this = this;
            var finalResult = $.Deferred();
            this.query(endpoints.databases.collections.collectionsStats, null, this.ownerDb)
                .done(function (results) {
                var stats = new collectionsStats(results, _this.ownerDb);
                finalResult.resolve(stats);
            })
                .fail(function (response) {
                _this.reportError("Can't fetch collection stats");
                finalResult.reject(response.responseText);
            });
            return finalResult;
        };
        return getCollectionsStatsCommand;
    }(commandBase));
    return getCollectionsStatsCommand;
});

//# sourceMappingURL=getCollectionsStatsCommand.js.map
