var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "models/database/documents/document", "endpoints"], function (require, exports, commandBase, document, endpoints) {
    "use strict";
    var getDocumentWithMetadataCommand = (function (_super) {
        __extends(getDocumentWithMetadataCommand, _super);
        function getDocumentWithMetadataCommand(id, db, shouldResolveNotFoundAsNull) {
            if (shouldResolveNotFoundAsNull === void 0) { shouldResolveNotFoundAsNull = false; }
            var _this = _super.call(this) || this;
            _this.id = id;
            _this.db = db;
            _this.shouldResolveNotFoundAsNull = shouldResolveNotFoundAsNull;
            if (!id) {
                throw new Error("Must specify ID");
            }
            return _this;
        }
        // we can't use JQueryPromise<document> here as it actually can return any schema
        getDocumentWithMetadataCommand.prototype.execute = function () {
            var _this = this;
            var documentResult = $.Deferred();
            var postResult = this.post(endpoints.databases.document.docs, JSON.stringify([this.id]), this.db);
            postResult.fail(function (xhr) { return documentResult.reject(xhr); });
            postResult.done(function (queryResult) {
                if (queryResult.Results.length === 0) {
                    if (_this.shouldResolveNotFoundAsNull) {
                        documentResult.resolve(null);
                    }
                    else {
                        documentResult.reject("Unable to find document with ID " + _this.id);
                    }
                }
                else {
                    documentResult.resolve(new document(queryResult.Results[0]));
                }
            });
            return documentResult;
        };
        return getDocumentWithMetadataCommand;
    }(commandBase));
    return getDocumentWithMetadataCommand;
});

//# sourceMappingURL=getDocumentWithMetadataCommand.js.map
