var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "common/pagedResultSet", "models/database/documents/document", "endpoints"], function (require, exports, commandBase, pagedResultSet, document, endpoints) {
    "use strict";
    var getDocumentsFromCollectionCommand = (function (_super) {
        __extends(getDocumentsFromCollectionCommand, _super);
        function getDocumentsFromCollectionCommand(collection, skip, take) {
            var _this = _super.call(this) || this;
            _this.collection = collection;
            _this.skip = skip;
            _this.take = take;
            return _this;
        }
        getDocumentsFromCollectionCommand.prototype.execute = function () {
            var _this = this;
            var args = {
                name: this.collection.name,
                start: this.skip,
                pageSize: this.take
            };
            var resultsSelector = function (dto) { return new pagedResultSet(dto.Results.map(function (x) { return new document(x); }), _this.collection.documentCount()); };
            var url = endpoints.databases.collections.collectionsDocs;
            return this.query(url, args, this.collection.ownerDatabase, resultsSelector);
        };
        return getDocumentsFromCollectionCommand;
    }(commandBase));
    return getDocumentsFromCollectionCommand;
});

//# sourceMappingURL=getDocumentsFromCollectionCommand.js.map
