var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "endpoints"], function (require, exports, commandBase, endpoints) {
    "use strict";
    var saveBulkOfDocuments = (function (_super) {
        __extends(saveBulkOfDocuments, _super);
        function saveBulkOfDocuments(dataTypes, bulkDocuments, db) {
            var _this = _super.call(this) || this;
            _this.dataTypes = dataTypes;
            _this.bulkDocuments = bulkDocuments;
            _this.db = db;
            return _this;
        }
        // performs bulk save of an array of objects 
        saveBulkOfDocuments.prototype.execute = function () {
            var _this = this;
            var saveBulkTask = this.post(endpoints.databases.batch.bulk_docs, ko.toJSON(this.bulkDocuments), this.db);
            this.reportInfo("Performing bulk save of " + this.dataTypes);
            saveBulkTask.done(function () { return _this.reportSuccess("Saved all bulk of documents"); });
            saveBulkTask.fail(function (response) { return _this.reportError("Failed to save bulk of documents", response.responseText, response.statusText); });
            return saveBulkTask;
        };
        return saveBulkOfDocuments;
    }(commandBase));
    return saveBulkOfDocuments;
});

//# sourceMappingURL=saveBulkOfDocuments.js.map
