var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var saveCustomFunctionsCommand = (function (_super) {
        __extends(saveCustomFunctionsCommand, _super);
        function saveCustomFunctionsCommand(db, toSave, global) {
            if (global === void 0) { global = false; }
            var _this = _super.call(this) || this;
            _this.db = db;
            _this.toSave = toSave;
            _this.global = global;
            if (!db) {
                throw new Error("Must specify database");
            }
            return _this;
        }
        saveCustomFunctionsCommand.prototype.validateCustomFunctions = function (document) {
            return this.post("/studio-tasks/validateCustomFunctions", document, this.db, { dataType: 'text' }); //TODO: use endpoints
        };
        saveCustomFunctionsCommand.prototype.execute = function () {
            var _this = this;
            var args = JSON.stringify(this.toSave.toDto());
            return this.validateCustomFunctions(args)
                .fail(function (response) { return _this.reportError("Failed to validate custom functions!", response.responseText, response.statusText); })
                .then(function () {
                var url = _this.global ? "/docs?id=Raven/Global/Javascript/Functions" : "/docs?id=Raven/Javascript/Functions"; //TODO: use endpoints
                var saveTask = _this.put(url, args, _this.db, null);
                saveTask.done(function () { return _this.reportSuccess("Custom functions saved!"); });
                saveTask.fail(function (response) { return _this.reportError("Failed to save custom functions!", response.responseText, response.statusText); });
                return saveTask;
            });
        };
        return saveCustomFunctionsCommand;
    }(commandBase));
    return saveCustomFunctionsCommand;
});

//# sourceMappingURL=saveCustomFunctionsCommand.js.map
