var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "endpoints"], function (require, exports, commandBase, endpoints) {
    "use strict";
    var saveDocumentCommand = (function (_super) {
        __extends(saveDocumentCommand, _super);
        function saveDocumentCommand(id, document, db, reportSaveProgress) {
            if (reportSaveProgress === void 0) { reportSaveProgress = true; }
            var _this = _super.call(this) || this;
            _this.id = id;
            _this.document = document;
            _this.db = db;
            _this.reportSaveProgress = reportSaveProgress;
            return _this;
        }
        saveDocumentCommand.prototype.execute = function () {
            var _this = this;
            this.document.__metadata.id = this.id;
            var commands = [this.document.toBulkDoc("PUT")];
            var args = ko.toJSON(commands);
            var url = endpoints.databases.batch.bulk_docs;
            var saveTask = this.post(url, args, this.db);
            if (this.reportSaveProgress) {
                saveTask.done(function (result) { return _this.reportSuccess("Saved " + result.Results[0].Key); });
                saveTask.fail(function (response) { return _this.reportError("Failed to save " + _this.id, response.responseText, response.statusText); });
            }
            return saveTask;
        };
        return saveDocumentCommand;
    }(commandBase));
    return saveDocumentCommand;
});

//# sourceMappingURL=saveDocumentCommand.js.map
