var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/database/documents/executeBulkDocsCommand"], function (require, exports, executeBulkDocsCommand) {
    "use strict";
    var saveScriptedIndexesCommand = (function (_super) {
        __extends(saveScriptedIndexesCommand, _super);
        function saveScriptedIndexesCommand(scriptedIndexes, db) {
            var _this = _super.call(this, scriptedIndexes.map(function (idx) { return (idx.isMarkedToDelete()) ? idx.toBulkDoc("DELETE") : idx.toBulkDoc("PUT"); }), db) || this;
            _this.scriptedIndexes = scriptedIndexes;
            return _this;
        }
        saveScriptedIndexesCommand.prototype.execute = function () {
            var _this = this;
            this.reportInfo("Saving Scripted Index...");
            return _super.prototype.execute.call(this)
                .fail(function (result) { return _this.reportError("Unable to save Scripted Index.", result.responseText, result.statusText); })
                .done(function () { return _this.reportSuccess("Saved Scripted Index."); });
        };
        return saveScriptedIndexesCommand;
    }(executeBulkDocsCommand));
    return saveScriptedIndexesCommand;
});

//# sourceMappingURL=saveScriptedIndexesCommand.js.map
