var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "commands/database/documents/deleteDocumentCommand"], function (require, exports, commandBase, deleteDocumentCommand) {
    "use strict";
    var updateServerPrefixHiLoCommand = (function (_super) {
        __extends(updateServerPrefixHiLoCommand, _super);
        function updateServerPrefixHiLoCommand(serverPrefix, db) {
            var _this = _super.call(this) || this;
            _this.serverPrefix = serverPrefix;
            _this.db = db;
            return _this;
        }
        updateServerPrefixHiLoCommand.prototype.execute = function () {
            var _this = this;
            if (this.serverPrefix) {
                var doc = {
                    ServerPrefix: this.serverPrefix
                };
                return this.put("/docs?id=Raven/ServerPrefixForHilo", JSON.stringify(doc), this.db) //TODO: use endpoints
                    .done(function () { return _this.reportSuccess("Saved ServerPrefix configuration"); })
                    .fail(function (response) { return _this.reportError("Failed to save ServerPrefix configuration", response.responseText, response.statusText); });
            }
            else {
                return new deleteDocumentCommand("Raven/ServerPrefixForHilo", this.db)
                    .execute()
                    .done(function () { return _this.reportSuccess("Saved ServerPrefix configuration"); })
                    .fail(function (response) { return _this.reportError("Failed to save ServerPrefix configuration", response.responseText, response.statusText); });
            }
        };
        return updateServerPrefixHiLoCommand;
    }(commandBase));
    return updateServerPrefixHiLoCommand;
});

//# sourceMappingURL=updateServerPrefixHiLoCommand.js.map
