var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "endpoints"], function (require, exports, commandBase, endpoints) {
    "use strict";
    var verifyDocumentsIDsCommand = (function (_super) {
        __extends(verifyDocumentsIDsCommand, _super);
        function verifyDocumentsIDsCommand(docIDs, db, queryLocalStorage, storeResultsInLocalStorage) {
            var _this = _super.call(this) || this;
            _this.docIDs = docIDs;
            _this.db = db;
            _this.queryLocalStorage = queryLocalStorage;
            _this.storeResultsInLocalStorage = storeResultsInLocalStorage;
            if (!docIDs) {
                throw new Error("Must specify IDs");
            }
            if (!db) {
                throw new Error("Must specify database");
            }
            return _this;
        }
        verifyDocumentsIDsCommand.prototype.execute = function () {
            var _this = this;
            var verifyResult = $.Deferred();
            var verifiedIDs = [];
            // if required to check with locally stored document ids first, remove known non existing documet ids first and confirm verified ids later
            if (this.queryLocalStorage) {
                if (verifyDocumentsIDsCommand.InvalidIDsLocal.length > 0) {
                    _.pullAll(this.docIDs, verifyDocumentsIDsCommand.InvalidIDsLocal);
                }
                if (verifyDocumentsIDsCommand.IDsLocalStorage.length > 0) {
                    this.docIDs.forEach(function (curId) {
                        if (verifyDocumentsIDsCommand.IDsLocalStorage.find(function (x) { return x === curId; })) {
                            verifiedIDs.push(curId);
                        }
                    });
                    _.pullAll(this.docIDs, verifyDocumentsIDsCommand.IDsLocalStorage);
                }
            }
            if (this.docIDs.length > 0) {
                var url = endpoints.databases.document.docs;
                var postResult = this.post(url + "?metadata-only=true", JSON.stringify(this.docIDs), this.db);
                postResult.fail(function (xhr) { return verifyResult.reject(xhr); });
                postResult.done(function (queryResult) {
                    if (queryResult && queryResult.Results) {
                        queryResult.Results.forEach(function (curVerifiedID) {
                            verifiedIDs.push(curVerifiedID['@metadata']['@id']);
                            if (_this.queryLocalStorage) {
                                verifyDocumentsIDsCommand.IDsLocalStorage.push(curVerifiedID['@metadata']['@id']);
                            }
                        });
                        if (_this.queryLocalStorage) {
                            _.pullAll(_this.docIDs, queryResult.Results.map(function (curResult) { return curResult['@metadata']['@id']; }));
                            (_a = verifyDocumentsIDsCommand.InvalidIDsLocal).push.apply(_a, _this.docIDs);
                        }
                    }
                    verifyResult.resolve(verifiedIDs);
                    var _a;
                });
                return verifyResult;
            }
            else {
                verifyResult.resolve(verifiedIDs);
                return verifyResult;
            }
        };
        return verifyDocumentsIDsCommand;
    }(commandBase));
    verifyDocumentsIDsCommand.IDsLocalStorage = []; //TODO: it isn't scoped to current database?
    verifyDocumentsIDsCommand.InvalidIDsLocal = [];
    return verifyDocumentsIDsCommand;
});

//# sourceMappingURL=verifyDocumentsIDsCommand.js.map
