var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var deleteLocalPeriodicExportSetupCommand = (function (_super) {
        __extends(deleteLocalPeriodicExportSetupCommand, _super);
        function deleteLocalPeriodicExportSetupCommand(setupToPersist, db) {
            var _this = _super.call(this) || this;
            _this.setupToPersist = setupToPersist;
            _this.db = db;
            return _this;
        }
        deleteLocalPeriodicExportSetupCommand.prototype.execute = function () {
            var _this = this;
            this.reportInfo("Updating Periodic Export setup.");
            return $.when(this.saveAccountInformation(), this.deleteSetup())
                .done(function () { return _this.reportSuccess("Updated Periodic Export setup."); })
                .fail(function (response) { return _this.reportError("Failed to update Periodic Export setup.", response.responseText); });
        };
        deleteLocalPeriodicExportSetupCommand.prototype.saveAccountInformation = function () {
            var jQueryOptions = {};
            if (this.setupToPersist.getEtag()) {
                jQueryOptions.headers = {
                    'If-None-Match': this.setupToPersist.getEtag()
                };
            }
            var url = "/admin/databases?name=" + this.db.name; //TODO: use endpoints
            var putArgs = JSON.stringify(this.setupToPersist.removeDatabaseSettings());
            return this.put(url, putArgs, null, jQueryOptions);
        };
        deleteLocalPeriodicExportSetupCommand.prototype.deleteSetup = function () {
            var url = "/docs?id=Raven/Backup/Periodic/Setup"; //TODO: use endpoints
            return this.del(url, null, this.db);
        };
        return deleteLocalPeriodicExportSetupCommand;
    }(commandBase));
    return deleteLocalPeriodicExportSetupCommand;
});

//# sourceMappingURL=deleteLocalPeriodicExportSetupCommand.js.map
