var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var deleteLocalReplicationsSetupCommand = (function (_super) {
        __extends(deleteLocalReplicationsSetupCommand, _super);
        function deleteLocalReplicationsSetupCommand(db) {
            var _this = _super.call(this) || this;
            _this.db = db;
            return _this;
        }
        deleteLocalReplicationsSetupCommand.prototype.execute = function () {
            var _this = this;
            this.reportInfo("Updating Replication config setup.");
            return $.when(this.deleteConflictResolution(), this.deleteLocalDestinations())
                .done(function () { return _this.reportSuccess("Updated Replication config setup."); })
                .fail(function (response) { return _this.reportError("Failed to update replication config setup.", response.responseText); });
        };
        deleteLocalReplicationsSetupCommand.prototype.deleteConflictResolution = function () {
            var url = "/docs?id=Raven/Replication/Config"; //TODO: use endpoints
            return this.del(url, null, this.db);
        };
        deleteLocalReplicationsSetupCommand.prototype.deleteLocalDestinations = function () {
            var url = "/docs?id=Raven/Replication/Destinations"; //TODO: use endpoints
            return this.del(url, null, this.db);
        };
        return deleteLocalReplicationsSetupCommand;
    }(commandBase));
    return deleteLocalReplicationsSetupCommand;
});

//# sourceMappingURL=deleteLocalReplicationsSetupCommand.js.map
