var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var saveGlobalSettingsCommand = (function (_super) {
        __extends(saveGlobalSettingsCommand, _super);
        function saveGlobalSettingsCommand(db, document) {
            var _this = _super.call(this) || this;
            _this.db = db;
            _this.document = document;
            if (!db) {
                throw new Error("Must specify database");
            }
            return _this;
        }
        saveGlobalSettingsCommand.prototype.execute = function () {
            var _this = this;
            this.reportInfo("Saving Global Settings...");
            var jQueryOptions = {};
            if (this.document.__metadata.etag()) {
                jQueryOptions.headers = {
                    'If-None-Match': this.document.__metadata.etag()
                };
            }
            var args = JSON.stringify(this.document.toDto());
            var url = "/configuration/global/settings"; //TODO: use endpoints
            var saveTask = this.put(url, args, null, jQueryOptions);
            saveTask.done(function () { return _this.reportSuccess("Global Settings were successfully saved!"); });
            saveTask.fail(function (response) { return _this.reportError("Failed to save global settings!", response.responseText, response.statusText); });
            return saveTask;
        };
        return saveGlobalSettingsCommand;
    }(commandBase));
    return saveGlobalSettingsCommand;
});

//# sourceMappingURL=saveGlobalSettingsCommand.js.map
