var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var deleteIndexCommand = (function (_super) {
        __extends(deleteIndexCommand, _super);
        function deleteIndexCommand(indexName, db) {
            var _this = _super.call(this) || this;
            _this.indexName = indexName;
            _this.db = db;
            return _this;
        }
        deleteIndexCommand.prototype.execute = function () {
            var _this = this;
            this.reportInfo("Deleting " + this.indexName + "...");
            var args = {
                name: this.indexName
            };
            return this.del("/indexes" + this.urlEncodeArgs(args), null, this.db) //TODO: use endpoints
                .fail(function (response) { return _this.reportError("Failed to delete index " + _this.indexName, response.responseText); })
                .done(function () { return _this.reportSuccess("Deleted " + _this.indexName); });
        };
        return deleteIndexCommand;
    }(commandBase));
    return deleteIndexCommand;
});

//# sourceMappingURL=deleteIndexCommand.js.map
