var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "endpoints"], function (require, exports, commandBase, endpoints) {
    "use strict";
    var enableIndexCommand = (function (_super) {
        __extends(enableIndexCommand, _super);
        function enableIndexCommand(indexName, db) {
            var _this = _super.call(this) || this;
            _this.indexName = indexName;
            _this.db = db;
            return _this;
        }
        enableIndexCommand.prototype.execute = function () {
            var _this = this;
            var args = {
                name: this.indexName
            };
            this.reportInfo("Enabling " + this.indexName);
            var url = endpoints.databases.adminIndex.adminIndexesEnable + this.urlEncodeArgs(args);
            return this.post(url, null, this.db, { dataType: undefined })
                .done(function () {
                _this.reportSuccess(_this.indexName + " was Enabled");
            })
                .fail(function (response) { return _this.reportError("Failed to enable index", response.responseText); });
        };
        return enableIndexCommand;
    }(commandBase));
    return enableIndexCommand;
});

//# sourceMappingURL=enableIndexCommand.js.map
