var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var getIndexSuggestionsCommand = (function (_super) {
        __extends(getIndexSuggestionsCommand, _super);
        function getIndexSuggestionsCommand(db, indexName, field, term, distance, accuracy, maxSuggestions, popularity) {
            if (distance === void 0) { distance = "Default"; }
            if (accuracy === void 0) { accuracy = 0.4; }
            if (maxSuggestions === void 0) { maxSuggestions = 5; }
            if (popularity === void 0) { popularity = true; }
            var _this = _super.call(this) || this;
            _this.db = db;
            _this.indexName = indexName;
            _this.field = field;
            _this.term = term;
            _this.distance = distance;
            _this.accuracy = accuracy;
            _this.maxSuggestions = maxSuggestions;
            _this.popularity = popularity;
            return _this;
        }
        getIndexSuggestionsCommand.prototype.execute = function () {
            var url = '/suggest/' + this.indexName; //TODO: use endpoints
            var args = {
                term: this.term,
                field: this.field,
                max: this.maxSuggestions,
                distance: this.distance,
                accuracy: this.accuracy,
                popularity: this.popularity
            };
            return this.query(url, args, this.db);
        };
        return getIndexSuggestionsCommand;
    }(commandBase));
    return getIndexSuggestionsCommand;
});

//# sourceMappingURL=getIndexSuggestionsCommand.js.map
