var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "models/database/index/scriptedIndex"], function (require, exports, commandBase, scriptedIndex) {
    "use strict";
    var getScriptedIndexesCommand = (function (_super) {
        __extends(getScriptedIndexesCommand, _super);
        function getScriptedIndexesCommand(db, indexName) {
            if (indexName === void 0) { indexName = ""; }
            var _this = _super.call(this) || this;
            _this.db = db;
            _this.indexName = indexName;
            return _this;
        }
        getScriptedIndexesCommand.prototype.execute = function () {
            var args = {
                startsWith: "Raven/ScriptedIndexResults/" + this.indexName,
                exclude: null,
                start: 0,
                pageSize: 256
            };
            return this.query("/docs", args, this.db, function (dtos) { return dtos.Results.map(function (dto) { return new scriptedIndex(dto); }); }); //TODO: use endpoints
        };
        return getScriptedIndexesCommand;
    }(commandBase));
    return getScriptedIndexesCommand;
});

//# sourceMappingURL=getScriptedIndexesCommand.js.map
