var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var renameIndexCommand = (function (_super) {
        __extends(renameIndexCommand, _super);
        function renameIndexCommand(existingIndexName, newIndexName, db) {
            var _this = _super.call(this) || this;
            _this.existingIndexName = existingIndexName;
            _this.newIndexName = newIndexName;
            _this.db = db;
            return _this;
        }
        renameIndexCommand.prototype.execute = function () {
            var _this = this;
            this.reportInfo("Renaming " + this.existingIndexName + "...");
            return this.rename()
                .fail(function (response) {
                _this.reportError("Failed to rename " + _this.existingIndexName, response.responseText, response.statusText);
            })
                .done(function () {
                _this.reportSuccess("Renamed " + _this.existingIndexName + " to " + _this.newIndexName);
            });
        };
        renameIndexCommand.prototype.rename = function () {
            var urlArgs = {
                newName: this.newIndexName
            };
            var url = "/indexes-rename/" + this.existingIndexName + this.urlEncodeArgs(urlArgs); //TODO: use endpoints
            return this.post(url, null, this.db, { dataType: undefined });
        };
        return renameIndexCommand;
    }(commandBase));
    return renameIndexCommand;
});

//# sourceMappingURL=renameIndexCommand.js.map
