var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "endpoints"], function (require, exports, commandBase, endpoints) {
    "use strict";
    var resetIndexCommand = (function (_super) {
        __extends(resetIndexCommand, _super);
        function resetIndexCommand(indexNameToReset, db) {
            var _this = _super.call(this) || this;
            _this.indexNameToReset = indexNameToReset;
            _this.db = db;
            return _this;
        }
        resetIndexCommand.prototype.execute = function () {
            var _this = this;
            var args = {
                name: this.indexNameToReset
            };
            var url = endpoints.databases.index.indexes + this.urlEncodeArgs(args);
            return this.reset(url, null, this.db)
                .done(function () { return _this.reportSuccess("Index " + _this.indexNameToReset + " successfully reset"); })
                .fail(function (response) { return _this.reportError("Failed to reset index: " + _this.indexNameToReset, response.responseText, response.statusText); });
        };
        return resetIndexCommand;
    }(commandBase));
    return resetIndexCommand;
});

//# sourceMappingURL=resetIndexCommand.js.map
