var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var saveIndexDefinitionCommand = (function (_super) {
        __extends(saveIndexDefinitionCommand, _super);
        function saveIndexDefinitionCommand(index, db) {
            var _this = _super.call(this) || this;
            _this.index = index;
            _this.db = db;
            return _this;
        }
        saveIndexDefinitionCommand.prototype.execute = function () {
            var _this = this;
            this.reportInfo("Saving " + this.index.Name + "...");
            return this.saveDefinition()
                .fail(function (response) {
                _this.reportError("Failed to save " + _this.index.Name, response.responseText, response.statusText);
            })
                .done(function () {
                _this.reportSuccess(_this.index.Name + " was Saved");
            });
        };
        saveIndexDefinitionCommand.prototype.saveDefinition = function () {
            var urlArgs = {
                definition: "yes",
                name: this.index.Name
            };
            var putArgs = JSON.stringify(this.index);
            var url = "/indexes" + this.urlEncodeArgs(urlArgs); //TODO: use endpoints
            return this.put(url, putArgs, this.db);
        };
        return saveIndexDefinitionCommand;
    }(commandBase));
    return saveIndexDefinitionCommand;
});

//# sourceMappingURL=saveIndexDefinitionCommand.js.map
