var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "endpoints"], function (require, exports, commandBase, endpoints) {
    "use strict";
    var saveIndexLockModeCommand = (function (_super) {
        __extends(saveIndexLockModeCommand, _super);
        function saveIndexLockModeCommand(indexes, lockMode, db, lockTitle) {
            var _this = _super.call(this) || this;
            _this.indexes = indexes;
            _this.lockMode = lockMode;
            _this.db = db;
            _this.lockTitle = lockTitle;
            return _this;
        }
        saveIndexLockModeCommand.prototype.execute = function () {
            var _this = this;
            var args = {
                mode: this.lockMode,
                name: this.indexes.map(function (x) { return x.name; })
            };
            var url = endpoints.databases.index.indexesSetLock + this.urlEncodeArgs(args);
            return this.post(url, null, this.db, { dataType: undefined })
                .done(function () {
                var indexesNameStr = _this.indexes.length === 1 ? _this.indexes[0].name : "Indexes";
                _this.reportSuccess(indexesNameStr + " Mode was set to: " + _this.lockTitle);
            })
                .fail(function (response) { return _this.reportError("Failed to set index lock mode", response.responseText); });
        };
        return saveIndexLockModeCommand;
    }(commandBase));
    return saveIndexLockModeCommand;
});

//# sourceMappingURL=saveIndexLockModeCommand.js.map
