var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "endpoints"], function (require, exports, commandBase, endpoints) {
    "use strict";
    var saveIndexPriorityCommand = (function (_super) {
        __extends(saveIndexPriorityCommand, _super);
        function saveIndexPriorityCommand(indexName, priority, db) {
            var _this = _super.call(this) || this;
            _this.indexName = indexName;
            _this.priority = priority;
            _this.db = db;
            return _this;
        }
        saveIndexPriorityCommand.prototype.execute = function () {
            var _this = this;
            var args = {
                name: this.indexName,
                priority: this.priority
            };
            this.reportInfo("Saving " + this.indexName + " Priority ...");
            var url = endpoints.databases.index.indexesSetPriority + this.urlEncodeArgs(args);
            return this.post(url, null, this.db, { dataType: undefined })
                .done(function () {
                _this.reportSuccess(_this.indexName + " Priority was set to " + args.priority);
            })
                .fail(function (response) { return _this.reportError("Failed to set index priority", response.responseText); });
        };
        return saveIndexPriorityCommand;
    }(commandBase));
    return saveIndexPriorityCommand;
});

//# sourceMappingURL=saveIndexPriorityCommand.js.map
