var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "endpoints"], function (require, exports, commandBase, endpoints) {
    "use strict";
    var toggleIndexingCommand = (function (_super) {
        __extends(toggleIndexingCommand, _super);
        function toggleIndexingCommand(start, db, options) {
            if (options === void 0) { options = null; }
            var _this = _super.call(this) || this;
            _this.start = start;
            _this.db = db;
            _this.toggleAll = false;
            if (options && options.hasOwnProperty("name")) {
                _this.names = options.name;
            }
            else if (options && options.hasOwnProperty("type")) {
                _this.type = options.type;
            }
            else {
                _this.toggleAll = true;
            }
            return _this;
        }
        toggleIndexingCommand.prototype.execute = function () {
            var _this = this;
            var basicUrl = this.start ? endpoints.databases.adminIndex.adminIndexesStart : endpoints.databases.adminIndex.adminIndexesStop;
            var args = null;
            if (this.names) {
                args = { name: this.names };
            }
            else if (this.type) {
                args = { type: this.type };
            }
            var url = basicUrl + (args ? this.urlEncodeArgs(args) : "");
            return this.post(url, null, this.db, { dataType: undefined })
                .done(function () {
                var state = _this.start ? "Resumed" : "Paused until restart";
                var indexNameMessage = _this.names ? _this.names[0] : "Indexing";
                _this.reportSuccess(indexNameMessage + " was " + state);
            })
                .fail(function (response) { return _this.reportError("Failed to toggle indexing status", response.responseText); });
        };
        return toggleIndexingCommand;
    }(commandBase));
    return toggleIndexingCommand;
});

//# sourceMappingURL=toggleIndexingCommand.js.map
