var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "endpoints"], function (require, exports, commandBase, endpoints) {
    "use strict";
    var evalByCollectionCommand = (function (_super) {
        __extends(evalByCollectionCommand, _super);
        function evalByCollectionCommand(collectionName, patchRequest, db) {
            var _this = _super.call(this) || this;
            _this.collectionName = collectionName;
            _this.patchRequest = patchRequest;
            _this.db = db;
            return _this;
        }
        evalByCollectionCommand.prototype.execute = function () {
            var _this = this;
            this.reportInfo("Patching documents...");
            var url = endpoints.databases.collections.collectionsDocs;
            var args = {
                name: this.collectionName
            };
            return this.patch(url + this.urlEncodeArgs(args), JSON.stringify(this.patchRequest), this.db)
                .done(function (response) {
                _this.reportSuccess("Scheduled patch of collection: " + _this.collectionName);
            })
                .fail(function (response) { return _this.reportError("Failed to schedule patch of collection " + _this.collectionName, response.responseText, response.statusText); });
        };
        return evalByCollectionCommand;
    }(commandBase));
    return evalByCollectionCommand;
});

//# sourceMappingURL=evalByCollectionCommand.js.map
