var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "endpoints"], function (require, exports, commandBase, endpoints) {
    "use strict";
    var evalByQueryCommand = (function (_super) {
        __extends(evalByQueryCommand, _super);
        function evalByQueryCommand(indexName, queryStr, patchRequest, db) {
            var _this = _super.call(this) || this;
            _this.indexName = indexName;
            _this.queryStr = queryStr;
            _this.patchRequest = patchRequest;
            _this.db = db;
            return _this;
        }
        evalByQueryCommand.prototype.execute = function () {
            var _this = this;
            this.reportInfo("Patching documents...");
            var url = endpoints.databases.queries.queries$ + this.indexName;
            var urlParams = "?query=" + encodeURIComponent(this.queryStr) + "&allowStale=true";
            return this.patch(url + urlParams, JSON.stringify(this.patchRequest), this.db)
                .done(function (response) {
                _this.reportSuccess("Scheduled patch of index: " + _this.indexName);
            })
                .fail(function (response) { return _this.reportError("Failed to schedule patch of index " + _this.indexName, response.responseText, response.statusText); });
        };
        return evalByQueryCommand;
    }(commandBase));
    return evalByQueryCommand;
});

//# sourceMappingURL=evalByQueryCommand.js.map
