var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/database/documents/executeBulkDocsCommand"], function (require, exports, executeBulkDocsCommand) {
    "use strict";
    var executePatchCommand = (function (_super) {
        __extends(executePatchCommand, _super);
        function executePatchCommand(bulkDocsDto, db, test) {
            var _this = _super.call(this, bulkDocsDto, db) || this;
            _this.test = test;
            return _this;
        }
        executePatchCommand.prototype.execute = function () {
            var _this = this;
            var failInfo = (this.test) ? "Patch test failed." : "Unable to patch documents.";
            var doneInfo = (this.test) ? "Patch tested. See the results below." : "Documents patched.";
            if (!this.test) {
                this.reportInfo("Patching documents...");
            }
            return _super.prototype.execute.call(this)
                .fail(function (result) { return _this.reportError(failInfo, result.responseText, result.statusText); })
                .done(function () { return _this.reportSuccess(doneInfo); });
        };
        return executePatchCommand;
    }(executeBulkDocsCommand));
    return executePatchCommand;
});

//# sourceMappingURL=executePatchCommand.js.map
