var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "commands/database/documents/saveDocumentCommand"], function (require, exports, commandBase, saveDocumentCommand) {
    "use strict";
    var savePatchCommand = (function (_super) {
        __extends(savePatchCommand, _super);
        function savePatchCommand(patchName, patchDocument, db) {
            var _this = _super.call(this) || this;
            _this.patchName = patchName;
            _this.patchDocument = patchDocument;
            _this.db = db;
            return _this;
        }
        savePatchCommand.prototype.execute = function () {
            var _this = this;
            this.reportInfo("Saving Patch.");
            return new saveDocumentCommand("Studio/Patch/" + this.patchName, this.patchDocument, this.db, false).execute()
                .done(function () { return _this.reportSuccess("Saved Patch."); })
                .fail(function (response) { return _this.reportError("Failed to save Patch.", response.responseText, response.statusText); });
        };
        return savePatchCommand;
    }(commandBase));
    return savePatchCommand;
});

//# sourceMappingURL=savePatchCommand.js.map
