var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "common/appUrl"], function (require, exports, commandBase, appUrl) {
    "use strict";
    var dataExplorationCommand = (function (_super) {
        __extends(dataExplorationCommand, _super);
        function dataExplorationCommand(request, db) {
            var _this = _super.call(this) || this;
            _this.request = request;
            _this.db = db;
            return _this;
        }
        dataExplorationCommand.prototype.execute = function () {
            var _this = this;
            var self = this;
            var queryTask = this.query(this.getUrl(), null, this.db);
            queryTask.fail(function (response) { return _this.reportError("Error during query", response.responseText, response.statusText); });
            return queryTask;
        };
        dataExplorationCommand.prototype.getUrl = function () {
            return "/streams/exploration/" + this.urlEncodeArgs(this.request); //TODO: use endpoints
        };
        dataExplorationCommand.prototype.getCsvUrl = function () {
            var requestWithCsvDownload = this.request;
            requestWithCsvDownload.download = "true";
            requestWithCsvDownload.format = "excel";
            return appUrl.forResourceQuery(this.db) + "/streams/exploration/" + this.urlEncodeArgs(requestWithCsvDownload); //TODO: use endpoints
        };
        return dataExplorationCommand;
    }(commandBase));
    return dataExplorationCommand;
});

//# sourceMappingURL=dataExplorationCommand.js.map
