var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "commands/operations/getOperationStatusCommand"], function (require, exports, commandBase, getOperationStatusCommand) {
    "use strict";
    var conflictsResolveCommand = (function (_super) {
        __extends(conflictsResolveCommand, _super);
        function conflictsResolveCommand(ownerDb, resolution) {
            var _this = _super.call(this) || this;
            _this.ownerDb = ownerDb;
            _this.resolution = resolution;
            if (!_this.ownerDb) {
                throw new Error("Must specify a database.");
            }
            return _this;
        }
        conflictsResolveCommand.prototype.execute = function () {
            var _this = this;
            var promise = $.Deferred();
            var url = "/studio-tasks/replication/conflicts/resolve?resolution=" + this.resolution; //TODO: use endpoints
            this.post(url, null, this.ownerDb)
                .fail(function (response) {
                _this.reportError("Failed to start conflict resolution!", response.responseText, response.statusText);
                promise.reject();
            }).done(function (result) {
                _this.monitorOperation(promise, result.OperationId);
            });
            return promise;
        };
        conflictsResolveCommand.prototype.monitorOperation = function (parentPromise, operationId) {
            new getOperationStatusCommand(this.ownerDb, operationId)
                .execute();
            /* TODO.done((result: operationStatusDto) => {
            if (result.Completed) {
                if (result.Faulted || result.Canceled) {
                    this.reportError("Failed to perform conflict resolution!", result.State.Error);
                    parentPromise.reject();
                } else {
                    this.reportSuccess("Conflict resolution was completed");
                    parentPromise.resolve();
                }
            } else {
                setTimeout(() => this.monitorOperation(parentPromise, operationId), 500);
            }
        });*/
        };
        return conflictsResolveCommand;
    }(commandBase));
    return conflictsResolveCommand;
});

//# sourceMappingURL=conflictsResolveCommand.js.map
