var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "commands/resources/getDatabaseSettingsCommand", "commands/resources/saveDatabaseSettingsCommand"], function (require, exports, commandBase, getDatabaseSettingsCommand, saveDatabaseSettingsCommand) {
    "use strict";
    var enableReplicationCommand = (function (_super) {
        __extends(enableReplicationCommand, _super);
        function enableReplicationCommand(db) {
            var _this = _super.call(this) || this;
            _this.db = db;
            return _this;
        }
        enableReplicationCommand.prototype.execute = function () {
            var _this = this;
            var task = $.Deferred();
            // query for database document
            new getDatabaseSettingsCommand(this.db, false)
                .execute()
                .done(function (dbSettings) {
                var activeBundles = dbSettings.Settings["Raven/ActiveBundles"];
                if (activeBundles && activeBundles.indexOf("Replication") > -1) {
                    // looks like we already have replication enabled - nothing to do
                    task.resolve(activeBundles.split(","));
                    _this.reportSuccess("Replication was already enabled for this database");
                }
                else {
                    if (!activeBundles) {
                        activeBundles = "Replication";
                    }
                    else {
                        activeBundles += ",Replication";
                    }
                    dbSettings.__metadata.etag(dbSettings.__metadata["@etag"]);
                    // and save updated settings back to server
                    dbSettings.Settings["Raven/ActiveBundles"] = activeBundles;
                    dbSettings.__metadata["Raven-Temp-Allow-Bundles-Change"] = true;
                    new saveDatabaseSettingsCommand(_this.db, dbSettings)
                        .execute()
                        .done(function () {
                        task.resolve(activeBundles.split(","));
                    }).fail(function () {
                        task.reject();
                    });
                }
            })
                .fail(function (response) {
                _this.reportError("Failed to enable replication bundle!", response.responseText, response.statusText);
                task.reject();
            });
            return task.promise();
        };
        return enableReplicationCommand;
    }(commandBase));
    return enableReplicationCommand;
});

//# sourceMappingURL=enableReplicationCommand.js.map
