var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "common/pagedResultSet", "commands/commandBase", "models/database/replication/conflictsInfo"], function (require, exports, pagedResultSet, commandBase, conflictsInfo) {
    "use strict";
    var getConflictsCommand = (function (_super) {
        __extends(getConflictsCommand, _super);
        function getConflictsCommand(ownerDb, skip, take) {
            var _this = _super.call(this) || this;
            _this.ownerDb = ownerDb;
            _this.skip = skip;
            _this.take = take;
            if (!_this.ownerDb) {
                throw new Error("Must specify a database.");
            }
            return _this;
        }
        getConflictsCommand.prototype.execute = function () {
            var args = {
                sort: "-ConflictDetectedAt",
                start: this.skip,
                pageSize: this.take,
                resultsTransformer: "Raven/ConflictDocumentsTransformer"
            };
            var resultsSelector = function (dto) { return new conflictsInfo(dto); };
            var url = "/indexes/Raven/ConflictDocuments"; //TODO: use endpoints
            var conflictsTask = $.Deferred();
            this.query(url, args, this.ownerDb, resultsSelector).
                fail(function (response) { return conflictsTask.reject(response); }).
                done(function (conflicts) {
                var items = conflicts.results;
                var resultsSet = new pagedResultSet(items, conflicts.totalResults);
                conflictsTask.resolve(resultsSet);
            });
            return conflictsTask;
        };
        return getConflictsCommand;
    }(commandBase));
    return getConflictsCommand;
});

//# sourceMappingURL=getConflictsCommand.js.map
