var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var getDocumentsLeftToReplicate = (function (_super) {
        __extends(getDocumentsLeftToReplicate, _super);
        function getDocumentsLeftToReplicate(sourceUrl, destinationUrl, databaseName, sourceId, db) {
            var _this = _super.call(this) || this;
            _this.sourceUrl = sourceUrl;
            _this.destinationUrl = destinationUrl;
            _this.databaseName = databaseName;
            _this.sourceId = sourceId;
            _this.db = db;
            return _this;
        }
        getDocumentsLeftToReplicate.prototype.execute = function () {
            var _this = this;
            var url = "/admin/replication/docs-left-to-replicate"; //TODO: use endpoints
            var args = {
                SourceUrl: this.sourceUrl,
                DestinationUrl: this.destinationUrl,
                DatabaseName: this.databaseName,
                SourceId: this.sourceId
            };
            return this.post(url, JSON.stringify(args), this.db, { dataType: "json" })
                .fail(function (response) { return _this.reportError("Failed to get documents left to replicate!", response.responseText, response.statusText); });
        };
        return getDocumentsLeftToReplicate;
    }(commandBase));
    return getDocumentsLeftToReplicate;
});

//# sourceMappingURL=getDocumentsLeftToReplicate.js.map
