var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "models/resources/database"], function (require, exports, commandBase, database) {
    "use strict";
    var getReplicationSourcesCommand = (function (_super) {
        __extends(getReplicationSourcesCommand, _super);
        function getReplicationSourcesCommand(db) {
            var _this = _super.call(this) || this;
            _this.db = db;
            return _this;
        }
        getReplicationSourcesCommand.prototype.execute = function () {
            var args = {
                startsWith: "Raven/Replication/Sources",
                exclude: null,
                start: 0,
                pageSize: 1024
            };
            return this.query("/docs", args, this.db, function (dtos) {
                var result = {};
                // insert remote databases info
                dtos.forEach(function (v) { return result[v.ServerInstanceId] = database.getNameFromUrl(v.Source); });
                // ... and insert local database instance id
                //TODO: result[this.db.statistics().databaseId()] = this.db.name;
                return result;
            });
        };
        return getReplicationSourcesCommand;
    }(commandBase));
    return getReplicationSourcesCommand;
});

//# sourceMappingURL=getReplicationSourcesCommand.js.map
