var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var replicateAllIndexesCommand = (function (_super) {
        __extends(replicateAllIndexesCommand, _super);
        function replicateAllIndexesCommand(db) {
            var _this = _super.call(this) || this;
            _this.db = db;
            return _this;
        }
        replicateAllIndexesCommand.prototype.execute = function () {
            var _this = this;
            var indexesUrl = '/databases/' + this.db.name + '/replication/replicate-indexes?op=replicate-all'; //TODO: use endpoints
            return this.post(indexesUrl, null, null, { dataType: undefined })
                .fail(function (response) {
                _this.reportError("Failed to send replicate all indexes command!", response.responseText, response.statusText);
            }).done(function () {
                _this.reportSuccess("Sent replicate all indexes command.");
            });
        };
        return replicateAllIndexesCommand;
    }(commandBase));
    return replicateAllIndexesCommand;
});

//# sourceMappingURL=replicateAllIndexesCommand.js.map
