var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var replicateAllTransformersCommand = (function (_super) {
        __extends(replicateAllTransformersCommand, _super);
        function replicateAllTransformersCommand(db) {
            var _this = _super.call(this) || this;
            _this.db = db;
            return _this;
        }
        replicateAllTransformersCommand.prototype.execute = function () {
            var _this = this;
            var transformersUrl = '/databases/' + this.db.name + '/replication/replicate-transformers?op=replicate-all'; //TODO: use endpoints
            return this.post(transformersUrl, null, null, { dataType: undefined })
                .fail(function (response) {
                _this.reportError("Failed to send replicate all transformers command!", response.responseText, response.statusText);
            }).done(function () {
                _this.reportSuccess("Sent replicate all transformers command");
            });
        };
        return replicateAllTransformersCommand;
    }(commandBase));
    return replicateAllTransformersCommand;
});

//# sourceMappingURL=replicateAllTransformersCommand.js.map
