var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var replicateTransformersCommand = (function (_super) {
        __extends(replicateTransformersCommand, _super);
        function replicateTransformersCommand(db, destination) {
            var _this = _super.call(this) || this;
            _this.db = db;
            _this.destination = destination;
            return _this;
        }
        replicateTransformersCommand.prototype.execute = function () {
            var _this = this;
            var transformersUrl = '/databases/' + this.db.name + '/replication/replicate-transformers?op=replicate-all-to-destination'; //TODO: use endpoints
            var destinationJson = JSON.stringify(this.destination.toDto());
            return this.post(transformersUrl, destinationJson, null, { dataType: undefined })
                .fail(function (response) {
                _this.reportError("Failed to send replicate transformers command!", response.responseText, response.statusText);
            }).done(function () {
                _this.reportSuccess("Sent replicate transformers command");
            });
        };
        return replicateTransformersCommand;
    }(commandBase));
    return replicateTransformersCommand;
});

//# sourceMappingURL=replicateTransformersCommand.js.map
