var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var resolveAllConflictsCommand = (function (_super) {
        __extends(resolveAllConflictsCommand, _super);
        function resolveAllConflictsCommand(db) {
            var _this = _super.call(this) || this;
            _this.db = db;
            return _this;
        }
        resolveAllConflictsCommand.prototype.execute = function () {
            var _this = this;
            var promise = $.Deferred();
            var url = '/replication/forceConflictResolution'; //TODO: use endpoints
            this.query(url, null, this.db)
                .fail(function (response) {
                _this.reportError("Failed to start conflict resolution task", response.responseText, response.statusText);
                promise.reject();
            }).done(function () {
                _this.reportSuccess("Started conflict resolution task (Status->Running Tasks)");
                promise.resolve();
            });
            return promise;
        };
        return resolveAllConflictsCommand;
    }(commandBase));
    return resolveAllConflictsCommand;
});

//# sourceMappingURL=resolveAllConflictsCommand.js.map
