var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var saveAutomaticConflictResolutionDocumentCommand = (function (_super) {
        __extends(saveAutomaticConflictResolutionDocumentCommand, _super);
        function saveAutomaticConflictResolutionDocumentCommand(dto, db, globalConfig) {
            if (globalConfig === void 0) { globalConfig = false; }
            var _this = _super.call(this) || this;
            _this.dto = dto;
            _this.db = db;
            _this.globalConfig = globalConfig;
            return _this;
        }
        saveAutomaticConflictResolutionDocumentCommand.prototype.execute = function () {
            var _this = this;
            this.reportInfo("Saving automatic conflict resolution settings.");
            return this.saveConfig()
                .done(function () { return _this.reportSuccess("Saved automatic conflict resolution settings."); })
                .fail(function (response) { return _this.reportError("Failed to save automatic conflict resolution settings.", response.responseText, response.statusText); });
        };
        saveAutomaticConflictResolutionDocumentCommand.prototype.saveConfig = function () {
            var id = this.globalConfig ? "Raven/Global/Replication/Config" : "Raven/Replication/Config";
            var url = "/docs?id=" + id; //TODO: use endpoints
            var putArgs = JSON.stringify(this.dto);
            return this.put(url, putArgs, this.db);
        };
        return saveAutomaticConflictResolutionDocumentCommand;
    }(commandBase));
    return saveAutomaticConflictResolutionDocumentCommand;
});

//# sourceMappingURL=saveAutomaticConflictResolutionDocumentCommand.js.map
