var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var saveReplicationDocumentCommand = (function (_super) {
        __extends(saveReplicationDocumentCommand, _super);
        function saveReplicationDocumentCommand(dto, db, globalConfig) {
            if (globalConfig === void 0) { globalConfig = false; }
            var _this = _super.call(this) || this;
            _this.dto = dto;
            _this.db = db;
            _this.globalConfig = globalConfig;
            return _this;
        }
        saveReplicationDocumentCommand.prototype.execute = function () {
            var _this = this;
            this.reportInfo("Saving Replication/ETL settings.");
            return this.saveSetup()
                .done(function () { return _this.reportSuccess("Saved Replication/ETL settings."); })
                .fail(function (response) { return _this.reportError("Failed to save Replication/ETL settings.", response.responseText, response.statusText); });
        };
        saveReplicationDocumentCommand.prototype.saveSetup = function () {
            var id = this.globalConfig ? "Raven/Global/Replication/Destinations" : "Raven/DocumentReplication/Configuration";
            var url = "/docs?id=" + id; //TODO: use endpoints
            var putArgs = JSON.stringify(this.dto);
            return this.put(url, putArgs, this.db);
        };
        return saveReplicationDocumentCommand;
    }(commandBase));
    return saveReplicationDocumentCommand;
});

//# sourceMappingURL=saveReplicationDocumentCommand.js.map
