var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "models/database/sqlReplication/sqlReplication"], function (require, exports, commandBase, sqlReplication) {
    "use strict";
    var getSqlReplicationsCommand = (function (_super) {
        __extends(getSqlReplicationsCommand, _super);
        function getSqlReplicationsCommand(db, sqlReplicationName) {
            if (sqlReplicationName === void 0) { sqlReplicationName = null; }
            var _this = _super.call(this) || this;
            _this.db = db;
            _this.sqlReplicationName = sqlReplicationName;
            return _this;
        }
        getSqlReplicationsCommand.prototype.execute = function () {
            var args = {
                startsWith: "Raven/SqlReplication/Configuration/",
                exclude: null,
                start: 0,
                pageSize: 256
            };
            return this.query("/docs", args, this.db, function (dtos) { return dtos.Results.map(function (dto) { return new sqlReplication(dto); }); }); //TODO: use endpoints
        };
        return getSqlReplicationsCommand;
    }(commandBase));
    return getSqlReplicationsCommand;
});

//# sourceMappingURL=getSqlReplicationsCommand.js.map
