var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "endpoints"], function (require, exports, commandBase, endpoints) {
    "use strict";
    var resetSqlReplicationCommand = (function (_super) {
        __extends(resetSqlReplicationCommand, _super);
        function resetSqlReplicationCommand(db, sqlReplicationName) {
            var _this = _super.call(this) || this;
            _this.db = db;
            _this.sqlReplicationName = sqlReplicationName;
            return _this;
        }
        resetSqlReplicationCommand.prototype.execute = function () {
            var _this = this;
            var args = {
                name: this.sqlReplicationName
            };
            var url = endpoints.databases.sqlReplication.sqlReplicationReset + this.urlEncodeArgs(args);
            return this.post(url, null, this.db, { dataType: undefined })
                .fail(function () { return _this.reportError("SQL replication '" + _this.sqlReplicationName + "' failed to reset!"); });
        };
        return resetSqlReplicationCommand;
    }(commandBase));
    return resetSqlReplicationCommand;
});

//# sourceMappingURL=resetSqlReplicationCommand.js.map
