var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/database/documents/executeBulkDocsCommand"], function (require, exports, executeBulkDocsCommand) {
    "use strict";
    var saveSqlReplicationsCommand = (function (_super) {
        __extends(saveSqlReplicationsCommand, _super);
        function saveSqlReplicationsCommand(onScreenReplications, deletedReplications, db) {
            var _this;
            var bulkPutReplications = onScreenReplications.map(function (sr) { return sr.toBulkDoc("PUT"); });
            var bulkDeleteReplications = deletedReplications.map(function (sr) { return sr.toBulkDoc("DELETE"); });
            _this = _super.call(this, bulkPutReplications.concat(bulkDeleteReplications), db) || this;
            return _this;
        }
        saveSqlReplicationsCommand.prototype.execute = function () {
            var _this = this;
            this.reportInfo("Saving SQL replications...");
            return _super.prototype.execute.call(this)
                .fail(function (result) { return _this.reportError("Unable to save SQL replications.", result.responseText, result.statusText); })
                .done(function () { return _this.reportSuccess("Saved SQL replications."); });
        };
        return saveSqlReplicationsCommand;
    }(executeBulkDocsCommand));
    return saveSqlReplicationsCommand;
});

//# sourceMappingURL=saveSqlReplicationsCommand.js.map
