var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var simulateSqlReplicationCommand = (function (_super) {
        __extends(simulateSqlReplicationCommand, _super);
        function simulateSqlReplicationCommand(db, simulatedSqlReplication, documentId, performRolledbackTransaction) {
            var _this = _super.call(this) || this;
            _this.db = db;
            _this.simulatedSqlReplication = simulatedSqlReplication;
            _this.documentId = documentId;
            _this.performRolledbackTransaction = performRolledbackTransaction;
            return _this;
        }
        simulateSqlReplicationCommand.prototype.execute = function () {
            var args = {
                documentId: this.documentId,
                performRolledBackTransaction: this.performRolledbackTransaction,
                sqlReplication: JSON.stringify(this.simulatedSqlReplication.toDto())
            };
            return this.post("/studio-tasks/simulate-sql-replication", JSON.stringify(args), this.db, { dataType: undefined }, 60000); //TODO: use endpoints
        };
        return simulateSqlReplicationCommand;
    }(commandBase));
    return simulateSqlReplicationCommand;
});

//# sourceMappingURL=simulateSqlReplicationCommand.js.map
