var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var resetSqlReplicationCommand = (function (_super) {
        __extends(resetSqlReplicationCommand, _super);
        function resetSqlReplicationCommand(db, disable) {
            var _this = _super.call(this) || this;
            _this.db = db;
            _this.disable = disable;
            return _this;
        }
        resetSqlReplicationCommand.prototype.execute = function () {
            var _this = this;
            var args = {
                disable: this.disable
            };
            var url = "/studio-tasks/sql-replication-toggle-disable" + _super.prototype.urlEncodeArgs.call(this, args); //TODO: use endpoints
            return this.post(url, null, this.db)
                .fail(function (result) {
                var action = _this.disable ? "disable" : "enable";
                _this.reportError("Failed to " + action + " SQL Replications", result.responseText, result.statusText);
            });
        };
        return resetSqlReplicationCommand;
    }(commandBase));
    return resetSqlReplicationCommand;
});

//# sourceMappingURL=toggleDisable.js.map
