var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "endpoints"], function (require, exports, commandBase, endpoints) {
    "use strict";
    var importDatabaseCommand = (function (_super) {
        __extends(importDatabaseCommand, _super);
        function importDatabaseCommand(db, operationId, token, file, model) {
            var _this = _super.call(this) || this;
            _this.db = db;
            _this.operationId = operationId;
            _this.token = token;
            _this.file = file;
            _this.model = model;
            return _this;
        }
        importDatabaseCommand.prototype.execute = function () {
            var _this = this;
            this.reportInfo("Importing data...");
            var urlArgs = {
                operationId: this.operationId,
                singleUseAuthToken: this.token.Token
            };
            var url = endpoints.databases.smuggler.smugglerImportAsync + this.urlEncodeArgs(urlArgs);
            var ajaxOptions = {
                processData: false,
                contentType: false
            };
            var formData = new FormData();
            var args = this.model.toDto();
            formData.append("importOptions", JSON.stringify(args));
            formData.append("file", this.file);
            return this.post(url, formData, this.db, ajaxOptions, 0)
                .done(function () { return _this.reportInfo("Data was uploaded successfully, processing..."); })
                .fail(function (response) { return _this.reportError("Failed to upload data", response.responseText, response.statusText); });
        };
        return importDatabaseCommand;
    }(commandBase));
    return importDatabaseCommand;
});

//# sourceMappingURL=importDatabaseCommand.js.map
