var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var saveCsvFileCommand = (function (_super) {
        __extends(saveCsvFileCommand, _super);
        function saveCsvFileCommand(fileData, fileName, db) {
            var _this = _super.call(this) || this;
            _this.fileData = fileData;
            _this.fileName = fileName;
            _this.db = db;
            return _this;
        }
        saveCsvFileCommand.prototype.execute = function () {
            var _this = this;
            this.reportInfo("Importing...");
            var customHeaders = {
                'X-FileName': this.fileName
            };
            var jQueryOptions = {
                headers: customHeaders,
                processData: false,
                contentType: false,
                dataType: 'text'
            };
            var saveTask = this.post("/studio-tasks/loadCsvFile", this.fileData, this.db, jQueryOptions); //TODO: use endpoints
            saveTask.done(function () { return _this.reportSuccess("CSV file imported"); });
            saveTask.fail(function (response) { return _this.reportError("Failed to import CSV file", response.responseText, response.statusText); });
            return saveTask;
        };
        return saveCsvFileCommand;
    }(commandBase));
    return saveCsvFileCommand;
});

//# sourceMappingURL=saveCsvFileCommand.js.map
