var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var setSubscriptionAckEtagCommand = (function (_super) {
        __extends(setSubscriptionAckEtagCommand, _super);
        function setSubscriptionAckEtagCommand(db, id, newEtag) {
            var _this = _super.call(this) || this;
            _this.db = db;
            _this.id = id;
            _this.newEtag = newEtag;
            if (!db) {
                throw new Error("Must specify database");
            }
            return _this;
        }
        setSubscriptionAckEtagCommand.prototype.execute = function () {
            var _this = this;
            var args = {
                id: this.id,
                newEtag: this.newEtag
            };
            var url = "/subscriptions/setSubscriptionAckEtag" + this.urlEncodeArgs(args); //TODO: use endpoints
            return this.post(url, null, this.db, { dataType: undefined })
                .done(function () { return _this.reportSuccess("Successfully set acknowledged etag"); })
                .fail(function (response) { return _this.reportError("Failed to set subscription acknowledged etag!", response.responseText, response.statusText); });
        };
        return setSubscriptionAckEtagCommand;
    }(commandBase));
    return setSubscriptionAckEtagCommand;
});

//# sourceMappingURL=setSubscriptionAckEtagCommand.js.map
