var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "endpoints"], function (require, exports, commandBase, endpoints) {
    "use strict";
    var deleteTransformerCommand = (function (_super) {
        __extends(deleteTransformerCommand, _super);
        function deleteTransformerCommand(transformerName, db) {
            var _this = _super.call(this) || this;
            _this.transformerName = transformerName;
            _this.db = db;
            return _this;
        }
        deleteTransformerCommand.prototype.execute = function () {
            var _this = this;
            this.reportInfo("Deleting " + this.transformerName + "...");
            var args = {
                name: this.transformerName
            };
            var url = endpoints.databases.transformer.transformers + this.urlEncodeArgs(args);
            return this.del(url, null, this.db)
                .done(function () { return _this.reportSuccess("Deleted " + _this.transformerName); })
                .fail(function (response) { return _this.reportError("Failed to delete transformer " + _this.transformerName, response.responseText); });
        };
        return deleteTransformerCommand;
    }(commandBase));
    return deleteTransformerCommand;
});

//# sourceMappingURL=deleteTransformerCommand.js.map
