var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "endpoints"], function (require, exports, commandBase, endpoints) {
    "use strict";
    var saveTransformerCommand = (function (_super) {
        __extends(saveTransformerCommand, _super);
        function saveTransformerCommand(transformer, db) {
            var _this = _super.call(this) || this;
            _this.transformer = transformer;
            _this.db = db;
            return _this;
        }
        saveTransformerCommand.prototype.execute = function () {
            var _this = this;
            var args = {
                name: this.transformer.name()
            };
            var url = endpoints.databases.transformer.transformers + this.urlEncodeArgs(args);
            var saveTransformerPutArgs = JSON.stringify(this.transformer.toDto());
            return this.put(url, saveTransformerPutArgs, this.db)
                .done(function () { return _this.reportSuccess("Saved " + _this.transformer.name()); })
                .fail(function (result) { return _this.reportError("Unable to save transformer", result.responseText, result.statusText); });
        };
        return saveTransformerCommand;
    }(commandBase));
    return saveTransformerCommand;
});

//# sourceMappingURL=saveTransformerCommand.js.map
