var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "endpoints"], function (require, exports, commandBase, endpoints) {
    "use strict";
    var saveTransformerLockModeCommand = (function (_super) {
        __extends(saveTransformerLockModeCommand, _super);
        function saveTransformerLockModeCommand(transformers, lockMode, db) {
            var _this = _super.call(this) || this;
            _this.transformers = transformers;
            _this.lockMode = lockMode;
            _this.db = db;
            return _this;
        }
        saveTransformerLockModeCommand.prototype.execute = function () {
            var _this = this;
            var args = {
                mode: this.lockMode,
                name: this.transformers.map(function (x) { return x.name(); })
            };
            var url = endpoints.databases.transformer.transformersSetLock + this.urlEncodeArgs(args);
            return this.post(url, JSON.stringify(args), this.db, { dataType: 'text' })
                .fail(function (response) { return _this.reportError("Failed to set transformer lock mode", response.responseText); });
        };
        return saveTransformerLockModeCommand;
    }(commandBase));
    return saveTransformerLockModeCommand;
});

//# sourceMappingURL=saveTransformerLockModeCommand.js.map
