var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var createFilesystemCommand = (function (_super) {
        __extends(createFilesystemCommand, _super);
        /**
        * @param filesystemName The file system name we are creating.
        */
        function createFilesystemCommand(filesystemName, settings, securedSettings) {
            var _this = _super.call(this) || this;
            _this.filesystemName = filesystemName;
            _this.settings = settings;
            _this.securedSettings = securedSettings;
            if (!filesystemName) {
                _this.reportError("File System must have a name!");
                throw new Error("File System must have a name!");
            }
            return _this;
        }
        createFilesystemCommand.prototype.execute = function () {
            var _this = this;
            this.reportInfo("Creating File System '" + this.filesystemName + "'");
            var filesystemDoc = {
                "Settings": this.settings,
                "SecuredSettings": this.securedSettings,
                "Disabled": false
            };
            var url = "/admin/fs/" + this.filesystemName;
            var createTask = this.put(url, JSON.stringify(filesystemDoc), null, { dataType: undefined });
            createTask.done(function () { return _this.reportSuccess(_this.filesystemName + " created"); });
            createTask.fail(function (response) { return _this.reportError("Failed to create file system", response.responseText, response.statusText); });
            return createTask;
        };
        return createFilesystemCommand;
    }(commandBase));
    return createFilesystemCommand;
});

//# sourceMappingURL=createFilesystemCommand.js.map
