var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var deleteDestinationCommand = (function (_super) {
        __extends(deleteDestinationCommand, _super);
        function deleteDestinationCommand(fs, destination) {
            var _this = _super.call(this) || this;
            _this.fs = fs;
            _this.destination = destination;
            return _this;
        }
        deleteDestinationCommand.prototype.execute = function () {
            var _this = this;
            var result = $.Deferred();
            var serverUrl = this.destination.ServerUrl;
            var fileSystem = this.destination.FileSystem;
            this.query("/config", { name: "Raven/Synchronization/Destinations" }, this.fs)
                .done(function (data) {
                if (data && data.hasOwnProperty('Destinations')) {
                    var destinationsRaw = data['Destinations'];
                    var destinations = (destinationsRaw instanceof Array) ? destinationsRaw : [destinationsRaw];
                    var dtos = destinations.filter(function (x) { return x.ServerUrl !== serverUrl || x.FileSystem !== fileSystem; });
                    data.Destinations = dtos;
                    var url = "/config?name=" + encodeURIComponent("Raven/Synchronization/Destinations");
                    _this.put(url, JSON.stringify(data), _this.fs)
                        .done(function () { return result.resolve(data); })
                        .fail(function (xhr, statusText, error) {
                        _this.reportError("Could not delete destination (server: " + serverUrl + ", filesystem: " + fileSystem + ")", error, statusText);
                    });
                }
            });
            return result;
        };
        return deleteDestinationCommand;
    }(commandBase));
    return deleteDestinationCommand;
});

//# sourceMappingURL=deleteDestinationCommand.js.map
