var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var deleteFilesCommand = (function (_super) {
        __extends(deleteFilesCommand, _super);
        function deleteFilesCommand(fileIds, fs) {
            var _this = _super.call(this) || this;
            _this.fileIds = fileIds;
            _this.fs = fs;
            return _this;
        }
        deleteFilesCommand.prototype.execute = function () {
            var _this = this;
            var deletionTasks = new Array();
            for (var i = 0; i < this.fileIds.length; i++) {
                var deleteCommand = this.deleteFile(this.fileIds[i]);
                deletionTasks.push(deleteCommand);
            }
            var successMessage = this.fileIds.length > 1 ? "Deleted " + this.fileIds.length + " files" : "Deleted " + this.fileIds[0];
            var combinedTask = $.when.apply($, deletionTasks)
                .done(function () { return _this.reportSuccess(successMessage); })
                .fail(function (response) { return _this.reportError("Failed to delete files", response.responseText, response.statusText); });
            return combinedTask;
        };
        deleteFilesCommand.prototype.deleteFile = function (fileId) {
            var url = "/files/" + encodeURIComponent(fileId);
            return this.del(url, null, this.fs, null, 9000 * this.fileIds.length);
        };
        return deleteFilesCommand;
    }(commandBase));
    return deleteFilesCommand;
});

//# sourceMappingURL=deleteFilesCommand.js.map
