var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "commands/operations/getOperationStatusCommand"], function (require, exports, commandBase, getOperationStatusCommand) {
    "use strict";
    var deleteFilesMatchingQueryCommand = (function (_super) {
        __extends(deleteFilesMatchingQueryCommand, _super);
        function deleteFilesMatchingQueryCommand(queryText, fs) {
            var _this = _super.call(this) || this;
            _this.queryText = queryText;
            _this.fs = fs;
            return _this;
        }
        deleteFilesMatchingQueryCommand.prototype.execute = function () {
            var _this = this;
            var deleteTaskWithWait = $.Deferred();
            this.reportInfo("Deleting files matching query...");
            var args = {
                query: this.queryText
            };
            var url = "/search/" + this.urlEncodeArgs(args);
            var task = this.del(url, null, this.fs);
            task.done(function (result) { return _this.waitForOperationToComplete(_this.fs, result.OperationId, deleteTaskWithWait); });
            task.fail(function (response) { return _this.reportError("Error deleting files matching query", response.responseText, response.statusText); });
            return deleteTaskWithWait;
        };
        deleteFilesMatchingQueryCommand.prototype.waitForOperationToComplete = function (fs, operationId, task) {
            new getOperationStatusCommand(fs, operationId)
                .execute();
            //TODO: .done((result: operationStatusDto) => this.deletionStatusRetrieved(fs, operationId, result, task));
        };
        deleteFilesMatchingQueryCommand.prototype.deletionStatusRetrieved = function (fs, operationId, result, task) {
            var _this = this;
            if (result.Completed) {
                if (!result.Faulted && !result.Canceled) {
                    this.reportSuccess("Files deleted");
                    task.resolve();
                }
                else {
                    this.reportError("Error deleting files matching query");
                    task.reject();
                }
            }
            else {
                setTimeout(function () { return _this.waitForOperationToComplete(fs, operationId, task); }, 1000);
            }
        };
        return deleteFilesMatchingQueryCommand;
    }(commandBase));
    return deleteFilesMatchingQueryCommand;
});

//# sourceMappingURL=deleteFilesMatchingQueryCommand.js.map
