var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var getConfigurationByKeyCommand = (function (_super) {
        __extends(getConfigurationByKeyCommand, _super);
        function getConfigurationByKeyCommand(fs, name) {
            var _this = _super.call(this) || this;
            _this.fs = fs;
            _this.name = name;
            return _this;
        }
        getConfigurationByKeyCommand.prototype.execute = function () {
            var _this = this;
            var url = "/config";
            var args = {
                name: this.name
            };
            var task = $.Deferred();
            this.query(url, args, this.fs)
                .done(function (data) {
                var prettifySpacing = 4;
                var configText = JSON.stringify(data, null, prettifySpacing);
                task.resolve(configText);
            })
                .fail(function (response) { return _this.reportError("Failed to retrieve filesystem configuration key. Does exist in this filesystem?", response.responseText, response.statusText); });
            return task;
        };
        return getConfigurationByKeyCommand;
    }(commandBase));
    return getConfigurationByKeyCommand;
});

//# sourceMappingURL=getConfigurationByKeyCommand.js.map
