var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var getConfigurationNamesByPrefixCommand = (function (_super) {
        __extends(getConfigurationNamesByPrefixCommand, _super);
        function getConfigurationNamesByPrefixCommand(fs, prefix) {
            var _this = _super.call(this) || this;
            _this.fs = fs;
            _this.prefix = prefix;
            return _this;
        }
        getConfigurationNamesByPrefixCommand.prototype.execute = function () {
            var _this = this;
            var url = "/config/search";
            var args = {
                prefix: this.prefix
            };
            var task = $.Deferred();
            this.query(url, args, this.fs)
                .done(function (data) {
                task.resolve(data);
            })
                .fail(function (response) { return _this.reportError("Failed to search configuration keys for prefix: " + _this.prefix, response.responseText, response.statusText); });
            return task;
        };
        return getConfigurationNamesByPrefixCommand;
    }(commandBase));
    return getConfigurationNamesByPrefixCommand;
});

//# sourceMappingURL=getConfigurationsByPrefixCommand.js.map
