var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "models/filesystem/file", "models/filesystem/fileMetadata"], function (require, exports, commandBase, file, fileMetadata) {
    "use strict";
    var getFileCommand = (function (_super) {
        __extends(getFileCommand, _super);
        function getFileCommand(fs, name) {
            var _this = _super.call(this) || this;
            _this.fs = fs;
            _this.name = name;
            return _this;
        }
        getFileCommand.prototype.execute = function () {
            var _this = this;
            var url = "/files/" + encodeURIComponent(this.name);
            var resultsSelector = function (metadata) {
                var fileHeaders = new file();
                fileHeaders.id(_this.name);
                for (var property in metadata) {
                    var value = metadata[property];
                    if (value[0] === "{" || value[0] === "[")
                        metadata[property] = JSON.parse(value);
                }
                fileHeaders.__metadata = new fileMetadata(metadata);
                return fileHeaders;
            };
            return this.head(url, null, this.fs, resultsSelector);
        };
        return getFileCommand;
    }(commandBase));
    return getFileCommand;
});

//# sourceMappingURL=getFileCommand.js.map
