var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "models/filesystem/file", "common/pagedResultSet", "common/queryUtil"], function (require, exports, commandBase, file, pagedResultSet, queryUtil) {
    "use strict";
    var getFilesystemFilesCommand = (function (_super) {
        __extends(getFilesystemFilesCommand, _super);
        function getFilesystemFilesCommand(fs, directory, skip, take) {
            var _this = _super.call(this) || this;
            _this.fs = fs;
            _this.directory = directory;
            _this.skip = skip;
            _this.take = take;
            return _this;
        }
        getFilesystemFilesCommand.prototype.execute = function () {
            var filesTask = this.fetchFiles();
            var doneTask = $.Deferred();
            filesTask.done(function (results) {
                var files = results.Files.map(function (d) { return new file(d, true); });
                var totalCount = results.FileCount;
                doneTask.resolve(new pagedResultSet(files, totalCount));
            });
            filesTask.fail(function (xhr) { return doneTask.reject(xhr); });
            return doneTask;
        };
        getFilesystemFilesCommand.prototype.fetchFiles = function () {
            var level = 1;
            if (this.directory) {
                var slashMatches = this.directory.match(/\//g).length;
                if (slashMatches) {
                    level = level + slashMatches;
                }
            }
            var levelQuery = "__level:" + level;
            var args = {
                query: this.directory ? "__directoryName:" + queryUtil.escapeTerm(this.directory) + " AND " + levelQuery : levelQuery,
                start: this.skip,
                pageSize: this.take
            };
            var url = "/search";
            var task = this.query(url, args, this.fs, null);
            return task;
        };
        return getFilesystemFilesCommand;
    }(commandBase));
    return getFilesystemFilesCommand;
});

//# sourceMappingURL=getFilesCommand.js.map
