var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "models/filesystem/conflictItem", "common/pagedResultSet"], function (require, exports, commandBase, conflictItem, pagedResultSet) {
    "use strict";
    var getFilesConflictsCommand = (function (_super) {
        __extends(getFilesConflictsCommand, _super);
        function getFilesConflictsCommand(fs, skip, take) {
            var _this = _super.call(this) || this;
            _this.fs = fs;
            _this.skip = skip;
            _this.take = take;
            return _this;
        }
        getFilesConflictsCommand.prototype.execute = function () {
            var args = {
                start: this.skip,
                pageSize: this.take
            };
            var url = "/synchronization/Conflicts";
            var conflictsTask = $.Deferred();
            this.query(url, args, this.fs).
                fail(function (response) { return conflictsTask.reject(response); }).
                done(function (conflicts) {
                var items = conflicts.Items.map(function (x) { return conflictItem.fromConflictItemDto(x); });
                var resultsSet = new pagedResultSet(items, conflicts.TotalCount);
                conflictsTask.resolve(resultsSet);
            });
            return conflictsTask;
        };
        return getFilesConflictsCommand;
    }(commandBase));
    return getFilesConflictsCommand;
});

//# sourceMappingURL=getFilesConflictsCommand.js.map
