var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "models/filesystem/file", "common/pagedResultSet"], function (require, exports, commandBase, file, pagedResultSet) {
    "use strict";
    var getFilesystemRevisionsCommand = (function (_super) {
        __extends(getFilesystemRevisionsCommand, _super);
        function getFilesystemRevisionsCommand(fs, skip, take) {
            var _this = _super.call(this) || this;
            _this.fs = fs;
            _this.skip = skip;
            _this.take = take;
            return _this;
        }
        getFilesystemRevisionsCommand.prototype.execute = function () {
            var _this = this;
            var filesTask = this.fetchFiles();
            var doneTask = $.Deferred();
            filesTask.done(function (results) {
                var wrappedResult = {
                    Files: results,
                    FileCount: (results.length === _this.take) ? _this.take + _this.skip + 10 : _this.skip + results.length,
                    Start: _this.skip,
                    PageSize: _this.take
                };
                var files = wrappedResult.Files.map(function (d) { return new file(d, false); });
                var totalCount = wrappedResult.FileCount;
                doneTask.resolve(new pagedResultSet(files, totalCount));
            });
            filesTask.fail(function (xhr) { return doneTask.reject(xhr); });
            return doneTask;
        };
        getFilesystemRevisionsCommand.prototype.fetchFiles = function () {
            var args = {
                startsWith: '/',
                matches: '*/revisions/*',
                start: this.skip,
                pageSize: this.take
            };
            var url = "/files";
            var task = this.query(url, args, this.fs, null);
            return task;
        };
        return getFilesystemRevisionsCommand;
    }(commandBase));
    return getFilesystemRevisionsCommand;
});

//# sourceMappingURL=getFilesystemRevisionsCommand.js.map
