var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var getFoldersStatsCommand = (function (_super) {
        __extends(getFoldersStatsCommand, _super);
        function getFoldersStatsCommand(fs, skip, take, directory) {
            var _this = _super.call(this) || this;
            _this.fs = fs;
            _this.skip = skip;
            _this.take = take;
            _this.directory = directory;
            return _this;
        }
        getFoldersStatsCommand.prototype.execute = function () {
            var url = "/folders/Subdirectories";
            var args = {
                start: this.skip,
                pageSize: this.take
            };
            if (this.directory) {
                args.directory = this.directory;
            }
            return this.query(url, args, this.fs, function (result) { return result.map(function (x) {
                return {
                    key: x,
                    title: x.substring(x.lastIndexOf("/") + 1),
                    isLazy: true,
                    isFolder: true
                };
            }); });
        };
        return getFoldersStatsCommand;
    }(commandBase));
    return getFoldersStatsCommand;
});

//# sourceMappingURL=getFoldersCommand.js.map
