var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "models/filesystem/synchronizationDetail"], function (require, exports, commandBase, synchronizationDetail) {
    "use strict";
    var getSyncOutgoingActivitiesCommand = (function (_super) {
        __extends(getSyncOutgoingActivitiesCommand, _super);
        function getSyncOutgoingActivitiesCommand(fs, activity, skip, take) {
            var _this = _super.call(this) || this;
            _this.fs = fs;
            _this.activity = activity;
            _this.skip = skip;
            _this.take = take;
            return _this;
        }
        getSyncOutgoingActivitiesCommand.prototype.execute = function () {
            var _this = this;
            var doneTask = $.Deferred();
            this.getActivities()
                .done(function (list) { return doneTask.resolve(list); })
                .fail(function (xhr) {
                _this.reportError("Failed to get outgoing and " + _this.activity + " synchronization activities.");
                doneTask.reject(xhr);
            });
            return doneTask;
        };
        getSyncOutgoingActivitiesCommand.prototype.getActivities = function () {
            var _this = this;
            var url;
            switch (this.activity) {
                case 1 /* Active */:
                    url = "/synchronization/active";
                    break;
                case 2 /* Pending */:
                    url = "/synchronization/pending";
                    break;
                default:
                    throw new TypeError("Not supported synchronization activity type when attempting to retrieve outgoing activities. Given type: " + this.activity);
            }
            var resultsSelector = function (x) {
                return {
                    TotalCount: x.TotalCount,
                    Items: x.Items.map(function (item) { return new synchronizationDetail(item, 0 /* Outgoing */, _this.activity); })
                };
            };
            return this.query(url, { start: this.skip, pageSize: this.take }, this.fs, resultsSelector, 15000);
        };
        return getSyncOutgoingActivitiesCommand;
    }(commandBase));
    return getSyncOutgoingActivitiesCommand;
});

//# sourceMappingURL=getSyncOutgoingActivitiesCommand.js.map
