var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "models/filesystem/synchronizationConfig"], function (require, exports, commandBase, synchronizationConfig) {
    "use strict";
    var getSynchronizationConfigCommand = (function (_super) {
        __extends(getSynchronizationConfigCommand, _super);
        function getSynchronizationConfigCommand(fs) {
            var _this = _super.call(this) || this;
            _this.fs = fs;
            return _this;
        }
        getSynchronizationConfigCommand.prototype.execute = function () {
            var _this = this;
            var url = "/config";
            var args = {
                name: "Raven/Synchronization/Config"
            };
            var task = $.Deferred();
            this.query(url, args, this.fs)
                .done(function (data) {
                task.resolve(new synchronizationConfig(data));
            })
                .fail(function (response) {
                if (response.status !== 404) {
                    _this.reportError("Failed to retrieve filesystem synchronization config.", response.responseText, response.statusText);
                    task.reject();
                }
                else {
                    task.resolve(synchronizationConfig.empty());
                }
            });
            return task;
        };
        return getSynchronizationConfigCommand;
    }(commandBase));
    return getSynchronizationConfigCommand;
});

//# sourceMappingURL=getSynchronizationConfigCommand.js.map
