var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var importFilesystemCommand = (function (_super) {
        __extends(importFilesystemCommand, _super);
        function importFilesystemCommand(fileData, batchSize, stripReplicationInformation, shouldDisableVersioiningBundle, fs) {
            var _this = _super.call(this) || this;
            _this.fileData = fileData;
            _this.batchSize = batchSize;
            _this.stripReplicationInformation = stripReplicationInformation;
            _this.shouldDisableVersioiningBundle = shouldDisableVersioiningBundle;
            _this.fs = fs;
            return _this;
        }
        importFilesystemCommand.prototype.execute = function () {
            var _this = this;
            this.reportInfo("Importing data...");
            var args = {
                batchSize: this.batchSize,
                stripReplicationInformation: this.stripReplicationInformation,
                shouldDisableVersioningBundle: this.shouldDisableVersioiningBundle
            };
            var url = "/studio-tasks/import" + this.urlEncodeArgs(args);
            var ajaxOptions = {
                processData: false,
                contentType: false
            };
            var importTask = this.post(url, this.fileData, this.fs, ajaxOptions);
            importTask.done(function () { return _this.reportInfo("Data was uploaded successfully, processing..."); });
            importTask.fail(function (response) { return _this.reportError("Failed to upload data", response.responseText, response.statusText); });
            return importTask;
        };
        return importFilesystemCommand;
    }(commandBase));
    return importFilesystemCommand;
});

//# sourceMappingURL=importFilesystemCommand.js.map
