var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var renameFileCommand = (function (_super) {
        __extends(renameFileCommand, _super);
        function renameFileCommand(fs, oldName, newName) {
            var _this = _super.call(this) || this;
            _this.fs = fs;
            _this.oldName = oldName;
            _this.newName = newName;
            return _this;
        }
        renameFileCommand.prototype.execute = function () {
            var _this = this;
            var url = "/files/" + encodeURIComponent(this.oldName) + "?rename=" + encodeURIComponent(this.newName);
            return this.patch(url, null, this.fs)
                .done(function () { return _this.reportSuccess("Successfully renamed file"); })
                .fail(function (response) { return _this.reportError("Unable to rename file name", response.responseText, response.statusText); });
        };
        return renameFileCommand;
    }(commandBase));
    return renameFileCommand;
});

//# sourceMappingURL=renameFileCommand.js.map
