var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var resolveConflictCommand = (function (_super) {
        __extends(resolveConflictCommand, _super);
        function resolveConflictCommand(fileName, strategy, fs, reportResolveProgress) {
            if (reportResolveProgress === void 0) { reportResolveProgress = true; }
            var _this = _super.call(this) || this;
            _this.fileName = fileName;
            _this.strategy = strategy;
            _this.fs = fs;
            _this.reportResolveProgress = reportResolveProgress;
            return _this;
        }
        resolveConflictCommand.prototype.execute = function () {
            var _this = this;
            if (this.reportResolveProgress) {
                this.reportInfo("Resolving conflicts for file " + this.fileName + "...");
            }
            var url = "/synchronization/resolveConflict/" + encodeURIComponent(this.fileName) + "?strategy=" + this.strategy;
            var resolveTask = this.patch(url, null, this.fs);
            if (this.reportResolveProgress) {
                resolveTask.done(function () { return _this.reportSuccess("Resolved conflicts for file " + _this.fileName); });
                resolveTask.fail(function (response) {
                    _this.reportError("Failed to resolve conflicts for file " + _this.fileName, response.responseText, response.statusText);
                });
            }
            return resolveTask;
        };
        return resolveConflictCommand;
    }(commandBase));
    return resolveConflictCommand;
});

//# sourceMappingURL=resolveConflictCommand.js.map
