var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var resolveConflictsCommand = (function (_super) {
        __extends(resolveConflictsCommand, _super);
        function resolveConflictsCommand(strategy, fs, reportResolveProgress) {
            if (reportResolveProgress === void 0) { reportResolveProgress = true; }
            var _this = _super.call(this) || this;
            _this.strategy = strategy;
            _this.fs = fs;
            _this.reportResolveProgress = reportResolveProgress;
            return _this;
        }
        resolveConflictsCommand.prototype.execute = function () {
            var _this = this;
            if (this.reportResolveProgress) {
                this.reportInfo("Resolving conflicts ...");
            }
            var url = "/synchronization/resolveConflicts?strategy=" + this.strategy;
            var resolveTask = this.patch(url, null, this.fs);
            if (this.reportResolveProgress) {
                resolveTask.done(function () { return _this.reportSuccess("Resolved conflicts"); });
                resolveTask.fail(function (response) {
                    _this.reportError("Failed to resolve conflicts", response.responseText, response.statusText);
                });
            }
            return resolveTask;
        };
        return resolveConflictsCommand;
    }(commandBase));
    return resolveConflictsCommand;
});

//# sourceMappingURL=resolveConflictsCommand.js.map
