var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var saveFilesystemConfigurationCommand = (function (_super) {
        __extends(saveFilesystemConfigurationCommand, _super);
        function saveFilesystemConfigurationCommand(fs, key, args) {
            var _this = _super.call(this) || this;
            _this.fs = fs;
            _this.key = key;
            _this.args = args;
            return _this;
        }
        saveFilesystemConfigurationCommand.prototype.execute = function () {
            var _this = this;
            var url = "/config?name=" + encodeURIComponent(this.key.key);
            return this.put(url, JSON.stringify(this.args), this.fs)
                .done(function () { return _this.reportSuccess("Saved configuration"); })
                .fail(function (qXHR, textStatus, errorThrown) { return _this.reportError("Unable to save configuration", errorThrown); });
        };
        return saveFilesystemConfigurationCommand;
    }(commandBase));
    return saveFilesystemConfigurationCommand;
});

//# sourceMappingURL=saveConfigurationCommand.js.map
