var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var saveDestinationCommand = (function (_super) {
        __extends(saveDestinationCommand, _super);
        function saveDestinationCommand(dto, fs) {
            var _this = _super.call(this) || this;
            _this.dto = dto;
            _this.fs = fs;
            return _this;
        }
        saveDestinationCommand.prototype.execute = function () {
            var _this = this;
            this.reportInfo("Saving Replication destinations.");
            return this.saveSetup()
                .done(function () { return _this.reportSuccess("Saved Replication destinations."); })
                .fail(function (response) { return _this.reportError("Failed to save Replication destinations.", response.responseText, response.statusText); });
        };
        saveDestinationCommand.prototype.saveSetup = function () {
            var name = "Raven/Synchronization/Destinations";
            var url = "/config?name=" + encodeURIComponent(name);
            var putArgs = JSON.stringify(this.dto);
            return this.put(url, putArgs, this.fs);
        };
        return saveDestinationCommand;
    }(commandBase));
    return saveDestinationCommand;
});

//# sourceMappingURL=saveDestinationCommand.js.map
