var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "common/pagedResultSet", "models/filesystem/file"], function (require, exports, commandBase, pagedResultSet, file) {
    "use strict";
    var searchByQueryCommand = (function (_super) {
        __extends(searchByQueryCommand, _super);
        function searchByQueryCommand(fs, queryParameter, skip, take) {
            var _this = _super.call(this) || this;
            _this.fs = fs;
            _this.queryParameter = queryParameter;
            _this.skip = skip;
            _this.take = take;
            return _this;
        }
        searchByQueryCommand.prototype.execute = function () {
            var filesTask = this.fetchFiles();
            var doneTask = $.Deferred();
            filesTask.done(function (results) { return doneTask.resolve(new pagedResultSet(results.Files.map(function (d) { return new file(d, false); }), results.FileCount)); });
            filesTask.fail(function (xhr) { return doneTask.reject(xhr); });
            return doneTask;
        };
        searchByQueryCommand.prototype.fetchFiles = function () {
            var args = {
                query: this.queryParameter,
                start: this.skip,
                pageSize: this.take
            };
            var url = "/search";
            return this.query(url, args, this.fs);
        };
        return searchByQueryCommand;
    }(commandBase));
    return searchByQueryCommand;
});

//# sourceMappingURL=searchByQueryCommand.js.map
