var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "commands/database/documents/deleteDocumentCommand", "commands/filesystem/monitorCompactCommand"], function (require, exports, commandBase, deleteDocumentCommand, monitorCompactCommand) {
    "use strict";
    var startCompactCommand = (function (_super) {
        __extends(startCompactCommand, _super);
        function startCompactCommand(fsToCompact, updateCompactStatus) {
            var _this = _super.call(this) || this;
            _this.fsToCompact = fsToCompact;
            _this.updateCompactStatus = updateCompactStatus;
            return _this;
        }
        startCompactCommand.prototype.execute = function () {
            var _this = this;
            var result = $.Deferred();
            new deleteDocumentCommand('Raven/Database/FileSystem/Status/' + this.fsToCompact, null)
                .execute()
                .fail(function (response) {
                _this.reportError("Failed to delete compact status document!", response.responseText, response.statusText);
                result.reject();
            })
                .done(function (_) {
                var url = '/admin/fs/compact' + _this.urlEncodeArgs({ filesystem: _this.fsToCompact });
                _this.post(url, null, null)
                    .fail(function (response) {
                    _this.reportError("Failed to compact filesystem!", response.responseText, response.statusText);
                    _this.logError(response, result);
                })
                    .done(function () { return new monitorCompactCommand(result, _this.fsToCompact, _this.updateCompactStatus).execute(); });
            });
            return result;
        };
        startCompactCommand.prototype.logError = function (response, result) {
            var r = JSON.parse(response.responseText);
            var compactStatus = { Messages: [r.Error], LastProgressMessage: "", State: "Faulted" };
            this.updateCompactStatus(compactStatus);
            result.reject();
        };
        return startCompactCommand;
    }(commandBase));
    return startCompactCommand;
});

//# sourceMappingURL=startCompactCommand.js.map
