var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var updateFileMetadataCommand = (function (_super) {
        __extends(updateFileMetadataCommand, _super);
        function updateFileMetadataCommand(fileName, metadata, fs, reportSaveProgress) {
            if (reportSaveProgress === void 0) { reportSaveProgress = true; }
            var _this = _super.call(this) || this;
            _this.fileName = fileName;
            _this.metadata = metadata;
            _this.fs = fs;
            _this.reportSaveProgress = reportSaveProgress;
            return _this;
        }
        updateFileMetadataCommand.prototype.execute = function () {
            var _this = this;
            if (this.reportSaveProgress) {
                this.reportInfo("Saving " + this.fileName + "...");
            }
            var customHeaders = {};
            //We only want to stringify when the header's value is a json doc.
            for (var key in this.metadata) {
                var value = this.metadata[key];
                if (typeof (value) != "string" && typeof (value) != "number")
                    customHeaders[key] = JSON.stringify(value);
                else {
                    customHeaders[key] = this.metadata[key];
                }
            }
            var jQueryOptions = {
                headers: customHeaders
            };
            var url = "/files/" + encodeURIComponent(this.fileName);
            var updateTask = this.post(url, null, this.fs, jQueryOptions);
            if (this.reportSaveProgress) {
                updateTask.done(function () { return _this.reportSuccess("Saved " + _this.fileName); });
                updateTask.fail(function (response) {
                    _this.reportError("Failed to save " + _this.fileName, response.responseText, response.statusText);
                });
            }
            return updateTask;
        };
        return updateFileMetadataCommand;
    }(commandBase));
    return updateFileMetadataCommand;
});

//# sourceMappingURL=updateFileMetadataCommand.js.map
