var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "commands/database/documents/getDocumentWithMetadataCommand"], function (require, exports, commandBase, getDocumentWithMetadataCommand) {
    "use strict";
    var monitorCompactCommand = (function (_super) {
        __extends(monitorCompactCommand, _super);
        function monitorCompactCommand(parentPromise, dbName, updateCompactStatus) {
            var _this = _super.call(this) || this;
            _this.parentPromise = parentPromise;
            _this.dbName = dbName;
            _this.updateCompactStatus = updateCompactStatus;
            return _this;
        }
        monitorCompactCommand.prototype.execute = function () {
            var _this = this;
            new getDocumentWithMetadataCommand("Raven/Database/Compact/Status/" + this.dbName, null)
                .execute()
                .fail(function (response) {
                setTimeout(function () { return _this.execute(); }, 1000);
            })
                .done(function (compactStatus) {
                _this.updateCompactStatus(compactStatus);
                if (compactStatus.State == "Running") {
                    setTimeout(function () { return _this.execute(); }, 1000);
                }
                else {
                    if (compactStatus.State == "Completed") {
                        _this.reportSuccess("Database was successfully compacted!");
                        _this.parentPromise.resolve();
                    }
                    else {
                        _this.reportError("Database wasn't compacted!");
                        _this.parentPromise.reject();
                    }
                }
            });
            return this.parentPromise;
        };
        return monitorCompactCommand;
    }(commandBase));
    return monitorCompactCommand;
});

//# sourceMappingURL=monitorCompactCommand.js.map
