var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "commands/database/documents/getDocumentWithMetadataCommand"], function (require, exports, commandBase, getDocumentWithMetadataCommand) {
    "use strict";
    var monitorRestoreCommand = (function (_super) {
        __extends(monitorRestoreCommand, _super);
        function monitorRestoreCommand(parentPromise, updateRestoreStatus) {
            var _this = _super.call(this) || this;
            _this.parentPromise = parentPromise;
            _this.updateRestoreStatus = updateRestoreStatus;
            return _this;
        }
        monitorRestoreCommand.prototype.execute = function () {
            var _this = this;
            new getDocumentWithMetadataCommand("Raven/Restore/Status", null)
                .execute()
                .fail(function (response) {
                setTimeout(function () { return _this.execute(); }, 1000);
            })
                .done(function (restoreStatus) {
                _this.updateRestoreStatus(restoreStatus);
                if (restoreStatus.State == "Running") {
                    setTimeout(function () { return _this.execute(); }, 1000);
                }
                else {
                    if (restoreStatus.State == "Completed") {
                        _this.reportSuccess("Database was successfully restored!");
                        _this.parentPromise.resolve();
                    }
                    else {
                        _this.reportError("Database wasn't restored!");
                        _this.parentPromise.reject();
                    }
                }
            });
            return this.parentPromise;
        };
        return monitorRestoreCommand;
    }(commandBase));
    return monitorRestoreCommand;
});

//# sourceMappingURL=monitorRestoreCommand.js.map
