var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var savePeriodicExportSetupCommand = (function (_super) {
        __extends(savePeriodicExportSetupCommand, _super);
        function savePeriodicExportSetupCommand(setupToPersist, db, globalConfig) {
            if (globalConfig === void 0) { globalConfig = false; }
            var _this = _super.call(this) || this;
            _this.setupToPersist = setupToPersist;
            _this.db = db;
            _this.globalConfig = globalConfig;
            return _this;
        }
        savePeriodicExportSetupCommand.prototype.execute = function () {
            var _this = this;
            this.reportInfo("Saving Periodic Export setup.");
            return $.when(this.saveAccountInformation(), this.saveSetup())
                .done(function () { return _this.reportSuccess("Saved Periodic Export setup."); })
                .fail(function (response) { return _this.reportError("Failed to save Periodic Export setup.", response.responseText); });
        };
        savePeriodicExportSetupCommand.prototype.saveAccountInformation = function () {
            var jQueryOptions = {};
            if (this.setupToPersist.getEtag()) {
                jQueryOptions.headers = {
                    'If-None-Match': this.setupToPersist.getEtag()
                };
            }
            var url = this.globalConfig ? "/configuration/global/settings" : "/admin/databases?name=" + this.db.name; //TODO: use endpoints
            var putArgs = JSON.stringify(this.setupToPersist.toDatabaseSettingsDto());
            return this.put(url, putArgs, null, jQueryOptions);
        };
        savePeriodicExportSetupCommand.prototype.saveSetup = function () {
            var url = this.globalConfig ? "/docs?id=Raven/Global/Backup/Periodic/Setup" : "/docs?id=Raven/Backup/Periodic/Setup"; //TODO: use endpoints
            var putArgs = JSON.stringify(this.setupToPersist.toDto());
            return this.put(url, putArgs, this.db);
        };
        return savePeriodicExportSetupCommand;
    }(commandBase));
    return savePeriodicExportSetupCommand;
});

//# sourceMappingURL=savePeriodicExportSetupCommand.js.map
