var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/database/documents/deleteDocumentCommand", "commands/commandBase", "commands/maintenance/monitorRestoreCommand"], function (require, exports, deleteDocumentCommand, commandBase, monitorRestoreCommand) {
    "use strict";
    var startRestoreCommand = (function (_super) {
        __extends(startRestoreCommand, _super);
        function startRestoreCommand(defrag, restoreRequest, updateRestoreStatus) {
            var _this = _super.call(this) || this;
            _this.defrag = defrag;
            _this.restoreRequest = restoreRequest;
            _this.updateRestoreStatus = updateRestoreStatus;
            return _this;
        }
        startRestoreCommand.prototype.execute = function () {
            var _this = this;
            var result = $.Deferred();
            new deleteDocumentCommand('Raven/Restore/Status', null) //TODO: use endpoints
                .execute()
                .fail(function (response) {
                _this.reportError("Failed to delete restore status document!", response.responseText, response.statusText);
                result.reject();
            })
                .done(function (_) {
                _this.post('/admin/restore?defrag=' + _this.defrag, ko.toJSON(_this.restoreRequest), null, { dataType: 'text' }) //TODO: use endpoints
                    .fail(function (response) {
                    _this.reportError("Failed to restore backup!", response.responseText, response.statusText);
                    _this.logError(response, result);
                    result.reject();
                })
                    .done(function () { return new monitorRestoreCommand(result, _this.updateRestoreStatus).execute(); });
            });
            return result;
        };
        startRestoreCommand.prototype.logError = function (response, result) {
            var r = JSON.parse(response.responseText);
            var restoreStatus = { Messages: [r.Error], State: "Faulted" };
            this.updateRestoreStatus(restoreStatus);
            result.reject();
        };
        return startRestoreCommand;
    }(commandBase));
    return startRestoreCommand;
});

//# sourceMappingURL=startRestoreCommand.js.map
