var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var toggleRejectDatabaseClients = (function (_super) {
        __extends(toggleRejectDatabaseClients, _super);
        /**
        * @param names - The array of resource names to toggle
        * @param isSettingDisabled - Status of disabled to set
        * @param resourceType - The resource type
        */
        function toggleRejectDatabaseClients(dbName, rejectClientsEnabled) {
            var _this = _super.call(this) || this;
            _this.dbName = dbName;
            _this.rejectClientsEnabled = rejectClientsEnabled;
            return _this;
        }
        toggleRejectDatabaseClients.prototype.execute = function () {
            var _this = this;
            var action = this.rejectClientsEnabled ? "reject clients mode" : "accept clients mode";
            var args = {
                id: this.dbName,
                isRejectClientsEnabled: this.rejectClientsEnabled
            };
            var url = "/admin/databases-toggle-reject-clients" + this.urlEncodeArgs(args); //TODO: use endpoints
            var toggleTask = this.post(url, null, null, { dataType: undefined });
            toggleTask.done(function () { return _this.reportSuccess("Successfully switched to " + action + " in " + _this.dbName); });
            toggleTask.fail(function (response) { return _this.reportError("Failed switching to " + action + " in " + _this.dbName, response.responseText, response.statusText); });
            return toggleTask;
        };
        return toggleRejectDatabaseClients;
    }(commandBase));
    return toggleRejectDatabaseClients;
});

//# sourceMappingURL=toggleRejectDatabaseClients.js.map
