var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "commands/operations/getOperationStatusCommand"], function (require, exports, commandBase, getOperationStatusCommand) {
    "use strict";
    var performSmugglingCommand = (function (_super) {
        __extends(performSmugglingCommand, _super);
        function performSmugglingCommand(migration, db, updateMigrationStatus) {
            var _this = _super.call(this) || this;
            _this.migration = migration;
            _this.db = db;
            _this.updateMigrationStatus = updateMigrationStatus;
            return _this;
        }
        performSmugglingCommand.prototype.execute = function () {
            var _this = this;
            var result = $.Deferred();
            this.post("/admin/serverSmuggling", JSON.stringify(this.migration), this.db) //TODO: use endpoints
                .fail(function (response) {
                _this.reportError("Failed to perform server migration!", response.responseText, response.statusText);
                result.reject();
            })
                .done(function (operationId) {
                _this.monitorOperation(result, operationId.OperationId);
            });
            return result;
        };
        performSmugglingCommand.prototype.monitorOperation = function (parentPromise, operationId) {
            new getOperationStatusCommand(this.db, operationId)
                .execute();
            /* TODO.done((result: serverSmugglingOperationStateDto) => {
            this.updateMigrationStatus(result);
            if (result.Completed) {
                if (result.Faulted || result.Canceled) {
                    this.reportError("Failed to perform server migration!", result.State.Error);
                    parentPromise.reject();
                } else {
                    this.reportSuccess("Server migration completed");
                    parentPromise.resolve();
                }
            } else {
                setTimeout(() => this.monitorOperation(parentPromise, operationId), 500);
            }
        });*/
        };
        return performSmugglingCommand;
    }(commandBase));
    return performSmugglingCommand;
});

//# sourceMappingURL=performSmugglingCommand.js.map
