var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var createCounterStorageCommand = (function (_super) {
        __extends(createCounterStorageCommand, _super);
        /**
        * @param filesystemName The file system name we are creating.
        */
        function createCounterStorageCommand(counterStorageName, settings) {
            var _this = _super.call(this) || this;
            _this.counterStorageName = counterStorageName;
            _this.settings = settings;
            if (!counterStorageName) {
                _this.reportError("Counter Storage must have a name!");
                throw new Error("Counter Storage must have a name!");
            }
            return _this;
        }
        createCounterStorageCommand.prototype.execute = function () {
            var _this = this;
            this.reportInfo("Creating Counter Storage '" + this.counterStorageName + "'");
            var filesystemDoc = {
                "Settings": this.settings,
                "Disabled": false
            };
            var url = "/admin/cs/" + this.counterStorageName; //TODO: use endpoints
            var createTask = this.put(url, JSON.stringify(filesystemDoc), null, { dataType: undefined });
            createTask.done(function () { return _this.reportSuccess(_this.counterStorageName + " created"); });
            createTask.fail(function (response) { return _this.reportError("Failed to create counter storage", response.responseText, response.statusText); });
            return createTask;
        };
        return createCounterStorageCommand;
    }(commandBase));
    return createCounterStorageCommand;
});

//# sourceMappingURL=createCounterStorageCommand.js.map
