var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "endpoints"], function (require, exports, commandBase, endpoints) {
    "use strict";
    var createDatabaseCommand = (function (_super) {
        __extends(createDatabaseCommand, _super);
        function createDatabaseCommand(databaseDocument) {
            var _this = _super.call(this) || this;
            _this.databaseDocument = databaseDocument;
            return _this;
        }
        createDatabaseCommand.prototype.execute = function () {
            var _this = this;
            var args = {
                name: this.databaseDocument.Id
            };
            var url = endpoints.global.adminDatabases.adminDatabases + this.urlEncodeArgs(args);
            return this.put(url, JSON.stringify(this.databaseDocument), null, { dataType: undefined })
                .done(function () { return _this.reportSuccess(_this.databaseDocument.Id + " created"); })
                .fail(function (response) { return _this.reportError("Failed to create database", response.responseText, response.statusText); });
        };
        return createDatabaseCommand;
    }(commandBase));
    return createDatabaseCommand;
});

//# sourceMappingURL=createDatabaseCommand.js.map
