var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var createTimeSeriesCommand = (function (_super) {
        __extends(createTimeSeriesCommand, _super);
        /**
        * @param timeSeriesName The file system name we are creating.
        */
        function createTimeSeriesCommand(timeSeriesName, settings) {
            var _this = _super.call(this) || this;
            _this.timeSeriesName = timeSeriesName;
            _this.settings = settings;
            if (!timeSeriesName) {
                _this.reportError("Time series must have a name!");
                throw new Error("Time series must have a name!");
            }
            return _this;
        }
        createTimeSeriesCommand.prototype.execute = function () {
            var _this = this;
            this.reportInfo("Creating Time Series '" + this.timeSeriesName + "'");
            var timeSeriesDoc = {
                "Settings": this.settings,
                "Disabled": false
            };
            var url = "/admin/ts/" + this.timeSeriesName; //TODO: use endpoints
            var createTask = this.put(url, JSON.stringify(timeSeriesDoc), null, { dataType: undefined });
            createTask.done(function () { return _this.reportSuccess(_this.timeSeriesName + " created"); });
            createTask.fail(function (response) { return _this.reportError("Failed to create time series", response.responseText, response.statusText); });
            return createTask;
        };
        return createTimeSeriesCommand;
    }(commandBase));
    return createTimeSeriesCommand;
});

//# sourceMappingURL=createTimeSeriesCommand.js.map
