var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "models/resources/database", "endpoints"], function (require, exports, commandBase, database, endpoints) {
    "use strict";
    var deleteResourceCommand = (function (_super) {
        __extends(deleteResourceCommand, _super);
        function deleteResourceCommand(resources, isHardDelete) {
            var _this = _super.call(this) || this;
            _this.resources = resources;
            _this.isHardDelete = isHardDelete;
            return _this;
        }
        deleteResourceCommand.prototype.execute = function () {
            var _this = this;
            var singleResource = this.resources.length === 1;
            this.reportInfo(singleResource ? "Deleting " + _.first(this.resources).name + "..." : "Deleting " + this.resources.length + " resources");
            var resourcesByQualifier = _.groupBy(this.resources, function (x) { return x.qualifier; });
            var tasks = Object.keys(resourcesByQualifier).map(function (qualifier) {
                var resourceGroup = resourcesByQualifier[qualifier];
                var url = _this.getDeleteEndpointUrlForQualifier(qualifier);
                var args = {
                    "hard-delete": _this.isHardDelete,
                    name: resourceGroup.map(function (x) { return x.name; })
                };
                return Promise.resolve(_this.del(url + _this.urlEncodeArgs(args), null, null, 9000 * _this.resources.length));
            });
            var result = $.Deferred();
            Promise.all(tasks)
                .then(function (results) {
                //TODO: display successful message
                //TODO: check if all resources was deleted! - display dialog with deletion summary in case of failure? 
                result.resolve(_this.resources);
            })
                .catch(function (response) {
                _this.reportError("Failed to delete resources", response.responseText, response.statusText);
                result.reject(response);
            });
            return result;
        };
        deleteResourceCommand.prototype.getDeleteEndpointUrlForQualifier = function (qualifier) {
            if (qualifier === database.qualifier) {
                return endpoints.global.adminDatabases.adminDatabases;
            }
            throw new Error("qualifer is not yet supported" + qualifier);
        };
        return deleteResourceCommand;
    }(commandBase));
    return deleteResourceCommand;
});

//# sourceMappingURL=deleteResourceCommand.js.map
