var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "models/database/documents/document"], function (require, exports, commandBase, document) {
    "use strict";
    var getDatabaseSettingsCommand = (function (_super) {
        __extends(getDatabaseSettingsCommand, _super);
        function getDatabaseSettingsCommand(db, reportRefreshProgress) {
            if (reportRefreshProgress === void 0) { reportRefreshProgress = false; }
            var _this = _super.call(this) || this;
            _this.db = db;
            _this.reportRefreshProgress = reportRefreshProgress;
            if (!db) {
                throw new Error("Must specify database");
            }
            return _this;
        }
        getDatabaseSettingsCommand.prototype.execute = function () {
            var _this = this;
            if (this.reportRefreshProgress) {
                this.reportInfo("Fetching Database Settings for '" + this.db.name + "'");
            }
            var resultsSelector = function (queryResult) { return new document(queryResult); };
            var url = "/admin/databases?name=" + this.db.name; //TODO: use endpoints
            var getTask = this.query(url, null, null, resultsSelector);
            if (this.reportRefreshProgress) {
                getTask.done(function () { return _this.reportSuccess("Database Settings of '" + _this.db.name + "' were successfully refreshed!"); });
                getTask.fail(function (response) { return _this.reportError("Failed to refresh Database Settings!", response.responseText, response.statusText); });
            }
            return getTask;
        };
        return getDatabaseSettingsCommand;
    }(commandBase));
    return getDatabaseSettingsCommand;
});

//# sourceMappingURL=getDatabaseSettingsCommand.js.map
