var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "common/appUrl", "endpoints"], function (require, exports, commandBase, appUrl, endpoints) {
    "use strict";
    var getDatabaseStatsCommand = (function (_super) {
        __extends(getDatabaseStatsCommand, _super);
        function getDatabaseStatsCommand(db, longWait) {
            if (longWait === void 0) { longWait = false; }
            var _this = _super.call(this) || this;
            _this.db = db;
            _this.longWait = longWait;
            return _this;
        }
        getDatabaseStatsCommand.prototype.execute = function () {
            var url = this.getQueryUrlFragment();
            return this.query(url, null, this.db, null, this.getTimeToAlert(this.longWait));
        };
        getDatabaseStatsCommand.prototype.getQueryUrl = function () {
            return appUrl.forResourceQuery(this.db) + this.getQueryUrlFragment();
        };
        getDatabaseStatsCommand.prototype.getQueryUrlFragment = function () {
            return endpoints.databases.stats.stats;
        };
        return getDatabaseStatsCommand;
    }(commandBase));
    return getDatabaseStatsCommand;
});

//# sourceMappingURL=getDatabaseStatsCommand.js.map
