var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var saveDatabaseSettingsCommand = (function (_super) {
        __extends(saveDatabaseSettingsCommand, _super);
        function saveDatabaseSettingsCommand(db, document) {
            var _this = _super.call(this) || this;
            _this.db = db;
            _this.document = document;
            if (!db) {
                throw new Error("Must specify database");
            }
            return _this;
        }
        saveDatabaseSettingsCommand.prototype.execute = function () {
            var _this = this;
            this.reportInfo("Saving Database Settings for '" + this.db.name + "'...");
            var jQueryOptions = {
                headers: {
                    'ETag': this.document.__metadata.etag(),
                    'Raven-Temp-Allow-Bundles-Change': this.document.__metadata['Raven-Temp-Allow-Bundles-Change']
                }
            };
            var args = JSON.stringify(this.document.toDto());
            var url = "/admin/databases?name=" + this.db.name; //TODO: use endpoints
            var saveTask = this.put(url, args, null, jQueryOptions);
            saveTask.done(function () { return _this.reportSuccess("Database Settings of '" + _this.db.name + "' were successfully saved!"); });
            saveTask.fail(function (response) { return _this.reportError("Failed to save Database Settings!", response.responseText, response.statusText); });
            return saveTask;
        };
        return saveDatabaseSettingsCommand;
    }(commandBase));
    return saveDatabaseSettingsCommand;
});

//# sourceMappingURL=saveDatabaseSettingsCommand.js.map
