var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var deleteKeyCommand = (function (_super) {
        __extends(deleteKeyCommand, _super);
        function deleteKeyCommand(type, key, ts) {
            var _this = _super.call(this) || this;
            _this.type = type;
            _this.key = key;
            _this.ts = ts;
            return _this;
        }
        deleteKeyCommand.prototype.execute = function () {
            var _this = this;
            var args = {
                key: this.key
            };
            var url = "/delete-key/" + this.type + this.urlEncodeArgs(args);
            return this.del(url, null, this.ts, { dataType: undefined })
                .done(function (numOfDeletedPoints) { return _this.reportSuccess("Successfully deleted '" + _this.key + "' key, with " + numOfDeletedPoints + " points"); })
                .fail(function (response) { return _this.reportError("Failed to delete '" + _this.key + "' key", response.responseText, response.statusText); });
        };
        return deleteKeyCommand;
    }(commandBase));
    return deleteKeyCommand;
});

//# sourceMappingURL=deleteKeyCommand.js.map
