var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var deletePointsCommand = (function (_super) {
        __extends(deletePointsCommand, _super);
        function deletePointsCommand(points, ts) {
            var _this = _super.call(this) || this;
            _this.points = points;
            _this.ts = ts;
            return _this;
        }
        deletePointsCommand.prototype.execute = function () {
            var _this = this;
            var successMessage = this.points.length > 1 ? this.points.length + " points deleted" : "Point deleted";
            var task = this.del("/delete-points", JSON.stringify(this.points), this.ts, null, 9000 * this.points.length)
                .done(function (x) { return _this.reportSuccess(successMessage); })
                .fail(function (response) { return _this.reportError("Failed to delete points", response.responseText, response.statusText); });
            return task;
        };
        return deletePointsCommand;
    }(commandBase));
    return deletePointsCommand;
});

//# sourceMappingURL=deletePointsCommand.js.map
