var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var deleteTypesCommand = (function (_super) {
        __extends(deleteTypesCommand, _super);
        function deleteTypesCommand(types, ts) {
            var _this = _super.call(this) || this;
            _this.types = types;
            _this.ts = ts;
            return _this;
        }
        deleteTypesCommand.prototype.execute = function () {
            var _this = this;
            var deletionTasks = new Array();
            ;
            for (var i = 0; i < this.types.length; i++) {
                var deleteCommand = this.deleteType(this.types[i]);
                deletionTasks.push(deleteCommand);
            }
            var successMessage = this.types.length > 1 ? "Deleted " + this.types.length + " types" : "Deleted " + this.types[0];
            var combinedTask = $.when.apply($, deletionTasks)
                .done(function () { return _this.reportSuccess(successMessage); })
                .fail(function (response) { return _this.reportError("Failed to delete type", response.responseText, response.statusText); });
            return combinedTask;
        };
        deleteTypesCommand.prototype.deleteType = function (type) {
            var url = "/types/" + encodeURIComponent(type);
            return this.del(url, null, this.ts, { dataType: undefined }, 9000 * this.types.length);
        };
        return deleteTypesCommand;
    }(commandBase));
    return deleteTypesCommand;
});

//# sourceMappingURL=deleteTypesCommand.js.map
