var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "models/timeSeries/timeSeriesKey", "common/pagedResultSet"], function (require, exports, commandBase, timeSeriesKey, pagedResultSet) {
    "use strict";
    var getKeysCommand = (function (_super) {
        __extends(getKeysCommand, _super);
        function getKeysCommand(ts, skip, take, type, keysCount) {
            var _this = _super.call(this) || this;
            _this.ts = ts;
            _this.skip = skip;
            _this.take = take;
            _this.type = type;
            _this.keysCount = keysCount;
            return _this;
        }
        getKeysCommand.prototype.execute = function () {
            var _this = this;
            var doneTask = $.Deferred();
            var selector = function (keys) { return keys.map(function (key) { return new timeSeriesKey(key, _this.ts); }); };
            var task = this.query("/keys/" + this.type, {
                skip: this.skip,
                take: this.take
            }, this.ts, selector);
            task.done(function (keys) { return doneTask.resolve(new pagedResultSet(keys, _this.keysCount)); });
            task.fail(function (xhr) { return doneTask.reject(xhr); });
            return doneTask;
        };
        return getKeysCommand;
    }(commandBase));
    return getKeysCommand;
});

//# sourceMappingURL=getKeysCommand.js.map
