var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase", "models/timeSeries/timeSeriesPoint"], function (require, exports, commandBase, timeSeriesPoint) {
    "use strict";
    var getPointsCommand = (function (_super) {
        __extends(getPointsCommand, _super);
        /**
        * @param skip - number of entries to skip
        * @param take - number of entries to take
        */
        function getPointsCommand(ts, skip, take, type, fields, key, start, end) {
            var _this = _super.call(this) || this;
            _this.ts = ts;
            _this.skip = skip;
            _this.take = take;
            _this.type = type;
            _this.fields = fields;
            _this.key = key;
            _this.start = start;
            _this.end = end;
            return _this;
        }
        getPointsCommand.prototype.execute = function () {
            var _this = this;
            var url = "/points/" + this.type + "?key=" + this.key;
            var selector = function (dtos) { return dtos.map(function (d) { return new timeSeriesPoint(_this.type, _this.fields, _this.key, d.At, d.Values); }); };
            var args = {
                skip: this.skip,
                take: this.take,
                start: this.start,
                end: this.end
            };
            return this.query(url, args, this.ts, selector);
        };
        return getPointsCommand;
    }(commandBase));
    return getPointsCommand;
});

//# sourceMappingURL=getPointsCommand.js.map
