var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/commandBase"], function (require, exports, commandBase) {
    "use strict";
    var putTypeCommand = (function (_super) {
        __extends(putTypeCommand, _super);
        function putTypeCommand(type, fields, ts) {
            var _this = _super.call(this) || this;
            _this.type = type;
            _this.fields = fields;
            _this.ts = ts;
            return _this;
        }
        putTypeCommand.prototype.execute = function () {
            var _this = this;
            var url = "/types/" + this.type;
            var dto = { Type: this.type, Fields: this.fields, KeysCount: 0 };
            return this.put(url, JSON.stringify(dto), this.ts, { dataType: undefined })
                .done(function () { return _this.reportSuccess("Type saved"); })
                .fail(function (response) {
                _this.reportError("Failed to save type", response.responseText, response.statusText);
            });
        };
        return putTypeCommand;
    }(commandBase));
    return putTypeCommand;
});

//# sourceMappingURL=putTypeCommand.js.map
