define(["require", "exports"], function (require, exports) {
    "use strict";
    /**
     * This is helper class to build boostrap multiselect with support for custom awesome checkboxes
     *
     * https://github.com/davidstutz/bootstrap-multiselect/issues/576
     */
    var awesomeMultiselect = (function () {
        function awesomeMultiselect() {
        }
        /**
         * Build dropdown
         * @param object
         */
        awesomeMultiselect.build = function (object) {
            object.multiselect({
                templates: {
                    li: '<li><div class="checkbox"><label></label></div></li>'
                }
            });
            if (object.data('instanceData')) {
                throw new Error("Object was already initialized. Use rebuild instead.");
            }
            object.data('instanceData', awesomeMultiselect.instanceNumber);
            awesomeMultiselect.instanceNumber++;
            awesomeMultiselect.fixAwesomeCheckboxes(object);
        };
        /**
         * Update multiselect
         * @param object
         */
        awesomeMultiselect.rebuild = function (object) {
            if (!object.data('instanceData')) {
                throw new Error("Please intialize multiselect using awesomeMultiselect.build before calling rebuild");
            }
            object.multiselect('rebuild');
            awesomeMultiselect.fixAwesomeCheckboxes(object);
        };
        awesomeMultiselect.fixAwesomeCheckboxes = function (object) {
            var instanceId = object.data('instanceData');
            $('.multiselect-container .checkbox', object.parent()).each(function (index) {
                var $self = $(this);
                var id = 'multiselect-' + instanceId + "-" + index;
                var $input = $self.find('input');
                var $label = $self.find('label');
                // check if DOM was already modified
                if (!$label.attr('for')) {
                    $input.detach();
                    $input.prependTo($self);
                    $self.click(function (e) { return e.stopPropagation(); });
                }
                $label.attr('for', id);
                $input.attr('id', id);
            });
        };
        return awesomeMultiselect;
    }());
    // used for generating unique label/ids
    awesomeMultiselect.instanceNumber = 1;
    return awesomeMultiselect;
});

//# sourceMappingURL=awesomeMultiselect.js.map
