define(["require", "exports", "durandal/composition", "viewmodels/viewModelBase"], function (require, exports, composition, viewModelBase) {
    "use strict";
    var helpBindingHandler = (function () {
        function helpBindingHandler() {
        }
        helpBindingHandler.install = function () {
            if (!ko.bindingHandlers["help"]) {
                ko.bindingHandlers["help"] = new helpBindingHandler();
                // This tells Durandal to fire this binding handler only after composition 
                // is complete and attached to the DOM.
                // This is required so that we know the correct height for the element.
                // See http://durandaljs.com/documentation/Interacting-with-the-DOM/
                composition.addBindingHandler("help");
            }
        };
        // Called by Knockout a single time when the binding handler is setup.
        helpBindingHandler.prototype.init = function (element, valueAccessor, allBindings, viewModel, bindingContext) {
            this.link = $('<a class="help_link"><i class="fa fa-question-circle"></i></a>').attr("target", "_blank");
            $(element).append(this.link);
        };
        helpBindingHandler.prototype.update = function (element, valueAccessor, allBindingsAccessor, viewModel, bindingContext) {
            var value = valueAccessor();
            var hashUnwrapped = ko.unwrap(value.hash);
            var version = viewModelBase.clientVersion();
            var titleUnwrapped = ko.unwrap(value.title);
            var href = "http://ravendb.net/l/" + hashUnwrapped + "/" + version + "/";
            this.link.attr("href", href);
            this.link.attr("title", titleUnwrapped);
        };
        return helpBindingHandler;
    }());
    return helpBindingHandler;
});

//# sourceMappingURL=helpBindingHandler.js.map
