/// <reference path="../../typings/tsd.d.ts" />
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "common/changeSubscription", "common/changesCallback", "common/constants/events", "common/abstractWebSocketClient"], function (require, exports, changeSubscription, changesCallback, EVENTS, abstractWebSocketClient) {
    "use strict";
    var changesApi = (function (_super) {
        __extends(changesApi, _super);
        function changesApi(rs) {
            var _this = _super.call(this, rs) || this;
            _this.serverStartTime = ko.observable();
            //TODO: private allReplicationConflicts = ko.observableArray<changesCallback<replicationConflictNotificationDto>>();
            _this.allDocsHandlers = ko.observableArray();
            _this.allIndexesHandlers = ko.observableArray();
            _this.allTransformersHandlers = ko.observableArray();
            //TODO: private allBulkInsertsHandlers = ko.observableArray<changesCallback<bulkInsertChangeNotificationDto>>();
            _this.allOperationsHandlers = ko.observableArray();
            _this.allAlertsHandlers = ko.observableArray();
            _this.watchedDocuments = new Map();
            _this.watchedPrefixes = new Map();
            _this.watchedOperations = new Map();
            _this.watchedIndexes = new Map();
            return _this;
        }
        /* TODO:
        private allFsSyncHandlers = ko.observableArray<changesCallback<synchronizationUpdateNotification>>();
        private allFsConflictsHandlers = ko.observableArray<changesCallback<synchronizationConflictNotification>>();
        private allFsConfigHandlers = ko.observableArray<changesCallback<filesystemConfigNotification>>();
        private allFsDestinationsHandlers = ko.observableArray<changesCallback<filesystemConfigNotification>>();
        private watchedFolders: dictionary<KnockoutObservableArray<changesCallback<fileChangeNotification>>> = {};
    
        private allCountersHandlers = ko.observableArray<changesCallback<counterChangeNotification>>();
        private watchedCounter: dictionary<KnockoutObservableArray<changesCallback<counterChangeNotification>>> = {};
        private watchedCountersInGroup: dictionary<KnockoutObservableArray<changesCallback<countersInGroupNotification>>> = {};
        private allCounterBulkOperationsHandlers = ko.observableArray<changesCallback<counterBulkOperationNotificationDto>>();
    
        private allTimeSeriesHandlers = ko.observableArray<changesCallback<timeSeriesKeyChangeNotification>>();
        private watchedTimeSeries: dictionary<KnockoutObservableArray<changesCallback<timeSeriesKeyChangeNotification>>> = {};
        private allTimeSeriesBulkOperationsHandlers = ko.observableArray<changesCallback<timeSeriesBulkOperationNotificationDto>>();*/
        changesApi.prototype.onServerStartTimeReceived = function (startTime) {
            this.serverStartTime(startTime);
        };
        Object.defineProperty(changesApi.prototype, "connectionDescription", {
            get: function () {
                return this.rs.fullTypeName + " = " + this.rs.name;
            },
            enumerable: true,
            configurable: true
        });
        changesApi.prototype.webSocketUrlFactory = function (token) {
            var connectionString = "singleUseAuthToken=" + token.Token + "&sendServerStartTime=true&throttleConnection=true";
            return "/changes?" + connectionString;
        };
        changesApi.prototype.onError = function (e) {
            _super.prototype.onError.call(this, e);
            this.serverStartTime(null);
        };
        changesApi.prototype.onClose = function (e) {
            _super.prototype.onClose.call(this, e);
            this.serverStartTime(null);
        };
        changesApi.prototype.onMessage = function (e) {
            var _this = this;
            if (!e.data.trim()) {
                // it is heartbeat only
                return;
            }
            var eventDto = JSON.parse(e.data);
            var eventType = eventDto.Type;
            var value = eventDto.Value;
            switch (eventType) {
                case "ServerStartTimeNotification":
                    this.onServerStartTimeReceived(value);
                    this.connectToWebSocketTask.resolve();
                    ko.postbox.publish(EVENTS.ChangesApi.Reconnected, this.rs);
                    break;
                case "DocumentChangeNotification":
                    this.fireEvents(this.allDocsHandlers(), value, function () { return true; });
                    this.watchedDocuments.forEach(function (callbacks, key) {
                        _this.fireEvents(callbacks(), value, function (event) { return event.Key != null && event.Key === key; });
                    });
                    this.watchedPrefixes.forEach(function (callbacks, key) {
                        _this.fireEvents(callbacks(), value, function (event) { return event.Key != null && event.Key.startsWith(key); });
                    });
                    break;
                case "IndexChangeNotification":
                    this.fireEvents(this.allIndexesHandlers(), value, function () { return true; });
                    this.watchedIndexes.forEach(function (callbacks, key) {
                        _this.fireEvents(callbacks(), value, function (event) { return event.Name != null && event.Name === key; });
                    });
                    break;
                case "TransformerChangeNotification":
                    this.fireEvents(this.allTransformersHandlers(), value, function () { return true; });
                    break;
                /* TODO: case "BulkInsertChangeNotification":
                    this.fireEvents(this.allBulkInsertsHandlers(), value, () => true);
                    break; */
                case "OperationStatusChangeNotification":
                    this.fireEvents(this.allOperationsHandlers(), value, function () { return true; });
                    this.watchedOperations.forEach(function (callbacks, key) {
                        return _this.fireEvents(callbacks(), value, function (event) { return event.OperationId === key; });
                    });
                    break;
                default:
                    console.log("Unhandled Changes API notification type: " + eventType);
            }
            /* TODO:} else if (eventType === "SynchronizationUpdateNotification") {
                this.fireEvents<typeHere>(this.allFsSyncHandlers(), value, () => true);
            } else if (eventType === "ReplicationConflictNotification") {
                this.fireEvents<typeHere>(this.allReplicationConflicts(), value, () => true);
            } else if (eventType === "ConflictNotification") {
                this.fireEvents<typeHere>(this.allFsConflictsHandlers(), value, () => true);
            } else if (eventType === "FileChangeNotification") {
                for (var key in this.watchedFolders) {
                    var folderCallbacks = this.watchedFolders[key];
                    this.fireEvents<typeHere>(folderCallbacks(), value, (event) => {
                        var notifiedFolder = folder.getFolderFromFilePath(event.File);
                        var match: string[] = null;
                        if (notifiedFolder && notifiedFolder.path) {
                            match = notifiedFolder.path.match(key);
                        }
                        return match && match.length > 0;
                    });
                }
            } else if (eventType === "ConfigurationChangeNotification") {
                if (value.Name.indexOf("Raven/Synchronization/Destinations") >= 0) {
                    this.fireEvents<typeHere>(this.allFsDestinationsHandlers(), value, () => true);
                }
                this.fireEvents<typeHere>(this.allFsConfigHandlers(), value, () => true);
            } else if (eventType === "ChangeNotification") {
                this.fireEvents<typeHere>(this.allCountersHandlers(), value, () => true);
                //TODO: send events to other subscriptions
            } else if (eventType === "KeyChangeNotification") {
                this.fireEvents<typeHere>(this.allTimeSeriesHandlers(), value, () => true);
                //TODO: send events to other subscriptions*/
        };
        changesApi.prototype.watchAllIndexes = function (onChange) {
            var _this = this;
            var callback = new changesCallback(onChange);
            if (this.allIndexesHandlers().length === 0) {
                this.send("watch-indexes");
            }
            this.allIndexesHandlers.push(callback);
            return new changeSubscription(function () {
                _this.allIndexesHandlers.remove(callback);
                if (_this.allIndexesHandlers().length === 0) {
                    _this.send("unwatch-indexes");
                }
            });
        };
        changesApi.prototype.watchIndex = function (indexName, onChange) {
            var _this = this;
            var callback = new changesCallback(onChange);
            if (!this.watchedIndexes.has(indexName)) {
                this.send("watch-index", indexName);
                this.watchedIndexes.set(indexName, ko.observableArray());
            }
            var callbacks = this.watchedIndexes.get(indexName);
            callbacks.push(callback);
            return new changeSubscription(function () {
                callbacks.remove(callback);
                if (callbacks().length === 0) {
                    _this.watchedIndexes.delete(indexName);
                    _this.send("unwatch-index", indexName);
                }
            });
        };
        changesApi.prototype.watchAllTransformers = function (onChange) {
            var _this = this;
            var callback = new changesCallback(onChange);
            if (this.allTransformersHandlers().length === 0) {
                this.send("watch-transformers");
            }
            this.allTransformersHandlers.push(callback);
            return new changeSubscription(function () {
                _this.allTransformersHandlers.remove(callback);
                if (_this.allTransformersHandlers().length === 0) {
                    _this.send("unwatch-transformers");
                }
            });
        };
        /*TODO:
        watchAllReplicationConflicts(onChange: (e: replicationConflictNotificationDto) => void) {
            var callback = new changesCallback<replicationConflictNotificationDto>(onChange);
            if (this.allReplicationConflicts().length === 0) {
                this.send("watch-replication-conflicts");
            }
            this.allReplicationConflicts.push(callback);
            return new changeSubscription(() => {
                this.allReplicationConflicts.remove(callback);
                if (this.allReplicationConflicts().length === 0) {
                    this.send("unwatch-replication-conflicts");
                }
            });
        }*/
        changesApi.prototype.watchAllDocs = function (onChange) {
            var _this = this;
            var callback = new changesCallback(onChange);
            if (this.allDocsHandlers().length === 0) {
                this.send("watch-docs");
            }
            this.allDocsHandlers.push(callback);
            return new changeSubscription(function () {
                _this.allDocsHandlers.remove(callback);
                if (_this.allDocsHandlers().length === 0) {
                    _this.send("unwatch-docs");
                }
            });
        };
        changesApi.prototype.watchDocument = function (docId, onChange) {
            var _this = this;
            var callback = new changesCallback(onChange);
            if (!this.watchedDocuments.has(docId)) {
                this.send("watch-doc", docId);
                this.watchedDocuments.set(docId, ko.observableArray());
            }
            var callbacks = this.watchedDocuments.get(docId);
            callbacks.push(callback);
            return new changeSubscription(function () {
                callbacks.remove(callback);
                if (callbacks().length === 0) {
                    _this.watchedDocuments.delete(docId);
                    _this.send("unwatch-doc", docId);
                }
            });
        };
        changesApi.prototype.watchDocsStartingWith = function (docIdPrefix, onChange) {
            var _this = this;
            var callback = new changesCallback(onChange);
            if (!this.watchedPrefixes.has(docIdPrefix)) {
                this.send("watch-prefix", docIdPrefix);
                this.watchedPrefixes.set(docIdPrefix, ko.observableArray());
            }
            var callbacks = this.watchedPrefixes.get(docIdPrefix);
            callbacks.push(callback);
            return new changeSubscription(function () {
                callbacks.remove(callback);
                if (callbacks().length === 0) {
                    _this.watchedPrefixes.delete(docIdPrefix);
                    _this.send("unwatch-prefix", docIdPrefix);
                }
            });
        };
        changesApi.prototype.watchOperation = function (operationId, onChange) {
            var _this = this;
            var callback = new changesCallback(onChange);
            if (!this.watchedOperations.has(operationId)) {
                this.send("watch-operation", operationId.toString());
                this.watchedOperations.set(operationId, ko.observableArray());
            }
            var callbacks = this.watchedOperations.get(operationId);
            callbacks.push(callback);
            return new changeSubscription(function () {
                callbacks.remove(callback);
                if (callbacks().length === 0) {
                    _this.watchedOperations.delete(operationId);
                    _this.send("unwatch-operation", operationId.toString());
                }
            });
        };
        changesApi.prototype.watchOperations = function (onChange) {
            var _this = this;
            var callback = new changesCallback(onChange);
            if (this.allOperationsHandlers().length === 0) {
                this.send("watch-operations");
            }
            this.allOperationsHandlers.push(callback);
            return new changeSubscription(function () {
                _this.allOperationsHandlers.remove(callback);
                if (_this.allOperationsHandlers().length === 0) {
                    _this.send("unwatch-operations");
                }
            });
        };
        changesApi.prototype.watchAlerts = function (onChange) {
            var _this = this;
            var callback = new changesCallback(onChange);
            if (this.allAlertsHandlers().length === 0) {
                this.send("watch-alerts");
            }
            this.allAlertsHandlers.push(callback);
            return new changeSubscription(function () {
                _this.allAlertsHandlers.remove(callback);
                if (_this.allAlertsHandlers().length === 0) {
                    _this.send("unwatch-alerts");
                }
            });
        };
        return changesApi;
    }(abstractWebSocketClient));
    return changesApi;
});

//# sourceMappingURL=changesApi.js.map
