/// <reference path="../../typings/tsd.d.ts"/>
define(["require", "exports"], function (require, exports) {
    "use strict";
    var chunkFetcher = (function () {
        function chunkFetcher(fetcher) {
            this.fetcher = fetcher;
            this.task = $.Deferred();
            this.result = [];
            if (!fetcher) {
                throw new Error("Fetcher must be specified.");
            }
        }
        chunkFetcher.prototype.execute = function () {
            var skip = 0;
            var take = 1024;
            this.fetchChunk(skip, take);
            return this.task;
        };
        chunkFetcher.prototype.fetchChunk = function (skip, take) {
            var _this = this;
            this.fetcher(skip, take)
                .fail(function (x) { return _this.task.reject(x); })
                .done(function (data) {
                (_a = _this.result).push.apply(_a, data);
                if (data.length === take) {
                    _this.fetchChunk(skip + take, take);
                }
                else {
                    _this.task.resolve(_this.result);
                }
                var _a;
            });
        };
        return chunkFetcher;
    }());
    return chunkFetcher;
});

//# sourceMappingURL=chunkFetcher.js.map
