define(["require", "exports", "common/messagePublisher"], function (require, exports, messagePublisher) {
    "use strict";
    var copyToClipboard = (function () {
        function copyToClipboard() {
        }
        copyToClipboard.copy = function (toCopy, successMessage) {
            var dummy = document.createElement("input");
            // Add it to the document
            document.body.appendChild(dummy);
            try {
                dummy.value = toCopy;
                // Select it
                dummy.select();
                // Copy its contents
                var success = document.execCommand("copy");
                if (success) {
                    messagePublisher.reportSuccess(successMessage);
                }
                else {
                    messagePublisher.reportWarning("Unable to copy to clipboard");
                }
            }
            catch (err) {
                messagePublisher.reportWarning("Unable to copy to clipboard", err);
            }
            finally {
                // Remove it as its not needed anymore
                document.body.removeChild(dummy);
            }
        };
        return copyToClipboard;
    }());
    return copyToClipboard;
});

//# sourceMappingURL=copyToClipboard.js.map
