/// <reference path="../../typings/tsd.d.ts" />
define(["require", "exports"], function (require, exports) {
    "use strict";
    var cssGenerator = (function () {
        function cssGenerator() {
        }
        cssGenerator.getCssClass = function (entityName, colorMaps, rs) {
            var resourceStyleMap = colorMaps.find(function (map) { return map.resourceName === rs.name; });
            if (!resourceStyleMap) {
                resourceStyleMap = {
                    resourceName: rs.name,
                    styleMap: {}
                };
                colorMaps.push(resourceStyleMap);
            }
            var existingStyle = resourceStyleMap.styleMap[entityName];
            if (existingStyle) {
                return existingStyle;
            }
            // We don't have an existing style. Assign one in the form of 'collection-style-X', where X is a number between 0 and maxStyleCount. These styles are found in app.less.
            var maxStyleCount = 32;
            var styleNumber = Object.keys(resourceStyleMap.styleMap).length % maxStyleCount;
            var style = "collection-style-" + styleNumber;
            resourceStyleMap.styleMap[entityName] = style;
            return style;
        };
        return cssGenerator;
    }());
    return cssGenerator;
});

//# sourceMappingURL=cssGenerator.js.map
