define(["require", "exports", "commands/auth/getSingleAuthTokenCommand", "common/messagePublisher"], function (require, exports, getSingleAuthTokenCommand, messagePublisher) {
    "use strict";
    var downloader = (function () {
        function downloader() {
            this.$downloadFrame = $("#downloadFrame");
        }
        downloader.prototype.download = function (rs, url) {
            var _this = this;
            new getSingleAuthTokenCommand(rs).execute().done(function (token) {
                var authToken = (url.indexOf("?") === -1 ? "?" : "&") + "singleUseAuthToken=" + token.Token;
                _this.$downloadFrame.attr("src", url + authToken);
            }).fail(function (qXHR, textStatus, errorThrown) { return messagePublisher.reportError("Could not get single auth token for download.", errorThrown); });
        };
        downloader.prototype.reset = function () {
            this.$downloadFrame.attr("src", "");
        };
        return downloader;
    }());
    return downloader;
});

//# sourceMappingURL=downloader.js.map
