/// <reference path="../../typings/tsd.d.ts" />
define(["require", "exports"], function (require, exports) {
    "use strict";
    var fileDownloader = (function () {
        function fileDownloader() {
        }
        fileDownloader.cleanup = function (domCacheElementName) {
            // clean previous elements (in any)
            $("#" + domCacheElementName).remove();
        };
        fileDownloader.createLinkAndStartDownload = function (blob, filename, domCacheElementName) {
            if (navigator && navigator.msSaveBlob) {
                navigator.msSaveBlob(blob, filename);
            }
            else {
                var blobUrl = URL.createObjectURL(blob);
                var a = document.createElement('a');
                a.id = "#" + domCacheElementName;
                a.download = filename;
                a.href = blobUrl;
                document.body.appendChild(a); // required by firefox
                a.click();
            }
        };
        fileDownloader.downloadAsJson = function (object, filename, domCacheElementName) {
            if (domCacheElementName === void 0) { domCacheElementName = "link"; }
            fileDownloader.cleanup(domCacheElementName);
            var modelAsString = JSON.stringify(object, null, 2);
            var blob = new Blob([modelAsString], { type: 'application/json' });
            fileDownloader.createLinkAndStartDownload(blob, filename, domCacheElementName);
        };
        fileDownloader.downloadAsZip = function (buffer, filename, domCacheElementName) {
            if (domCacheElementName === void 0) { domCacheElementName = "link"; }
            fileDownloader.cleanup(domCacheElementName);
            var blob = new Blob([buffer], { type: 'application/zip' });
            fileDownloader.createLinkAndStartDownload(blob, filename, domCacheElementName);
        };
        return fileDownloader;
    }());
    return fileDownloader;
});

//# sourceMappingURL=fileDownloader.js.map
