/// <reference path="../../typings/tsd.d.ts"/>
define(["require", "exports"], function (require, exports) {
    "use strict";
    var jsonUtil = (function () {
        function jsonUtil() {
        }
        jsonUtil.syntaxHighlight = function (json) {
            if (typeof json != 'string') {
                json = JSON.stringify(json, undefined, 2);
            }
            json = json.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;');
            return json.replace(/("(\\u[a-zA-Z0-9]{4}|\\[^u]|[^\\"])*"(\s*:)?|\b(true|false|null)\b|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?)/g, function (match) {
                var cls = 'number';
                if (/^"/.test(match)) {
                    if (/:$/.test(match)) {
                        cls = 'key';
                    }
                    else {
                        cls = 'string';
                    }
                }
                else if (/true|false/.test(match)) {
                    cls = 'boolean';
                }
                else if (/null/.test(match)) {
                    cls = 'null';
                }
                return '<span class="' + cls + '">' + match + '</span>';
            });
        };
        return jsonUtil;
    }());
    jsonUtil.newLineNormalizingHashFunction = function (object) {
        return ko.toJSON(object).replace(/\\r\\n/g, '\\n');
    };
    jsonUtil.newLineNormalizingHashFunctionWithIgnoredFields = function (ignoredFields) {
        return function (object) {
            return ko.toJSON(object, function (k, v) { return ignoredFields.indexOf(k) == -1 ? v : null; }).replace(/\\r\\n/g, '\\n');
        };
    };
    return jsonUtil;
});

//# sourceMappingURL=jsonUtil.js.map
