/// <reference path="../../typings/tsd.d.ts" />
define(["require", "exports", "models/database/index/indexMergeSuggestion"], function (require, exports, indexMergeSuggestion) {
    "use strict";
    var mergedIndexesStorage = (function () {
        function mergedIndexesStorage() {
        }
        mergedIndexesStorage.getMergedIndex = function (db, mergedIndexName) {
            var newSuggestion = null;
            try {
                if (!!mergedIndexName && mergedIndexName.indexOf(db.mergedIndexLocalStoragePrefix) == 0) {
                    var suggestion = localStorage.getObject(mergedIndexName); //TODO: don't use any here
                    localStorage.removeItem(mergedIndexName);
                    newSuggestion = new indexMergeSuggestion(suggestion);
                }
            }
            catch (e) {
                return null;
            }
            return newSuggestion;
        };
        mergedIndexesStorage.saveMergedIndex = function (db, id, suggestion) {
            var localStorageName = mergedIndexesStorage.getMergedIndexName(db, id);
            localStorage.setObject(localStorageName, suggestion.toDto());
        };
        mergedIndexesStorage.getMergedIndexName = function (db, id) {
            return db.mergedIndexLocalStoragePrefix + '.' + id;
        };
        return mergedIndexesStorage;
    }());
    return mergedIndexesStorage;
});

//# sourceMappingURL=mergedIndexesStorage.js.map
