define(["require", "exports", "common/constants/events", "durandal/app", "viewmodels/common/recentErrors"], function (require, exports, EVENTS, app, recentErrors) {
    "use strict";
    var notificationCenterRecentErrors = (function () {
        function notificationCenterRecentErrors() {
            var _this = this;
            this.recordedErrors = ko.observableArray();
            ko.postbox.subscribe(EVENTS.NotificationCenter.RecentError, function (alert) { return _this.showAlert(alert); });
            //TODO: this.globalChangesApi.watchDocsStartingWith("Raven/Alerts", () => this.fetchSystemDatabaseAlerts())  - do we need watch for this document - it depends on RavenDB-5313
        }
        notificationCenterRecentErrors.prototype.fetchSystemDatabaseAlerts = function () {
            /* TODO
            new getDocumentWithMetadataCommand("Raven/Alerts", this.systemDatabase)
                .execute()
                .done((doc: documentClass) => {
                    //
                });*/
        };
        notificationCenterRecentErrors.prototype.dismissRecentError = function (alert) {
            this.recordedErrors.remove(alert);
        };
        notificationCenterRecentErrors.prototype.showRecentErrorDialog = function (alert) {
            //TODO: using old dialog to display sigle item, it will be changed in future
            var errorDetails = new recentErrors(ko.observableArray([alert]));
            app.showBootstrapDialog(errorDetails);
        };
        notificationCenterRecentErrors.prototype.showAlert = function (alert) {
            if (!_.includes(this.recordedErrors(), alert)) {
                this.recordedErrors.unshift(alert);
            }
        };
        return notificationCenterRecentErrors;
    }());
    return notificationCenterRecentErrors;
});

//# sourceMappingURL=notificationCenterRecentErrors.js.map
