/// <reference path="../../typings/tsd.d.ts" />
define(["require", "exports"], function (require, exports) {
    "use strict";
    var oauthContext = (function () {
        function oauthContext() {
        }
        oauthContext.clean = function () {
            oauthContext.apiKey(null);
            oauthContext.authHeader(null);
        };
        return oauthContext;
    }());
    oauthContext.apiKey = ko.observable(null);
    oauthContext.authHeader = ko.observable(null);
    oauthContext.apiKeyName = ko.computed(function () {
        var key = oauthContext.apiKey();
        if (key === null) {
            return null;
        }
        var slashPos = key.indexOf('/');
        if (slashPos >= 0) {
            return key.substring(0, slashPos);
        }
        return null;
    });
    oauthContext.apiKeySecret = ko.computed(function () {
        var key = oauthContext.apiKey();
        if (key === null) {
            return null;
        }
        var slashPos = key.indexOf('/');
        if (slashPos >= 0) {
            return key.substring(slashPos + 1);
        }
        return null;
    });
    return oauthContext;
});

//# sourceMappingURL=oauthContext.js.map
