define(["require", "exports"], function (require, exports) {
    "use strict";
    var optional = (function () {
        function optional(instance) {
            this.instance = instance;
        }
        optional.val = function (value) {
            return new optional(value);
        };
        optional.prototype.bind = function (fetcher) {
            if (this.instance !== null && this.instance !== undefined) {
                var val = fetcher(this.instance);
                return new optional(val);
            }
            return new optional(null);
        };
        optional.prototype.toString = function () {
            if (this.instance !== null && this.instance !== undefined) {
                return this.instance.toString();
            }
            return "";
        };
        return optional;
    }());
    return optional;
});

//# sourceMappingURL=optional.js.map
