define(["require", "exports"], function (require, exports) {
    "use strict";
    var recentPatchesStorage = (function () {
        function recentPatchesStorage() {
        }
        recentPatchesStorage.getRecentPatches = function (db) {
            var localStorageName = db.recentPatchesLocalStorageName;
            var recentPatchesFromLocalStorage = this.getRecentPatchesFromLocalStorage(localStorageName);
            if (recentPatchesFromLocalStorage == null || recentPatchesFromLocalStorage instanceof Array === false) {
                localStorage.setObject(localStorageName, []);
                recentPatchesFromLocalStorage = [];
            }
            return recentPatchesFromLocalStorage;
        };
        recentPatchesStorage.saveRecentPatches = function (db, recentPatches) {
            var localStorageName = db.recentPatchesLocalStorageName;
            localStorage.setObject(localStorageName, recentPatches);
        };
        recentPatchesStorage.removeIndexFromRecentPatches = function (db, indexName) {
            var localStorageName = db.recentPatchesLocalStorageName;
            var recentPatchesFromLocalStorage = this.getRecentPatchesFromLocalStorage(localStorageName);
            if (recentPatchesFromLocalStorage == null)
                return;
            var newRecentPatches = recentPatchesFromLocalStorage.filter(function (query) { return query.PatchOnOption !== "Index" || query.SelectedItem !== indexName; });
            localStorage.setObject(localStorageName, newRecentPatches);
        };
        recentPatchesStorage.removeRecentPatches = function (db) {
            var localStorageName = db.recentPatchesLocalStorageName;
            localStorage.setObject(localStorageName, []);
        };
        recentPatchesStorage.getRecentPatchesFromLocalStorage = function (localStorageName) {
            var recentPatchesFromLocalStorage = null;
            try {
                recentPatchesFromLocalStorage = localStorage.getObject(localStorageName);
            }
            catch (err) {
            }
            return recentPatchesFromLocalStorage;
        };
        return recentPatchesStorage;
    }());
    return recentPatchesStorage;
});

//# sourceMappingURL=recentPatchesStorage.js.map
