/// <reference path="../../typings/tsd.d.ts" />
define(["require", "exports"], function (require, exports) {
    "use strict";
    var recentQueriesStorage = (function () {
        function recentQueriesStorage() {
        }
        recentQueriesStorage.getRecentQueries = function (db) {
            var localStorageName = db.recentQueriesLocalStorageName;
            var recentQueriesFromLocalStorage = this.getRecentQueriesFromLocalStorage(localStorageName);
            if (recentQueriesFromLocalStorage == null || recentQueriesFromLocalStorage instanceof Array === false) {
                localStorage.setObject(localStorageName, []);
                recentQueriesFromLocalStorage = [];
            }
            // we have restore properties coming from local storage, 
            // when saving object.prop = undefined in localstorage 
            // we don't get 'prop' property during read.
            recentQueriesFromLocalStorage.forEach(function (entry) {
                if (entry.TransformerQuery) {
                    if (("transformerName" in entry.TransformerQuery) === false) {
                        entry.TransformerQuery.transformerName = undefined;
                    }
                    ;
                }
            });
            return recentQueriesFromLocalStorage;
        };
        recentQueriesStorage.saveRecentQueries = function (db, recentQueries) {
            var localStorageName = db.recentQueriesLocalStorageName;
            localStorage.setObject(localStorageName, recentQueries);
        };
        recentQueriesStorage.removeIndexFromRecentQueries = function (db, indexName) {
            var localStorageName = db.recentQueriesLocalStorageName;
            var recentQueriesFromLocalStorage = this.getRecentQueriesFromLocalStorage(localStorageName);
            if (recentQueriesFromLocalStorage == null)
                return;
            var newRecentQueries = recentQueriesFromLocalStorage.filter(function (query) { return query.IndexName != indexName; });
            localStorage.setObject(localStorageName, newRecentQueries);
        };
        recentQueriesStorage.removeRecentQueries = function (db) {
            var localStorageName = db.recentQueriesLocalStorageName;
            localStorage.setObject(localStorageName, []);
        };
        recentQueriesStorage.getRecentQueriesFromLocalStorage = function (localStorageName) {
            var recentQueriesFromLocalStorage = null;
            try {
                recentQueriesFromLocalStorage = localStorage.getObject(localStorageName);
            }
            catch (err) {
            }
            return recentQueriesFromLocalStorage;
        };
        return recentQueriesStorage;
    }());
    return recentQueriesStorage;
});

//# sourceMappingURL=recentQueriesStorage.js.map
