/// <reference path="../../typings/tsd.d.ts" />
define(["require", "exports"], function (require, exports) {
    "use strict";
    var serverBuildReminder = (function () {
        function serverBuildReminder() {
        }
        serverBuildReminder.get = function () {
            return localStorage.getObject(serverBuildReminder.localStorageName);
        };
        serverBuildReminder.mute = function (isMuteNeeded) {
            if (isMuteNeeded) {
                localStorage.setObject(serverBuildReminder.localStorageName, new Date());
            }
            else {
                localStorage.removeItem(serverBuildReminder.localStorageName);
            }
            var event = document.createEvent('StorageEvent');
            event.initStorageEvent('storage', false, false, serverBuildReminder.localStorageName, isMuteNeeded, !isMuteNeeded, null, window.sessionStorage);
            window.dispatchEvent(event);
        };
        serverBuildReminder.isReminderNeeded = function () {
            var lastBuildCheck = serverBuildReminder.get();
            var timestamp = Date.parse(lastBuildCheck);
            var difference = 0;
            if (!isNaN(timestamp)) {
                var lastBuildCheckMoment = moment(lastBuildCheck);
                var currentDateMoment = moment(new Date());
                difference = currentDateMoment.diff(lastBuildCheckMoment, 'days', true);
            }
            if (isNaN(timestamp) || difference > 7) {
                serverBuildReminder.mute(false);
                return true;
            }
            return false;
        };
        return serverBuildReminder;
    }());
    serverBuildReminder.localStorageName = "LastServerBuildReminder";
    return serverBuildReminder;
});

//# sourceMappingURL=serverBuildReminder.js.map
