/// <reference path="../../typings/tsd.d.ts"/>
define(["require", "exports", "viewmodels/shell/accessHelper"], function (require, exports, accessHelper) {
    "use strict";
    var settingsAccessAuthorizer = (function () {
        function settingsAccessAuthorizer() {
        }
        return settingsAccessAuthorizer;
    }());
    settingsAccessAuthorizer.isForbidden = ko.computed(function () {
        var globalAdmin = accessHelper.isGlobalAdmin();
        var canReadWriteSettings = accessHelper.canReadWriteSettings();
        var canReadSettings = accessHelper.canReadSettings();
        return !globalAdmin && !canReadWriteSettings && !canReadSettings;
    });
    settingsAccessAuthorizer.isReadOnly = ko.computed(function () {
        var globalAdmin = accessHelper.isGlobalAdmin();
        var canReadWriteSettings = accessHelper.canReadWriteSettings();
        var canReadSettings = accessHelper.canReadSettings();
        return !globalAdmin && !canReadWriteSettings && canReadSettings;
    });
    settingsAccessAuthorizer.canWrite = ko.computed(function () {
        var globalAdmin = accessHelper.isGlobalAdmin();
        var canReadWriteSettings = accessHelper.canReadWriteSettings();
        var canReadSettings = accessHelper.canReadSettings();
        return globalAdmin || canReadWriteSettings || canReadSettings;
    });
    settingsAccessAuthorizer.canReadOrWrite = ko.computed(function () {
        var globalAdmin = accessHelper.isGlobalAdmin();
        var canReadWriteSettings = accessHelper.canReadWriteSettings();
        return globalAdmin || canReadWriteSettings;
    });
    return settingsAccessAuthorizer;
});

//# sourceMappingURL=settingsAccessAuthorizer.js.map
