define(["require", "exports", "common/shell/menu/intermediateMenuItem", "common/shell/menu/leafMenuItem"], function (require, exports, intermediateMenuItem, leafMenuItem) {
    "use strict";
    function getDocumentsMenuItem(appUrls) {
        var documentsChildren = [
            new leafMenuItem({
                title: "Documents",
                nav: true,
                route: "databases/documents",
                moduleId: "viewmodels/database/documents/documents",
                dynamicHash: appUrls.documents,
                css: 'icon-documents'
            }),
            /* TODO:
                    new leafMenuItem({
                        title: "Conflicts",
                        nav: true,
                        route: "database/conflicts",
                        moduleId: "viewmodels/database/conflicts/conflicts",
                        css: 'icon-plus',
                        dynamicHash: appUrls.conflicts
                    }),*/
            new leafMenuItem({
                title: "Patch",
                nav: true,
                route: "databases/patch(/:recentPatchHash)",
                moduleId: "viewmodels/database/patch/patch",
                css: 'icon-patch',
                dynamicHash: appUrls.patch
            }),
            new leafMenuItem({
                route: "databases/edit",
                title: "Edit Document",
                moduleId: "viewmodels/database/documents/editDocument",
                nav: false,
                itemRouteToHighlight: "databases/documents"
            })
        ];
        return new intermediateMenuItem("Documents", documentsChildren, "icon-documents", {
            dynamicHash: appUrls.documents
        });
    }
    return getDocumentsMenuItem;
});

//# sourceMappingURL=documents.js.map
