define(["require", "exports", "common/shell/menu/intermediateMenuItem", "common/shell/menu/leafMenuItem"], function (require, exports, intermediateMenuItem, leafMenuItem) {
    "use strict";
    function getSettingsMenuItem(appUrls) {
        var items = [
            new leafMenuItem({
                route: ['databases/settings', 'databases/settings/databaseSettings'],
                moduleId: 'viewmodels/database/settings/databaseSettings',
                title: 'Database Settings',
                nav: true,
                css: 'icon-database-settings',
                dynamicHash: appUrls.databaseSettings
            }),
            /* TODO
            new leafMenuItem({
                route: 'databases/settings/quotas',
                moduleId: 'viewmodels/database/settings/quotas',
                title: 'Quotas',
                nav: true,
                css: 'icon-plus',
                dynamicHash: appUrls.quotas
            }),*/
            new leafMenuItem({
                route: 'databases/settings/replication',
                moduleId: 'viewmodels/database/settings/replications',
                title: 'Replication',
                nav: true,
                css: 'icon-replication',
                dynamicHash: appUrls.replications
            }),
            /* TODO
            new leafMenuItem({
                route: 'databases/settings/etl',
                moduleId: 'viewmodels/database/settings/etl',
                title: 'ETL',
                nav: true,
                css: 'icon-plus',
                dynamicHash: appUrls.etl
            }),*/
            new leafMenuItem({
                route: 'databases/settings/sqlReplication',
                moduleId: 'viewmodels/database/settings/sqlReplications',
                title: 'SQL Replication',
                nav: true,
                css: 'icon-sql-replication',
                dynamicHash: appUrls.sqlReplications
            }),
            new leafMenuItem({
                route: 'databases/settings/editSqlReplication(/:sqlReplicationName)',
                moduleId: 'viewmodels/database/settings/editSqlReplication',
                title: 'Edit SQL Replication',
                nav: false,
                css: 'icon-sql-replication',
                dynamicHash: appUrls.editSqlReplication
            }),
            new leafMenuItem({
                route: 'databases/settings/sqlReplicationConnectionStringsManagement',
                moduleId: 'viewmodels/database/settings/sqlReplicationConnectionStringsManagement',
                title: 'SQL Replication Connection Strings',
                nav: false,
                css: 'icon-sql-replication-connection-string',
                dynamicHash: appUrls.sqlReplicationsConnections
            }),
            new leafMenuItem({
                route: 'databases/settings/versioning',
                moduleId: 'viewmodels/database/settings/versioning',
                title: 'Versioning',
                nav: true,
                css: 'icon-versioning',
                dynamicHash: appUrls.versioning
            }),
            new leafMenuItem({
                route: 'databases/settings/periodicExport',
                moduleId: 'viewmodels/database/settings/periodicExport',
                title: 'Periodic Export',
                nav: true,
                css: 'icon-periodic-export',
                dynamicHash: appUrls.periodicExport
            }),
        ];
        return new intermediateMenuItem('Settings', items, 'icon-settings');
    }
    return getSettingsMenuItem;
});

//# sourceMappingURL=settings.js.map
