define(["require", "exports", "common/shell/menu/intermediateMenuItem", "common/shell/menu/leafMenuItem"], function (require, exports, intermediateMenuItem, leafMenuItem) {
    "use strict";
    function getTransformersMenuItem(appUrls) {
        var transformersChildren = [
            new leafMenuItem({
                title: 'Transformers',
                route: 'databases/transformers',
                moduleId: 'viewmodels/database/transformers/transformers',
                css: 'icon-list',
                nav: true,
                dynamicHash: appUrls.transformers
            }),
            new leafMenuItem({
                route: 'databases/transformers/edit(/:transformerName)',
                moduleId: 'viewmodels/database/transformers/editTransformer',
                title: 'Edit Transformer',
                css: 'icon-edit',
                nav: false,
                itemRouteToHighlight: 'databases/transformers'
            })
        ];
        return new intermediateMenuItem("Transformers", transformersChildren, 'icon-etl');
    }
    return getTransformersMenuItem;
});

//# sourceMappingURL=transformers.js.map
