define(["require", "exports"], function (require, exports) {
    "use strict";
    var leafMenuItem = (function () {
        function leafMenuItem(_a) {
            var title = _a.title, tooltip = _a.tooltip, route = _a.route, moduleId = _a.moduleId, nav = _a.nav, hash = _a.hash, css = _a.css, dynamicHash = _a.dynamicHash, enabled = _a.enabled, openAsDialog = _a.openAsDialog, itemRouteToHighlight = _a.itemRouteToHighlight;
            var _this = this;
            this.parent = ko.observable(null);
            this.type = "leaf";
            if (nav && !hash && !dynamicHash && !openAsDialog) {
                console.error("Invalid route configuration:" + title);
            }
            this.itemRouteToHighlight = itemRouteToHighlight;
            this.title = title;
            this.route = route;
            this.moduleId = moduleId;
            this.nav = nav;
            this.hash = hash;
            this.dynamicHash = dynamicHash;
            this.css = css;
            this.enabled = enabled;
            this.openAsDialog = openAsDialog;
            this.path = ko.pureComputed(function () {
                if (_this.hash) {
                    return _this.hash;
                }
                else if (_this.dynamicHash) {
                    return _this.dynamicHash();
                }
                return null;
            });
        }
        return leafMenuItem;
    }());
    return leafMenuItem;
});

//# sourceMappingURL=leafMenuItem.js.map
