/// <reference path="../../typings/tsd.d.ts" />
define(["require", "exports"], function (require, exports) {
    "use strict";
    var starredDocumentsStorage = (function () {
        function starredDocumentsStorage() {
        }
        starredDocumentsStorage.getStarredDocuments = function (db) {
            var localStorageName = db.starredDocumentsLocalStorageName;
            var starredDocumentsFromLocalStorage = this.getFromLocalStorage(localStorageName);
            if (starredDocumentsFromLocalStorage == null || starredDocumentsFromLocalStorage instanceof Array === false) {
                starredDocumentsFromLocalStorage = [];
                starredDocumentsStorage.saveToLocalStorage(db, starredDocumentsFromLocalStorage);
            }
            return starredDocumentsFromLocalStorage;
        };
        starredDocumentsStorage.isStarred = function (db, documentId) {
            var starred = starredDocumentsStorage.getStarredDocuments(db);
            return _.includes(starred, documentId);
        };
        starredDocumentsStorage.markDocument = function (db, documentId, asStarred) {
            var starred = starredDocumentsStorage.getStarredDocuments(db);
            var alreadyStored = _.includes(starred, documentId);
            if (asStarred) {
                if (!alreadyStored) {
                    var locationToInsert = _.sortedIndex(starred, documentId);
                    starred.splice(locationToInsert, 0, documentId);
                    starredDocumentsStorage.saveToLocalStorage(db, starred);
                }
            }
            else {
                if (alreadyStored) {
                    _.pull(starred, documentId);
                    starredDocumentsStorage.saveToLocalStorage(db, starred);
                }
            }
        };
        starredDocumentsStorage.saveToLocalStorage = function (db, starredDocuments) {
            var localStorageName = db.starredDocumentsLocalStorageName;
            localStorage.setObject(localStorageName, starredDocuments);
        };
        starredDocumentsStorage.getFromLocalStorage = function (localStorageName) {
            var starredDocumentsFromLocalStorage = null;
            try {
                starredDocumentsFromLocalStorage = localStorage.getObject(localStorageName);
            }
            catch (err) {
            }
            return starredDocumentsFromLocalStorage;
        };
        return starredDocumentsStorage;
    }());
    return starredDocumentsStorage;
});

//# sourceMappingURL=starredDocumentsStorage.js.map
