define(["require", "exports"], function (require, exports) {
    "use strict";
    var tableNavigationTrait = (function () {
        function tableNavigationTrait(containerSelector, currentItem, allItems, nThRowSelector) {
            this.containerSelector = containerSelector;
            this.currentItem = currentItem;
            this.allItems = allItems;
            this.nThRowSelector = nThRowSelector;
            // empty by design
        }
        tableNavigationTrait.prototype.tableKeyDown = function (sender, e) {
            var isKeyUp = e.keyCode === 38;
            var isKeyDown = e.keyCode === 40;
            if (isKeyUp || isKeyDown) {
                e.preventDefault();
                var oldSelection = this.currentItem();
                if (oldSelection) {
                    var oldSelectionIndex = this.allItems().indexOf(oldSelection);
                    var newSelectionIndex = oldSelectionIndex;
                    if (isKeyUp && oldSelectionIndex > 0) {
                        newSelectionIndex--;
                    }
                    else if (isKeyDown && oldSelectionIndex < this.allItems().length - 1) {
                        newSelectionIndex++;
                    }
                    this.currentItem(this.allItems()[newSelectionIndex]);
                    var newSelectedRow = $(this.nThRowSelector(newSelectionIndex + 1));
                    if (newSelectedRow) {
                        this.ensureRowVisible(newSelectedRow);
                    }
                }
                return false;
            }
            return true;
        };
        tableNavigationTrait.prototype.ensureRowVisible = function (row) {
            var $container = $(this.containerSelector);
            var scrollTop = $container.scrollTop();
            var scrollBottom = scrollTop + $container.height();
            var scrollHeight = scrollBottom - scrollTop;
            var rowPosition = row.position();
            var rowTop = rowPosition.top;
            var rowBottom = rowTop + row.height();
            if (rowTop < 0) {
                $container.scrollTop(scrollTop + rowTop);
            }
            else if (rowBottom > scrollHeight) {
                $container.scrollTop(scrollTop + (rowBottom - scrollHeight));
            }
        };
        return tableNavigationTrait;
    }());
    return tableNavigationTrait;
});

//# sourceMappingURL=tableNavigationTrait.js.map
