define(["require", "exports", "models/filesystem/uploadItem"], function (require, exports, uploadItem) {
    "use strict";
    var uploadQueueHelper = (function () {
        function uploadQueueHelper() {
        }
        uploadQueueHelper.stringifyUploadQueue = function (queue) {
            return ko.toJSON(queue);
        };
        uploadQueueHelper.parseUploadQueue = function (queue, fs) {
            var stringArray = JSON.parse(queue);
            var uploadQueue = [];
            for (var i = 0; i < stringArray.length; i++) {
                uploadQueue.push(new uploadItem(stringArray[i]["id"], stringArray[i]["fileName"], stringArray[i]["status"], fs));
            }
            return uploadQueueHelper.sortUploadQueue(uploadQueue);
        };
        uploadQueueHelper.sortUploadQueue = function (uploadQueue) {
            return uploadQueue.sort(function (a, b) {
                if (a.status() === uploadQueueHelper.failedStatus) {
                    return -1;
                }
                else if (a.status() === uploadQueueHelper.uploadingStatus)
                    if (b.status() === uploadQueueHelper.failedStatus)
                        return 1;
                    else
                        return -1;
                else if (a.status() === uploadQueueHelper.queuedStatus) {
                    if (b.status() === uploadQueueHelper.failedStatus || b.status() === uploadQueueHelper.uploadingStatus)
                        return 1;
                    else
                        return -1;
                }
                else
                    return 1;
            });
        };
        uploadQueueHelper.updateLocalStorage = function (x, fs) {
            window.localStorage.setItem(uploadQueueHelper.localStorageUploadQueueKey + fs.name, uploadQueueHelper.stringifyUploadQueue(x));
        };
        uploadQueueHelper.updateQueueStatus = function (guid, status, queue) {
            var items = ko.utils.arrayFilter(queue, function (i) {
                return i.id() === guid;
            });
            if (items) {
                items[0].status(status);
            }
            queue = uploadQueueHelper.sortUploadQueue(queue);
            ;
        };
        return uploadQueueHelper;
    }());
    uploadQueueHelper.uploadingStatus = "Uploading...";
    uploadQueueHelper.failedStatus = "Failed";
    uploadQueueHelper.uploadedStatus = "Uploaded";
    uploadQueueHelper.queuedStatus = "Queued";
    uploadQueueHelper.localStorageUploadQueueKey = "ravenFs-uploadQueue.";
    return uploadQueueHelper;
});

//# sourceMappingURL=uploadQueueHelper.js.map
