/// <reference path="../../../typings/tsd.d.ts" />
define(["require", "exports", "commands/auth/getLicenseStatusCommand"], function (require, exports, getLicenseStatusCommand) {
    "use strict";
    var license = (function () {
        function license() {
        }
        license.fetchLicenseStatus = function () {
            return new getLicenseStatusCommand()
                .execute()
                .done(function (result) {
                if (result.Status.includes("AGPL")) {
                    result.Status = "Development Only";
                }
                license.licenseStatus(result);
            });
        };
        return license;
    }());
    license.licenseStatus = ko.observable();
    license.supportCoverage = ko.observable();
    license.hotSpare = ko.observable();
    license.licenseCssClass = ko.computed(function () {
        var status = license.licenseStatus();
        var hotSpare = license.hotSpare();
        if (hotSpare) {
            return 'hot-spare';
        }
        if (status == null || status.LicenseType !== "Commercial") {
            return 'dev-only';
        }
        if (status.Status.includes("Expired")) {
            return 'expired';
        }
        else {
            return 'commercial';
        }
    });
    license.supportCssClass = ko.computed(function () {
        var support = license.supportCoverage();
        if (support == null) {
            return 'no-support';
        }
        switch (support.Status) {
            case 'ProductionSupport':
                return 'production-support';
            case 'ProfessionalSupport':
                return 'professional-support';
            case 'PartialSupport':
                return 'partial-support';
            default:
                return 'no-support';
        }
    });
    return license;
});

//# sourceMappingURL=license.js.map
