/// <reference path="../../../typings/tsd.d.ts"/>
define(["require", "exports"], function (require, exports) {
    "use strict";
    var counterStorageStatistics = (function () {
        function counterStorageStatistics() {
            this.countersCount = ko.observable();
            this.counterCountText = ko.observable("");
            this.groupCountText = ko.observable("");
            this.requestsPerSecondText = ko.observable("");
        }
        counterStorageStatistics.prototype.getItemCountText = function (itemCount, singularText, suffix) {
            var itemCountText = itemCount.toLocaleString() + " " + singularText;
            if (itemCount !== 1) {
                itemCountText += suffix;
            }
            return itemCountText;
        };
        counterStorageStatistics.prototype.fromDto = function (dto) {
            this.countersCount(dto.CountersCount);
            this.counterCountText(this.getItemCountText(dto.CountersCount, "counter", "s"));
            this.groupCountText(this.getItemCountText(dto.GroupsCount, "group", "s"));
            this.requestsPerSecondText(dto.RequestsPerSecond + " requests per second");
        };
        return counterStorageStatistics;
    }());
    return counterStorageStatistics;
});

//# sourceMappingURL=counterStorageStatistics.js.map
