/// <reference path="../../../../typings/tsd.d.ts"/>
define(["require", "exports"], function (require, exports) {
    "use strict";
    var adminLogsConfigEntry = (function () {
        function adminLogsConfigEntry(category, level, includeStackTrace) {
            if (includeStackTrace === void 0) { includeStackTrace = false; }
            this.includeStackTrace = ko.observable();
            this.category = ko.observable();
            this.level = ko.observable();
            this.category(category);
            this.level(level);
            this.includeStackTrace(includeStackTrace);
        }
        adminLogsConfigEntry.prototype.clone = function () {
            return new adminLogsConfigEntry(this.category(), this.level(), this.includeStackTrace());
        };
        adminLogsConfigEntry.empty = function () {
            return new adminLogsConfigEntry(null, null, false);
        };
        adminLogsConfigEntry.prototype.toDto = function () {
            return {
                category: this.category(),
                level: this.level(),
                includeStackTrace: this.includeStackTrace()
            };
        };
        return adminLogsConfigEntry;
    }());
    return adminLogsConfigEntry;
});

//# sourceMappingURL=adminLogsConfigEntry.js.map
