/// <reference path="../../../../typings/tsd.d.ts"/>
define(["require", "exports"], function (require, exports) {
    "use strict";
    var alert = (function () {
        function alert(dto) {
            this.isOpen = ko.observable(false);
            this.id = dto.Id;
            this.key = dto.Key;
            this.message = ko.observable(dto.Message);
            this.read = dto.Read;
            this.severity = ko.observable(dto.Severity);
            this.type = dto.Type;
            this.createdAt = dto.CreatedAt;
            this.dismissedUntil = dto.DismissedUntil;
            this.content = dto.Content;
            this.initStatus();
        }
        alert.prototype.initStatus = function () {
            var _this = this;
            this.isError = ko.pureComputed(function () {
                return _this.severity() === "Error";
            });
            this.isWarning = ko.pureComputed(function () {
                return _this.severity() === "Warning";
            });
            this.isInfo = ko.pureComputed(function () {
                return _this.severity() === "Info";
            });
        };
        alert.prototype.hasDetails = function () {
            var _this = this;
            return ["NewServerVersionAvailable"].some(function (x) { return x === _this.type; });
        };
        alert.prototype.openDetails = function () {
            if (!this.isOpen()) {
                ko.postbox.publish("Alerts.DetailsOpen", this);
                this.isOpen(true);
            }
        };
        alert.prototype.canOpenDetails = function () {
            return this.type !== 'NewServerVersionAvailable';
        };
        alert.prototype.canBeDismissed = function () {
            return this.type !== 'NewServerVersionAvailable';
        };
        return alert;
    }());
    return alert;
});

//# sourceMappingURL=alert.js.map
