/// <reference path="../../../../typings/tsd.d.ts"/>
define(["require", "exports"], function (require, exports) {
    "use strict";
    var performanceTestRequest = (function () {
        function performanceTestRequest(dto) {
            this.path = ko.observable();
            this.fileSize = ko.observable();
            this.testType = ko.observable("generic");
            // generic type specific options:
            this.operationType = ko.observable();
            this.bufferingType = ko.observable();
            this.sequential = ko.observable();
            this.threadCount = ko.observable();
            this.timeToRunInSeconds = ko.observable();
            //random seed - we don't expose on UI
            this.chunkSize = ko.observable();
            // batch type specific options:
            this.numberOfDocuments = ko.observable();
            this.sizeOfDocuments = ko.observable();
            this.numberOfDocumentsInBatch = ko.observable();
            this.waitBetweenBatches = ko.observable();
            this.path(dto.Path);
            this.fileSize(dto.FileSize);
            this.testType(dto.TestType);
            this.operationType(dto.OperationType);
            this.bufferingType(dto.BufferingType);
            this.sequential(dto.Sequential);
            this.threadCount(dto.ThreadCount);
            this.timeToRunInSeconds(dto.TimeToRunInSeconds);
            this.chunkSize(dto.ChunkSize);
            this.numberOfDocuments(dto.NumberOfDocuments);
            this.sizeOfDocuments(dto.SizeOfDocuments);
            this.numberOfDocumentsInBatch(dto.NumberOfDocumentsInBatch);
            this.waitBetweenBatches(dto.WaitBetweenBatches);
        }
        performanceTestRequest.empty = function () {
            return new performanceTestRequest({
                TestType: "generic",
                Path: "c:\\temp\\",
                FileSize: 1024 * 1024 * 1024,
                OperationType: "Write",
                BufferingType: "None",
                Sequential: true,
                ThreadCount: 4,
                TimeToRunInSeconds: 30,
                ChunkSize: 4 * 1024,
                NumberOfDocuments: 300000,
                SizeOfDocuments: 8 * 1024,
                NumberOfDocumentsInBatch: 200,
                WaitBetweenBatches: 0
            });
        };
        performanceTestRequest.prototype.toDto = function () {
            if (this.testType() == "generic") {
                return {
                    TestType: this.testType(),
                    Path: this.path(),
                    FileSize: this.fileSize(),
                    OperationType: this.operationType(),
                    BufferingType: this.bufferingType(),
                    Sequential: this.sequential(),
                    ThreadCount: this.threadCount(),
                    TimeToRunInSeconds: this.timeToRunInSeconds(),
                    ChunkSize: this.chunkSize()
                };
            }
            else {
                return {
                    TestType: this.testType(),
                    Path: this.path(),
                    FileSize: this.fileSize(),
                    NumberOfDocuments: this.numberOfDocuments(),
                    SizeOfDocuments: this.sizeOfDocuments(),
                    NumberOfDocumentsInBatch: this.numberOfDocumentsInBatch(),
                    WaitBetweenBatches: this.waitBetweenBatches()
                };
            }
        };
        return performanceTestRequest;
    }());
    return performanceTestRequest;
});

//# sourceMappingURL=performanceTestRequest.js.map
