define(["require", "exports", "models/database/documents/collection"], function (require, exports, collection) {
    "use strict";
    var collectionsStats = (function () {
        function collectionsStats(statsDto, ownerDatabase) {
            this.numberOfDocuments = ko.observable();
            this.numberOfDocuments(statsDto.NumberOfDocuments);
            this.collections = [];
            for (var key in statsDto.Collections) {
                if (!statsDto.Collections.hasOwnProperty(key))
                    continue;
                this.collections.push(new collection(key, ownerDatabase, statsDto.Collections[key]));
            }
        }
        collectionsStats.prototype.getCollectionCount = function (collectionName) {
            var matchedCollection = this.collections.find(function (x) { return x.name === collectionName; });
            return matchedCollection ? matchedCollection.documentCount() : 0;
        };
        return collectionsStats;
    }());
    return collectionsStats;
});

//# sourceMappingURL=collectionsStats.js.map
