define(["require", "exports", "common/execJs"], function (require, exports, execJs) {
    "use strict";
    var customColumnParams = (function () {
        function customColumnParams(dto, isNew) {
            if (isNew === void 0) { isNew = false; }
            var _this = this;
            this.header = ko.observable();
            this.binding = ko.observable();
            this.template = ko.observable();
            this.width = ko.observable();
            this.isNew = ko.observable();
            this.hasHeaderFocus = ko.observable();
            this.bindingCustomValidity = ko.computed(function () {
                var binding = _this.binding();
                return execJs.validateSyntax(binding) || "";
            });
            this.header(dto.Header);
            this.binding(dto.Binding);
            this.template(dto.Template || "defaultTemplate");
            this.width(dto.DefaultWidth);
            this.isNew(isNew);
            this.binding.subscribe(function (newValue) {
                if (_this.isNew() === false) {
                    //the header was already modified before
                    return;
                }
                _this.header(newValue);
            });
            this.header.subscribe(function () {
                if (_this.hasHeaderFocus()) {
                    _this.isNew(false);
                }
            });
        }
        customColumnParams.empty = function () {
            return new customColumnParams({ Header: '', Binding: '', DefaultWidth: 200 }, true);
        };
        customColumnParams.prototype.toDto = function () {
            return {
                'Header': this.header(),
                'Binding': this.binding(),
                'DefaultWidth': this.width()
            };
        };
        return customColumnParams;
    }());
    return customColumnParams;
});

//# sourceMappingURL=customColumnParams.js.map
