define(["require", "exports", "models/database/documents/documentMetadata"], function (require, exports, documentMetadata) {
    "use strict";
    var customFunctions = (function () {
        function customFunctions(dto) {
            if (!dto) {
                dto = {
                    Functions: ""
                };
                this.__metadata = new documentMetadata();
            }
            else {
                this.__metadata = new documentMetadata(dto["@metadata"]);
            }
            this.functions = dto.Functions;
        }
        customFunctions.prototype.toDto = function (includeMetadata) {
            var dto = {
                Functions: this.functions
            };
            if (includeMetadata && this.__metadata) {
                dto['@metadata'] = this.__metadata.toDto();
            }
            return dto;
        };
        customFunctions.prototype.clone = function () {
            var copy = new customFunctions(this.toDto());
            copy.functions = this.functions;
            return copy;
        };
        customFunctions.empty = function () {
            return new customFunctions({
                Functions: ""
            });
        };
        return customFunctions;
    }());
    return customFunctions;
});

//# sourceMappingURL=customFunctions.js.map
