/// <reference path="../../../../typings/tsd.d.ts"/>
define(["require", "exports"], function (require, exports) {
    "use strict";
    var versioningEntry = (function () {
        function versioningEntry(collection, dto) {
            var _this = this;
            this.active = ko.observable();
            this.maxRevisions = ko.observable();
            this.purgeOnDelete = ko.observable();
            this.collection = ko.observable().extend({ required: true });
            this.collection(collection);
            this.maxRevisions(dto.MaxRevisions);
            this.active(dto.Active);
            this.purgeOnDelete(dto.PurgeOnDelete);
            this.isDefault = ko.pureComputed(function () { return _this.collection() === versioningEntry.DefaultConfiguration; });
        }
        versioningEntry.prototype.toDto = function () {
            return {
                Active: this.active(),
                MaxRevisions: this.maxRevisions(),
                PurgeOnDelete: this.purgeOnDelete()
            };
        };
        versioningEntry.empty = function () {
            return new versioningEntry("", {
                Active: true,
                MaxRevisions: 5,
                PurgeOnDelete: false
            });
        };
        return versioningEntry;
    }());
    versioningEntry.DefaultConfiguration = "DefaultConfiguration";
    return versioningEntry;
});

//# sourceMappingURL=versioningEntry.js.map
