/// <reference path="../../../../typings/tsd.d.ts"/>
define(["require", "exports"], function (require, exports) {
    "use strict";
    var configurationDocument = (function () {
        function configurationDocument(dto) {
            this.localExists = ko.observable();
            this.globalExists = ko.observable();
            this.mergedDocument = ko.observable();
            this.globalDocument = ko.observable();
            this.etag = ko.observable();
            this.metadata = ko.observable();
            this.localExists(dto.LocalExists);
            this.globalExists(dto.GlobalExists);
            this.mergedDocument(dto.MergedDocument);
            this.globalDocument(dto.GlobalDocument);
            this.etag(dto.Etag);
            this.metadata(dto.Metadata);
        }
        configurationDocument.fromDtoWithTransform = function (dto, transform) {
            return new configurationDocument({
                Etag: dto.Etag,
                MergedDocument: transform(dto.MergedDocument),
                Metadata: dto.Metadata,
                GlobalDocument: transform(dto.GlobalDocument),
                LocalExists: dto.LocalExists,
                GlobalExists: dto.GlobalExists
            });
        };
        configurationDocument.prototype.isUsingGlobal = function () {
            var g = this.globalExists();
            var l = this.localExists();
            return g && !l;
        };
        configurationDocument.prototype.copyFromGlobal = function () {
            if (this.globalExists()) {
                this.localExists(false);
                this.mergedDocument().copyFromParent(this.globalDocument());
            }
        };
        return configurationDocument;
    }());
    return configurationDocument;
});

//# sourceMappingURL=configurationDocument.js.map
