define(["require", "exports", "models/database/index/indexDefinition", "common/idGenerator"], function (require, exports, indexDefinition, idGenerator) {
    "use strict";
    var indexMergeSuggestion = (function () {
        function indexMergeSuggestion(dto) {
            this.id = ko.observable();
            this.canMerge = dto.CanMerge;
            this.collection = dto.Collection;
            this.mergedIndexDefinition = dto.MergedIndex ? new indexDefinition(dto.MergedIndex) : null;
            this.id(idGenerator.generateId());
            this.canDelete = dto.CanDelete;
            this.surpassingIndex = dto.SurpassingIndex;
        }
        indexMergeSuggestion.prototype.isSurpassingIndex = function () {
            return this.mergedIndexDefinition == null;
        };
        indexMergeSuggestion.prototype.toDto = function () {
            return {
                CanMerge: this.canMerge,
                Collection: this.collection,
                MergedIndex: this.mergedIndexDefinition ? this.mergedIndexDefinition.toDto() : null,
                CanDelete: this.canDelete,
                SurpassingIndex: this.surpassingIndex,
            };
        };
        return indexMergeSuggestion;
    }());
    return indexMergeSuggestion;
});

//# sourceMappingURL=indexMergeSuggestion.js.map
