/// <reference path="../../../../typings/tsd.d.ts"/>
define(["require", "exports"], function (require, exports) {
    "use strict";
    var luceneField = (function () {
        function luceneField(name, stores, indexing, sort, analyzer, suggestionEnabled, termVector, indexFieldNames) {
            if (stores === void 0) { stores = "No"; }
            if (indexing === void 0) { indexing = "Default"; }
            if (sort === void 0) { sort = "None"; }
            if (analyzer === void 0) { analyzer = 'StandardAnalyzer'; }
            if (suggestionEnabled === void 0) { suggestionEnabled = false; }
            if (termVector === void 0) { termVector = "No"; }
            var _this = this;
            this.indexFieldNames = indexFieldNames;
            this.name = ko.observable();
            this.stores = ko.observable();
            this.sort = ko.observable();
            this.termVector = ko.observable();
            this.indexing = ko.observable();
            this.analyzer = ko.observable();
            this.suggestionEnabled = ko.observable();
            this.fieldNameAutocompletes = ko.observableArray();
            this.name(name);
            this.stores(stores);
            this.indexing(indexing);
            this.sort(sort);
            this.analyzer(analyzer);
            this.suggestionEnabled(suggestionEnabled);
            this.termVector(termVector);
            this.name.subscribe(function () { return _this.calculateFieldNamesAutocomplete(); });
        }
        luceneField.prototype.calculateFieldNamesAutocomplete = function () {
            var _this = this;
            if (!!this.indexFieldNames && this.indexFieldNames.length > 0) {
                if (this.name().length > 0) {
                    this.fieldNameAutocompletes(this.indexFieldNames.filter(function (x) { return x.toLowerCase().indexOf(_this.name().toLowerCase()) >= 0; }));
                }
                else {
                    this.fieldNameAutocompletes(this.indexFieldNames);
                }
            }
        };
        luceneField.prototype.setName = function (curName) {
            this.name(curName);
        };
        return luceneField;
    }());
    return luceneField;
});

//# sourceMappingURL=luceneField.js.map
