var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "models/database/documents/document", "common/bindingHelpers/aceEditorBindingHandler"], function (require, exports, document, aceEditorBindingHandler) {
    "use strict";
    var scriptedIndex = (function (_super) {
        __extends(scriptedIndex, _super);
        function scriptedIndex(dto) {
            var _this = _super.call(this, dto) || this;
            _this.indexName = ko.observable();
            _this.indexScript = ko.observable();
            _this.deleteScript = ko.observable();
            _this.deleteLater = ko.observable();
            var scriptedIndexName = dto['@metadata']['@id'].slice(scriptedIndex.PREFIX.length);
            _this.indexName(scriptedIndexName);
            _this.indexScript(dto.IndexScript);
            _this.deleteScript(dto.DeleteScript);
            _this.subscribeToObservable(_this.indexScript);
            _this.subscribeToObservable(_this.deleteScript);
            _this.indexName.subscribe(function (v) { return _this.__metadata.id = scriptedIndex.PREFIX + v; });
            return _this;
        }
        scriptedIndex.emptyForIndex = function (indexName) {
            var meta = [];
            meta['@id'] = this.PREFIX + indexName;
            meta['Raven-Entity-Name'] = 'ScriptedIndexResults';
            return new scriptedIndex({
                '@metadata': meta,
                IndexScript: "",
                DeleteScript: ""
            });
        };
        scriptedIndex.prototype.toDto = function () {
            var meta = this.__metadata.toDto();
            return {
                '@metadata': meta,
                IndexScript: this.indexScript(),
                DeleteScript: this.deleteScript()
            };
        };
        scriptedIndex.prototype.markToDelete = function () {
            this.indexScript("");
            this.deleteScript("");
            this.deleteLater(true);
        };
        scriptedIndex.prototype.cancelDeletion = function () {
            this.deleteLater(false);
        };
        scriptedIndex.prototype.isMarkedToDelete = function () {
            return this.deleteLater();
        };
        scriptedIndex.prototype.subscribeToObservable = function (observable) {
            observable.subscribe(function (newValue) {
                var message = "";
                var currentEditor = aceEditorBindingHandler.currentEditor;
                if (currentEditor != undefined) {
                    var textarea = $(currentEditor.container).find('textarea')[0];
                    if (newValue === "") {
                        message = "Please fill out this field.";
                    }
                    textarea.setCustomValidity(message);
                    setTimeout(function () {
                        var annotations = currentEditor.getSession().getAnnotations();
                        var isErrorExists = false;
                        for (var i = 0; i < annotations.length; i++) {
                            var annotationType = annotations[i].type;
                            if (annotationType === "error" || annotationType === "warning") {
                                isErrorExists = true;
                                break;
                            }
                        }
                        if (isErrorExists) {
                            message = "The script isn't a javascript legal expression!";
                            textarea.setCustomValidity(message);
                        }
                    }, 700);
                }
            });
        };
        return scriptedIndex;
    }(document));
    scriptedIndex.PREFIX = 'Raven/ScriptedIndexResults/';
    return scriptedIndex;
});

//# sourceMappingURL=scriptedIndex.js.map
