/// <reference path="../../../../typings/tsd.d.ts"/>
define(["require", "exports", "models/database/index/transformerParam"], function (require, exports, transformerParam) {
    "use strict";
    var transformerQuery = (function () {
        function transformerQuery(dto) {
            this.transformerName = dto.transformerName;
            this.queryParams = dto.queryParams;
        }
        transformerQuery.prototype.addParamByNameAndValue = function (name, value) {
            this.queryParams.push(new transformerParam(name, value));
        };
        transformerQuery.prototype.addParam = function (param) {
            this.queryParams.push(param);
        };
        transformerQuery.prototype.toUrl = function () {
            if (this.transformerName) {
                var paramsUrl = this.queryParams
                    .map(function (param) { return "tp-" + param.name + "=" + param.value; }) // transform transformerParam array into "tp-NAME=VALUE" strings (also array)
                    .join("&");
                return "&resultsTransformer=" + this.transformerName + (paramsUrl.length > 0 ? "&" + paramsUrl : "");
            }
            else {
                return "";
            }
        };
        transformerQuery.prototype.toDto = function () {
            return {
                transformerName: this.transformerName,
                queryParams: this.queryParams
            };
        };
        return transformerQuery;
    }());
    return transformerQuery;
});

//# sourceMappingURL=transformerQuery.js.map
