/// <reference path="../../../../typings/tsd.d.ts"/>
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "models/database/patch/patchParam", "models/database/documents/document", "models/database/documents/documentMetadata"], function (require, exports, patchParam, document, documentMetadata) {
    "use strict";
    var patchDocument = (function (_super) {
        __extends(patchDocument, _super);
        function patchDocument(dto) {
            var _this = _super.call(this, dto) || this;
            _this.patchOnOption = ko.observable();
            _this.selectedItem = ko.observable();
            _this.query = ko.observable();
            _this.script = ko.observable();
            _this.parameters = ko.observableArray();
            _this.allPatchOptions = ["Document", "Collection", "Index"];
            _this.patchOnOption(dto.PatchOnOption);
            _this.query(dto.Query);
            _this.script(dto.Script);
            _this.selectedItem(dto.SelectedItem);
            _this.parameters(dto.Values.map(function (val) { return new patchParam(val); }));
            _this.patchOptions = ko.computed(function () { return _this.allPatchOptions.filter(function (x) { return x !== _this.patchOnOption(); }); });
            return _this;
        }
        patchDocument.empty = function () {
            var meta = {};
            meta['Raven-Entity-Name'] = 'PatchDocuments';
            return new patchDocument({
                '@metadata': meta,
                PatchOnOption: "Document",
                Query: "",
                Script: "",
                SelectedItem: "",
                Values: []
            });
        };
        patchDocument.prototype.toDto = function () {
            var meta = this.__metadata.toDto();
            return {
                '@metadata': meta,
                PatchOnOption: this.patchOnOption(),
                Query: this.query(),
                Script: this.script(),
                SelectedItem: this.selectedItem(),
                Values: this.parameters().map(function (val) { return val.toDto(); })
            };
        };
        patchDocument.prototype.isDocumentPatch = function () {
            return this.patchOnOption() === "Document";
        };
        patchDocument.prototype.isCollectionPatch = function () {
            return this.patchOnOption() === "Collection";
        };
        patchDocument.prototype.isIndexPatch = function () {
            return this.patchOnOption() === "Index";
        };
        patchDocument.prototype.createParameter = function () {
            this.parameters.push(patchParam.empty());
        };
        patchDocument.prototype.removeParameter = function (key) {
            this.parameters.remove(key);
        };
        patchDocument.prototype.name = function () {
            return this.__metadata.id.replace('Studio/Patch/', '');
        };
        patchDocument.prototype.resetMetadata = function () {
            this.__metadata = new documentMetadata();
            this.__metadata.ravenEntityName = 'PatchDocuments';
        };
        patchDocument.prototype.clone = function () {
            return new patchDocument(this.toDto());
        };
        return patchDocument;
    }(document));
    return patchDocument;
});

//# sourceMappingURL=patchDocument.js.map
