define(["require", "exports", "models/database/patch/patchParam"], function (require, exports, patchParam) {
    "use strict";
    var patchDocuments = (function () {
        function patchDocuments(dto) {
            this.patchOnOption = ko.observable();
            this.selectedItem = ko.observable();
            this.query = ko.observable();
            this.script = ko.observable();
            this.parameters = ko.observableArray();
            this.patchOnOption(dto.PatchOnOption);
            this.query(dto.Query);
            this.script(dto.Script);
            this.selectedItem(dto.SelectedItem);
            this.parameters(dto.Values.map(function (val) { return new patchParam(val); }));
        }
        patchDocuments.empty = function () {
            return new patchDocuments({
                PatchOnOption: "Document",
                Query: "",
                Script: "",
                SelectedItem: "",
                Values: []
            });
        };
        patchDocuments.prototype.isDocumentPatch = function () {
            return this.patchOnOption() === "Document";
        };
        patchDocuments.prototype.isCollectionPatch = function () {
            return this.patchOnOption() === "Collection";
        };
        patchDocuments.prototype.isIndexPatch = function () {
            return this.patchOnOption() === "Index";
        };
        patchDocuments.prototype.createParameter = function () {
            this.parameters.push(patchParam.empty());
        };
        patchDocuments.prototype.removeParameter = function (key) {
            this.parameters.remove(key);
        };
        return patchDocuments;
    }());
    return patchDocuments;
});

//# sourceMappingURL=patchDocuments.js.map
