/// <reference path="../../../../typings/tsd.d.ts"/>
define(["require", "exports"], function (require, exports) {
    "use strict";
    var replicationPatchScript = (function () {
        function replicationPatchScript(collection, script) {
            var _this = this;
            this.collection = ko.observable();
            this.script = ko.observable();
            this.hasScript = ko.pureComputed(function () { return typeof (_this.script()) !== "undefined"; });
            this.collectionWithLabel = ko.computed(function () { return _this.collection() || "Select collection"; });
            this.collection(collection);
            this.script(script);
        }
        replicationPatchScript.empty = function () {
            return new replicationPatchScript(undefined, undefined);
        };
        replicationPatchScript.prototype.toggleScript = function () {
            if (typeof (this.script()) === "undefined") {
                this.script("");
            }
            else {
                this.script(undefined);
            }
        };
        replicationPatchScript.prototype.createSearchResults = function (collections) {
            var _this = this;
            return ko.computed(function () {
                if (_this.collection()) {
                    var collectionToLower = _this.collection().toLowerCase();
                    return collections()
                        .filter(function (collection) { return collection.name.toLowerCase().indexOf(collectionToLower) === 0; })
                        .map(function (x) { return x.name; });
                }
                else {
                    return collections().map(function (x) { return x.name; });
                }
            });
        };
        return replicationPatchScript;
    }());
    return replicationPatchScript;
});

//# sourceMappingURL=replicationPatchScript.js.map
