/// <reference path="../../../../typings/tsd.d.ts" />
define(["require", "exports", "models/database/sqlReplication/predefinedSqlConnection"], function (require, exports, predefinedConnection) {
    "use strict";
    var sqlReplicationConnections = (function () {
        function sqlReplicationConnections(dto) {
            this.predefinedConnections = ko.observableArray();
            //TODO: this.__metadata = dto["metadata"];
            if (dto) {
                var connections = [];
                for (var connectionName in dto.Connections) {
                    connections.push(new predefinedConnection(connectionName, dto.Connections[connectionName]));
                }
                this.predefinedConnections(connections);
            }
        }
        sqlReplicationConnections.empty = function () {
            return new sqlReplicationConnections({
                Connections: {},
                Id: null
            });
        };
        sqlReplicationConnections.prototype.toDto = function () {
            //TODO: var meta = this.__metadata.toDto();
            //TODO: meta["@id"] = "Raven/SqlReplication/Connections/";
            var connectionsMap = {};
            this.predefinedConnections().forEach(function (c) {
                connectionsMap[c.name()] = c.toDto();
            });
            return {
                Connections: connectionsMap,
                Id: null
            };
        };
        return sqlReplicationConnections;
    }());
    sqlReplicationConnections.sqlProvidersConnectionStrings = [
        { ProviderName: "System.Data.SqlClient", ConnectionString: "Server=[Server Address];Database=[Database Name];User Id=[User ID];Password=[Password];" },
        { ProviderName: "System.Data.SqlServerCe.4.0", ConnectionString: "Data Source=[path of .sdf file];Persist Security Info=False;" },
        { ProviderName: "System.Data.SqlServerCe.3.5", ConnectionString: "Provider=Microsoft.SQLSERVER.CE.OLEDB.3.5;Data Source=[path of .sdf file];" },
        { ProviderName: "System.Data.OleDb", ConnectionString: "" },
        { ProviderName: "System.Data.OracleClient", ConnectionString: "Data Source=[TNSNames name];User Id=[User ID];Password=[Password];Integrated Security=no;" },
        { ProviderName: "MySql.Data.MySqlClient", ConnectionString: "Server=[Server Address];Port=[Server Port(default:3306)];Database=[Database Name];Uid=[User ID];Pwd=[Password];" },
        { ProviderName: "Npgsql", ConnectionString: "Server=[Server Address];Port=[Port];Database=[Database Name];User Id=[User ID];Password=[Password];" }
    ];
    return sqlReplicationConnections;
});

//# sourceMappingURL=sqlReplicationConnections.js.map
