/// <reference path="../../../../typings/tsd.d.ts"/>
define(["require", "exports"], function (require, exports) {
    "use strict";
    var sqlReplicationTable = (function () {
        function sqlReplicationTable(dto) {
            this.tableName = ko.observable().extend({ required: true });
            this.documentKeyColumn = ko.observable().extend({ required: true });
            this.insertOnly = ko.observable(false);
            this.tableName(dto.TableName);
            this.documentKeyColumn(dto.DocumentKeyColumn);
            this.insertOnly(dto.InsertOnlyMode);
        }
        sqlReplicationTable.empty = function () {
            return new sqlReplicationTable({
                TableName: null,
                DocumentKeyColumn: null,
                InsertOnlyMode: false
            });
        };
        sqlReplicationTable.prototype.toDto = function () {
            return {
                TableName: this.tableName(),
                DocumentKeyColumn: this.documentKeyColumn(),
                InsertOnlyMode: this.insertOnly()
            };
        };
        return sqlReplicationTable;
    }());
    return sqlReplicationTable;
});

//# sourceMappingURL=sqlReplicationTable.js.map
