define(["require", "exports", "../../../common/generalUtils"], function (require, exports, genUtils) {
    "use strict";
    var indexStatistics = (function () {
        function indexStatistics(dto) {
            this.indexName = dto.Name;
            this.indexType = dto.Type;
            this.indexId = dto.Id;
            this.isStale = dto.IsStale;
            this.entriesCount = dto.EntriesCount.toLocaleString();
            this.errorsCount = dto.ErrorsCount > 0 ? dto.ErrorsCount.toLocaleString() : "0";
            this.mapAttempts = dto.MapAttempts.toLocaleString();
            this.mapSuccesses = dto.MapSuccesses.toLocaleString();
            this.mapErrors = dto.MapErrors > 0 ? dto.MapErrors.toLocaleString() : "0";
            this.mappedPerSecondRate = dto.MappedPerSecondRate;
            this.mappedPerSecondRateStr = dto.MappedPerSecondRate > 1 ? genUtils.formatNumberToStringFixed(dto.MappedPerSecondRate, 2) : "";
            this.reduceAttempts = dto.ReduceAttempts ? dto.ReduceAttempts.toLocaleString() : "";
            this.reduceSuccesses = dto.ReduceSuccesses ? dto.ReduceSuccesses.toLocaleString() : "";
            this.reduceErrors = dto.ReduceErrors > 0 ? dto.ReduceErrors.toLocaleString() : "0";
            this.reducedPerSecondRate = dto.ReducedPerSecondRate;
            this.reducedPerSecondRateStr = dto.ReducedPerSecondRate > 1 ? genUtils.formatNumberToStringFixed(dto.ReducedPerSecondRate, 2) : "";
            this.isReduceIndex = this.indexType === "AutoMapReduce" || this.indexType === "MapReduce";
            this.isFaultyIndex = this.indexType === "Faulty";
        }
        return indexStatistics;
    }());
    return indexStatistics;
});

//# sourceMappingURL=indexStatistics.js.map
