/// <reference path="../../../../typings/tsd.d.ts"/>
define(["require", "exports", "common/generalUtils"], function (require, exports, generalUtils) {
    "use strict";
    var storageReportItem = (function () {
        function storageReportItem(name, type, showType, size, internalChildren) {
            if (internalChildren === void 0) { internalChildren = null; }
            this.pageCount = null;
            this.numberOfEntries = null;
            this.lazyLoadChildren = false;
            this.name = name;
            this.type = type;
            this.showType = showType;
            this.size = size;
            this.internalChildren = internalChildren;
        }
        storageReportItem.prototype.formatSize = function () {
            return generalUtils.formatBytesToSize(this.size);
        };
        storageReportItem.prototype.formatPercentage = function (parentSize) {
            return (this.size * 100 / parentSize).toFixed(2) + '%';
        };
        storageReportItem.prototype.hasChildren = function () {
            return this.internalChildren && this.internalChildren.length > 0;
        };
        return storageReportItem;
    }());
    return storageReportItem;
});

//# sourceMappingURL=storageReportItem.js.map
