/// <reference path="../../../../typings/tsd.d.ts"/>
define(["require", "exports"], function (require, exports) {
    "use strict";
    var Subscription = (function () {
        function Subscription(id, etag) {
            var _this = this;
            this.id = id;
            this.etag = etag;
            this.ackEtag = ko.observable();
            this.newAckEtag = ko.observable();
            this.isChangeInProgress = ko.observable();
            this.subscriptionId = id;
            this.ackEtag(etag);
            this.newAckEtag(etag);
            this.isButtonDisabled = ko.computed(function () { return _this.ackEtag() === _this.newAckEtag() || _this.isChangeInProgress(); });
            this.etagCustomValidityError = ko.computed(function () {
                var errorMessage = "";
                var currentNewAckEtag = _this.newAckEtag();
                if (currentNewAckEtag.length !== 36) {
                    errorMessage = "Etag length is invalid";
                }
                else if (currentNewAckEtag[8] !== "-" || currentNewAckEtag[13] !== "-" ||
                    currentNewAckEtag[18] !== "-" || currentNewAckEtag[23] !== "-") {
                    errorMessage = "Invalid etag format";
                }
                return errorMessage;
            });
        }
        return Subscription;
    }());
    return Subscription;
});

//# sourceMappingURL=subscription.js.map
