define(["require", "exports"], function (require, exports) {
    "use strict";
    var exportDatabaseModel = (function () {
        function exportDatabaseModel() {
            this.includeDocuments = ko.observable(true);
            this.includeIndexes = ko.observable(true);
            this.includeTransformers = ko.observable(true);
            this.includeIdentities = ko.observable(true);
            this.includeRevisionDocuments = ko.observable(true);
            this.exportFileName = ko.observable();
            this.includeExpiredDocuments = ko.observable(false);
            this.removeAnalyzers = ko.observable(false);
            this.includeAllCollections = ko.observable(true);
            this.includedCollections = ko.observableArray([]);
            this.transformScript = ko.observable();
        }
        exportDatabaseModel.prototype.toDto = function () {
            var operateOnTypes = [];
            if (this.includeDocuments()) {
                operateOnTypes.push("Documents");
            }
            if (this.includeIndexes()) {
                operateOnTypes.push("Indexes");
            }
            if (this.includeTransformers()) {
                operateOnTypes.push("Transformers");
            }
            if (this.includeIdentities()) {
                operateOnTypes.push("Identities");
            }
            if (this.includeRevisionDocuments()) {
                operateOnTypes.push("RevisionDocuments");
            }
            return {
                CollectionsToExport: this.includeAllCollections() ? null : this.includedCollections(),
                FileName: this.exportFileName(),
                IncludeExpired: this.includeExpiredDocuments(),
                TransformScript: this.transformScript(),
                RemoveAnalyzers: this.removeAnalyzers(),
                OperateOnTypes: operateOnTypes.join(",")
            };
        };
        return exportDatabaseModel;
    }());
    return exportDatabaseModel;
});

//# sourceMappingURL=exportDatabaseModel.js.map
