define(["require", "exports"], function (require, exports) {
    "use strict";
    var importDatabaseModel = (function () {
        function importDatabaseModel() {
            this.includeDocuments = ko.observable(true);
            this.includeIndexes = ko.observable(true);
            this.includeTransformers = ko.observable(true);
            this.includeIdentities = ko.observable(true);
            this.removeAnalyzers = ko.observable(false);
            this.includeRevisionDocuments = ko.observable(true);
            this.includeExpiredDocuments = ko.observable(true);
            this.shouldDisableVersioningBundle = ko.observable(false);
            this.transformScript = ko.observable();
        }
        importDatabaseModel.prototype.toDto = function () {
            var operateOnTypes = [];
            if (this.includeDocuments()) {
                operateOnTypes.push("Documents");
            }
            if (this.includeIndexes()) {
                operateOnTypes.push("Indexes");
            }
            if (this.includeTransformers()) {
                operateOnTypes.push("Transformers");
            }
            if (this.includeRevisionDocuments()) {
                operateOnTypes.push("RevisionDocuments");
            }
            if (this.includeIdentities()) {
                operateOnTypes.push("Identities");
            }
            return {
                IncludeExpired: this.includeExpiredDocuments(),
                TransformScript: this.transformScript(),
                RemoveAnalyzers: this.removeAnalyzers(),
                DisableVersioningBundle: this.shouldDisableVersioningBundle(),
                OperateOnTypes: operateOnTypes.join(",")
            };
        };
        return importDatabaseModel;
    }());
    return importDatabaseModel;
});

//# sourceMappingURL=importDatabaseModel.js.map
