define(["require", "exports", "commands/filesystem/getConfigurationByKeyCommand"], function (require, exports, getConfigurationByKeyCommand) {
    "use strict";
    var configurationKey = (function () {
        function configurationKey(fs, key) {
            this.fs = fs;
            this.key = key;
        }
        // Notifies consumers that this configuration key should be the selected one.
        // Called from the UI when a user clicks a configuration key the configuration page.
        configurationKey.prototype.activate = function () {
            ko.postbox.publish("ActivateConfigurationKey", this);
        };
        configurationKey.prototype.getValues = function () {
            return new getConfigurationByKeyCommand(this.fs, this.key).execute();
        };
        return configurationKey;
    }());
    return configurationKey;
});

//# sourceMappingURL=configurationKey.js.map
