/// <reference path="../../../typings/tsd.d.ts"/>
define(["require", "exports", "models/filesystem/conflictHistory"], function (require, exports, conflictHistory) {
    "use strict";
    var conflictItem = (function () {
        function conflictItem(fileName, remoteServerUrl, resolveUsingRemote) {
            this.resolveUsingRemote = false;
            this.fileName = fileName;
            this.remoteServerUrl = remoteServerUrl;
            this.remoteHistory = [];
            this.currentHistory = [];
            this.resolveUsingRemote = resolveUsingRemote;
            this.status = this.resolveUsingRemote ? "Scheduled resolution using remote version" : "Not resolved";
        }
        conflictItem.prototype.getDocumentPropertyNames = function () {
            return ["id", "fileName", "remoteServerUrl", "status"];
        };
        conflictItem.prototype.getId = function () {
            return this.fileName;
        };
        conflictItem.prototype.getUrl = function () {
            return this.fileName;
        };
        conflictItem.fromConflictItemDto = function (dto) {
            var item = new conflictItem(dto.FileName, dto.RemoteServerUrl, dto.ResolveUsingRemote);
            if (dto.RemoteHistory != null) {
                var remoteHistory = dto.RemoteHistory.map(function (x) { return new conflictHistory(x.Version, x.ServerId); });
                (_a = item.remoteHistory).push.apply(_a, remoteHistory);
            }
            if (dto.CurrentHistory != null) {
                var currentHistory = dto.CurrentHistory.map(function (x) { return new conflictHistory(x.Version, x.ServerId); });
                (_b = item.currentHistory).push.apply(_b, currentHistory);
            }
            return item;
            var _a, _b;
        };
        return conflictItem;
    }());
    return conflictItem;
});

//# sourceMappingURL=conflictItem.js.map
