/// <reference path="../../../typings/tsd.d.ts"/>
define(["require", "exports", "models/filesystem/fileMetadata"], function (require, exports, fileMetadata) {
    "use strict";
    var file = (function () {
        function file(dto, excludeDirectoryInId) {
            this.id = ko.observable();
            if (dto) {
                if (dto.FullPath && dto.FullPath[0] === "/") {
                    dto.FullPath = dto.FullPath.replace("/", "");
                }
                if (excludeDirectoryInId) {
                    this.id(dto.Name);
                }
                else {
                    this.id(dto.FullPath);
                }
                if (dto.HumaneTotalSize === " Bytes") {
                    dto.HumaneTotalSize = "0 Bytes";
                }
                this.directory = dto.Directory;
                this.fullPath = dto.FullPath;
                this.Size = dto.HumaneTotalSize;
                this.LastModified = dto.Metadata["Last-Modified"];
                this.__metadata = new fileMetadata(dto.Metadata);
            }
        }
        file.prototype.getId = function () {
            return this.id();
        };
        file.prototype.setId = function (newName) {
            this.id(newName);
        };
        file.prototype.getUrl = function () {
            return this.fullPath ? this.fullPath : this.id();
        };
        file.prototype.getDocumentPropertyNames = function () {
            return ["Size", "LastModified"];
        };
        return file;
    }());
    return file;
});

//# sourceMappingURL=file.js.map
