/// <reference path="../../../typings/tsd.d.ts"/>
define(["require", "exports"], function (require, exports) {
    "use strict";
    var fileSystemStatistics = (function () {
        function fileSystemStatistics() {
            this.fileCountText = ko.observable();
            this.requestsCountText = ko.observable();
            this.meanDurationText = ko.observable();
        }
        fileSystemStatistics.prototype.fromDto = function (dto) {
            this.fileCountText(this.getItemCountText(dto.FileCount, "file", "s"));
            this.requestsCountText(dto.Metrics.RequestsPerSecond + " requests per second");
            this.meanDurationText(dto.Metrics.RequestsDuration.Mean.toFixed(1) + "ms mean duration");
        };
        fileSystemStatistics.prototype.getItemCountText = function (itemCount, singularText, suffix) {
            var itemCountText = itemCount.toLocaleString() + " " + singularText;
            if (itemCount !== 1) {
                itemCountText += suffix;
            }
            return itemCountText;
        };
        return fileSystemStatistics;
    }());
    return fileSystemStatistics;
});

//# sourceMappingURL=fileSystemStatistics.js.map
