define(["require", "exports", "common/pagedList"], function (require, exports, pagedList) {
    "use strict";
    var filesystemCollection = (function () {
        function filesystemCollection(name, owner) {
            this.name = name;
            this.owner = owner;
            this.itemsCount = ko.observable(0);
            this.isAllItems = false;
        }
        // Notifies consumers that this collection should be the selected one.
        // Called from the UI when a user clicks a collection the documents page.
        filesystemCollection.prototype.activate = function () {
            ko.postbox.publish("ActivateCollection", this);
        };
        filesystemCollection.prototype.getItems = function () {
            if (!this.itemsList) {
                this.itemsList = this.createPagedList();
            }
            return this.itemsList;
        };
        filesystemCollection.prototype.fetchItems = function (skip, take) {
            throw new Error('This method is abstract');
        };
        filesystemCollection.prototype.createPagedList = function () {
            var _this = this;
            var fetcher = function (skip, take) { return _this.fetchItems(skip, take); };
            var list = new pagedList(fetcher);
            list.collectionName = this.name;
            return list;
        };
        return filesystemCollection;
    }());
    return filesystemCollection;
});

//# sourceMappingURL=filesystemCollection.js.map
