/// <reference path="../../../typings/tsd.d.ts"/>
define(["require", "exports"], function (require, exports) {
    "use strict";
    var folder = (function () {
        function folder(path) {
            this.path = path;
            if (path) {
                var lastSlash = path.lastIndexOf("/");
                if (lastSlash > 0) {
                    this.name = path.substring(lastSlash + 1);
                }
                else {
                    this.name = path.substring(1);
                }
            }
        }
        folder.getFolderFromFilePath = function (filePath) {
            var lastSlash = filePath.lastIndexOf("/");
            if (lastSlash == 0) {
                return new folder("/");
            }
            if (lastSlash > 0) {
                return new folder(filePath.substring(0, lastSlash));
            }
            return null;
        };
        folder.prototype.getSubpathsFrom = function (basePath) {
            if (basePath) {
                if (basePath[basePath.length - 1] != "/") {
                    basePath = basePath + "/";
                }
                var restOfPath = this.path.replace(basePath, "");
                var subPaths = [new folder(basePath)];
                var lastIndexOfSlash = restOfPath.indexOf("/");
                for (var i = 0; i < restOfPath.match(/\//g).length; i++) {
                    if (lastIndexOfSlash > 0) {
                        subPaths.push(new folder(basePath + restOfPath.substring(0, lastIndexOfSlash)));
                    }
                    lastIndexOfSlash = restOfPath.indexOf("/", lastIndexOfSlash + 1);
                }
                subPaths.push(new folder(this.path));
                return subPaths;
            }
            return null;
        };
        folder.prototype.isFileAtFolderLevel = function (filePath) {
            var fileToFolder = folder.getFolderFromFilePath(filePath);
            return fileToFolder && this.path === fileToFolder.path;
        };
        return folder;
    }());
    return folder;
});

//# sourceMappingURL=folder.js.map
