/// <reference path="../../../typings/tsd.d.ts"/>
define(["require", "exports"], function (require, exports) {
    "use strict";
    var synchronizationDetail = (function () {
        function synchronizationDetail(dto, direction, status) {
            this.FileName = ko.observable();
            this.FileEtag = ko.observable();
            this.DestinationUrl = ko.observable();
            this.Type = ko.observable();
            this.TypeDescription = ko.observable();
            this.Status = ko.observable();
            this.Direction = ko.observable();
            this.AdditionalInfo = ko.observable();
            this.FileName(dto.FileName);
            this.FileEtag(dto.FileETag);
            this.DestinationUrl(dto.DestinationUrl);
            this.Type(synchronizationDetail.getType(dto.Type));
            this.TypeDescription(synchronizationDetail.getTypeDescription(this.Type()));
            this.Status(status);
            this.Direction(direction);
        }
        synchronizationDetail.prototype.getId = function () {
            return this.FileName();
        };
        synchronizationDetail.prototype.getUrl = function () {
            return this.getId();
        };
        synchronizationDetail.prototype.getDocumentPropertyNames = function () {
            return ["Id", "FileEtag", "DestinationUrl", "Type", "Status"];
        };
        synchronizationDetail.getType = function (typeAsString) {
            switch (typeAsString) {
                case "ContentUpdate":
                    return 1 /* ContentUpdate */;
                case "Delete":
                    return 4 /* Delete */;
                case "MetadataUpdate":
                    return 2 /* MetadataUpdate */;
                case "Rename":
                    return 3 /* Rename */;
                default:
                    return 0 /* Unknown */;
            }
        };
        synchronizationDetail.getTypeDescription = function (type) {
            switch (type) {
                case 1 /* ContentUpdate */:
                    return "Content Update";
                case 4 /* Delete */:
                    return "Delete";
                case 2 /* MetadataUpdate */:
                    return "Metadata Update";
                case 3 /* Rename */:
                    return "Rename";
                default:
                    return "Unknown";
            }
        };
        return synchronizationDetail;
    }());
    return synchronizationDetail;
});

//# sourceMappingURL=synchronizationDetail.js.map
