define(["require", "exports", "models/filesystem/synchronizationDestination"], function (require, exports, synchronizationDestination) {
    "use strict";
    var synchronizationReplicationSetup = (function () {
        function synchronizationReplicationSetup(dto) {
            this.source = ko.observable();
            this.destinations = ko.observableArray().extend({ required: true });
            this.source(dto.Source);
            this.destinations(dto.Destinations.map(function (dest) { return new synchronizationDestination(dest); }));
        }
        synchronizationReplicationSetup.prototype.toDto = function () {
            return {
                Destinations: this.destinations().map(function (dest) { return dest.toDto(); }),
                Source: this.source()
            };
        };
        return synchronizationReplicationSetup;
    }());
    return synchronizationReplicationSetup;
});

//# sourceMappingURL=synchronizationReplicationSetup.js.map
