/// <reference path="../../../typings/tsd.d.ts"/>
define(["require", "exports"], function (require, exports) {
    "use strict";
    var databaseStatistics = (function () {
        function databaseStatistics() {
            this.countOfDocuments = ko.observable();
            this.databaseId = ko.observable();
            this.countOfDocumentsText = ko.observable();
            this.countOfIndexesText = ko.observable();
            this.staleFilteredIndexesCountText = ko.observable();
            this.countOfFilteredIndexesText = ko.observable();
            this.staleIndexesCountText = ko.observable();
            this.errorsCountText = ko.observable();
        }
        databaseStatistics.prototype.fromDto = function (dto) {
            this.countOfDocuments(dto.CountOfDocuments);
            this.databaseId(dto.DatabaseId);
            this.countOfFilteredIndexesText("0 indexes"); //TODO: this.getItemCountText(dto.CountOfIndexesExcludingDisabledAndAbandoned, "index", "es")
            this.staleFilteredIndexesCountText("0 stale"); //TODO: dto.CountOfStaleIndexesExcludingDisabledAndAbandoned.toLocaleString() + " stale"
            this.errorsCountText("0 errors"); //TODO: this.getItemCountText(dto.Errors.length, "error", "s")
            this.countOfDocumentsText("0 documents"); //TODO: this.getItemCountText(dto.CountOfDocuments, "document", "s")
            this.countOfIndexesText("0 indexes"); //TODO: this.getItemCountText(dto.CountOfIndexes, "index", "es")
            this.staleIndexesCountText("0 stale"); //TODO: dto.StaleIndexes.length.toLocaleString() + " stale"
            this.errorsCountText("0 errors"); //TODO: this.getItemCountText(dto.Errors.length, "error", "s")
        };
        databaseStatistics.prototype.getItemCountText = function (itemCount, singularText, suffix) {
            if (!itemCount) {
                itemCount = 0;
            }
            var itemCountText = itemCount.toLocaleString() + " " + singularText;
            if (itemCount !== 1) {
                itemCountText += suffix;
            }
            return itemCountText;
        };
        return databaseStatistics;
    }());
    return databaseStatistics;
});

//# sourceMappingURL=databaseStatistics.js.map
