/// <reference path="../../../typings/tsd.d.ts"/>
define(["require", "exports", "common/constants/events"], function (require, exports, EVENTS) {
    "use strict";
    var resource = (function () {
        function resource(rsInfo) {
            this.isAdminCurrentTenant = ko.observable(false);
            this.activeBundles = ko.observableArray();
            this.disabled = ko.observable(false);
        }
        resource.prototype.activate = function () {
            ko.postbox.publish(EVENTS.Resource.Activate, {
                resource: this
            });
        };
        resource.prototype.updateUsing = function (incomingCopy) {
            this.isAdminCurrentTenant(incomingCopy.IsAdmin);
            this.activeBundles(incomingCopy.Bundles);
            this.name = incomingCopy.Name;
            this.disabled(incomingCopy.Disabled);
        };
        Object.defineProperty(resource.prototype, "qualifiedName", {
            get: function () {
                return this.qualifier + "/" + this.name;
            },
            enumerable: true,
            configurable: true
        });
        return resource;
    }());
    return resource;
});

//# sourceMappingURL=resource.js.map
