/// <reference path="../../../typings/tsd.d.ts"/>
define(["require", "exports"], function (require, exports) {
    "use strict";
    var serverSmugglingItem = (function () {
        function serverSmugglingItem(database) {
            var _this = this;
            this.incremental = ko.observable(true);
            this.stripReplicationInformation = ko.observable(false);
            this.shouldDisableVersioningBundle = ko.observable(false);
            this.resource = database;
            this.hasReplicationBundle = ko.computed(function () { return _this.resource.isBundleActive("replication"); });
            this.hasVersioningBundle = ko.computed(function () { return _this.resource.isBundleActive("versioning"); });
        }
        serverSmugglingItem.prototype.toDto = function () {
            return {
                Name: this.resource.name,
                Incremental: this.incremental(),
                StripReplicationInformation: this.stripReplicationInformation(),
                ShouldDisableVersioningBundle: this.shouldDisableVersioningBundle()
            };
        };
        return serverSmugglingItem;
    }());
    return serverSmugglingItem;
});

//# sourceMappingURL=serverSmugglingItem.js.map
