/// <reference path="../../../typings/tsd.d.ts"/>
define(["require", "exports"], function (require, exports) {
    "use strict";
    var pointChange = (function () {
        function pointChange(point, isNew) {
            if (isNew === void 0) { isNew = false; }
            var _this = this;
            this.type = ko.observable("");
            this.key = ko.observable("");
            this.at = ko.observable();
            this.fields = ko.observableArray();
            this.values = ko.observableArray();
            this.isNew = ko.observable(false);
            this.type(point.type);
            this.key(point.key);
            this.at(point.At);
            this.fields(point.fields);
            this.values(point.values);
            this.isNew(isNew);
            this.typeCustomValidityError = ko.computed(function () {
                var type = _this.type();
                if (!$.trim(type))
                    return "'Type' cannot be empty";
                if (type.length > 255) {
                    return "'Type' length can't exceed 255 characters";
                }
                if (type.includes('\\')) {
                    return "'Type' cannot contain '\\' char";
                }
                return "";
            });
            this.keyCustomValidityError = ko.computed(function () {
                var key = _this.key();
                if (!$.trim(key))
                    return "'key' cannot be empty";
                if (key.length > 255) {
                    return "'key' length can't exceed 255 characters";
                }
                return "";
            });
            this.atCustomValidityError = ko.computed(function () {
                var at = _this.at();
                if (!$.trim(at))
                    return "'At' cannot be empty";
                // Todo: Validate a valid DateTime.ticks value
                return "";
            });
        }
        pointChange.prototype.isNumber = function (num) {
            if (num < 0)
                return true;
            var n1 = Math.abs(num);
            var n2 = parseInt(num, 10);
            return !isNaN(n1) && n2 === n1 && n1.toString() === num;
        };
        return pointChange;
    }());
    return pointChange;
});

//# sourceMappingURL=pointChange.js.map
