/// <reference path="../../../typings/tsd.d.ts"/>
define(["require", "exports"], function (require, exports) {
    "use strict";
    var timeSeriesStatistics = (function () {
        function timeSeriesStatistics() {
            this.typesCount = ko.observable();
            this.keysCount = ko.observable();
            this.pointsCount = ko.observable();
            this.typesCountText = ko.observable("");
            this.keysCountText = ko.observable("");
            this.pointsCountText = ko.observable("");
            this.requestsPerSecondText = ko.observable("");
            this.timeSeriesSize = ko.observable("");
        }
        timeSeriesStatistics.prototype.getItemCountText = function (itemCount, singularText, suffix) {
            var itemCountText = itemCount.toLocaleString() + " " + singularText;
            if (itemCount !== 1) {
                itemCountText += suffix;
            }
            return itemCountText;
        };
        timeSeriesStatistics.prototype.fromDto = function (dto) {
            this.typesCount(dto.TypesCount);
            this.keysCount(dto.KeysCount);
            this.pointsCount(dto.PointsCount);
            this.typesCountText(this.getItemCountText(dto.TypesCount, "type", "s"));
            this.keysCountText(this.getItemCountText(dto.KeysCount, "key", "s"));
            this.pointsCountText(this.getItemCountText(dto.PointsCount, "point", "s"));
            this.requestsPerSecondText(dto.RequestsPerSecond + " requests per second");
            this.timeSeriesSize(dto.TimeSeriesSize);
        };
        return timeSeriesStatistics;
    }());
    return timeSeriesStatistics;
});

//# sourceMappingURL=timeSeriesStatistics.js.map
