define(["require", "exports"], function (require, exports) {
    "use strict";
    var typeChange = (function () {
        function typeChange(type, isNew) {
            if (isNew === void 0) { isNew = false; }
            var _this = this;
            this.type = ko.observable("");
            this.fields = ko.observableArray();
            this.isNew = ko.observable(false);
            this.type(type.name);
            this.fields(type.fields);
            this.isNew(isNew);
            this.typeCustomValidityError = ko.computed(function () {
                var name = _this.type();
                if (!$.trim(name))
                    return "Type name cannot be empty";
                if (name.length > 255) {
                    return "Type name length can't exceed 255 characters";
                }
                if (name.includes('\\')) {
                    return "Type name cannot contain '\\' char";
                }
                return "";
            });
        }
        typeChange.prototype.addField = function () {
            this.fields.push("");
        };
        typeChange.prototype.removeField = function (field) {
            this.fields.remove(field);
        };
        return typeChange;
    }());
    return typeChange;
});

//# sourceMappingURL=typeChange.js.map
