/*
Taken from: https://github.com/mbejda/BootstrapModalDurandalJS/blob/master/bootstrapModal.js

with LOCAL modifications!
*/
define(["require", "exports", "durandal/system", "plugins/dialog", "durandal/app", "durandal/viewEngine", "knockout"], function (require, exports, system, dialog, app, viewEngine, ko) {
    "use strict";
    var closeCalled = false;
    dialog.addContext('bootstrapModal', {
        closeCalled: false,
        blockoutOpacity: .2,
        removeDelay: 300,
        addHost: function (theDialog) {
            var body = $('body');
            var host = $('<div class="modal" id="bootstrapModal" tabindex="-1" role="dialog" aria-labelledby="bootstrapModal" aria-hidden="true"></div>')
                .appendTo(body);
            theDialog.host = host.get(0);
            closeCalled = false;
        },
        removeHost: function (theDialog) {
            closeCalled = true;
            $('#bootstrapModal').modal('hide');
            $('body').removeClass('modal-open');
        },
        attached: null,
        compositionComplete: function (child, parent, context) {
            var theDialog = dialog.getDialog(context.model);
            var options = {};
            options.show = true;
            if ($(child).hasClass('prevent-close')) {
                options.backdrop = 'static';
                options.keyboard = false;
            }
            $('#bootstrapModal').modal(options);
            $('#bootstrapModal').on('hidden.bs.modal', function (e) {
                if (!closeCalled) {
                    theDialog.close();
                }
                ko.removeNode(theDialog.host);
                $('.modal-backdrop').remove();
            });
        }
    });
    var bootstrapMarkup = [
        '<div data-view="plugins/messageBox" data-bind="css: getClass(), style: getStyle()">',
        '<div class="modal-content">',
        '<div class="modal-header">',
        '<h3 data-bind="html: title"></h3>',
        '</div>',
        '<div class="modal-body">',
        '<p class="message" data-bind="html: message"></p>',
        '</div>',
        '<div class="modal-footer">',
        '<!-- ko foreach: options -->',
        '<button data-bind="click: function () { $parent.selectOption($parent.getButtonValue($data)); }, text: $parent.getButtonText($data), css: $parent.getButtonClass($index)"></button>',
        '<!-- /ko -->',
        '<div style="clear:both;"></div>',
        '</div>',
        '</div>',
        '</div>'
    ].join('\n');
    var bootstrapModal = (function () {
        function bootstrapModal() {
        }
        bootstrapModal.install = function () {
            app.showBootstrapDialog = function (obj, activationData) { return dialog.show(obj, activationData, 'bootstrapModal'); };
            app.showBootstrapMessage = function (message, title, options, autoclose, settings) {
                return dialog.showBootstrapMessage(message, title, options, autoclose, settings);
            };
            dialog.showBootstrapDialog = function (obj, activationData) { return dialog.show(obj, activationData, 'bootstrapModal'); };
            dialog.showBootstrapMessage = function (message, title, options, autoclose, settings) {
                if (system.isString(dialog.MessageBox)) {
                    return dialog.show(dialog.MessageBox, [
                        message,
                        title || dialog.MessageBox.defaultTitle,
                        options || dialog.MessageBox.defaultOptions,
                        autoclose || false,
                        settings || {}
                    ], 'bootstrapModal');
                }
                var bootstrapDefaults = {
                    buttonClass: "btn btn-default",
                    primaryButtonClass: "btn-primary autofocus",
                    secondaryButtonClass: "",
                    "class": "modal-dialog",
                    style: null
                };
                dialog.MessageBox.prototype.getView = function () { return viewEngine.processMarkup(bootstrapMarkup); };
                var bootstrapSettings = $.extend(bootstrapDefaults, settings);
                return dialog.show(new dialog.MessageBox(message, title, options, autoclose, bootstrapSettings), {}, 'bootstrapModal');
            };
            dialog.MessageBox.prototype.compositionComplete = function (child, parent, context) {
                var theDialog = dialog.getDialog(context.model);
                var $child = $(child);
                if ($child.hasClass('autoclose') || context.model.autoclose) {
                    $(theDialog.blockout).click(function () {
                        theDialog.close();
                    });
                }
            };
        };
        return bootstrapModal;
    }());
    return bootstrapModal;
});

//# sourceMappingURL=bootstrapModal.js.map
