var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "plugins/dialog", "commands/database/documents/deleteDocumentsCommand", "viewmodels/dialogViewModelBase"], function (require, exports, dialog, deleteDocumentsCommand, dialogViewModelBase) {
    "use strict";
    var deleteDocuments = (function (_super) {
        __extends(deleteDocuments, _super);
        function deleteDocuments(documents, db) {
            var _this = _super.call(this, null) || this;
            _this.db = db;
            _this.documents = ko.observableArray();
            _this.deletionStarted = false;
            _this.deletionTask = $.Deferred(); // Gives consumers a way to know when the async delete operation completes.
            if (documents.length === 0) {
                throw new Error("Must have at least one document to delete.");
            }
            _this.documents(documents);
            return _this;
        }
        deleteDocuments.prototype.deleteDocs = function () {
            var _this = this;
            var deletedDocIds = this.documents().map(function (i) { return i.getId(); });
            var deleteCommand = new deleteDocumentsCommand(deletedDocIds, this.db);
            var deleteCommandTask = deleteCommand.execute();
            deleteCommandTask.done(function () { return _this.deletionTask.resolve(_this.documents()); });
            deleteCommandTask.fail(function (response) { return _this.deletionTask.reject(response); });
            this.deletionStarted = true;
            dialog.close(this);
        };
        deleteDocuments.prototype.cancel = function () {
            dialog.close(this);
        };
        deleteDocuments.prototype.deactivate = function (args) {
            _super.prototype.deactivate.call(this, args);
            // If we were closed via X button or other dialog dismissal, reject the deletion task since
            // we never carried it out.
            if (!this.deletionStarted) {
                this.deletionTask.reject();
            }
        };
        return deleteDocuments;
    }(dialogViewModelBase));
    return deleteDocuments;
});

//# sourceMappingURL=deleteDocuments.js.map
