var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "plugins/dialog", "viewmodels/dialogViewModelBase", "common/oauthContext", "common/apiKeyLocalStorage"], function (require, exports, dialog, dialogViewModelBase, oauthContext, apiKeyLocalStorage) {
    "use strict";
    var enterApiKey = (function (_super) {
        __extends(enterApiKey, _super);
        function enterApiKey() {
            var _this = _super.apply(this, arguments) || this;
            _this.apiKey = ko.observable("");
            _this.saveInLocalStorage = ko.observable(false);
            return _this;
        }
        enterApiKey.prototype.cancel = function () {
            dialog.close(this);
        };
        enterApiKey.prototype.ok = function () {
            oauthContext.apiKey(this.apiKey());
            if (this.saveInLocalStorage()) {
                apiKeyLocalStorage.setValue(this.apiKey());
            }
            else {
                apiKeyLocalStorage.clean();
            }
            dialog.close(this);
        };
        return enterApiKey;
    }(dialogViewModelBase));
    return enterApiKey;
});

//# sourceMappingURL=enterApiKey.js.map
