var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "common/constants/events", "viewmodels/viewModelBase", "commands/resources/getDatabaseStatsCommand", "plugins/router", "models/resources/database", "common/appUrl"], function (require, exports, EVENTS, viewModelBase, getDatabaseStatsCommand, router, database, appUrl) {
    "use strict";
    var upgrade = (function (_super) {
        __extends(upgrade, _super);
        function upgrade() {
            var _this = _super.apply(this, arguments) || this;
            _this.inProgress = ko.observable(true);
            return _this;
        }
        upgrade.prototype.attached = function () {
            var _this = this;
            _super.prototype.attached.call(this);
            this.poolStats();
            ko.postbox.subscribe(EVENTS.Resource.Activate, function (e) {
                if (e.resource instanceof database) {
                    _this.dbChanged(e.resource);
                }
            });
        };
        upgrade.prototype.dbChanged = function (db) {
            router.navigate(appUrl.forDocuments(null, db));
        };
        upgrade.prototype.poolStats = function () {
            var _this = this;
            this.fetchStats()
                .done(function () {
                _this.inProgress(false);
            }).fail(function () {
                _this.timeoutHandle = setTimeout(_this.poolStats(), 500);
            });
        };
        upgrade.prototype.detached = function () {
            clearTimeout(this.timeoutHandle);
        };
        upgrade.prototype.fetchStats = function () {
            var db = this.activeDatabase();
            if (db) {
                return new getDatabaseStatsCommand(db)
                    .execute();
            }
            return null;
        };
        return upgrade;
    }(viewModelBase));
    return upgrade;
});

//# sourceMappingURL=upgrade.js.map
