var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "plugins/dialog", "commands/counter/deleteCountersByGroupCommand", "viewmodels/dialogViewModelBase"], function (require, exports, dialog, deleteCountersByGroupCommand, dialogViewModelBase) {
    "use strict";
    var deleteGroup = (function (_super) {
        __extends(deleteGroup, _super);
        function deleteGroup(group, cs) {
            var _this = _super.call(this) || this;
            _this.group = group;
            _this.cs = cs;
            _this.deletionTask = $.Deferred();
            _this.deletionStarted = false;
            return _this;
        }
        deleteGroup.prototype.deleteGroup = function () {
            var _this = this;
            var deleteCommand = new deleteCountersByGroupCommand(this.group, this.cs);
            var deleteCommandTask = deleteCommand.execute();
            deleteCommandTask.done(function (result) { return _this.deletionTask.resolve(result); });
            deleteCommandTask.fail(function (response) { return _this.deletionTask.reject(response); });
            this.deletionStarted = true;
            dialog.close(this);
        };
        deleteGroup.prototype.cancel = function () {
            dialog.close(this);
        };
        deleteGroup.prototype.deactivate = function () {
            // If we were closed via X button or other dialog dismissal, reject the deletion task since
            // we never started it.
            if (!this.deletionStarted) {
                this.deletionTask.reject();
            }
        };
        return deleteGroup;
    }(dialogViewModelBase));
    return deleteGroup;
});

//# sourceMappingURL=deleteGroup.js.map
