var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "plugins/dialog", "viewmodels/dialogViewModelBase", "models/counter/counterChange"], function (require, exports, dialog, dialogViewModelBase, counterChange) {
    "use strict";
    var editCounterDialog = (function (_super) {
        __extends(editCounterDialog, _super);
        function editCounterDialog(editedCounter) {
            var _this = _super.call(this) || this;
            _this.updateTask = $.Deferred();
            _this.updateTaskStarted = false;
            _this.editedCounter = ko.observable();
            _this.editedCounter(!editedCounter ? counterChange.empty() : editedCounter);
            _this.isNew = ko.computed(function () { return !!_this.editedCounter() && _this.editedCounter().isNew(); });
            return _this;
        }
        editCounterDialog.prototype.cancel = function () {
            dialog.close(this);
        };
        editCounterDialog.prototype.nextOrCreate = function () {
            this.updateTaskStarted = true;
            this.updateTask.resolve(this.editedCounter());
            dialog.close(this);
        };
        editCounterDialog.prototype.deactivate = function () {
            // If we were closed via X button or other dialog dismissal, reject the deletion task since
            // we never started it.
            if (!this.updateTaskStarted) {
                this.updateTask.reject();
            }
        };
        return editCounterDialog;
    }(dialogViewModelBase));
    return editCounterDialog;
});

//# sourceMappingURL=editCounterDialog.js.map
