var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "plugins/dialog", "viewmodels/dialogViewModelBase"], function (require, exports, dialog, dialogViewModelBase) {
    "use strict";
    var copyDocuments = (function (_super) {
        __extends(copyDocuments, _super);
        function copyDocuments(documents, elementToFocusOnDismissal) {
            var _this = _super.call(this, elementToFocusOnDismissal) || this;
            _this.isCopyingDocs = ko.observable(true);
            _this.documentsOrIdsText = ko.computed(function () {
                var prettifySpacing = 4;
                if (_this.isCopyingDocs()) {
                    return documents.map(function (d) { return d.getId() + "\r\n" + JSON.stringify(d.toDto(false), null, prettifySpacing); }).join("\r\n\r\n");
                }
                else {
                    return documents.map(function (d) { return d.getId(); }).join(", ");
                }
            });
            return _this;
        }
        copyDocuments.prototype.attached = function () {
            var _this = this;
            _super.prototype.attached.call(this);
            this.selectText();
            jwerty.key("CTRL+C, enter", function (e) {
                e.preventDefault();
                _this.close();
            }, this, "#documentsText");
        };
        copyDocuments.prototype.deactivate = function () {
            $("#documentsText").unbind('keydown.jwerty');
        };
        copyDocuments.prototype.selectText = function () {
            $("#documentsText").select();
        };
        copyDocuments.prototype.close = function () {
            dialog.close(this);
        };
        copyDocuments.prototype.activateDocs = function () {
            this.isCopyingDocs(true);
            this.selectText();
        };
        copyDocuments.prototype.activateIds = function () {
            this.isCopyingDocs(false);
            this.selectText();
        };
        return copyDocuments;
    }(dialogViewModelBase));
    return copyDocuments;
});

//# sourceMappingURL=copyDocuments.js.map
