var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "plugins/dialog", "commands/database/documents/deleteCollectionCommand", "viewmodels/dialogViewModelBase"], function (require, exports, dialog, deleteCollectionCommand, dialogViewModelBase) {
    "use strict";
    var deleteCollection = (function (_super) {
        __extends(deleteCollection, _super);
        function deleteCollection(collection, db) {
            var _this = _super.call(this) || this;
            _this.collection = collection;
            _this.db = db;
            _this.deletionTask = $.Deferred();
            _this.deletionStarted = false;
            _this.isAllDocuments = collection.isAllDocuments;
            return _this;
        }
        deleteCollection.prototype.deleteCollection = function () {
            var _this = this;
            var collectionName = this.isAllDocuments ? "*" : this.collection.name;
            var deleteCommand = new deleteCollectionCommand(collectionName, this.db);
            var deleteCommandTask = deleteCommand.execute();
            deleteCommandTask.done(function (result) { return _this.deletionTask.resolve(result); });
            deleteCommandTask.fail(function (response) { return _this.deletionTask.reject(response); });
            this.deletionStarted = true;
            dialog.close(this);
        };
        deleteCollection.prototype.cancel = function () {
            dialog.close(this);
        };
        deleteCollection.prototype.deactivate = function () {
            // If we were closed via X button or other dialog dismissal, reject the deletion task since
            // we never started it.
            if (!this.deletionStarted) {
                this.deletionTask.reject();
            }
        };
        return deleteCollection;
    }(dialogViewModelBase));
    return deleteCollection;
});

//# sourceMappingURL=deleteCollection.js.map
