var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/database/index/deleteIndexCommand", "plugins/dialog", "viewmodels/dialogViewModelBase", "common/messagePublisher"], function (require, exports, deleteIndexCommand, dialog, dialogViewModelBase, messagePublisher) {
    "use strict";
    var cancelSideBySizeConfirm = (function (_super) {
        __extends(cancelSideBySizeConfirm, _super);
        function cancelSideBySizeConfirm(indexNames, db, title) {
            var _this = _super.call(this) || this;
            _this.indexNames = indexNames;
            _this.db = db;
            _this.cancelTask = $.Deferred();
            if (!indexNames || indexNames.length === 0) {
                throw new Error("Indexes must not be null or empty.");
            }
            _this.title = !!title ? title : indexNames.length == 1 ? 'Cancel side-by-side index?' : 'Cancel side-by-side indexes?';
            return _this;
        }
        cancelSideBySizeConfirm.prototype.cancelIndexes = function () {
            var _this = this;
            var cancelTasks = this.indexNames.map(function (name) { return new deleteIndexCommand(name, _this.db).execute(); });
            var myDeleteTask = this.cancelTask;
            $.when.apply($, cancelTasks)
                .done(function () {
                if (_this.indexNames.length > 1) {
                    messagePublisher.reportSuccess("Successfully cancelled " + _this.indexNames.length + " index replacements!");
                }
                myDeleteTask.resolve(false);
            })
                .fail(function () {
                myDeleteTask.reject();
            });
            dialog.close(this);
        };
        cancelSideBySizeConfirm.prototype.cancel = function () {
            this.cancelTask.reject();
            dialog.close(this);
        };
        return cancelSideBySizeConfirm;
    }(dialogViewModelBase));
    return cancelSideBySizeConfirm;
});

//# sourceMappingURL=cancelSideBySizeConfirm.js.map
