var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "models/database/index/indexDefinition", "plugins/dialog", "viewmodels/dialogViewModelBase", "commands/database/index/getIndexDefinitionCommand", "common/bindingHelpers/aceEditorBindingHandler"], function (require, exports, indexDefinition, dialog, dialogViewModelBase, getIndexDefinitionCommand, aceEditorBindingHandler) {
    "use strict";
    var copyIndexDialog = (function (_super) {
        __extends(copyIndexDialog, _super);
        //TODO: isPAste in copy dialog ? 
        function copyIndexDialog(indexName, db, isPaste, elementToFocusOnDismissal) {
            if (isPaste === void 0) { isPaste = false; }
            var _this = _super.call(this, elementToFocusOnDismissal) || this;
            _this.indexName = indexName;
            _this.db = db;
            _this.isPaste = isPaste;
            _this.indexJSON = ko.observable("");
            aceEditorBindingHandler.install();
            return _this;
        }
        copyIndexDialog.prototype.canActivate = function (args) {
            var _this = this;
            if (this.isPaste) {
                return true;
            }
            else {
                var canActivateResult = $.Deferred();
                new getIndexDefinitionCommand(this.indexName, this.db)
                    .execute()
                    .done(function (definitionDto) {
                    var prettifySpacing = 4;
                    var jsonString = JSON.stringify(new indexDefinition(definitionDto).toDto(), null, prettifySpacing);
                    _this.indexJSON(jsonString);
                    canActivateResult.resolve({ can: true });
                })
                    .fail(function () { return canActivateResult.reject(); });
                return canActivateResult;
            }
        };
        copyIndexDialog.prototype.setInitialFocus = function () {
            // Overrides the base class' setInitialFocus and does nothing.
            // Doing nothing because we will focus the Ace Editor when it's initialized.
        };
        copyIndexDialog.prototype.enterKeyPressed = function () {
            // Overrides the base class' enterKeyPressed. Because the user might
            // edit the JSON, or even type some in manually, enter might really mean new line, not Save changes.
            if (!this.isPaste) {
                return _super.prototype.enterKeyPressed.call(this);
            }
            else {
                this.saveIndex();
            }
            return true;
        };
        copyIndexDialog.prototype.saveIndex = function () {
        };
        copyIndexDialog.prototype.close = function () {
            dialog.close(this);
        };
        return copyIndexDialog;
    }(dialogViewModelBase));
    return copyIndexDialog;
});

//# sourceMappingURL=copyIndexDialog.js.map
