var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/database/index/deleteIndexCommand", "plugins/dialog", "viewmodels/dialogViewModelBase", "common/messagePublisher"], function (require, exports, deleteIndexCommand, dialog, dialogViewModelBase, messagePublisher) {
    "use strict";
    var deleteIndexesConfirm = (function (_super) {
        __extends(deleteIndexesConfirm, _super);
        function deleteIndexesConfirm(indexNames, db, title) {
            var _this = _super.call(this) || this;
            _this.indexNames = indexNames;
            _this.db = db;
            _this.deleteTask = $.Deferred();
            if (!indexNames || indexNames.length === 0) {
                throw new Error("Indexes must not be null or empty.");
            }
            _this.title = title || (indexNames.length === 1 ? "Delete index?" : "Delete indexes?");
            return _this;
        }
        deleteIndexesConfirm.prototype.deleteIndexes = function () {
            var _this = this;
            var deleteTasks = this.indexNames.map(function (name) { return new deleteIndexCommand(name, _this.db).execute(); });
            $.when.apply($, deleteTasks)
                .done(function () {
                if (_this.indexNames.length > 1) {
                    messagePublisher.reportSuccess("Successfully deleted " + _this.indexNames.length + " indexes!");
                }
                _this.deleteTask.resolve(true);
            })
                .fail(function () { return _this.deleteTask.reject(); });
            dialog.close(this);
        };
        deleteIndexesConfirm.prototype.cancel = function () {
            this.deleteTask.resolve(false);
            dialog.close(this);
        };
        return deleteIndexesConfirm;
    }(dialogViewModelBase));
    return deleteIndexesConfirm;
});

//# sourceMappingURL=deleteIndexesConfirm.js.map
