var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "plugins/router", "viewmodels/viewModelBase", "models/database/index/index", "models/database/index/indexDefinition", "models/database/index/luceneField", "models/database/index/spatialIndexField", "commands/database/index/getIndexDefinitionCommand", "common/appUrl", "plugins/dialog", "common/jsonUtil", "common/bindingHelpers/aceEditorBindingHandler", "common/messagePublisher", "common/bindingHelpers/autoCompleteBindingHandler", "durandal/app", "models/database/index/indexAceAutoCompleteProvider", "commands/database/index/getScriptedIndexesCommand", "models/database/index/scriptedIndex", "common/autoCompleterSupport", "common/mergedIndexesStorage", "viewmodels/database/indexes/deleteIndexesConfirm", "viewmodels/database/indexes/replaceIndexDialog", "commands/database/documents/saveDocumentCommand", "models/database/index/indexReplaceDocument", "commands/database/index/saveIndexDefinitionCommand", "commands/database/index/renameIndexCommand", "commands/database/documents/saveScriptedIndexesCommand", "commands/database/index/deleteIndexCommand", "viewmodels/database/indexes/cancelSideBySizeConfirm", "viewmodels/database/indexes/copyIndexDialog", "commands/database/index/getCSharpIndexDefinitionCommand", "viewmodels/common/showDataDialog", "commands/database/index/formatIndexCommand", "viewmodels/database/indexes/renameOrDuplicateIndexDialog", "common/eventsCollector"], function (require, exports, router, viewModelBase, index, indexDefinition, luceneField, spatialIndexField, getIndexDefinitionCommand, appUrl, dialog, jsonUtil, aceEditorBindingHandler, messagePublisher, autoCompleteBindingHandler, app, indexAceAutoCompleteProvider, getScriptedIndexesCommand, scriptedIndexModel, autoCompleterSupport, mergedIndexesStorage, deleteIndexesConfirm, replaceIndexDialog, saveDocumentCommand, indexReplaceDocument, saveIndexDefinitionCommand, renameIndexCommand, saveScriptedIndexesCommand, deleteIndexCommand, cancelSideBySizeConfirm, copyIndexDialog, getCSharpIndexDefinitionCommand, showDataDialog, formatIndexCommand, renameOrDuplicateIndexDialog, eventsCollector) {
    "use strict";
    var editIndex = (function (_super) {
        __extends(editIndex, _super);
        function editIndex() {
            var _this = _super.call(this) || this;
            _this.isEditingExistingIndex = ko.observable(false);
            _this.mergeSuggestion = ko.observable(null);
            _this.editedIndex = ko.observable();
            _this.termsUrl = ko.observable();
            _this.queryUrl = ko.observable();
            _this.editMaxIndexOutputsPerDocument = ko.observable(false);
            _this.indexErrorsList = ko.observableArray();
            _this.loadedIndexName = ko.observable();
            // Scripted Index Part
            _this.isScriptedIndexBundleActive = ko.observable(false);
            _this.scriptedIndex = ko.observable(null);
            _this.indexScript = ko.observable("");
            _this.deleteScript = ko.observable("");
            aceEditorBindingHandler.install();
            autoCompleteBindingHandler.install();
            _this.appUrls = appUrl.forCurrentDatabase();
            _this.hasExistingReduce = ko.computed(function () { return _this.editedIndex() && _this.editedIndex().reduce(); });
            _this.hasMultipleMaps = ko.computed(function () { return _this.editedIndex() && _this.editedIndex().maps().length > 1; });
            _this.indexName = ko.computed(function () { return (!!_this.editedIndex() && _this.isEditingExistingIndex()) ? _this.editedIndex().name() : "New Index"; });
            _this.currentIndexName = ko.computed(function () { return _this.isEditingExistingIndex() ? _this.editedIndex().name() : (_this.mergeSuggestion() != null) ? "Merged Index" : "New Index"; });
            _this.isScriptedIndexBundleActive.subscribe(function (active) {
                if (active) {
                    _this.fetchOrCreateScriptedIndex();
                }
            });
            _this.indexName.subscribe(function (name) {
                if (_this.scriptedIndex() !== null) {
                    _this.scriptedIndex().indexName(name);
                }
            });
            _this.scriptedIndex.subscribe(function (scriptedIndex) {
                _this.indexScript = scriptedIndex.indexScript;
                _this.deleteScript = scriptedIndex.deleteScript;
                _this.initializeDirtyFlag();
                _this.editedIndex().name.valueHasMutated();
            });
            _this.editedIndex(_this.createNewIndexDefinition());
            _this.canSaveSideBySideIndex = ko.computed(function () {
                if (!_this.isEditingExistingIndex()) {
                    return false;
                }
                var loadedIndex = _this.loadedIndexName();
                var editedName = _this.editedIndex().name();
                return loadedIndex === editedName;
            });
            return _this;
        }
        editIndex.prototype.canActivate = function (indexToEditName) {
            _super.prototype.canActivate.call(this, indexToEditName);
            var db = this.activeDatabase();
            var mergeSuggestion = mergedIndexesStorage.getMergedIndex(db, indexToEditName);
            if (mergeSuggestion != null) {
                this.mergeSuggestion(mergeSuggestion);
                this.editedIndex(mergeSuggestion.mergedIndexDefinition);
            }
            else if (indexToEditName) {
                this.isEditingExistingIndex(true);
                var canActivateResult = $.Deferred();
                this.fetchIndexData(indexToEditName)
                    .done(function () { return canActivateResult.resolve({ can: true }); })
                    .fail(function () {
                    messagePublisher.reportError("Could not find " + decodeURIComponent(indexToEditName) + " index");
                    canActivateResult.resolve({ redirect: appUrl.forIndexes(db) });
                });
                return canActivateResult;
            }
            return $.Deferred().resolve({ can: true });
        };
        editIndex.prototype.activate = function (indexToEditName) {
            _super.prototype.activate.call(this, indexToEditName);
            if (this.isEditingExistingIndex()) {
                this.editExistingIndex(indexToEditName);
            }
            this.updateHelpLink('CQ5AYO');
            this.initializeDirtyFlag();
            this.indexAutoCompleter = new indexAceAutoCompleteProvider(this.activeDatabase(), this.editedIndex);
            this.checkIfScriptedIndexBundleIsActive();
        };
        editIndex.prototype.attached = function () {
            _super.prototype.attached.call(this);
            this.addMapHelpPopover();
            this.addReduceHelpPopover();
            this.addScriptsLabelPopover();
        };
        editIndex.prototype.initializeDirtyFlag = function () {
            var _this = this;
            var indexDef = this.editedIndex();
            var checkedFieldsArray = [indexDef.storeAllFields, indexDef.name, indexDef.map, indexDef.maps, indexDef.reduce, indexDef.numOfLuceneFields, indexDef.numOfSpatialFields, indexDef.maxIndexOutputsPerDocument];
            indexDef.luceneFields().forEach(function (lf) {
                checkedFieldsArray.push(lf.name);
                checkedFieldsArray.push(lf.stores);
                checkedFieldsArray.push(lf.sort);
                checkedFieldsArray.push(lf.termVector);
                checkedFieldsArray.push(lf.indexing);
                checkedFieldsArray.push(lf.analyzer);
                checkedFieldsArray.push(lf.suggestionEnabled);
            });
            indexDef.spatialFields().forEach(function (sf) {
                checkedFieldsArray.push(sf.name);
                checkedFieldsArray.push(sf.type);
                checkedFieldsArray.push(sf.strategy);
                checkedFieldsArray.push(sf.minX);
                checkedFieldsArray.push(sf.maxX);
                checkedFieldsArray.push(sf.circleRadiusUnits);
                checkedFieldsArray.push(sf.maxTreeLevel);
                checkedFieldsArray.push(sf.minY);
                checkedFieldsArray.push(sf.maxY);
            });
            checkedFieldsArray.push(this.indexScript);
            checkedFieldsArray.push(this.deleteScript);
            this.dirtyFlag = new ko.DirtyFlag(checkedFieldsArray, false, jsonUtil.newLineNormalizingHashFunction);
            this.isSaveEnabled = ko.computed(function () { return !!_this.editedIndex().name() && _this.dirtyFlag().isDirty(); });
        };
        editIndex.prototype.editExistingIndex = function (unescapedIndexName) {
            var indexName = decodeURIComponent(unescapedIndexName);
            this.loadedIndexName(indexName);
            this.termsUrl(appUrl.forTerms(unescapedIndexName, this.activeDatabase()));
            this.queryUrl(appUrl.forQuery(this.activeDatabase(), indexName));
        };
        editIndex.prototype.addMapHelpPopover = function () {
            $("#indexMapsLabel").popover({
                html: true,
                trigger: 'hover',
                content: 'Maps project the fields to search on or to group by. It uses LINQ query syntax.<br/><br/>Example:</br><pre><span class="code-keyword">from</span> order <span class="code-keyword">in</span> docs.Orders<br/><span class="code-keyword">where</span> order.IsShipped<br/><span class="code-keyword">select new</span><br/>{</br>   order.Date, <br/>   order.Amount,<br/>   RegionId = order.Region.Id <br />}</pre>Each map function should project the same set of fields.',
            });
        };
        editIndex.prototype.addReduceHelpPopover = function () {
            $("#indexReduceLabel").popover({
                html: true,
                trigger: 'hover',
                content: 'The Reduce function consolidates documents from the Maps stage into a smaller set of documents. It uses LINQ query syntax.<br/><br/>Example:</br><pre><span class="code-keyword">from</span> result <span class="code-keyword">in</span> results<br/><span class="code-keyword">group</span> result <span class="code-keyword">by new</span> { result.RegionId, result.Date } into g<br/><span class="code-keyword">select new</span><br/>{<br/>  Date = g.Key.Date,<br/>  RegionId = g.Key.RegionId,<br/>  Amount = g.Sum(x => x.Amount)<br/>}</pre>The objects produced by the Reduce function should have the same fields as the inputs.',
            });
        };
        editIndex.prototype.fetchIndexData = function (unescapedIndexName) {
            var indexName = decodeURIComponent(unescapedIndexName);
            return $.when(this.fetchIndexToEdit(indexName));
        };
        editIndex.prototype.fetchIndexToEdit = function (indexName) {
            var _this = this;
            var deferred = $.Deferred();
            new getIndexDefinitionCommand(indexName, this.activeDatabase())
                .execute()
                .done(function (result) {
                _this.editedIndex(new indexDefinition(result));
                _this.originalIndexName = _this.editedIndex().name();
                //TODO this.editMaxIndexOutputsPerDocument(result.MaxIndexOutputsPerDocument ? result.MaxIndexOutputsPerDocument > 0 ? true : false : false);
                _this.editMaxIndexOutputsPerDocument(false);
                deferred.resolve();
            })
                .fail(function () { return deferred.reject(); });
            return deferred;
        };
        editIndex.prototype.createNewIndexDefinition = function () {
            return indexDefinition.empty();
        };
        editIndex.prototype.save = function () {
            var _this = this;
            var editedIndex = this.editedIndex();
            //if index name has changed it isn't the same index
            if (this.originalIndexName === this.indexName() && editedIndex.lockMode === "LockedIgnore") {
                messagePublisher.reportWarning("Can not overwrite locked index: " + editedIndex.name() + ". " +
                    "Any changes to the index will be ignored.");
                return;
            }
            if (editedIndex.name()) {
                var index = editedIndex.toDto();
                if (this.isEditingExistingIndex() && index.Name !== this.loadedIndexName()) {
                    // user changed index name on edit page, ask him what to do: rename or duplicate
                    var dialog = new renameOrDuplicateIndexDialog(this.loadedIndexName(), this.editedIndex().name());
                    dialog.getSaveAsNewTask()
                        .done(function () { return _this.saveIndex(index); });
                    dialog.getRenameTask()
                        .done(function () { return _this.renameIndex(_this.loadedIndexName(), index.Name); });
                    app.showBootstrapDialog(dialog);
                }
                else {
                    this.saveIndex(index);
                }
            }
        };
        editIndex.prototype.deleteMergedIndexes = function (indexesToDelete) {
            var db = this.activeDatabase();
            var deleteViewModel = new deleteIndexesConfirm(indexesToDelete, db, "Delete Merged Indexes?");
            dialog.show(deleteViewModel);
        };
        editIndex.prototype.updateUrl = function (indexName, isSavingMergedIndex) {
            if (isSavingMergedIndex === void 0) { isSavingMergedIndex = false; }
            var url = appUrl.forEditIndex(indexName, this.activeDatabase());
            if (this.loadedIndexName() !== indexName) {
                _super.prototype.navigate.call(this, url);
            }
            else if (isSavingMergedIndex) {
                _super.prototype.updateUrl.call(this, url);
            }
        };
        editIndex.prototype.refreshIndex = function () {
            var _this = this;
            eventsCollector.default.reportEvent("index", "refresh");
            var canContinue = this.canContinueIfNotDirty('Unsaved Data', 'You have unsaved data. Are you sure you want to refresh the index from the server?');
            canContinue.done(function () {
                _this.fetchIndexData(_this.loadedIndexName())
                    .done(function () {
                    _this.initializeDirtyFlag();
                    _this.editedIndex().name.valueHasMutated();
                });
            });
        };
        editIndex.prototype.deleteIndex = function () {
            var _this = this;
            eventsCollector.default.reportEvent("index", "delete");
            var indexName = this.loadedIndexName();
            if (indexName) {
                var db = this.activeDatabase();
                var deleteViewModel = new deleteIndexesConfirm([indexName], db);
                deleteViewModel.deleteTask.done(function () {
                    //prevent asking for unsaved changes
                    _this.dirtyFlag().reset(); // Resync Changes
                    router.navigate(appUrl.forIndexes(db));
                });
                dialog.show(deleteViewModel);
            }
        };
        editIndex.prototype.cancelSideBySideIndex = function () {
            var _this = this;
            eventsCollector.default.reportEvent("index", "cancel-side-by-side");
            var indexName = this.loadedIndexName();
            if (indexName) {
                var db = this.activeDatabase();
                var cancelSideBySideIndexViewModel = new cancelSideBySizeConfirm([indexName], db);
                cancelSideBySideIndexViewModel.cancelTask.done(function () {
                    //prevent asking for unsaved changes
                    _this.dirtyFlag().reset(); // Resync Changes
                    router.navigate(appUrl.forIndexes(db));
                });
                dialog.show(cancelSideBySideIndexViewModel);
            }
        };
        editIndex.prototype.addMap = function () {
            eventsCollector.default.reportEvent("index", "add-map");
            this.editedIndex().maps.push(ko.observable());
        };
        editIndex.prototype.addReduce = function () {
            eventsCollector.default.reportEvent("index", "add-reduce");
            if (!this.hasExistingReduce()) {
                this.editedIndex().reduce(" ");
                this.addReduceHelpPopover();
            }
        };
        editIndex.prototype.addField = function () {
            eventsCollector.default.reportEvent("index", "add-field");
            var field = new luceneField("");
            field.indexFieldNames = this.editedIndex().fields();
            field.calculateFieldNamesAutocomplete();
            this.editedIndex().luceneFields.push(field);
        };
        editIndex.prototype.removeStoreAllFields = function () {
            eventsCollector.default.reportEvent("index", "remove-store-all-fields");
            this.editedIndex().setOrRemoveStoreAllFields(false);
        };
        editIndex.prototype.removeMaxIndexOutputs = function () {
            eventsCollector.default.reportEvent("index", "remove-max-index-outputs");
            this.editedIndex().maxIndexOutputsPerDocument(0);
            this.editMaxIndexOutputsPerDocument(false);
        };
        editIndex.prototype.addSpatialField = function () {
            eventsCollector.default.reportEvent("index", "add-spatial-field");
            var field = spatialIndexField.empty();
            this.editedIndex().spatialFields.push(field);
        };
        editIndex.prototype.removeMap = function (mapIndex) {
            eventsCollector.default.reportEvent("index", "remove-map");
            this.editedIndex().maps.splice(mapIndex, 1);
        };
        editIndex.prototype.removeReduce = function () {
            eventsCollector.default.reportEvent("index", "remove-reduce");
            this.editedIndex().reduce(null);
        };
        editIndex.prototype.removeLuceneField = function (fieldIndex) {
            eventsCollector.default.reportEvent("index", "remove-lucene-field");
            var fieldToRemove = this.editedIndex().luceneFields()[fieldIndex];
            this.editedIndex().luceneFields.splice(fieldIndex, 1);
            if (fieldToRemove.name() === "__all_fields") {
                this.editedIndex().setOrRemoveStoreAllFields(false);
            }
        };
        editIndex.prototype.removeSpatialField = function (fieldIndex) {
            eventsCollector.default.reportEvent("index", "remove-spatial-field");
            this.editedIndex().spatialFields.splice(fieldIndex, 1);
        };
        editIndex.prototype.copyIndex = function () {
            eventsCollector.default.reportEvent("index", "copy");
            app.showBootstrapDialog(new copyIndexDialog(this.editedIndex().name(), this.activeDatabase(), false));
        };
        editIndex.prototype.createCSharpCode = function () {
            eventsCollector.default.reportEvent("index", "generate-csharp-code");
            new getCSharpIndexDefinitionCommand(this.editedIndex().name(), this.activeDatabase())
                .execute()
                .done(function (data) { return app.showBootstrapDialog(new showDataDialog("C# Index Definition", data, null)); });
        };
        editIndex.prototype.formatIndex = function () {
            eventsCollector.default.reportEvent("index", "format-index");
            var index = this.editedIndex();
            var mapReduceObservableArray = new Array();
            mapReduceObservableArray.push.apply(mapReduceObservableArray, index.maps());
            if (!!index.reduce()) {
                mapReduceObservableArray.push(index.reduce);
            }
            var mapReduceArray = mapReduceObservableArray.map(function (observable) { return observable(); });
            new formatIndexCommand(this.activeDatabase(), mapReduceArray)
                .execute()
                .done(function (formatedMapReduceArray) {
                formatedMapReduceArray.forEach(function (element, i) {
                    if (element.indexOf("Could not format:") == -1) {
                        mapReduceObservableArray[i](element);
                    }
                    else {
                        var isReduce = !!index.reduce() && i == formatedMapReduceArray.length - 1;
                        var errorMessage = isReduce ? "Failed to format reduce!" : "Failed to format map '" + i + "'!";
                        messagePublisher.reportError(errorMessage, element);
                    }
                });
            });
        };
        editIndex.prototype.checkIfScriptedIndexBundleIsActive = function () {
            var db = this.activeDatabase();
            var activeBundles = db.activeBundles();
            this.isScriptedIndexBundleActive(activeBundles.indexOf("ScriptedIndexResults") != -1);
        };
        editIndex.prototype.fetchOrCreateScriptedIndex = function () {
            var _this = this;
            var self = this;
            new getScriptedIndexesCommand(this.activeDatabase(), this.indexName())
                .execute()
                .done(function (scriptedIndexes) {
                if (scriptedIndexes.length > 0) {
                    self.scriptedIndex(scriptedIndexes[0]);
                }
                else {
                    self.scriptedIndex(scriptedIndexModel.emptyForIndex(self.indexName()));
                }
                _this.initializeDirtyFlag();
            });
        };
        editIndex.prototype.addScriptsLabelPopover = function () {
            var indexScriptpopOverSettings = {
                html: true,
                trigger: 'hover',
                content: 'Index Scripts are written in JavaScript.<br/><br/>Example:</br><pre><span class="code-keyword">var</span> company = LoadDocument(<span class="code-keyword">this</span>.Company);<br/><span class="code-keyword">if</span>(company == null) <span class="code-keyword">return</span>;<br/>company.Orders = { Count: <span class="code-keyword">this</span>.Count, Total: <span class="code-keyword">this</span>.Total };<br/>PutDocument(<span class="code-keyword">this</span>.Company, company);</pre>',
                selector: '.index-script-label',
            };
            $('#indexScriptPopover').popover(indexScriptpopOverSettings);
            var deleteScriptPopOverSettings = {
                html: true,
                trigger: 'hover',
                content: 'Index Scripts are written in JavaScript.<br/><br/>Example:</br><pre><span class="code-keyword">var</span> company = LoadDocument(<span class="code-keyword">this</span>.Company);<br/><span class="code-keyword">if</span> (company == null) <span class="code-keyword">return</span>;<br/><span class="code-keyword">delete</span> company.Orders;<br/>PutDocument(<span class="code-keyword">this</span>.Company, company);</pre>',
                selector: '.delete-script-label',
            };
            $('#deleteScriptPopover').popover(deleteScriptPopOverSettings);
        };
        editIndex.prototype.scriptedIndexCompleter = function (editor, session, pos, prefix, callback) {
            var completions = [
                { name: "LoadDocument", args: "id" },
                { name: "PutDocument", args: "id, doc" },
                { name: "DeleteDocument", args: "id" }
            ];
            var result = completions
                .filter(function (entry) { return autoCompleterSupport.wordMatches(prefix, entry.name); })
                .map(function (entry) { return { name: entry.name, value: entry.name, score: 100, meta: entry.args }; });
            callback(null, result);
        };
        editIndex.prototype.makePermanent = function () {
            var _this = this;
            eventsCollector.default.reportEvent("index", "make-permanent");
            if (this.editedIndex().name() && this.editedIndex().isTestIndex()) {
                this.editedIndex().isTestIndex(false);
                // trim Test prefix
                var indexToDelete = this.editedIndex().name();
                this.editedIndex().name(this.editedIndex().name().substr(index.TestIndexPrefix.length));
                var indexDef = this.editedIndex().toDto();
                if (this.scriptedIndex() !== null) {
                    // reset etag as we save different document
                    this.scriptedIndex().__metadata.etag(null);
                }
                this.saveIndex(indexDef)
                    .done(function () {
                    new deleteIndexCommand(indexToDelete, _this.activeDatabase()).execute();
                });
            }
        };
        editIndex.prototype.tryIndex = function () {
            eventsCollector.default.reportEvent("index", "try-index");
            if (this.editedIndex().name()) {
                if (!this.editedIndex().isTestIndex()) {
                    this.editedIndex().isTestIndex(true);
                    this.editedIndex().name(index.TestIndexPrefix + this.editedIndex().name());
                }
                var indexDef = this.editedIndex().toDto();
                if (this.scriptedIndex() !== null) {
                    // reset etag as we save different document
                    this.scriptedIndex().__metadata.etag(null);
                }
                this.saveIndex(indexDef);
            }
        };
        editIndex.prototype.renameIndex = function (existingIndexName, newIndexName) {
            var _this = this;
            eventsCollector.default.reportEvent("index", "rename");
            return new renameIndexCommand(existingIndexName, newIndexName, this.activeDatabase())
                .execute()
                .done(function () {
                _this.initializeDirtyFlag();
                _this.updateUrl(newIndexName, false);
            });
        };
        editIndex.prototype.saveIndex = function (index) {
            var _this = this;
            eventsCollector.default.reportEvent("index", "save");
            var commands = [];
            index.Type = index.Reduce ? "MapReduce" : index.Type;
            commands.push(new saveIndexDefinitionCommand(index, this.activeDatabase()).execute());
            if (this.scriptedIndex() !== null) {
                commands.push(new saveScriptedIndexesCommand([this.scriptedIndex()], this.activeDatabase()).execute());
            }
            return $.when.apply($, commands).done(function () {
                if (_this.scriptedIndex()) {
                    _this.fetchOrCreateScriptedIndex(); // reload scripted index to obtain fresh etag and metadata
                }
                _this.initializeDirtyFlag();
                _this.editedIndex().name.valueHasMutated();
                var isSavingMergedIndex = _this.mergeSuggestion() != null;
                if (!_this.isEditingExistingIndex()) {
                    _this.isEditingExistingIndex(true);
                    _this.editExistingIndex(index.Name);
                }
                if (isSavingMergedIndex) {
                    var indexesToDelete = _this.mergeSuggestion().canMerge.filter(function (indexName) { return indexName != _this.editedIndex().name(); });
                    _this.deleteMergedIndexes(indexesToDelete);
                    _this.mergeSuggestion(null);
                }
                _this.updateUrl(index.Name, isSavingMergedIndex);
            });
        };
        editIndex.prototype.replaceIndex = function () {
            var _this = this;
            eventsCollector.default.reportEvent("index", "replace");
            var indexToReplaceName = this.editedIndex().name();
            var replaceDialog = new replaceIndexDialog(indexToReplaceName, this.activeDatabase());
            replaceDialog.replaceSettingsTask.done(function (replaceDocument) {
                if (!_this.editedIndex().isSideBySideIndex()) {
                    _this.editedIndex().name(index.SideBySideIndexPrefix + _this.editedIndex().name());
                }
                var indexDef = _this.editedIndex().toDto();
                var replaceDocumentKey = indexReplaceDocument.replaceDocumentPrefix + _this.editedIndex().name();
                if (_this.scriptedIndex() !== null) {
                    // reset etag as we save different document
                    _this.scriptedIndex().__metadata.etag(null);
                }
                _this.saveIndex(indexDef)
                    .fail(function (response) { return messagePublisher.reportError("Failed to save replace index.", response.responseText, response.statusText); })
                    .done(function () {
                    new saveDocumentCommand(replaceDocumentKey, replaceDocument, _this.activeDatabase(), false)
                        .execute()
                        .fail(function (response) { return messagePublisher.reportError("Failed to save replace index document.", response.responseText, response.statusText); })
                        .done(function () { return messagePublisher.reportSuccess("Successfully saved side-by-side index"); });
                })
                    .always(function () { return dialog.close(replaceDialog); });
            });
            app.showBootstrapDialog(replaceDialog);
        };
        return editIndex;
    }(viewModelBase));
    return editIndex;
});

//# sourceMappingURL=editIndex.js.map
