var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "viewmodels/viewModelBase", "moment", "common/tableNavigationTrait"], function (require, exports, viewModelBase, moment, tableNavigationTrait) {
    "use strict";
    var indexErrors = (function (_super) {
        __extends(indexErrors, _super);
        function indexErrors() {
            var _this = _super.call(this) || this;
            _this.allIndexErrors = ko.observableArray();
            _this.hasFetchedErrors = ko.observable(false);
            _this.selectedIndexError = ko.observable();
            _this.now = ko.observable();
            _this.updateNowTimeoutHandle = 0;
            _this.updateCurrentNowTime();
            _this.tableNavigation = new tableNavigationTrait("#indexErrorsTableContainer", _this.selectedIndexError, _this.allIndexErrors, function (i) { return "#indexErrorsTableContainer table tbody tr:nth-child(" + (i + 1) + ")"; });
            return _this;
        }
        indexErrors.prototype.createNotifications = function () {
            return [];
        };
        indexErrors.prototype.activate = function (args) {
            _super.prototype.activate.call(this, args);
            this.updateHelpLink('ABUXGF');
            this.fetchIndexErrors();
        };
        indexErrors.prototype.deactivate = function () {
            clearTimeout(this.updateNowTimeoutHandle);
        };
        indexErrors.prototype.fetchIndexErrors = function () {
            var db = this.activeDatabase();
            if (db) {
            }
            return null;
        };
        indexErrors.prototype.selectIndexError = function (indexError) {
            this.selectedIndexError(indexError);
        };
        indexErrors.prototype.createHumanReadableTime = function (time) {
            var _this = this;
            if (time) {
                // Return a computed that returns a humanized string based off the current time, e.g. "7 minutes ago".
                // It's a computed so that it updates whenever we update this.now field.
                return ko.computed(function () {
                    var dateMoment = moment(time);
                    var agoInMs = dateMoment.diff(_this.now());
                    return moment.duration(agoInMs).humanize(true) + dateMoment.format(" (MM/DD/YY, h:mma)");
                });
            }
            return ko.computed(function () { return time; });
        };
        indexErrors.prototype.updateCurrentNowTime = function () {
            var _this = this;
            this.now(moment());
            this.updateNowTimeoutHandle = setTimeout(function () { return _this.updateCurrentNowTime(); }, 60000);
        };
        return indexErrors;
    }(viewModelBase));
    return indexErrors;
});

//# sourceMappingURL=indexErrors.js.map
