var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "plugins/dialog", "viewmodels/dialogViewModelBase", "commands/database/index/getIndexesDefinitionsCommand", "commands/database/transformers/getTransformersCommand", "common/bindingHelpers/aceEditorBindingHandler"], function (require, exports, dialog, dialogViewModelBase, getIndexesDefinitionsCommand, getTransformersCommand, aceEditorBindingHandler) {
    "use strict";
    //TODO: we will probably split this class into indexes and transformers
    var indexesAndTransformersClipboardDialog = (function (_super) {
        __extends(indexesAndTransformersClipboardDialog, _super);
        function indexesAndTransformersClipboardDialog(db, isPaste, elementToFocusOnDismissal) {
            if (isPaste === void 0) { isPaste = false; }
            var _this = _super.call(this, elementToFocusOnDismissal) || this;
            _this.db = db;
            _this.isPaste = isPaste;
            _this.json = ko.observable("");
            _this.indexes = ko.observableArray([]);
            //TODO: transformers = ko.observableArray<transformerDto>([]);
            _this.pasteDeferred = $.Deferred();
            aceEditorBindingHandler.install();
            return _this;
        }
        indexesAndTransformersClipboardDialog.prototype.canActivate = function (args) {
            var _this = this;
            if (this.isPaste) {
                return true;
            }
            else {
                var canActivateResult = $.Deferred();
                var getIndexDefinitionsPromise = new getIndexesDefinitionsCommand(this.db)
                    .execute()
                    .done(function (results) {
                    _this.indexes(results);
                });
                var getTransformersPromise = new getTransformersCommand(this.db)
                    .execute(); /* TODO
                .done((results: transformerDto[]) => {
                    this.transformers(results);
                });*/
                $.when(getTransformersPromise, getIndexDefinitionsPromise)
                    .then(function () {
                    canActivateResult.resolve({ can: true });
                    var prettifySpacing = 4;
                    _this.json(JSON.stringify({
                        Indexes: _this.indexes(),
                    }, null, prettifySpacing));
                }, function () {
                    canActivateResult.reject();
                });
                return canActivateResult;
            }
        };
        indexesAndTransformersClipboardDialog.prototype.setInitialFocus = function () {
            // Overrides the base class' setInitialFocus and does nothing.
            // Doing nothing because we will focus the Ace Editor when it's initialized.
        };
        indexesAndTransformersClipboardDialog.prototype.enterKeyPressed = function () {
            // Overrides the base class' enterKeyPressed. Because the user might
            // edit the JSON, or even type some in manually, enter might really mean new line, not Save changes.
            if (!this.isPaste) {
                return _super.prototype.enterKeyPressed.call(this);
            }
            else {
                this.saveAll();
            }
            return true;
        };
        indexesAndTransformersClipboardDialog.prototype.saveAll = function () {
            /* TODO
            if (this.isPaste && this.json()) {
                var indexesAndTransformers: { Indexes: indexDefinitionListItemDto[]; Transformers: transformerDto[] };
                var indexesDefinitions: indexDefinitionDto[] = [];
                var transformersDefinitions: savedTransformerDto[] = [];
    
                try {
                    indexesAndTransformers = JSON.parse(this.json());
                    if (indexesAndTransformers.Indexes && indexesAndTransformers.Indexes.length > 0) {
                        indexesDefinitions.pushAll(indexesAndTransformers.Indexes.map((index: indexDefinitionListItemDto) => {
                            return index.definition;
                        }));
                    }
    
                    if (indexesAndTransformers.Transformers && indexesAndTransformers.Transformers.length > 0) {
                        transformersDefinitions.pushAll(indexesAndTransformers.Transformers.map((transformer: transformerDto) => {
                            return {
                                 Transformer: {
                                    Name: transformer.name,
                                    TransformResults: transformer.definition.TransformResults,
                                    LockMode: transformer.definition.LockMode
                                }
                            }
                        }));
                    }
                    if (indexesDefinitions.length === 0 && transformersDefinitions.length === 0) {
                        throw "No indexes or transformers found in json string";
                    }
                } catch (e) {
                    this.pasteDeferred.reject();
                    messagePublisher.reportError("Index paste failed, invalid json string", e);
                }
    
                var allOperationsPromises: Array<JQueryPromise<any>> = [];
                var succeededIndexes: string[] = [];
                var failedIndexes: string[] = [];
                var succeededTransformers: string[] = [];
                var failedTransformers: string[] = [];
    
                if (indexesDefinitions.length > 0) {
                    indexesDefinitions.forEach((index: indexDefinitionDto) => {
                        var curDeferred = $.Deferred();
                        allOperationsPromises.push(curDeferred);
                        new saveIndexDefinitionCommand(index, this.db)
                            .execute()
                            .done(() => succeededIndexes.push(index.Name))
                            .fail(() => failedIndexes.push(index.Name))
                            .always(() => curDeferred.resolve());
    
                    });
                }
                
                if (transformersDefinitions.length > 0) {
                    transformersDefinitions.forEach((transformer: savedTransformerDto) => {
                        var curDeferred = $.Deferred();
                        allOperationsPromises.push(curDeferred);
                        new saveTransformerCommand(new transformerDefinition().initFromSave(transformer), this.db)
                            .execute()
                            .done(() => {
                                succeededTransformers.push(transformer.Transformer.Name);
                            })
                            .fail(() => {
                                failedTransformers.push(transformer.Transformer.Name);
                            })
                            .always(() => curDeferred.resolve());
                    });
                }
    
                $.when.apply($, allOperationsPromises)
                    .always(() => this.summarize(succeededIndexes, failedIndexes, succeededTransformers, failedTransformers));
            } else {
                this.close();
            }*/
        };
        indexesAndTransformersClipboardDialog.prototype.summarize = function (succeededIndexes, failedIndexes, succeededTransformers, failedTransformers) {
            var summaryText = "";
            if (succeededIndexes.length > 0) {
                summaryText += "Succeeded Indexes: " + succeededIndexes.length + "\n";
            }
            if (failedIndexes.length > 0) {
                summaryText += "Failed Indexes: \n" + failedIndexes.join("\n") + "\n";
            }
            if (succeededTransformers.length > 0) {
                summaryText += "Succeeded Transformers: " + succeededTransformers.length + "\n";
            }
            if (failedTransformers.length > 0) {
                summaryText += "Failed Transformers: \n" + failedTransformers.join("\n") + "\n";
            }
            this.pasteDeferred.resolve(summaryText);
            this.close();
        };
        indexesAndTransformersClipboardDialog.prototype.close = function () {
            dialog.close(this);
        };
        return indexesAndTransformersClipboardDialog;
    }(dialogViewModelBase));
    return indexesAndTransformersClipboardDialog;
});

//# sourceMappingURL=indexesAndTransformersClipboardDialog.js.map
