var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "plugins/dialog", "viewmodels/dialogViewModelBase"], function (require, exports, dialog, dialogViewModelBase) {
    "use strict";
    var visualizerImport = (function (_super) {
        __extends(visualizerImport, _super);
        function visualizerImport() {
            var _this = _super.apply(this, arguments) || this;
            _this.importTask = $.Deferred();
            _this.hasFileSelected = ko.observable(false);
            _this.isImporting = ko.observable(false);
            return _this;
        }
        visualizerImport.prototype.fileSelected = function (args) {
            this.hasFileSelected(true);
        };
        visualizerImport.prototype.doImport = function () {
            var _this = this;
            var fileInput = document.querySelector("#importFilePicker");
            var self = this;
            var file = fileInput.files[0];
            var reader = new FileReader();
            reader.onload = function () {
                self.dataImported(this.result);
            };
            reader.onerror = function (error) { return _this.importTask.reject(error); };
            reader.readAsText(file);
        };
        visualizerImport.prototype.dataImported = function (result) {
            var json = JSON.parse(result);
            this.importTask.resolve(json);
            dialog.close(this);
        };
        visualizerImport.prototype.cancel = function () {
            dialog.close(this);
        };
        visualizerImport.prototype.task = function () {
            return this.importTask.promise();
        };
        return visualizerImport;
    }(dialogViewModelBase));
    return visualizerImport;
});

//# sourceMappingURL=visualizerImport.js.map
