var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "plugins/dialog", "viewmodels/dialogViewModelBase", "commands/database/patch/getPatchesCommand"], function (require, exports, dialog, dialogViewModelBase, getPatchesCommand) {
    "use strict";
    var loadPatch = (function (_super) {
        __extends(loadPatch, _super);
        function loadPatch(database) {
            var _this = _super.call(this) || this;
            _this.database = database;
            _this.nextTask = $.Deferred();
            _this.nextTaskStarted = false;
            _this.patchName = ko.observable("");
            _this.patches = ko.observableArray();
            _this.patch = ko.observable();
            return _this;
        }
        loadPatch.prototype.activate = function () {
            this.fetchAllPatches();
            this.patchName = ko.observable("Select patch to load");
        };
        loadPatch.prototype.cancel = function () {
            dialog.close(this);
        };
        loadPatch.prototype.loadThePatch = function () {
            this.nextTaskStarted = true;
            this.nextTask.resolve(this.patch());
            dialog.close(this);
        };
        loadPatch.prototype.deactivate = function () {
            // If we were closed via X button or other dialog dismissal, reject the deletion task since
            // we never started it.
            if (!this.nextTaskStarted) {
                this.nextTask.reject();
            }
        };
        loadPatch.prototype.onExit = function () {
            return this.nextTask.promise();
        };
        loadPatch.prototype.fetchAllPatches = function () {
            var _this = this;
            new getPatchesCommand(this.database)
                .execute()
                .done(function (patches) { return _this.patches(patches); });
        };
        loadPatch.prototype.setSelectedPatch = function (patch) {
            this.patch(patch);
            this.patchName(patch.name());
        };
        return loadPatch;
    }(dialogViewModelBase));
    return loadPatch;
});

//# sourceMappingURL=loadPatch.js.map
