var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "plugins/dialog", "viewmodels/dialogViewModelBase"], function (require, exports, dialog, dialogViewModelBase) {
    "use strict";
    var savePatch = (function (_super) {
        __extends(savePatch, _super);
        function savePatch() {
            var _this = _super.apply(this, arguments) || this;
            _this.nextTask = $.Deferred();
            _this.nextTaskStarted = false;
            _this.patchName = ko.observable();
            return _this;
        }
        savePatch.prototype.cancel = function () {
            dialog.close(this);
        };
        savePatch.prototype.saveThePatch = function () {
            this.nextTaskStarted = true;
            this.nextTask.resolve(this.patchName());
            dialog.close(this);
        };
        savePatch.prototype.deactivate = function () {
            // If we were closed via X button or other dialog dismissal, reject the deletion task since
            // we never started it.
            if (!this.nextTaskStarted) {
                this.nextTask.reject();
            }
        };
        savePatch.prototype.onExit = function () {
            return this.nextTask.promise();
        };
        return savePatch;
    }(dialogViewModelBase));
    return savePatch;
});

//# sourceMappingURL=savePatch.js.map
