var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "viewmodels/filesystem/search/inMethodFilter", "viewmodels/filesystem/search/fieldStringFilter", "viewmodels/filesystem/search/fieldRangeFilter", "durandal/app", "plugins/router", "common/appUrl", "viewmodels/viewModelBase", "commands/resources/getDatabaseStatsCommand", "commands/database/index/getIndexDefinitionCommand", "common/bindingHelpers/aceEditorBindingHandler", "common/pagedList", "common/messagePublisher", "commands/database/documents/getCollectionsStatsCommand", "commands/database/query/queryIndexCommand", "models/database/query/querySort", "models/database/documents/collection", "commands/database/transformers/getTransformersCommand", "commands/database/globalConfig/getEffectiveCustomFunctionsCommand", "viewmodels/database/query/deleteDocumentsMatchingQueryConfirm", "models/database/documents/document", "models/database/documents/customColumnParams", "models/database/documents/customColumns", "viewmodels/common/selectColumns", "commands/database/documents/getCustomColumnsCommand", "viewmodels/database/query/queryStatsDialog", "models/database/documents/customFunctions", "models/database/index/transformer", "models/database/index/transformerQuery", "commands/database/index/getIndexSuggestionsCommand", "common/recentQueriesStorage", "common/queryUtil", "common/eventsCollector", "common/generalUtils", "viewmodels/common/showDataDialog"], function (require, exports, InMethodFilter, fieldStringFilter, fieldRangeFilter, app, router, appUrl, viewModelBase, getDatabaseStatsCommand, getIndexDefinitionCommand, aceEditorBindingHandler, pagedList, messagePublisher, getCollectionsStatsCommand, queryIndexCommand, querySort, collection, getTransformersCommand, getEffectiveCustomFunctionsCommand, deleteDocumentsMatchingQueryConfirm, document, customColumnParams, customColumns, selectColumns, getCustomColumnsCommand, queryStatsDialog, customFunctions, transformerType, transformerQueryType, getIndexSuggestionsCommand, recentQueriesStorage, queryUtil, eventsCollector, genUtils, showDataDialog) {
    "use strict";
    var query = (function (_super) {
        __extends(query, _super);
        function query() {
            var _this = _super.call(this) || this;
            _this.isTestIndex = ko.observable(false);
            _this.selectedIndex = ko.observable();
            _this.indexes = ko.observableArray();
            _this.queryText = ko.observable("");
            _this.queryResults = ko.observable();
            _this.selectedResultIndices = ko.observableArray();
            _this.queryStats = ko.observable();
            _this.sortBys = ko.observableArray();
            _this.indexFields = ko.observableArray();
            _this.transformer = ko.observable();
            _this.allTransformers = ko.observableArray();
            _this.isDefaultOperatorOr = ko.observable(true);
            _this.showFields = ko.observable(false);
            _this.indexEntries = ko.observable(false);
            _this.recentQueries = ko.observableArray();
            _this.rawJsonUrl = ko.observable();
            _this.collections = ko.observableArray([]);
            _this.collectionNames = ko.observableArray();
            _this.isLoading = ko.observable(false);
            _this.isCacheDisable = ko.observable(false);
            _this.warningText = ko.observable();
            _this.isWarning = ko.observable(false);
            _this.searchField = ko.observable("Select field");
            _this.contextName = ko.observable();
            _this.dynamicPrefix = "dynamic/";
            _this.currentColumnsParams = ko.observable(customColumns.empty());
            _this.currentCustomFunctions = ko.observable(customFunctions.empty());
            _this.indexSuggestions = ko.observableArray([]);
            _this.csvUrl = ko.observable();
            _this.appUrls = appUrl.forCurrentDatabase();
            _this.editIndexUrl = ko.computed(function () { return _this.selectedIndex() ? appUrl.forEditIndex(_this.selectedIndex(), _this.activeDatabase()) : null; });
            _this.visualizerUrl = ko.computed(function () { return _this.selectedIndex() ? appUrl.forVisualizer(_this.activeDatabase(), _this.selectedIndex()) : null; });
            _this.indexPerfStatsUrl = ko.computed(function () { return _this.selectedIndex() ? appUrl.forIndexPerformance(_this.activeDatabase()) : null; });
            _this.termsUrl = ko.computed(function () { return _this.selectedIndex() ? appUrl.forTerms(_this.selectedIndex(), _this.activeDatabase()) : null; });
            _this.statsUrl = ko.computed(function () { return appUrl.forStatus(_this.activeDatabase()); });
            _this.hasSelectedIndex = ko.computed(function () { return _this.selectedIndex() != null; });
            _this.hasEditableIndex = ko.computed(function () { return _this.selectedIndex() != null && _this.selectedIndex().indexOf("dynamic/") !== 0; });
            _this.rawJsonUrl.subscribe(function (value) { return ko.postbox.publish("SetRawJSONUrl", value); });
            _this.selectedIndexLabel = ko.computed(function () { return _this.selectedIndex() === "dynamic" ? "All Documents" : _this.selectedIndex(); });
            _this.containsAsterixQuery = ko.computed(function () { return _this.queryText().includes("*.*"); });
            _this.isStaticIndexSelected = ko.computed(function () { return _this.selectedIndex() == null || _this.selectedIndex().indexOf(_this.dynamicPrefix) == -1; });
            _this.selectedIndexEditUrl = ko.computed(function () {
                if (_this.queryStats()) {
                    var index = _this.queryStats().IndexName;
                    if (!!index && index.indexOf(_this.dynamicPrefix) !== 0) {
                        return appUrl.forEditIndex(index, _this.activeDatabase());
                    }
                }
                return "";
            });
            _this.indexesExceptCurrent = ko.computed(function () {
                var allIndexes = _this.indexes();
                var selectedIndex = _this.selectedIndex();
                var allIndexesCopy;
                if (!!selectedIndex && selectedIndex.indexOf(_this.dynamicPrefix) === -1) {
                    allIndexesCopy = allIndexes.filter(function (indexDto) { return indexDto.name !== selectedIndex; });
                }
                else {
                    allIndexesCopy = allIndexes.slice(0); // make copy as sort works in situ
                }
                allIndexesCopy.sort(function (l, r) { return l.name.toLowerCase() > r.name.toLowerCase() ? 1 : -1; });
                return allIndexesCopy;
            });
            _this.collectionNamesExceptCurrent = ko.computed(function () {
                var allCollectionNames = _this.collectionNames();
                var selectedIndex = _this.selectedIndex();
                if (!!selectedIndex && selectedIndex.indexOf(_this.dynamicPrefix) == 0) {
                    return allCollectionNames.filter(function (collectionName) { return _this.dynamicPrefix + collectionName != selectedIndex; });
                }
                return allCollectionNames;
            });
            _this.showSuggestions = ko.computed(function () {
                return _this.indexSuggestions().length > 0;
            });
            _this.didDynamicChangeIndex = ko.computed(function () {
                if (_this.queryStats()) {
                    var recievedIndex = _this.queryStats().IndexName;
                    var selectedIndex = _this.selectedIndex();
                    return selectedIndex.indexOf(_this.dynamicPrefix) === 0 && _this.indexes()[0].name !== recievedIndex;
                }
                else {
                    return false;
                }
            });
            _this.isIndexMapReduce = ko.computed(function () {
                var currentIndex = _this.indexes().find(function (i) { return i.name === _this.selectedIndex(); });
                return !!currentIndex && currentIndex.hasReduce;
            });
            _this.isDynamicIndex = ko.computed(function () {
                var currentIndex = _this.indexes().find(function (i) { return i.name === _this.selectedIndex(); });
                return !!currentIndex && currentIndex.name.startsWith("Auto/");
            });
            _this.enableDeleteButton = ko.computed(function () {
                var currentIndex = _this.indexes().find(function (i) { return i.name === _this.selectedIndex(); });
                var isMapReduce = _this.isIndexMapReduce();
                var isDynamic = _this.isDynamicIndex();
                return !!currentIndex && !isMapReduce && !isDynamic;
            });
            aceEditorBindingHandler.install();
            // Refetch the index fields whenever the selected index name changes.
            _this.selectedIndex
                .subscribe(function (indexName) {
                if (indexName) {
                    _this.fetchIndexFields(indexName);
                }
            });
            return _this;
        }
        query.prototype.openQueryStats = function () {
            eventsCollector.default.reportEvent("query", "show-stats");
            var viewModel = new queryStatsDialog(this.queryStats(), this.selectedIndexEditUrl(), this.didDynamicChangeIndex(), this.rawJsonUrl());
            app.showBootstrapDialog(viewModel);
        };
        query.prototype.canActivate = function (args) {
            _super.prototype.canActivate.call(this, args);
            var deferred = $.Deferred();
            var db = this.activeDatabase();
            if (!!db) {
                this.fetchRecentQueries();
                $.when(this.fetchCustomFunctions(db), this.fetchAllTransformers(db))
                    .done(function () { return deferred.resolve({ can: true }); });
            }
            else {
                deferred.resolve({ redirect: "#resources" });
            }
            return deferred;
        };
        query.prototype.activate = function (indexNameOrRecentQueryHash) {
            var _this = this;
            _super.prototype.activate.call(this, indexNameOrRecentQueryHash);
            this.updateHelpLink('KCIMJK');
            this.selectedIndex.subscribe(function (index) { return _this.onIndexChanged(index); });
            var db = this.activeDatabase();
            return $.when(this.fetchAllCollections(db), this.fetchAllIndexes(db))
                .done(function () { return _this.selectInitialQuery(indexNameOrRecentQueryHash); });
        };
        query.prototype.detached = function () {
            _super.prototype.detached.call(this);
            aceEditorBindingHandler.detached();
        };
        query.prototype.attached = function () {
            var _this = this;
            _super.prototype.attached.call(this);
            this.createKeyboardShortcut("F2", function () { return _this.editSelectedIndex(); }, query.containerSelector);
            this.createKeyboardShortcut("ctrl+enter", function () { return _this.runQuery(); }, query.containerSelector);
            this.createKeyboardShortcut("alt+c", function () { return _this.focusOnQuery(); }, query.containerSelector);
            this.createKeyboardShortcut("alt+r", function () { return _this.runQuery(); }, query.containerSelector); // Using keyboard shortcut here, rather than HTML's accesskey, so that we don't steal focus from the editor.
            $("#indexQueryLabel").popover({
                html: true,
                trigger: "hover",
                container: ".form-horizontal",
                content: '<p>Queries use Lucene syntax. Examples:</p><pre><span class="code-keyword">Name</span>: Hi?berna*<br/><span class="code-keyword">Count</span>: [0 TO 10]<br/><span class="code-keyword">Title</span>: "RavenDb Queries 1010" AND <span class="code-keyword">Price</span>: [10.99 TO *]</pre>',
            });
            ko.postbox.publish("SetRawJSONUrl", appUrl.forIndexQueryRawData(this.activeDatabase(), this.selectedIndex()));
            this.focusOnQuery();
            var self = this;
            $(window).bind('storage', function () {
                self.fetchRecentQueries();
            });
            this.isLoading.extend({ rateLimit: 100 });
        };
        query.prototype.fetchRecentQueries = function () {
            this.recentQueries(recentQueriesStorage.getRecentQueries(this.activeDatabase()));
        };
        query.prototype.fetchCustomFunctions = function (db) {
            var _this = this;
            var deferred = $.Deferred();
            var customFunctionsCommand = new getEffectiveCustomFunctionsCommand(db).execute();
            customFunctionsCommand.done(function (cf) {
                _this.currentCustomFunctions(new customFunctions(cf.MergedDocument));
            })
                .always(function () { return deferred.resolve(); });
            return deferred;
        };
        query.prototype.fetchAllTransformers = function (db) {
            var _this = this;
            return new getTransformersCommand(db)
                .execute()
                .done(function (transformers) { return _this.allTransformers(transformers); });
        };
        query.prototype.fetchAllCollections = function (db) {
            var _this = this;
            var deferred = $.Deferred();
            new getCollectionsStatsCommand(db)
                .execute()
                .done(function (results) {
                _this.collections(results.collections);
                _this.collectionNames(results.collections.map(function (c) { return c.name; }));
                deferred.resolve();
            });
            return deferred;
        };
        query.prototype.fetchAllIndexes = function (db) {
            var _this = this;
            var deferred = $.Deferred();
            new getDatabaseStatsCommand(db)
                .execute()
                .done(function (results) {
                _this.indexes(results.Indexes.map(function (i) {
                    return {
                        name: i.Name,
                        hasReduce: false,
                    };
                }));
                deferred.resolve();
            });
            return deferred;
        };
        query.prototype.createPostboxSubscriptions = function () {
            var _this = this;
            return [
                ko.postbox.subscribe("ViewItem", function (itemNumber) {
                    _this.queryResults().getNthItem(itemNumber)
                        .done(function (item) {
                        var dto = item.toDto(true);
                        app.showBootstrapDialog(new showDataDialog(item.getId(), JSON.stringify(dto, null, 2)));
                    });
                })
            ];
        };
        query.prototype.onIndexChanged = function (newIndexName) {
            var _this = this;
            var command = getCustomColumnsCommand.forIndex(newIndexName, this.activeDatabase());
            this.contextName(command.docName);
            command.execute().done(function (dto) {
                if (dto) {
                    _this.currentColumnsParams().columns($.map(dto.Columns, function (c) { return new customColumnParams(c); }));
                    _this.currentColumnsParams().customMode(true);
                }
                else {
                    // use default values!
                    _this.currentColumnsParams().columns.removeAll();
                    _this.currentColumnsParams().customMode(false);
                }
            });
        };
        query.prototype.selectInitialQuery = function (indexNameOrRecentQueryHash) {
            if (!indexNameOrRecentQueryHash) {
                // if no index exists ==> use the default dynamic/All Documents
                this.setSelectedIndex("dynamic");
            }
            else if (this.indexes().find(function (i) { return i.name === indexNameOrRecentQueryHash; }) ||
                indexNameOrRecentQueryHash.startsWith("dynamic")) {
                this.setSelectedIndex(indexNameOrRecentQueryHash);
            }
            else if (indexNameOrRecentQueryHash.indexOf("recentquery-") === 0) {
                var hash = parseInt(indexNameOrRecentQueryHash.substr("recentquery-".length), 10);
                var matchingQuery = this.recentQueries().find(function (q) { return q.Hash === hash; });
                if (matchingQuery) {
                    this.runRecentQuery(matchingQuery);
                }
                else {
                    this.navigate(appUrl.forQuery(this.activeDatabase()));
                }
            }
            else if (indexNameOrRecentQueryHash) {
                // if indexName exists and we didn't fall into any case show error and redirect to documents page
                messagePublisher.reportError("Could not find " + indexNameOrRecentQueryHash + " index");
                router.navigate(appUrl.forDocuments(collection.allDocsCollectionName, this.activeDatabase()));
            }
        };
        query.prototype.focusOnQuery = function () {
            var editorElement = $("#queryEditor").length == 1 ? $("#queryEditor")[0] : null;
            if (editorElement) {
                var docEditor = ko.utils.domData.get(editorElement, "aceEditor");
                if (docEditor) {
                    docEditor.focus();
                }
            }
        };
        query.prototype.editSelectedIndex = function () {
            eventsCollector.default.reportEvent("query", "edit-selected-index");
            this.navigate(this.editIndexUrl());
        };
        query.prototype.runRecentQuery = function (query) {
            eventsCollector.default.reportEvent("query", "run-recent");
            this.selectedIndex(query.IndexName);
            this.queryText(query.QueryText);
            this.showFields(query.ShowFields);
            this.indexEntries(query.IndexEntries);
            this.isDefaultOperatorOr(query.UseAndOperator === false);
            this.sortBys(query.Sorts.map(function (s) { return querySort.fromQuerySortString(s); }));
            this.selectTransformer(this.findTransformerByName(this.getStoredQueryTransformerName(query)));
            this.applyTransformerParameters(query);
            this.runQuery();
        };
        query.prototype.toggleCacheEnable = function () {
            eventsCollector.default.reportEvent("query", "toggle-cache");
            this.isCacheDisable(!this.isCacheDisable());
        };
        query.prototype.runQuery = function () {
            var _this = this;
            eventsCollector.default.reportEvent("query", "run");
            var selectedIndex = this.selectedIndex();
            if (selectedIndex) {
                this.isWarning(false);
                this.isLoading(true);
                this.focusOnQuery();
                var queryText = this.queryText();
                var sorts = this.sortBys().filter(function (s) { return s.fieldName() != null; });
                var database = this.activeDatabase();
                var showFields = this.showFields();
                var indexEntries = this.indexEntries();
                var transformer = null;
                if (this.transformer()) {
                    transformer = new transformerQueryType({
                        transformerName: this.transformer().name(),
                        queryParams: []
                    });
                    var canRunQuery = true;
                    $("#transformerParams .transformer_param_flag").each(function (index, element) {
                        $(element).parent().removeClass("has-error");
                        if (element.value) {
                            transformer.addParamByNameAndValue(element.name, element.value);
                        }
                        else if (element.required) {
                            canRunQuery = false;
                            $(element).parent().addClass("has-error");
                        }
                    });
                    if (!canRunQuery) {
                        return; // Cannot run query without required parameters
                    }
                }
                this.currentColumnsParams().enabled(this.showFields() === false && this.indexEntries() === false);
                var useAndOperator = this.isDefaultOperatorOr() === false;
                var queryCommand = new queryIndexCommand(selectedIndex, database, 0, 25, queryText, sorts, transformer, showFields, indexEntries, useAndOperator, this.isCacheDisable());
                this.rawJsonUrl(appUrl.forResourceQuery(database) + queryCommand.getUrl());
                this.csvUrl(queryCommand.getCsvUrl());
                var resultsFetcher = function (skip, take) {
                    var command = new queryIndexCommand(selectedIndex, database, skip, take, queryText, sorts, transformer, showFields, indexEntries, useAndOperator, _this.isCacheDisable());
                    return command.execute()
                        .always(function () {
                        _this.isLoading(false);
                        _this.focusOnQuery();
                    })
                        .done(function (queryResults) {
                        _this.queryStats(queryResults.additionalResultInfo);
                        _this.indexSuggestions([]);
                        if (queryResults.totalResultCount == 0) {
                            var queryFields = _this.extractQueryFields();
                            var alreadyLookedForNull = false;
                            if (_this.selectedIndex().indexOf(_this.dynamicPrefix) !== 0) {
                                alreadyLookedForNull = true;
                                for (var i = 0; i < queryFields.length; i++) {
                                    _this.getIndexSuggestions(selectedIndex, queryFields[i]);
                                    if (queryFields[i].FieldValue == 'null') {
                                        _this.isWarning(true);
                                        _this.warningText(("The Query contains '" + queryFields[i].FieldName + ": null', this will check if the field contains the string 'null', is this what you meant?"));
                                    }
                                }
                            }
                            if (!alreadyLookedForNull) {
                                for (var i = 0; i < queryFields.length; i++) {
                                    ;
                                    if (queryFields[i].FieldValue == 'null') {
                                        _this.isWarning(true);
                                        _this.warningText(("The Query contains '" + queryFields[i].FieldName + ": null', this will check if the field contains the string 'null', is this what you meant?"));
                                    }
                                }
                            }
                        }
                    })
                        .fail(function () {
                        recentQueriesStorage.removeIndexFromRecentQueries(database, selectedIndex);
                    });
                };
                var resultsList = new pagedList(resultsFetcher);
                this.queryResults(resultsList);
                this.recordQueryRun(selectedIndex, queryText, sorts.map(function (s) { return s.toQuerySortString(); }), transformer, showFields, indexEntries, useAndOperator);
                return resultsList;
            }
            return null;
        };
        query.prototype.queryCompleter = function (editor, session, pos, prefix, callback) {
            queryUtil.queryCompleter(this.indexFields, this.selectedIndex, this.dynamicPrefix, this.activeDatabase, editor, session, pos, prefix, callback);
        };
        query.prototype.recordQueryRun = function (indexName, queryText, sorts, transformerQuery, showFields, indexEntries, useAndOperator) {
            eventsCollector.default.reportEvent("query", "record-run");
            var newQuery = {
                IndexEntries: indexEntries,
                IndexName: indexName,
                IsPinned: false,
                QueryText: queryText,
                ShowFields: showFields,
                Sorts: sorts,
                TransformerQuery: transformerQuery,
                UseAndOperator: useAndOperator,
                Hash: genUtils.hashCode(indexName + (queryText || "") +
                    sorts.reduce(function (a, b) { return a + b; }, "") +
                    (transformerQuery ? transformerQuery.toUrl() : "") +
                    showFields +
                    indexEntries +
                    useAndOperator)
            };
            // Put the query into the URL, so that if the user refreshes the page, he's still got this query loaded.
            var queryUrl = appUrl.forQuery(this.activeDatabase(), newQuery.Hash);
            this.updateUrl(queryUrl);
            // Add this query to our recent queries list in the UI, or move it to the top of the list if it's already there.
            var existing = this.recentQueries().find(function (q) { return q.Hash === newQuery.Hash; });
            if (existing) {
                this.recentQueries.remove(existing);
                this.recentQueries.unshift(existing);
            }
            else {
                this.recentQueries.unshift(newQuery);
            }
            // Limit us to 15 query recent runs.
            if (this.recentQueries().length > 15) {
                this.recentQueries.remove(this.recentQueries()[15]);
            }
            //save the recent queries to local storage
            recentQueriesStorage.saveRecentQueries(this.activeDatabase(), this.recentQueries());
        };
        query.prototype.getRecentQuerySortText = function (sorts) {
            if (sorts.length > 0) {
                return sorts
                    .map(function (s) { return querySort.fromQuerySortString(s); })
                    .map(function (s) { return s.toHumanizedString(); })
                    .reduce(function (first, second) { return first + ", " + second; });
            }
            return "";
        };
        query.prototype.setSelectedIndex = function (indexName) {
            this.sortBys.removeAll();
            this.selectedIndex(indexName);
            this.runQuery();
            // Reflect the new index in the address bar.
            var indexQuery = query.getIndexUrlPartFromIndexName(indexName);
            var url = appUrl.forQuery(this.activeDatabase(), indexQuery);
            this.updateUrl(url);
        };
        query.getIndexUrlPartFromIndexName = function (indexNameOrCollectionName) {
            if (indexNameOrCollectionName === "All Documents") {
                return "dynamic";
            }
            return indexNameOrCollectionName;
        };
        query.prototype.addSortBy = function () {
            var _this = this;
            eventsCollector.default.reportEvent("query", "add-sort-by");
            var sort = new querySort();
            sort.fieldName.subscribe(function () { return _this.runQuery(); });
            sort.isAscending.subscribe(function () { return _this.runQuery(); });
            sort.isRange.subscribe(function () { return _this.runQuery(); });
            this.sortBys.push(sort);
        };
        query.prototype.removeSortBy = function (sortBy) {
            eventsCollector.default.reportEvent("query", "remove-sort-by");
            this.sortBys.remove(sortBy);
            this.runQuery();
        };
        query.prototype.addTransformer = function () {
            eventsCollector.default.reportEvent("query", "add-transformer");
            this.transformer(transformerType.empty());
        };
        query.prototype.selectTransformer = function (dto) {
            if (dto) {
                this.transformer(new transformerType(dto));
                this.runQuery();
            }
            else {
                this.transformer(null);
            }
        };
        query.prototype.removeTransformer = function () {
            eventsCollector.default.reportEvent("query", "remove-transformer");
            this.transformer(null);
            this.runQuery();
        };
        query.prototype.setOperatorOr = function () {
            eventsCollector.default.reportEvent("query", "set-operator", "or");
            this.isDefaultOperatorOr(true);
            this.runQuery();
        };
        query.prototype.setOperatorAnd = function () {
            eventsCollector.default.reportEvent("query", "set-operator", "and");
            this.isDefaultOperatorOr(false);
            this.runQuery();
        };
        query.prototype.toggleShowFields = function () {
            eventsCollector.default.reportEvent("query", "show-fields");
            this.showFields(!this.showFields());
            this.runQuery();
        };
        query.prototype.toggleIndexEntries = function () {
            eventsCollector.default.reportEvent("query", "index-entries");
            this.indexEntries(!this.indexEntries());
            this.runQuery();
        };
        query.prototype.deleteDocsMatchingQuery = function () {
            var _this = this;
            eventsCollector.default.reportEvent("query", "delete-documents");
            // Run the query so that we have an idea of what we'll be deleting.
            var queryResult = this.runQuery();
            queryResult
                .fetch(0, 1)
                .done(function (results) {
                if (results.totalResultCount === 0) {
                    app.showBootstrapMessage("There are no documents matching your query.", "Nothing to do");
                }
                else {
                    _this.promptDeleteDocsMatchingQuery(results.totalResultCount);
                }
            });
        };
        query.prototype.promptDeleteDocsMatchingQuery = function (resultCount) {
            var _this = this;
            var viewModel = new deleteDocumentsMatchingQueryConfirm(this.selectedIndex(), this.queryText(), resultCount, this.activeDatabase());
            app
                .showBootstrapDialog(viewModel)
                .done(function () { return _this.runQuery(); });
        };
        query.prototype.getQueryGrid = function () {
            var gridContents = $(query.queryGridSelector).children()[0];
            if (gridContents) {
                return ko.dataFor(gridContents);
            }
            return null;
        };
        query.prototype.selectColumns = function () {
            var _this = this;
            eventsCollector.default.reportEvent("query", "select-columns");
            var selectColumnsViewModel = new selectColumns(this.currentColumnsParams().clone(), this.currentCustomFunctions().clone(), this.contextName(), this.activeDatabase(), this.getQueryGrid().getColumnsNames());
            app.showBootstrapDialog(selectColumnsViewModel);
            selectColumnsViewModel.onExit().done(function (cols) {
                _this.currentColumnsParams(cols);
                _this.runQuery();
            });
        };
        query.prototype.fetchIndexFields = function (indexName) {
            var _this = this;
            // Fetch the index definition so that we get an updated list of fields to be used as sort by options.
            // Fields don't show for All Documents.
            var self = this;
            var isAllDocumentsDynamicQuery = indexName === "All Documents";
            if (!isAllDocumentsDynamicQuery) {
                //if index is dynamic, get columns using index definition, else get it using first index result
                if (indexName.indexOf(this.dynamicPrefix) === 0) {
                    var collectionName = indexName.substring(8);
                    new collection(collectionName, this.activeDatabase())
                        .fetchDocuments(0, 1)
                        .done(function (result) {
                        if (!!result && result.totalResultCount > 0 && result.items.length > 0) {
                            var dynamicIndexPattern = new document(result.items[0]);
                            if (!!dynamicIndexPattern) {
                                _this.indexFields(dynamicIndexPattern.getDocumentPropertyNames());
                            }
                        }
                    });
                }
                else {
                    new getIndexDefinitionCommand(indexName, this.activeDatabase())
                        .execute()
                        .done(function (result) {
                        self.isTestIndex(result.IsTestIndex);
                        self.indexFields(Object.keys(result.Fields));
                    });
                }
            }
        };
        query.prototype.findTransformerByName = function (transformerName) {
            return this.allTransformers().find(function (x) { return x.Name === transformerName; });
        };
        query.prototype.getStoredQueryTransformerName = function (query) {
            if (query.TransformerQuery) {
                return query.TransformerQuery.transformerName;
            }
            return "";
        };
        query.prototype.getStoredQueryTransformerParameters = function (queryParams) {
            if (queryParams.length > 0) {
                return "(" +
                    queryParams
                        .map(function (param) { return param.name + "=" + param.value; })
                        .join(", ") + ")";
            }
            return "";
        };
        query.prototype.applyTransformerParameters = function (query) {
            if (query.TransformerQuery && query.TransformerQuery.queryParams) {
                query.TransformerQuery.queryParams.forEach(function (param) {
                    $("#transformerParams input[name=" + param.name + "]").val(param.value);
                });
            }
        };
        query.prototype.extractQueryFields = function () {
            var query = this.queryText();
            var luceneSimpleFieldRegex = /(\w+):\s*("((?:[^"\\]|\\.)*)"|'((?:[^'\\]|\\.)*)'|(\w+))/g;
            var queryFields = [];
            var match = null;
            while ((match = luceneSimpleFieldRegex.exec(query))) {
                var value = match[3] || match[4] || match[5];
                queryFields.push({
                    FieldName: match[1],
                    FieldValue: value,
                    Index: match.index
                });
            }
            return queryFields;
        };
        query.prototype.getIndexSuggestions = function (indexName, info) {
            var _this = this;
            if (_.includes(this.indexFields(), info.FieldName)) {
                var task = new getIndexSuggestionsCommand(this.activeDatabase(), indexName, info.FieldName, info.FieldValue).execute();
                task.done(function (result) {
                    for (var index = 0; index < result.Suggestions.length; index++) {
                        _this.indexSuggestions.push({
                            Index: info.Index,
                            FieldName: info.FieldName,
                            FieldValue: info.FieldValue,
                            Suggestion: result.Suggestions[index]
                        });
                    }
                });
            }
        };
        query.prototype.applySuggestion = function (suggestion) {
            eventsCollector.default.reportEvent("query", "apply-suggestion");
            var value = this.queryText();
            var startIndex = value.indexOf(suggestion.FieldValue, suggestion.Index);
            this.queryText(value.substring(0, startIndex) + suggestion.Suggestion + value.substring(startIndex + suggestion.FieldValue.length));
            this.indexSuggestions([]);
            this.runQuery();
        };
        query.prototype.exportCsv = function () {
            eventsCollector.default.reportEvent("query", "export-csv");
            var db = this.activeDatabase();
            var url = appUrl.forResourceQuery(db) + this.csvUrl();
            this.downloader.download(db, url);
        };
        query.prototype.fieldNameStartsWith = function () {
            var _this = this;
            eventsCollector.default.reportEvent("query", "field-name-starts-with");
            var fieldStartsWithViewModel = new fieldStringFilter("Field sub text");
            fieldStartsWithViewModel
                .applyFilterTask
                .done(function (input, option) {
                if (_this.queryText().length !== 0) {
                    _this.queryText(_this.queryText() + " AND ");
                }
                if (option === "Starts with") {
                    _this.queryText(_this.queryText() + _this.searchField() + ":" + queryUtil.escapeTerm(input) + "*");
                }
                else if (option === "Ends with") {
                    _this.queryText(_this.queryText() + _this.searchField() + ":" + "*" + queryUtil.escapeTerm(input));
                }
                else if (option === "Contains") {
                    _this.queryText(_this.queryText() + _this.searchField() + ":" + "*" + queryUtil.escapeTerm(input) + "*");
                }
                else if (option === "Exact") {
                    _this.queryText(_this.queryText() + _this.searchField() + ":" + queryUtil.escapeTerm(input));
                }
            });
            app.showBootstrapDialog(fieldStartsWithViewModel);
        };
        query.prototype.fieldValueRange = function () {
            var _this = this;
            eventsCollector.default.reportEvent("query", "field-value-range");
            var fieldRangeFilterViewModel = new fieldRangeFilter("Field range filter");
            fieldRangeFilterViewModel
                .applyFilterTask
                .done(function (fromStr, toStr, option) {
                var from = !fromStr || fromStr.length === 0 ? "*" : fromStr;
                var to = !toStr || toStr.length === 0 ? "*" : toStr;
                var fromPrefix = "";
                var toPrefix = "";
                if (_this.queryText().length !== 0) {
                    _this.queryText(_this.queryText() + " AND ");
                }
                if (option === "Numeric Double") {
                    if (from !== "*")
                        fromPrefix = "Dx";
                    if (to !== "*")
                        toPrefix = "Dx";
                    _this.queryText(_this.queryText() + _this.searchField() + "_Range:[" + fromPrefix + from + " TO " + toPrefix + to + "]");
                }
                else if (option === "Numeric Long") {
                    if (from !== "*")
                        fromPrefix = "Lx";
                    if (to !== "*")
                        toPrefix = "Lx";
                    _this.queryText(_this.queryText() + _this.searchField() + "_Range:[" + fromPrefix + from + " TO " + toPrefix + to + "]");
                }
                else if (option === "Numeric Int") {
                    if (from !== "*")
                        fromPrefix = "Ix";
                    if (to !== "*")
                        toPrefix = "Ix";
                    _this.queryText(_this.queryText() + _this.searchField() + "_Range:[" + fromPrefix + from + " TO " + toPrefix + to + "]");
                }
                else if (option === "Alphabetical") {
                    _this.queryText(_this.queryText() + _this.searchField() + ":[" + from + " TO " + to + "]");
                }
                else if (option === "Datetime") {
                    _this.queryText(_this.queryText() + _this.searchField() + ":[" + from + " TO " + to + "]");
                }
            });
            app.showBootstrapDialog(fieldRangeFilterViewModel);
        };
        query.prototype.fieldValueInMethod = function () {
            var _this = this;
            eventsCollector.default.reportEvent("query", "field-value-in");
            var inMethodFilterViewModel = new InMethodFilter("Field in method filter");
            inMethodFilterViewModel
                .applyFilterTask
                .done(function (inputs) {
                if (_this.queryText().length !== 0) {
                    _this.queryText(_this.queryText() + " AND ");
                }
                var escapedStrings = inputs.map(function (s) { return queryUtil.escapeTerm(s); }).join();
                _this.queryText(_this.queryText() + "@in<" + _this.searchField() + ">:(" + escapedStrings + ")");
            });
            app.showBootstrapDialog(inMethodFilterViewModel);
        };
        return query;
    }(viewModelBase));
    query.containerSelector = "#queryContainer";
    query.queryGridSelector = "#queryResultsGrid";
    return query;
});

//# sourceMappingURL=query.js.map
