var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/database/debug/getStatusDebugChangesCommand", "viewmodels/viewModelBase"], function (require, exports, getStatusDebugChangesCommand, viewModelBase) {
    "use strict";
    var statusDebugChanges = (function (_super) {
        __extends(statusDebugChanges, _super);
        function statusDebugChanges() {
            var _this = _super.apply(this, arguments) || this;
            _this.data = ko.observable();
            return _this;
        }
        statusDebugChanges.prototype.activate = function (args) {
            var _this = this;
            _super.prototype.activate.call(this, args);
            this.activeDatabase.subscribe(function () { return _this.fetchStatusDebugChanges(); });
            this.updateHelpLink('JHZ574');
            return this.fetchStatusDebugChanges();
        };
        statusDebugChanges.prototype.fetchStatusDebugChanges = function () {
            var _this = this;
            var db = this.activeDatabase();
            if (db) {
                return new getStatusDebugChangesCommand(db)
                    .execute()
                    .done(function (results) { return _this.data(results); });
            }
            return null;
        };
        return statusDebugChanges;
    }(viewModelBase));
    return statusDebugChanges;
});

//# sourceMappingURL=statusDebugChanges.js.map
