var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/database/debug/getStatusDebugConfigCommand", "viewmodels/viewModelBase", "common/bindingHelpers/aceEditorBindingHandler"], function (require, exports, getStatusDebugConfigCommand, viewModelBase, aceEditorBindingHandler) {
    "use strict";
    var statusDebugConfig = (function (_super) {
        __extends(statusDebugConfig, _super);
        function statusDebugConfig() {
            var _this = _super.call(this) || this;
            _this.data = ko.observable("");
            aceEditorBindingHandler.install();
            _this.isForbidden = ko.computed(function () { return !_this.data(); });
            return _this;
        }
        statusDebugConfig.prototype.canActivate = function (args) {
            _super.prototype.canActivate.call(this, args);
            var deffered = $.Deferred();
            this.fetchStatusDebugConfig().always(function () { return deffered.resolve({ can: true }); });
            return deffered;
        };
        statusDebugConfig.prototype.activate = function (args) {
            var _this = this;
            _super.prototype.activate.call(this, args);
            this.updateHelpLink('JHZ574');
            this.activeDatabase.subscribe(function () { return _this.fetchStatusDebugConfig(); });
        };
        statusDebugConfig.prototype.compositionComplete = function () {
            var _this = this;
            _super.prototype.compositionComplete.call(this);
            var editorElement = $("#statusDebugConfigEditor");
            if (editorElement.length > 0) {
                this.editor = ko.utils.domData.get(editorElement[0], "aceEditor");
            }
            $("#statusDebugConfigEditor").on('DynamicHeightSet', function () { return _this.editor.resize(); });
        };
        statusDebugConfig.prototype.detached = function () {
            _super.prototype.detached.call(this);
            $("#statusDebugConfigEditor").off('DynamicHeightSet');
        };
        statusDebugConfig.prototype.fetchStatusDebugConfig = function () {
            var _this = this;
            var db = this.activeDatabase();
            return new getStatusDebugConfigCommand(db)
                .execute()
                .done(function (results) { return _this.data(JSON.stringify(results, null, 4)); });
        };
        return statusDebugConfig;
    }(viewModelBase));
    return statusDebugConfig;
});

//# sourceMappingURL=statusDebugConfig.js.map
