var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/database/debug/getStatusDebugCurrentlyIndexingCommand", "viewmodels/viewModelBase", "common/bindingHelpers/autoRefreshBindingHandler"], function (require, exports, getStatusDebugCurrentlyIndexingCommand, viewModelBase, autoRefreshBindingHandler) {
    "use strict";
    var statusDebugCurrentlyIndexing = (function (_super) {
        __extends(statusDebugCurrentlyIndexing, _super);
        function statusDebugCurrentlyIndexing() {
            var _this = _super.call(this) || this;
            _this.data = ko.observable();
            autoRefreshBindingHandler.install();
            return _this;
        }
        statusDebugCurrentlyIndexing.prototype.activate = function (args) {
            var _this = this;
            _super.prototype.activate.call(this, args);
            this.updateHelpLink('JHZ574');
            this.activeDatabase.subscribe(function () { return _this.fetchCurrentlyIndexing(); });
            return this.fetchCurrentlyIndexing();
        };
        statusDebugCurrentlyIndexing.prototype.fetchCurrentlyIndexing = function () {
            var _this = this;
            var db = this.activeDatabase();
            if (db) {
                return new getStatusDebugCurrentlyIndexingCommand(db)
                    .execute()
                    .done(function (results) { return _this.data(results); });
            }
            return null;
        };
        return statusDebugCurrentlyIndexing;
    }(viewModelBase));
    return statusDebugCurrentlyIndexing;
});

//# sourceMappingURL=statusDebugCurrentlyIndexing.js.map
