var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "viewmodels/viewModelBase", "models/database/documents/customColumns", "models/database/documents/customColumnParams", "common/pagedList", "commands/database/debug/getDocRefsCommand", "common/eventsCollector"], function (require, exports, viewModelBase, customColumns, customColumnParams, pagedList, getDocRefsCommand, eventsCollector) {
    "use strict";
    var statusDebugDocrefs = (function (_super) {
        __extends(statusDebugDocrefs, _super);
        function statusDebugDocrefs() {
            var _this = _super.apply(this, arguments) || this;
            _this.currentDocRefs = ko.observable();
            _this.columns = ko.observable(customColumns.empty());
            _this.docId = ko.observable("");
            _this.canSearch = ko.computed(function () { return _this.docId().length > 0; });
            _this.resultsCount = ko.computed(function () {
                if (!_this.currentDocRefs())
                    return -1;
                return _this.currentDocRefs().totalResultCount();
            });
            return _this;
        }
        statusDebugDocrefs.prototype.activate = function (args) {
            _super.prototype.activate.call(this, args);
            this.updateHelpLink('JHZ574');
            this.columns().columns([
                new customColumnParams({ Header: "Id", Binding: "Id", DefaultWidth: 300 }),
            ]);
        };
        statusDebugDocrefs.prototype.fetchDocRefs = function () {
            eventsCollector.default.reportEvent("docrefs", "fetch");
            this.currentDocRefs(this.createPagedList(this.activeDatabase()));
        };
        statusDebugDocrefs.prototype.createPagedList = function (db) {
            var _this = this;
            var fetcher = function (skip, take) {
                return new getDocRefsCommand(db, _this.docId(), skip, take).execute();
            };
            return new pagedList(fetcher);
        };
        return statusDebugDocrefs;
    }(viewModelBase));
    return statusDebugDocrefs;
});

//# sourceMappingURL=statusDebugDocrefs.js.map
