var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "viewmodels/viewModelBase", "common/pagedList", "models/database/documents/customColumns", "models/database/documents/customColumnParams", "commands/database/debug/getIdentitiesCommand"], function (require, exports, viewModelBase, pagedList, customColumns, customColumnParams, getIdentitiesCommand) {
    "use strict";
    var statusDebugIdentities = (function (_super) {
        __extends(statusDebugIdentities, _super);
        function statusDebugIdentities() {
            var _this = _super.apply(this, arguments) || this;
            _this.currentIdentities = ko.observable();
            _this.columns = ko.observable(customColumns.empty());
            _this.resultsCount = ko.computed(function () {
                if (!_this.currentIdentities())
                    return -1;
                return _this.currentIdentities().totalResultCount();
            });
            return _this;
        }
        statusDebugIdentities.prototype.activate = function (args) {
            _super.prototype.activate.call(this, args);
            this.columns().columns([
                new customColumnParams({ Header: "Key", Binding: "Key", DefaultWidth: 300 }),
                new customColumnParams({ Header: "Value", Binding: "Value", DefaultWidth: 300 }),
            ]);
            this.updateHelpLink('JHZ574');
            this.fetchIdentities();
        };
        statusDebugIdentities.prototype.fetchIdentities = function () {
            this.currentIdentities(this.createPagedList(this.activeDatabase()));
        };
        statusDebugIdentities.prototype.createPagedList = function (db) {
            var fetcher = function (skip, take) {
                return new getIdentitiesCommand(db, skip, take).execute();
            };
            return new pagedList(fetcher);
        };
        return statusDebugIdentities;
    }(viewModelBase));
    return statusDebugIdentities;
});

//# sourceMappingURL=statusDebugIdentities.js.map
