var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/database/debug/getStatusDebugIndexFieldsCommand", "viewmodels/viewModelBase", "common/bindingHelpers/aceEditorBindingHandler", "common/messagePublisher", "common/eventsCollector"], function (require, exports, getStatusDebugIndexFieldsCommand, viewModelBase, aceEditorBindingHandler, messagePublisher, eventsCollector) {
    "use strict";
    var statusDebugIndexFields = (function (_super) {
        __extends(statusDebugIndexFields, _super);
        function statusDebugIndexFields() {
            var _this = _super.call(this) || this;
            _this.result = ko.observable();
            _this.indexStr = ko.observable("");
            aceEditorBindingHandler.install();
            return _this;
        }
        statusDebugIndexFields.prototype.activate = function (args) {
            _super.prototype.activate.call(this, args);
            this.updateHelpLink('JHZ574');
        };
        statusDebugIndexFields.prototype.attached = function () {
            _super.prototype.attached.call(this);
            $("#indexDefLabel").popover({
                html: true,
                trigger: 'hover',
                container: '.form-horizontal',
                content: 'Enter index definition and click <kbd>Show index fields</kbd>.<br /> Example:<pre><span class="code-keyword">from</span> doc <span class="code-keyword">in</span> docs <span class="code-keyword">select new</span> { Id = doc.Id }</pre>',
            });
        };
        statusDebugIndexFields.prototype.compositionComplete = function () {
            var _this = this;
            _super.prototype.compositionComplete.call(this);
            var editorElement = $("#statusDebugIndexFieldsEditor");
            if (editorElement.length > 0) {
                this.editor = ko.utils.domData.get(editorElement[0], "aceEditor");
            }
            $("#statusDebugIndexFieldsEditor").on('DynamicHeightSet', function () { return _this.editor.resize(); });
            this.focusOnEditor();
            this.indexStr.subscribe(function (newValue) {
                var message = "";
                var currentEditor = aceEditorBindingHandler.currentEditor;
                var textarea = $(currentEditor.container).find("textarea")[0];
                if (newValue === "") {
                    message = "Please fill out this field.";
                }
                textarea.setCustomValidity(message);
                /*setTimeout(() => {
                    var annotations = currentEditor.getSession().getAnnotations();
                    var isErrorExists = false;
                    for (var i = 0; i < annotations.length; i++) {
                        var annotationType = annotations[i].type;
                        if (annotationType === "error" || annotationType === "warning") {
                            isErrorExists = true;
                            break;
                        }
                    }
                    if (isErrorExists) {
                        message = "The script isn't a javascript legal expression!";
                        textarea.setCustomValidity(message);
                    }
                }, 700);*/
            });
            this.indexStr.valueHasMutated();
        };
        statusDebugIndexFields.prototype.detached = function () {
            _super.prototype.detached.call(this);
            $("#statusDebugIndexFieldsEditor").off('DynamicHeightSet');
        };
        statusDebugIndexFields.prototype.focusOnEditor = function () {
            this.editor.focus();
        };
        statusDebugIndexFields.prototype.fetchIndexFields = function () {
            var _this = this;
            eventsCollector.default.reportEvent("index-fields", "show");
            this.result(null);
            var db = this.activeDatabase();
            if (db) {
                return new getStatusDebugIndexFieldsCommand(db, this.indexStr())
                    .execute()
                    .done(function (results) { return _this.result(results); })
                    .fail(function (response) {
                    _this.focusOnEditor();
                    messagePublisher.reportError("Failed to compute index fields!", response.responseText, response.statusText);
                });
            }
            return null;
        };
        return statusDebugIndexFields;
    }(viewModelBase));
    return statusDebugIndexFields;
});

//# sourceMappingURL=statusDebugIndexFields.js.map
