var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/database/debug/getStatusDebugRoutesCommand", "viewmodels/viewModelBase", "common/bindingHelpers/aceEditorBindingHandler", "viewmodels/shell/accessHelper"], function (require, exports, getStatusDebugRoutesCommand, viewModelBase, aceEditorBindingHandler, accessHelper) {
    "use strict";
    var statusDebugRoutes = (function (_super) {
        __extends(statusDebugRoutes, _super);
        function statusDebugRoutes() {
            var _this = _super.call(this) || this;
            _this.data = ko.observable();
            _this.isGlobalAdmin = accessHelper.isGlobalAdmin;
            aceEditorBindingHandler.install();
            return _this;
        }
        statusDebugRoutes.prototype.compositionComplete = function () {
            var _this = this;
            _super.prototype.compositionComplete.call(this);
            var editorElement = $("#statusDebugRoutesEditor");
            if (editorElement.length > 0) {
                this.editor = ko.utils.domData.get(editorElement[0], "aceEditor");
            }
            $("#statusDebugRoutesEditor").on('DynamicHeightSet', function () { return _this.editor.resize(); });
        };
        statusDebugRoutes.prototype.detached = function () {
            _super.prototype.detached.call(this);
            $("#statusDebugRoutesEditor").off('DynamicHeightSet');
        };
        statusDebugRoutes.prototype.activate = function (args) {
            var _this = this;
            _super.prototype.activate.call(this, args);
            this.updateHelpLink('JHZ574');
            if (this.isGlobalAdmin()) {
                this.fetchRoutes();
                this.activeDatabase.subscribe(function () { return _this.fetchRoutes(); });
            }
        };
        statusDebugRoutes.prototype.fetchRoutes = function () {
            var _this = this;
            return new getStatusDebugRoutesCommand()
                .execute()
                .done(function (results) {
                return _this.data(JSON.stringify(results, null, 4));
            });
        };
        return statusDebugRoutes;
    }(viewModelBase));
    return statusDebugRoutes;
});

//# sourceMappingURL=statusDebugRoutes.js.map
