var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/database/debug/getStatusDebugTasksSummaryCommand", "viewmodels/viewModelBase", "common/appUrl"], function (require, exports, getStatusDebugTasksSummaryCommand, viewModelBase, appUrl) {
    "use strict";
    var statusDebugTasks = (function (_super) {
        __extends(statusDebugTasks, _super);
        function statusDebugTasks() {
            var _this = _super.call(this) || this;
            _this.data = ko.observable();
            _this.detailsUrl = ko.computed(function () { return appUrl.forResourceQuery(_this.activeDatabase()) + "/debug/tasks"; });
            return _this;
        }
        statusDebugTasks.prototype.activate = function (args) {
            var _this = this;
            _super.prototype.activate.call(this, args);
            this.updateHelpLink('JHZ574');
            this.activeDatabase.subscribe(function () { return _this.fetchTasks(); });
            return this.fetchTasks();
        };
        statusDebugTasks.prototype.fetchTasks = function () {
            var _this = this;
            var db = this.activeDatabase();
            if (db) {
                return new getStatusDebugTasksSummaryCommand(db)
                    .execute()
                    .done(function (results) { return _this.data(results); });
            }
            return null;
        };
        return statusDebugTasks;
    }(viewModelBase));
    return statusDebugTasks;
});

//# sourceMappingURL=statusDebugTasks.js.map
