var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "common/appUrl", "viewmodels/viewModelBase", "commands/auth/getSingleAuthTokenCommand", "common/eventsCollector"], function (require, exports, appUrl, viewModelBase, getSingleAuthTokenCommand, eventsCollector) {
    "use strict";
    var statusDebugWebSocket = (function (_super) {
        __extends(statusDebugWebSocket, _super);
        function statusDebugWebSocket() {
            var _this = _super.apply(this, arguments) || this;
            _this.results = ko.observable("");
            return _this;
        }
        statusDebugWebSocket.prototype.activate = function (args) {
            _super.prototype.activate.call(this, args);
            this.updateHelpLink('JHZ574');
        };
        //TODO: use abstractWebSocketClient
        statusDebugWebSocket.prototype.test = function () {
            var _this = this;
            eventsCollector.default.reportEvent("web-socket", "test");
            if ("WebSocket" in window) {
                var getTokenTask = new getSingleAuthTokenCommand(this.activeDatabase()).execute();
                getTokenTask
                    .done(function (tokenObject) {
                    var token = tokenObject.Token;
                    var connectionString = 'singleUseAuthToken=' + token + '&id=test&coolDownWithDataLoss=1000&isMultyTenantTransport=false';
                    _this.connectWebSocket(connectionString);
                })
                    .fail(function (e) {
                    if (e.status == 0) {
                        _this.appendLog("Connection has closed (during getToken)");
                    }
                    else {
                        _this.appendLog(e.responseJSON.Error);
                    }
                });
            }
            else {
                this.appendLog("Looks like your browser doesn't support web sockets");
            }
        };
        statusDebugWebSocket.prototype.connectWebSocket = function (connectionString) {
            var _this = this;
            var connectionOpened = false;
            var wsProtocol = window.location.protocol === 'https:' ? 'wss://' : 'ws://';
            var url = wsProtocol + window.location.host + appUrl.forResourceQuery(this.activeDatabase()) + '/websocket/validate?' + connectionString;
            this.appendLog("Connecting to web socket using url: " + url);
            var webSocket = new WebSocket(url);
            webSocket.onerror = function (e) {
                if (connectionOpened == false) {
                    _this.appendLog("Server doesn't support web sockets protocol");
                }
                else {
                    _this.appendLog("WebSocket Error" + JSON.stringify(e));
                }
            };
            webSocket.onmessage = function (e) {
                var data = JSON.parse(e.data);
                _this.appendLog("Got message from websocket. Status Code = " + data.StatusCode + ", message = " + data.StatusMessage);
                setTimeout(function () { return webSocket.close(1000, "CLOSE_NORMAL"); }, 50);
            };
            webSocket.onclose = function (e) {
                if (e.wasClean == false) {
                    _this.appendLog("WebSocket disconnected in unclean way");
                }
                else {
                    _this.appendLog("Closed WebSocket connection");
                }
            };
            webSocket.onopen = function () {
                _this.appendLog("Connected to WebSocket");
                connectionOpened = true;
            };
        };
        statusDebugWebSocket.prototype.appendLog = function (msg) {
            this.results(this.results() + msg + "\r\n");
        };
        return statusDebugWebSocket;
    }(viewModelBase));
    return statusDebugWebSocket;
});

//# sourceMappingURL=statusDebugWebSocket.js.map
