var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "viewmodels/viewModelBase", "common/appUrl", "viewmodels/database/status/status", "viewmodels/shell/accessHelper"], function (require, exports, viewModelBase, appUrl, status, accessHelper) {
    "use strict";
    var requests = (function (_super) {
        __extends(requests, _super);
        function requests() {
            var _this = _super.call(this) || this;
            _this.router = status.statusRouter.createChildRouter()
                .map([
                { route: 'databases/status/requests', moduleId: 'viewmodels/database/status/requests/requestsCount', title: 'Requests count', tooltip: "Displays requests counts over time", nav: true, hash: appUrl.forCurrentDatabase().requestsCount },
                { route: 'databases/status/requests/tracing', moduleId: 'viewmodels/database/status/requests/requestTracing', title: 'Request tracing', tooltip: "Displays recent requests with their status and execution times", nav: accessHelper.canExposeConfigOverTheWire(), hash: appUrl.forCurrentDatabase().requestsTracing },
            ])
                .buildNavigationModel();
            appUrl.mapUnknownRoutes(_this.router);
            _this.currentRouteTitle = ko.computed(function () {
                // Is there a better way to get the active route?
                var activeRoute = _this.router.navigationModel().find(function (r) { return r.isActive(); });
                return activeRoute != null ? activeRoute.title : "";
            });
            return _this;
        }
        return requests;
    }(viewModelBase));
    return requests;
});

//# sourceMappingURL=requests.js.map
