var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "viewmodels/dialogViewModelBase", "plugins/dialog", "commands/database/sqlReplication/getSqlReplicationStatsCommand"], function (require, exports, dialogViewModelBase, dialog, getSqlReplicationStatsCommand) {
    "use strict";
    var sqlReplicationStatsDialog = (function (_super) {
        __extends(sqlReplicationStatsDialog, _super);
        function sqlReplicationStatsDialog(activeDatabase, sqlReplicationName) {
            var _this = _super.call(this) || this;
            _this.activeDatabase = activeDatabase;
            _this.sqlReplicationName = sqlReplicationName;
            _this.repData = ko.observable();
            return _this;
        }
        sqlReplicationStatsDialog.prototype.activate = function (args) {
            this.fetchSqlReplicationStats();
        };
        sqlReplicationStatsDialog.prototype.cancel = function () {
            dialog.close(this);
        };
        sqlReplicationStatsDialog.prototype.fetchSqlReplicationStats = function () {
            var _this = this;
            return new getSqlReplicationStatsCommand(this.activeDatabase, this.sqlReplicationName)
                .execute()
                .done(function (result) {
                _this.repData(result);
            }).fail(function () { return _this.repData(null); });
        };
        return sqlReplicationStatsDialog;
    }(dialogViewModelBase));
    return sqlReplicationStatsDialog;
});

//# sourceMappingURL=sqlReplicationStatsDialog.js.map
