var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/database/debug/getSlowDocCountsCommand", "viewmodels/viewModelBase", "commands/operations/killOperationCommand", "common/generalUtils", "common/eventsCollector"], function (require, exports, getSlowDocCountsCommand, viewModelBase, killOperationComamnd, genUtils, eventsCollector) {
    "use strict";
    var statusStorageCollections = (function (_super) {
        __extends(statusStorageCollections, _super);
        function statusStorageCollections() {
            var _this = _super.apply(this, arguments) || this;
            _this.data = ko.observable();
            _this.canSearch = ko.observable(true);
            _this.progress = ko.observable();
            _this.operationId = ko.observable();
            _this.formatTimeSpan = genUtils.formatTimeSpan;
            _this.formatBytesToSize = genUtils.formatBytesToSize;
            return _this;
        }
        statusStorageCollections.prototype.cancelOperation = function () {
            eventsCollector.default.reportEvent("storage", "kill-fetch-counts");
            if (this.operationId()) {
                new killOperationComamnd(this.activeDatabase(), this.operationId())
                    .execute();
            }
        };
        statusStorageCollections.prototype.activate = function (args) {
            var _this = this;
            _super.prototype.activate.call(this, args);
            this.activeDatabase.subscribe(function () { return _this.resetView(); });
            return this.resetView();
        };
        statusStorageCollections.prototype.resetView = function () {
            this.data(null);
            this.canSearch(true);
        };
        statusStorageCollections.prototype.fetchDocCounts = function () {
            var _this = this;
            eventsCollector.default.reportEvent("storage", "fetch-counts");
            var db = this.activeDatabase();
            if (db) {
                this.canSearch(false);
                var command = new getSlowDocCountsCommand(db, function (msg) { return _this.progress(msg); });
                command
                    .execute()
                    .done(function (scheduleTaskResult) {
                    _this.operationId(scheduleTaskResult.OperationId);
                    command.getCalculationCompletedTask()
                        .done(function (result) {
                        _this.data(result);
                    })
                        .always(function () {
                        _this.operationId(null);
                        _this.progress(null);
                        _this.canSearch(true);
                    });
                })
                    .fail(function () { return _this.canSearch(true); });
            }
            return null;
        };
        return statusStorageCollections;
    }(viewModelBase));
    return statusStorageCollections;
});

//# sourceMappingURL=statusStorageCollections.js.map
