var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/database/debug/getUserInfoCommand", "viewmodels/viewModelBase", "common/eventsCollector"], function (require, exports, getUserInfoCommand, viewModelBase, eventsCollector) {
    "use strict";
    var userInfo = (function (_super) {
        __extends(userInfo, _super);
        function userInfo() {
            var _this = _super.apply(this, arguments) || this;
            _this.data = ko.observable();
            return _this;
        }
        userInfo.prototype.activate = function (args) {
            var _this = this;
            _super.prototype.activate.call(this, args);
            this.activeDatabase.subscribe(function () { return _this.fetchUserInfo(); });
            this.updateHelpLink('JSVY4P');
            return this.fetchUserInfo();
        };
        userInfo.prototype.fetchUserInfo = function () {
            var _this = this;
            eventsCollector.default.reportEvent("user-info", "fetch");
            var db = this.activeDatabase();
            if (db) {
                return new getUserInfoCommand(db)
                    .execute()
                    .done(function (results) { return _this.data(results); });
            }
            return null;
        };
        return userInfo;
    }(viewModelBase));
    return userInfo;
});

//# sourceMappingURL=userInfo.js.map
