var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "viewmodels/viewModelBase", "commands/database/studio/saveCsvFileCommand", "common/eventsCollector"], function (require, exports, viewmodelBase, saveCsvFileCommand, eventsCollector) {
    "use strict";
    var csvImport = (function (_super) {
        __extends(csvImport, _super);
        function csvImport() {
            var _this = _super.apply(this, arguments) || this;
            _this.hasFileSelected = ko.observable(false);
            _this.isImporting = ko.observable(false);
            return _this;
        }
        csvImport.prototype.fileSelected = function (args) {
            this.hasFileSelected(true);
        };
        csvImport.prototype.activate = function (args) {
            _super.prototype.activate.call(this, args);
            this.updateHelpLink('CX96R3');
        };
        csvImport.prototype.importCsv = function () {
            var _this = this;
            eventsCollector.default.reportEvent("csv", "import");
            if (!this.isImporting()) {
                this.isImporting(true);
                var formData = new FormData();
                var fileInput = document.querySelector("#csvFilePicker");
                formData.append("file", fileInput.files[0]);
                new saveCsvFileCommand(formData, fileInput.files[0].name, this.activeDatabase())
                    .execute()
                    .always(function () { return _this.isImporting(false); });
            }
        };
        return csvImport;
    }(viewmodelBase));
    return csvImport;
});

//# sourceMappingURL=csvImport.js.map
