var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "viewmodels/viewModelBase", "commands/database/subscriptions/getSubscriptionCommand", "commands/database/subscriptions/setSubscriptionAckEtagCommand", "common/eventsCollector"], function (require, exports, viewModelBase, getSubscriptionCommand, setSubscriptionCommand, eventsCollector) {
    "use strict";
    var SubscriptionsTask = (function (_super) {
        __extends(SubscriptionsTask, _super);
        function SubscriptionsTask() {
            var _this = _super.apply(this, arguments) || this;
            _this.data = ko.observableArray();
            return _this;
        }
        SubscriptionsTask.prototype.activate = function (args) {
            var _this = this;
            _super.prototype.activate.call(this, args);
            this.updateHelpLink("23PHKW");
            this.activeDatabase.subscribe(function () { return _this.fetchSubscriptions(); });
            return this.fetchSubscriptions();
        };
        SubscriptionsTask.prototype.fetchSubscriptions = function () {
            var _this = this;
            var db = this.activeDatabase();
            if (db) {
                return new getSubscriptionCommand(db)
                    .execute()
                    .done(function (results) { return _this.data(results); });
            }
            return null;
        };
        SubscriptionsTask.prototype.setSubscriptionEtag = function (subscription) {
            eventsCollector.default.reportEvent("subscription", "set-etag");
            var db = this.activeDatabase();
            if (db) {
                subscription.isChangeInProgress(true);
                var newAckEtag = subscription.newAckEtag();
                return new setSubscriptionCommand(db, subscription.subscriptionId, newAckEtag)
                    .execute()
                    .done(function () { return subscription.ackEtag(newAckEtag); })
                    .always(function () { return subscription.isChangeInProgress(false); });
            }
            return null;
        };
        return SubscriptionsTask;
    }(viewModelBase));
    return SubscriptionsTask;
});

//# sourceMappingURL=subscriptionsTask.js.map
