var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "plugins/router", "common/appUrl", "viewmodels/viewModelBase"], function (require, exports, durandalRouter, appUrl, viewModelBase) {
    "use strict";
    var tasks = (function (_super) {
        __extends(tasks, _super);
        function tasks() {
            var _this = _super.call(this) || this;
            _this.router = null;
            _this.isOnUserDatabase = ko.computed(function () { return !!_this.activeDatabase(); });
            _this.appUrls = appUrl.forCurrentDatabase();
            _this.router = durandalRouter.createChildRouter();
            return _this;
        }
        tasks.prototype.activate = function (args) {
            var _this = this;
            _super.prototype.activate.call(this, args);
            var importDatabaseUrl = ko.computed(function () { return appUrl.forImportDatabase(_this.activeDatabase()); });
            var exportDatabaseUrl = ko.computed(function () { return appUrl.forExportDatabase(_this.activeDatabase()); });
            var setAcknowledgedEtagUrl = ko.computed(function () { return appUrl.forSetAcknowledgedEtag(_this.activeDatabase()); });
            var sampleDataUrl = ko.computed(function () { return appUrl.forSampleData(_this.activeDatabase()); });
            var csvImportUrl = ko.computed(function () { return appUrl.forCsvImport(_this.activeDatabase()); });
            var routeArray = [
                { route: ['databases/tasks', 'databases/tasks/importDatabase'], moduleId: 'viewmodels/database/tasks/importDatabase', title: 'Import Database', nav: true, dynamicHash: importDatabaseUrl },
                { route: 'databases/tasks/exportDatabase', moduleId: 'viewmodels/database/tasks/exportDatabase', title: 'Export Database', nav: true, dynamicHash: exportDatabaseUrl },
                { route: 'databases/tasks/subscriptionsTask', moduleId: 'viewmodels/database/tasks/subscriptionsTask', title: 'Subscriptions', nav: this.activeDatabase() && this.activeDatabase().isAdminCurrentTenant(), dynamicHash: setAcknowledgedEtagUrl },
                { route: 'databases/tasks/sampleData', moduleId: 'viewmodels/database/tasks/createSampleData', title: 'Create Sample Data', nav: true, dynamicHash: sampleDataUrl },
                { route: 'databases/tasks/csvImport', moduleId: 'viewmodels/database/tasks/csvImport', title: 'CSV Import', nav: true, dynamicHash: csvImportUrl }
            ];
            this.router
                .reset()
                .map(routeArray)
                .buildNavigationModel();
            appUrl.mapUnknownRoutes(this.router);
            this.activeSubViewTitle = ko.computed(function () {
                // Is there a better way to get the active route?
                var activeRoute = _this.router.navigationModel().find(function (r) { return r.isActive(); });
                return activeRoute != null ? activeRoute.title : "";
            });
        };
        return tasks;
    }(viewModelBase));
    return tasks;
});

//# sourceMappingURL=tasks.js.map
