var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "plugins/dialog", "viewmodels/dialogViewModelBase", "commands/database/transformers/getSingleTransformerCommand", "common/bindingHelpers/aceEditorBindingHandler"], function (require, exports, dialog, dialogViewModelBase, getSingleTransformerCommand, aceEditorBindingHandler) {
    "use strict";
    var copyTransformerDialog = (function (_super) {
        __extends(copyTransformerDialog, _super);
        function copyTransformerDialog(transformerName, db, isPaste, elementToFocusOnDismissal) {
            if (isPaste === void 0) { isPaste = false; }
            var _this = _super.call(this, elementToFocusOnDismissal) || this;
            _this.transformerName = transformerName;
            _this.db = db;
            _this.isPaste = isPaste;
            _this.transformerJSON = ko.observable("");
            aceEditorBindingHandler.install();
            return _this;
        }
        copyTransformerDialog.prototype.canActivate = function (args) {
            if (this.isPaste) {
                return true;
            }
            else {
                var canActivateResult = $.Deferred();
                new getSingleTransformerCommand(this.transformerName, this.db)
                    .execute(); /* TODO
                .done((results: savedTransformerDto) => {
                    var prettifySpacing = 4;
                    var jsonString = JSON.stringify(results, null, prettifySpacing);
                    this.transformerJSON(jsonString);
                    canActivateResult.resolve({ can: true });
                })
                .fail(() => canActivateResult.reject());*/
                canActivateResult.resolve({ can: true });
                return canActivateResult;
            }
        };
        copyTransformerDialog.prototype.setInitialFocus = function () {
            // Overrides the base class' setInitialFocus and does nothing.
            // Doing nothing because we will focus the Ace Editor when it's initialized.
        };
        copyTransformerDialog.prototype.enterKeyPressed = function () {
            // Overrides the base class' enterKeyPressed. Because the user might
            // edit the JSON, or even type some in manually, enter might really mean new line, not Save changes.
            if (!this.isPaste) {
                return _super.prototype.enterKeyPressed.call(this);
            }
            else {
                this.saveTransformer();
            }
            return true;
        };
        copyTransformerDialog.prototype.saveTransformer = function () {
        };
        copyTransformerDialog.prototype.close = function () {
            dialog.close(this);
        };
        return copyTransformerDialog;
    }(dialogViewModelBase));
    return copyTransformerDialog;
});

//# sourceMappingURL=copyTransformerDialog.js.map
