var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/database/transformers/deleteTransformerCommand", "plugins/dialog", "viewmodels/dialogViewModelBase"], function (require, exports, DeleteTransformerCommand, dialog, dialogViewModelBase) {
    "use strict";
    var deleteTransformerConfirm = (function (_super) {
        __extends(deleteTransformerConfirm, _super);
        function deleteTransformerConfirm(transformersNames, db) {
            var _this = _super.call(this) || this;
            _this.transformersNames = transformersNames;
            _this.db = db;
            _this.deleteTask = $.Deferred();
            if (!transformersNames || transformersNames.length === 0) {
                throw new Error("Transformers must not be null or empty.");
            }
            return _this;
            //this.message = transformersNames.length === 1 ? "You're deleting  "Really Delete '" + transformersNames[0] + "' transformer?" : 'Really delete all transformers?';
        }
        deleteTransformerConfirm.prototype.deleteTransformers = function () {
            var _this = this;
            var deleteTasks = this.transformersNames
                .map(function (name) { return new DeleteTransformerCommand(name, _this.db).execute(); });
            $.when.apply($, deleteTasks).done(function () { return _this.deleteTask.resolve(); });
            dialog.close(this);
        };
        deleteTransformerConfirm.prototype.cancel = function () {
            this.deleteTask.reject();
            dialog.close(this);
        };
        return deleteTransformerConfirm;
    }(dialogViewModelBase));
    return deleteTransformerConfirm;
});

//# sourceMappingURL=deleteTransformerConfirm.js.map
