var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "commands/database/transformers/saveTransformerCommand", "plugins/dialog", "viewmodels/dialogViewModelBase", "common/messagePublisher"], function (require, exports, saveTransformerCommand, dialog, dialogViewModelBase, messagePublisher) {
    "use strict";
    var saveTransformerWithNewNameConfirm = (function (_super) {
        __extends(saveTransformerWithNewNameConfirm, _super);
        function saveTransformerWithNewNameConfirm(savedTransformer, db) {
            var _this = _super.call(this) || this;
            _this.savedTransformer = savedTransformer;
            _this.db = db;
            _this.saveTask = $.Deferred();
            if (!savedTransformer) {
                throw new Error("Transformer must not be null");
            }
            _this.message = "If you wish to save a new transformer with this new name press OK, to cancel the save command press Cancel";
            return _this;
        }
        saveTransformerWithNewNameConfirm.prototype.saveTransformer = function () {
            var _this = this;
            new saveTransformerCommand(this.savedTransformer, this.db).execute().done(function () { return _this.saveTask.resolve(); });
            dialog.close(this);
        };
        saveTransformerWithNewNameConfirm.prototype.cancel = function () {
            this.saveTask.reject();
            messagePublisher.reportInfo("Transformer Not Saved!");
            dialog.close(this);
        };
        return saveTransformerWithNewNameConfirm;
    }(dialogViewModelBase));
    return saveTransformerWithNewNameConfirm;
});

//# sourceMappingURL=saveTransformerWithNewNameConfirm.js.map
