var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "viewmodels/viewModelBase", "models/database/documents/document", "models/resources/environmentColor", "commands/database/documents/saveDocumentCommand", "viewmodels/shell"], function (require, exports, viewModelBase, documentClass, environmentColor, saveDocumentCommand, shell) {
    "use strict";
    var studioConfig = (function (_super) {
        __extends(studioConfig, _super);
        function studioConfig() {
            var _this = _super.call(this) || this;
            _this.configDocument = ko.observable();
            _this.environmentColors = [
                new environmentColor("Default", "#f8f8f8"),
                new environmentColor("Development", "#80FF80"),
                new environmentColor("Staging", "#F5824D"),
                new environmentColor("Production", "#FF8585")
            ];
            _this.selectedColor = ko.observable();
            /* TODOvar color = this.environmentColors.filter((color) => color.name === shell.selectedEnvironmentColorStatic().name);
            var selectedColor = !!color[0] ? color[0] : this.environmentColors[0];
            this.selectedColor(selectedColor); */
            var self = _this;
            _this.selectedColor.subscribe(function (newValue) { return self.setEnvironmentColor(newValue); });
            return _this;
        }
        studioConfig.prototype.canActivate = function (args) {
            var deffered = $.Deferred();
            deffered.resolve({ can: true });
            this.configDocument(documentClass.empty());
            return deffered;
        };
        studioConfig.prototype.attached = function () {
            var _this = this;
            _super.prototype.attached.call(this);
            $("select").selectpicker();
            this.pickColor();
            $("#select-color li").each(function (index, element) {
                var color = _this.environmentColors[index];
                $(element).css("backgroundColor", color.backgroundColor);
            });
        };
        studioConfig.prototype.setEnvironmentColor = function (envColor) {
            var _this = this;
            var newDocument = this.configDocument();
            newDocument["EnvironmentColor"] = envColor.toDto();
            var saveTask = this.saveStudioConfig(newDocument);
            saveTask.done(function () {
                _this.pickColor();
                //TODO: shell.selectedEnvironmentColorStatic(envColor);
            });
        };
        studioConfig.prototype.pickColor = function () {
            $("#select-color button").css("backgroundColor", this.selectedColor().backgroundColor);
        };
        studioConfig.prototype.saveStudioConfig = function (newDocument) {
            return new saveDocumentCommand(studioConfig.documentId, newDocument, this.activeDatabase())
                .execute();
            /* TODO
            .done((saveResult: bulkDocumentDto[]) => {
                this.configDocument(newDocument);
                (<any>this.configDocument()).__metadata['@etag'] = saveResult[0].Etag;
            });*/
        };
        return studioConfig;
    }(viewModelBase));
    studioConfig.documentId = shell.studioConfigDocumentId;
    return studioConfig;
});

//# sourceMappingURL=databaseStudioConfig.js.map
