var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "viewmodels/dialogViewModelBase", "plugins/dialog", "common/messagePublisher"], function (require, exports, dialogViewModelBase, dialog, messagePublisher) {
    "use strict";
    var createConfigurationKey = (function (_super) {
        __extends(createConfigurationKey, _super);
        function createConfigurationKey(keys) {
            var _this = _super.call(this) || this;
            _this.creationTask = $.Deferred();
            _this.creationTaskStarted = false;
            _this.configurationKeyName = ko.observable('');
            _this.configurationKeyNameFocus = ko.observable(true);
            _this.keys = keys;
            return _this;
        }
        createConfigurationKey.prototype.cancel = function () {
            dialog.close(this);
        };
        createConfigurationKey.prototype.attached = function () {
            _super.prototype.attached.call(this);
            this.configurationKeyNameFocus(true);
        };
        createConfigurationKey.prototype.deactivate = function () {
            // If we were closed via X button or other dialog dismissal, reject the deletion task since
            // we never started it.
            if (!this.creationTaskStarted) {
                this.creationTask.reject();
            }
        };
        createConfigurationKey.prototype.create = function () {
            // For now we're just creating the filesystem.
            var configKeyName = this.configurationKeyName();
            if (this.isClientSideInputOk(configKeyName)) {
                this.creationTaskStarted = true;
                this.creationTask.resolve(configKeyName);
                dialog.close(this);
            }
        };
        createConfigurationKey.prototype.isClientSideInputOk = function (keyName) {
            var errorMessage = "";
            if (keyName == null) {
                errorMessage = "Please fill out the Configuration Key name field";
            }
            else if (this.isConfigurationKeyExists(keyName, this.keys)) {
                errorMessage = "Configuration Key Already Exists!";
            }
            else if ((errorMessage = this.checkInput(keyName)) != null) { }
            if (errorMessage != null) {
                messagePublisher.reportError(errorMessage);
                this.configurationKeyNameFocus(true);
                return false;
            }
            return true;
        };
        createConfigurationKey.prototype.checkInput = function (name) {
            var message = null;
            //not implemented for the moment
            return message;
        };
        createConfigurationKey.prototype.isConfigurationKeyExists = function (keyName, configurationKeys) {
            for (var i = 0; i < configurationKeys.length; i++) {
                if (keyName == configurationKeys[i].key) {
                    return true;
                }
            }
            return false;
        };
        return createConfigurationKey;
    }(dialogViewModelBase));
    return createConfigurationKey;
});

//# sourceMappingURL=createConfigurationKey.js.map
