var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "plugins/dialog", "viewmodels/dialogViewModelBase", "commands/filesystem/deleteFilesMatchingQueryCommand"], function (require, exports, dialog, dialogViewModelBase, deleteFilesMatchingQueryCommand) {
    "use strict";
    var deleteFilesMatchingQueryConfirm = (function (_super) {
        __extends(deleteFilesMatchingQueryConfirm, _super);
        function deleteFilesMatchingQueryConfirm(queryText, totalFilesCount, fs) {
            var _this = _super.call(this) || this;
            _this.queryText = queryText;
            _this.totalFilesCount = totalFilesCount;
            _this.fs = fs;
            _this.deletionStarted = false;
            _this.deletionTask = $.Deferred(); // Gives consumers a way to know when the async delete operation completes.
            return _this;
        }
        deleteFilesMatchingQueryConfirm.prototype.cancel = function () {
            dialog.close(this);
        };
        deleteFilesMatchingQueryConfirm.prototype.deleteFiles = function () {
            var _this = this;
            var deleteCommandTask = new deleteFilesMatchingQueryCommand(this.queryText, this.fs).execute();
            deleteCommandTask.done(function () { return _this.deletionTask.resolve(); });
            deleteCommandTask.fail(function (response) { return _this.deletionTask.reject(response); });
            this.deletionStarted = true;
            dialog.close(this);
        };
        deleteFilesMatchingQueryConfirm.prototype.deactivate = function (args) {
            _super.prototype.deactivate.call(this, args);
            // If we were closed via X button or other dialog dismissal, reject the deletion task since
            // we never carried it out.
            if (!this.deletionStarted) {
                this.deletionTask.reject();
            }
        };
        return deleteFilesMatchingQueryConfirm;
    }(dialogViewModelBase));
    return deleteFilesMatchingQueryConfirm;
});

//# sourceMappingURL=deleteFilesMatchingQueryConfirm.js.map
