var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "viewmodels/dialogViewModelBase", "plugins/dialog"], function (require, exports, dialogViewModelBase, dialog) {
    "use strict";
    var createFolderInFilesystem = (function (_super) {
        __extends(createFolderInFilesystem, _super);
        function createFolderInFilesystem(folders) {
            var _this = _super.call(this) || this;
            _this.creationTask = $.Deferred();
            _this.creationTaskStarted = false;
            _this.folderName = ko.observable('');
            _this.foldersLowerCase = folders.map(function (x) { return x.toLowerCase(); });
            _this.folderNameCustomValidityError = ko.computed(function () {
                var errorMessage = '';
                if (_this.folderExists(_this.folderName())) {
                    return 'Folder already exists!';
                }
                return errorMessage;
            });
            return _this;
        }
        createFolderInFilesystem.prototype.cancel = function () {
            dialog.close(this);
        };
        createFolderInFilesystem.prototype.deactivate = function () {
            // If we were closed via X button or other dialog dismissal, reject the deletion task since
            // we never started it.
            if (!this.creationTaskStarted) {
                this.creationTask.reject();
            }
        };
        createFolderInFilesystem.prototype.create = function () {
            var folderName = this.folderName();
            this.creationTaskStarted = true;
            this.creationTask.resolve(folderName.toLowerCase());
            dialog.close(this);
        };
        createFolderInFilesystem.prototype.folderExists = function (folderName) {
            return _.includes(this.foldersLowerCase, folderName.toLowerCase());
        };
        return createFolderInFilesystem;
    }(dialogViewModelBase));
    return createFolderInFilesystem;
});

//# sourceMappingURL=createFolderInFilesystem.js.map
