var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "plugins/dialog", "viewmodels/dialogViewModelBase", "commands/filesystem/renameFileCommand"], function (require, exports, dialog, dialogViewModelBase, renameFileCommand) {
    "use strict";
    var fileRenameDialog = (function (_super) {
        __extends(fileRenameDialog, _super);
        function fileRenameDialog(oldFilename, fs) {
            var _this = _super.call(this) || this;
            _this.oldFilename = oldFilename;
            _this.fs = fs;
            _this.newName = ko.observable();
            _this.nextTask = $.Deferred();
            _this.nextTaskStarted = false;
            _this.newName(oldFilename);
            return _this;
        }
        fileRenameDialog.prototype.cancel = function () {
            this.nextTask.reject();
            dialog.close(this);
        };
        fileRenameDialog.prototype.rename = function () {
            var _this = this;
            this.nextTaskStarted = true;
            new renameFileCommand(this.fs, this.oldFilename, this.newName()).execute()
                .done(function () { return _this.nextTask.resolve(_this.newName()); })
                .fail(function () { return _this.nextTask.reject(); });
            dialog.close(this);
        };
        fileRenameDialog.prototype.deactivate = function () {
            // If we were closed via X button or other dialog dismissal, reject the deletion task since
            // we never started it.
            if (!this.nextTaskStarted) {
                this.nextTask.reject();
            }
        };
        fileRenameDialog.prototype.onExit = function () {
            return this.nextTask.promise();
        };
        return fileRenameDialog;
    }(dialogViewModelBase));
    return fileRenameDialog;
});

//# sourceMappingURL=fileRenameDialog.js.map
