var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "viewmodels/filesystem/files/searchDialogViewModel"], function (require, exports, searchDialogViewModel) {
    "use strict";
    var searchFileSizeRangeClause = (function (_super) {
        __extends(searchFileSizeRangeClause, _super);
        function searchFileSizeRangeClause() {
            var _this = _super.call(this, [ko.observable(""), ko.observable("")]) || this;
            _this.applyFilterTask = $.Deferred();
            _this.units = [
                { name: 'b', multiplier: 1 },
                { name: 'Kb', multiplier: 1024 },
                { name: 'Mb', multiplier: 1024 * 1024 },
                { name: 'Gb', multiplier: 1024 * 1024 * 1024 }
            ];
            _this.sizeFromUnit = ko.observable(_this.units[0]);
            _this.sizeToUnit = ko.observable(_this.units[0]);
            return _this;
        }
        searchFileSizeRangeClause.prototype.applyFilter = function () {
            var filter = "__size_numeric:[" + this.convertInputStringToRangeValue(this.inputs[0](), this.sizeFromUnit()) +
                " TO " + this.convertInputStringToRangeValue(this.inputs[1](), this.sizeToUnit()) + "]";
            this.applyFilterTask.resolve(filter);
            this.close();
        };
        searchFileSizeRangeClause.prototype.convertInputStringToRangeValue = function (input, unit) {
            if (!input)
                return "*";
            var value = parseInt(input) * unit.multiplier;
            return "Lx" + value.toString();
        };
        searchFileSizeRangeClause.prototype.enabled = function () {
            return this.checkRequired(false);
        };
        return searchFileSizeRangeClause;
    }(searchDialogViewModel));
    return searchFileSizeRangeClause;
});

//# sourceMappingURL=searchFileSizeRangeClause.js.map
