var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "viewmodels/filesystem/files/searchDialogViewModel", "commands/filesystem/searchByTermCommand", "common/bindingHelpers/autoCompleteBindingHandler"], function (require, exports, searchDialogViewModel, searchByTermCommand, autoCompleteBindingHandler) {
    "use strict";
    var searchHasMetadataClause = (function (_super) {
        __extends(searchHasMetadataClause, _super);
        function searchHasMetadataClause(fs) {
            var _this = _super.call(this, [ko.observable(""), ko.observable("")]) || this;
            _this.fs = fs;
            _this.applyFilterTask = $.Deferred();
            _this.keySearchResults = ko.observableArray();
            _this.inputs[0].throttle(250).subscribe(function (search) { return _this.fetchKeySearchResults(search); });
            autoCompleteBindingHandler.install();
            return _this;
        }
        searchHasMetadataClause.prototype.applyFilter = function () {
            this.applyFilterTask.resolve(this.inputs[0]() + ":" + this.inputs[1]());
            this.close();
        };
        searchHasMetadataClause.prototype.fetchKeySearchResults = function (query) {
            var _this = this;
            if (query.length >= 1) {
                new searchByTermCommand(this.fs, query).execute()
                    .done(function (x) {
                    x = x.filter(function (item, pos, arr) {
                        return item[0] != ("_") && !_.includes(searchHasMetadataClause.ExcludedMetadataFields, item);
                    });
                    _this.keySearchResults(x);
                });
            }
        };
        searchHasMetadataClause.prototype.setKey = function (key) {
            this.inputs[0](key);
        };
        return searchHasMetadataClause;
    }(searchDialogViewModel));
    searchHasMetadataClause.ExcludedMetadataFields = ["Content-Length", "Last-Modified", "Content-MD5", "RavenFS-Size", "Origin"];
    return searchHasMetadataClause;
});

//# sourceMappingURL=searchHasMetadataClause.js.map
