var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "viewmodels/filesystem/files/searchDialogViewModel", "commands/filesystem/getFoldersStartsWithCommand"], function (require, exports, searchDialogViewModel, getFoldersStartsWithCommand) {
    "use strict";
    var searchInFolderClause = (function (_super) {
        __extends(searchInFolderClause, _super);
        function searchInFolderClause(fs) {
            var _this = _super.call(this, [ko.observable("/")]) || this;
            _this.fs = fs;
            _this.applyFilterTask = $.Deferred();
            _this.searchResults = ko.observable([]);
            _this.inputs[0].subscribe(function () {
                _this.fillAutoComplete();
            });
            _this.fillAutoComplete();
            return _this;
        }
        searchInFolderClause.prototype.fillAutoComplete = function () {
            var _this = this;
            new getFoldersStartsWithCommand(this.fs, 0, 6, this.inputs[0]())
                .execute()
                .done(function (results) {
                _this.searchResults(results);
                //this.setInitialFocus();
            });
        };
        searchInFolderClause.prototype.applyFilter = function () {
            var searchCriteria = this.inputs[0]();
            if (searchCriteria.endsWith('/')) {
                searchCriteria = searchCriteria.substr(0, searchCriteria.length - 1);
            }
            this.applyFilterTask.resolve(searchCriteria);
            this.close();
        };
        searchInFolderClause.prototype.setInput = function (value) {
            value = value === "/" ? "/" : value + "/";
            this.inputs[0](value);
        };
        searchInFolderClause.prototype.enabled = function () {
            return this.checkRequired(true);
        };
        return searchInFolderClause;
    }(searchDialogViewModel));
    return searchInFolderClause;
});

//# sourceMappingURL=searchInFolderClause.js.map
