var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "plugins/router", "viewmodels/viewModelBase", "common/appUrl"], function (require, exports, durandalRouter, viewModelBase, appUrl) {
    "use strict";
    var synchronization = (function (_super) {
        __extends(synchronization, _super);
        function synchronization() {
            var _this = _super.call(this) || this;
            _this.appUrls = appUrl.forCurrentFilesystem();
            _this.router = durandalRouter.createChildRouter()
                .map([
                { route: "filesystems/synchronization", moduleId: "viewmodels/filesystem/synchronization/synchronizationConflicts", title: "Conflicts", nav: true, hash: appUrl.forCurrentFilesystem().filesystemSynchronization },
                { route: "filesystems/synchronization/destinations", moduleId: "viewmodels/filesystem/synchronization/synchronizationDestinations", title: "Destinations", nav: true, hash: appUrl.forCurrentFilesystem().filesystemSynchronizationDestinations },
                { route: "filesystems/synchronization/configuration", moduleId: "viewmodels/filesystem/synchronization/synchronizationConfiguration", title: "Configuration", nav: true, hash: appUrl.forCurrentFilesystem().filesystemSynchronizationConfiguration }
            ])
                .buildNavigationModel();
            synchronization.statusRouter = _this.router;
            appUrl.mapUnknownRoutes(_this.router);
            _this.activeSubViewTitle = ko.computed(function () {
                // Is there a better way to get the active route?
                var activeRoute = _this.router.navigationModel().find(function (r) { return r.isActive(); });
                return activeRoute != null ? activeRoute.title : "";
            });
            return _this;
        }
        synchronization.prototype.canActivate = function (args) {
            return true;
        };
        return synchronization;
    }(viewModelBase));
    return synchronization;
});

//# sourceMappingURL=synchronization.js.map
