var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "common/appUrl", "viewmodels/viewModelBase", "commands/filesystem/getSynchronizationConfigCommand", "commands/filesystem/saveConfigurationCommand", "models/filesystem/configurationKey", "common/eventsCollector"], function (require, exports, appUrl, viewModelBase, getSynchronizationConfigCommand, saveConfigurationCommand, configurationKey, eventsCollector) {
    "use strict";
    var synchronizationConfiguration = (function (_super) {
        __extends(synchronizationConfiguration, _super);
        function synchronizationConfiguration() {
            var _this = _super.apply(this, arguments) || this;
            _this.config = ko.observable();
            _this.dirtyFlag = new ko.DirtyFlag([]);
            return _this;
        }
        synchronizationConfiguration.prototype.canActivate = function (args) {
            _super.prototype.canActivate.call(this, args);
            var deferred = $.Deferred();
            var fs = this.activeFilesystem();
            if (fs) {
                this.fetchConfig()
                    .done(function () { return deferred.resolve({ can: true }); })
                    .fail(function () { return deferred.resolve({ redirect: appUrl.forResources() }); });
            }
            return deferred;
        };
        synchronizationConfiguration.prototype.activate = function (args) {
            var _this = this;
            _super.prototype.activate.call(this, args);
            this.updateHelpLink("1K9SAA");
            this.dirtyFlag = new ko.DirtyFlag([this.config]);
            this.isSaveEnabled = ko.computed(function () {
                return _this.dirtyFlag().isDirty();
            });
        };
        synchronizationConfiguration.prototype.saveChanges = function () {
            var _this = this;
            eventsCollector.default.reportEvent("fs-configuration", "save");
            new saveConfigurationCommand(this.activeFilesystem(), new configurationKey(this.activeFilesystem(), "Raven/Synchronization/Config"), this.config().toDto())
                .execute()
                .done(function () { return _this.dirtyFlag().reset(); });
        };
        synchronizationConfiguration.prototype.fetchConfig = function () {
            var _this = this;
            return new getSynchronizationConfigCommand(this.activeFilesystem())
                .execute()
                .done(function (result) { return _this.config(result); });
        };
        return synchronizationConfiguration;
    }(viewModelBase));
    return synchronizationConfiguration;
});

//# sourceMappingURL=synchronizationConfiguration.js.map
