var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "viewmodels/viewModelBase", "commands/operations/getOperationStatusCommand", "common/eventsCollector"], function (require, exports, viewModelBase, getOperationStatusCommand, eventsCollector) {
    "use strict";
    var importDatabase = (function (_super) {
        __extends(importDatabase, _super);
        function importDatabase() {
            var _this = _super.apply(this, arguments) || this;
            _this.batchSize = ko.observable(1024);
            _this.stripReplicationInformation = ko.observable(false);
            _this.shouldDisableVersioningBundle = ko.observable(false);
            _this.hasFileSelected = ko.observable(false);
            _this.importedFileName = ko.observable();
            _this.isUploading = ko.observable(false);
            _this.filePickerTag = "#importFilesystemFilePicker";
            return _this;
        }
        importDatabase.prototype.attached = function () {
            _super.prototype.attached.call(this);
            this.updateHelpLink("N822WN");
        };
        importDatabase.prototype.canDeactivate = function (isClose) {
            _super.prototype.canDeactivate.call(this, isClose);
            if (this.isUploading()) {
                this.confirmationMessage("Upload is in progress", "Please wait until uploading is complete.", ['OK']);
                return false;
            }
            return true;
        };
        importDatabase.prototype.createPostboxSubscriptions = function () {
            return [];
        };
        importDatabase.prototype.fileSelected = function (fileName) {
            /* TODO:
            var fs: filesystem = this.activeFilesystem();
            var isFileSelected = !!$.trim(fileName);
            var importFileName = $(this.filePickerTag).val().split(/(\\|\/)/g).pop();
            if (isFileSelected) {
                var fileInput = <HTMLInputElement>document.querySelector(this.filePickerTag);
                new fsCheckSufficientDiskSpaceCommand(fileInput.files[0].size, this.activeFilesystem())
                    .execute()
                    .done(() => {
                        this.hasFileSelected(isFileSelected);
                        this.importedFileName(importFileName);
                        fs.importStatus("");
                    })
                    .fail(() => {
                        fs.importStatus("No sufficient diskspace for import, consider using Raven.Smuggler.exe directly.");
                        this.hasFileSelected(false);
                        this.importedFileName("");
                    });
            }*/
        };
        importDatabase.prototype.importFs = function () {
            eventsCollector.default.reportEvent("fs", "import");
            /* TODO
            var fs: filesystem = this.activeFilesystem();
            fs.isImporting(true);
            this.isUploading(true);
            fs.importStatus("Uploading 0%");
    
            var formData = new FormData();
            var fileInput = <HTMLInputElement>document.querySelector(this.filePickerTag);
            formData.append("file", fileInput.files[0]);
                    
            new importFilesystemCommand(formData, this.batchSize(), this.stripReplicationInformation(), this.shouldDisableVersioningBundle(), this.activeFilesystem())
                .execute()
                .done((result: operationIdDto) => {
                    var operationId = result.OperationId;
                    this.waitForOperationToComplete(fs, operationId);
                    fs.importStatus("Processing uploaded file");
                })
                .fail(() => {
                    fs.importStatus("");
                    fs.isImporting(false);
                })
                .always(() => this.isUploading(false));*/
        };
        importDatabase.prototype.waitForOperationToComplete = function (fs, operationId) {
            new getOperationStatusCommand(fs, operationId)
                .execute();
            //TODO: .done((result: dataDumperOperationStatusDto) => this.importStatusRetrieved(fs, operationId, result));
        };
        importDatabase.prototype.importStatusRetrieved = function (fs, operationId, result) {
            /* TODO
            if (result.Completed) {
                if (result.ExceptionDetails == null) {
                    this.hasFileSelected(false);
                    $(this.filePickerTag).val("");
                    fs.importStatus("Last import was from '" + this.importedFileName());
                    messagePublisher.reportSuccess("Successfully imported data to " + fs.name);
                } else if (result.Canceled) {
                    fs.importStatus("Import was canceled!");
                } else {
                    fs.importStatus("Failed to import file system, see recent errors for details!");
                    messagePublisher.reportError("Failed to import file system!", result.ExceptionDetails);
                }
    
                fs.isImporting(false);
            }
            else {
                if (result.State && result.State.Progress) {
                    fs.importStatus("Processing uploaded file, " + result.State.Progress.toLocaleLowerCase());
                }
                setTimeout(() => this.waitForOperationToComplete(fs, operationId), 1000);
            }*/
        };
        return importDatabase;
    }(viewModelBase));
    return importDatabase;
});

//# sourceMappingURL=importFilesystem.js.map
