var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "plugins/router", "common/appUrl", "viewmodels/viewModelBase"], function (require, exports, durandalRouter, appUrl, viewModelBase) {
    "use strict";
    var tasks = (function (_super) {
        __extends(tasks, _super);
        function tasks() {
            var _this = _super.call(this) || this;
            _this.router = null;
            _this.appUrls = appUrl.forCurrentFilesystem();
            var importFilesystemUrl = ko.computed(function () { return appUrl.forImportFilesystem(_this.activeFilesystem()); });
            var exportFilesystemUrl = ko.computed(function () { return appUrl.forExportFilesystem(_this.activeFilesystem()); });
            var routeArray = [
                { route: ["filesystems/tasks", "filesystems/tasks/importFilesystem"], moduleId: "viewmodels/filesystem/tasks/importFilesystem", title: "Import File System", nav: true, dynamicHash: importFilesystemUrl },
                { route: "filesystems/tasks/exportFilesystem", moduleId: "viewmodels/filesystem/tasks/exportFilesystem", title: "Export File System", nav: true, dynamicHash: exportFilesystemUrl }
            ];
            _this.router = durandalRouter.createChildRouter()
                .map(routeArray)
                .buildNavigationModel();
            appUrl.mapUnknownRoutes(_this.router);
            _this.activeSubViewTitle = ko.computed(function () {
                // Is there a better way to get the active route?
                var activeRoute = _this.router.navigationModel().find(function (r) { return r.isActive(); });
                return activeRoute != null ? activeRoute.title : "";
            });
            return _this;
        }
        return tasks;
    }(viewModelBase));
    return tasks;
});

//# sourceMappingURL=tasks.js.map
