var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "durandal/app", "plugins/dialog", "viewmodels/dialogViewModelBase", "commands/auth/getSingleAuthTokenCommand", "models/database/debug/adminLogsConfigEntry"], function (require, exports, app, dialog, dialogViewModelBase, getSingleAuthTokenCommand, adminLogsConfigEntry) {
    "use strict";
    var adminLogsConfigureDialog = (function (_super) {
        __extends(adminLogsConfigureDialog, _super);
        function adminLogsConfigureDialog(logConfig) {
            var _this = _super.call(this) || this;
            _this.logConfig = logConfig;
            _this.configurationTask = $.Deferred();
            return _this;
        }
        adminLogsConfigureDialog.prototype.attached = function () {
            _super.prototype.attached.call(this);
            this.form = $("#log-config-form");
        };
        adminLogsConfigureDialog.prototype.cancel = function () {
            dialog.close(this);
        };
        adminLogsConfigureDialog.prototype.deactivate = function () {
            this.configurationTask.reject();
        };
        adminLogsConfigureDialog.prototype.startServerLogging = function () {
            var _this = this;
            var getTokenTask = new getSingleAuthTokenCommand(null, true).execute();
            getTokenTask
                .done(function (tokenObject) {
                _this.logConfig.singleAuthToken(tokenObject);
                _this.configurationTask.resolve(_this.logConfig);
                dialog.close(_this);
            })
                .fail(function (e) {
                var response = JSON.parse(e.responseText);
                var msg = e.statusText;
                if ("Error" in response) {
                    msg += ": " + response.Error;
                }
                else if ("Reason" in response) {
                    msg += ": " + response.Reason;
                }
                app.showBootstrapMessage(msg, "Error");
            });
        };
        adminLogsConfigureDialog.prototype.addCategory = function () {
            this.logConfig.entries.push(new adminLogsConfigEntry("Raven.", "Debug"));
        };
        adminLogsConfigureDialog.prototype.deleteRow = function (row) {
            this.logConfig.entries.remove(row);
        };
        adminLogsConfigureDialog.prototype.generateBindingInputId = function (index) {
            return 'binding-' + index;
        };
        return adminLogsConfigureDialog;
    }(dialogViewModelBase));
    return adminLogsConfigureDialog;
});

//# sourceMappingURL=adminLogsConfigureDialog.js.map
