var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "viewmodels/viewModelBase", "common/appUrl", "viewmodels/manage/adminSettings"], function (require, exports, viewModelBase, appUrl, adminSettings) {
    "use strict";
    var globalConfig = (function (_super) {
        __extends(globalConfig, _super);
        /* TODO
        static developerLicense = ko.computed(() => !license.licenseStatus().IsCommercial);
        static canUseGlobalConfigurations = ko.computed(() => !license.licenseStatus().IsCommercial || license.licenseStatus().Attributes.globalConfigurations === "true");
        */
        function globalConfig() {
            var _this = _super.call(this) || this;
            _this.router = adminSettings.adminSettingsRouter.createChildRouter()
                .map([
                { route: "globalConfig", moduleId: "viewmodels/manage/globalConfig/globalConfigPeriodicExport", title: "Periodic export", tooltip: "", nav: true, hash: appUrl.forGlobalConfigPeriodicExport() },
                { route: "globalConfigDatabaseSettings", moduleId: "viewmodels/manage/globalConfig/globalConfigDatabaseSettings", title: "Cluster-wide database settings", tooltip: "Global cluster-wide database settings", nav: true, hash: appUrl.forGlobalConfigDatabaseSettings() },
                { route: "globalConfigReplication", moduleId: "viewmodels/manage/globalConfig/globalConfigReplications", title: "Replication", tooltip: "Global replication settings", nav: true, hash: appUrl.forGlobalConfigReplication() },
                { route: "globalConfigSqlReplication", moduleId: "viewmodels/manage/globalConfig/globalConfigSqlReplication", title: "SQL Replication", tooltip: "Global SQL replication settings", nav: true, hash: appUrl.forGlobalConfigSqlReplication() },
                { route: "globalConfigQuotas", moduleId: "viewmodels/manage/globalConfig/globalConfigQuotas", title: "Quotas", tooltip: "Global quotas settings", nav: true, hash: appUrl.forGlobalConfigQuotas() },
                { route: "globalConfigCustomFunctions", moduleId: "viewmodels/manage/globalConfig/globalConfigCustomFunctions", title: "Custom functions", tooltip: "Global custom functions settings", nav: true, hash: appUrl.forGlobalConfigCustomFunctions() },
                { route: "globalConfigVersioning", moduleId: "viewmodels/manage/globalConfig/globalConfigVersioning", title: "Versioning", tooltip: "Global versioning settings", nav: true, hash: appUrl.forGlobalConfigVersioning() }
            ])
                .buildNavigationModel();
            appUrl.mapUnknownRoutes(_this.router);
            _this.currentRouteTitle = ko.computed(function () {
                // Is there a better way to get the active route?
                var activeRoute = _this.router.navigationModel().find(function (r) { return r.isActive(); });
                return activeRoute != null ? activeRoute.title : "";
            });
            return _this;
        }
        return globalConfig;
    }(viewModelBase));
    return globalConfig;
});

//# sourceMappingURL=globalConfig.js.map
