var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "viewmodels/viewModelBase", "commands/licensing/GetHotSpareInformation", "commands/licensing/testHotSpareCommand", "commands/licensing/activateHotSpareCommand", "common/eventsCollector"], function (require, exports, viewModelBase, getHotSpareInformation, testHotSpareCommand, activateHotSpareCommand, eventsCollector) {
    "use strict";
    var hotSpare = (function (_super) {
        __extends(hotSpare, _super);
        function hotSpare() {
            var _this = _super.apply(this, arguments) || this;
            _this.runningOnExpiredLicense = ko.observable(false);
            _this.activationMode = ko.observable();
            _this.activationTime = ko.observable();
            _this.remainingTestActivation = ko.observable();
            _this.isActivationExpired = ko.observable(false);
            return _this;
        }
        hotSpare.prototype.activate = function (args) {
            _super.prototype.activate.call(this, args);
            this.updateHelpLink("SV6IMV");
            this.fetchHotSpareInformation();
        };
        hotSpare.prototype.fetchHotSpareInformation = function () {
            var _this = this;
            new getHotSpareInformation().execute().done(function (res) {
                _this.activationMode(res.ActivationMode);
                _this.activationTime(res.ActivationTime);
                _this.remainingTestActivation(res.RemainingTestActivations);
            }).fail(function () {
                alert("Can't fetch license information");
            });
        };
        hotSpare.prototype.isTestEnabled = function () {
            return this.activationMode() === 'NotActivated';
        };
        hotSpare.prototype.testLicense = function () {
            eventsCollector.default.reportEvent("hot-spare", "test");
            new testHotSpareCommand().execute();
        };
        hotSpare.prototype.activateLicense = function () {
            var _this = this;
            eventsCollector.default.reportEvent("hot-spare", "activate");
            var self = this;
            this.confirmationMessage("Hot Spare Activation", "This is a one time activation, valid for 96 hours, are you sure you want to activate the hot spare license?")
                .done(function () {
                new activateHotSpareCommand()
                    .execute()
                    .done(function () {
                    _this.fetchHotSpareInformation();
                    // refresh top navbar with 
                    //TODO:shell.fetchStudioConfig();
                })
                    .fail(function (response) {
                    if (response.status === 403) {
                        self.isActivationExpired(true);
                    }
                });
            });
        };
        return hotSpare;
    }(viewModelBase));
    return hotSpare;
});

//# sourceMappingURL=hotSpare.js.map
