var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "viewmodels/viewModelBase"], function (require, exports, viewModelBase) {
    "use strict";
    var stackInfo = (function () {
        function stackInfo(ThreadIds, StackTrace) {
            var _this = this;
            this.ThreadIds = ThreadIds;
            this.StackTrace = StackTrace;
            this.boxHeight = function () {
                return _this.StackTrace.length * stackInfo.lineHeight + 2 * stackInfo.boxPadding;
            };
            this.stackWithShortcuts = function () {
                return _this.StackTrace.map(function (v) {
                    return {
                        short: stackInfo.shortName(v),
                        full: v
                    };
                });
            };
        }
        stackInfo.shortName = function (v) {
            var withoutArgs = v.replace(/\(.*?\)/g, '');
            if (withoutArgs.includes('+')) {
                return withoutArgs.replace(/.*\.(.*\+.*)/, '$1');
            }
            else {
                return withoutArgs.replace(/.*\.([^\.]+\.[^\.]+)$/, '$1');
            }
        };
        stackInfo.isUserCode = function (line) {
            return line.startsWith("Raven") || line.startsWith("Voron");
        };
        return stackInfo;
    }());
    stackInfo.boxPadding = 8;
    stackInfo.lineHeight = 12;
    stackInfo.headerSize = 16;
    var infoPackage = (function (_super) {
        __extends(infoPackage, _super);
        function infoPackage() {
            return _super.apply(this, arguments) || this;
        }
        return infoPackage;
    }(viewModelBase));
    return infoPackage;
});

//# sourceMappingURL=infoPackage.js.map
