var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "plugins/dialog", "viewmodels/dialogViewModelBase", "jszip"], function (require, exports, dialog, dialogViewModelBase, jszip) {
    "use strict";
    var importPackageImport = (function (_super) {
        __extends(importPackageImport, _super);
        function importPackageImport() {
            var _this = _super.apply(this, arguments) || this;
            _this.importTask = $.Deferred();
            _this.hasFileSelected = ko.observable(false);
            _this.isImporting = ko.observable(false);
            return _this;
        }
        importPackageImport.prototype.fileSelected = function (args) {
            this.hasFileSelected(true);
        };
        importPackageImport.prototype.doImport = function () {
            var _this = this;
            var fileInput = document.querySelector("#importFilePicker");
            var self = this;
            var file = fileInput.files[0];
            var reader = new FileReader();
            reader.onload = function () {
                // try to detect type
                var firstChar = new Uint8Array(this.result.slice(0, 1))[0];
                if (firstChar === 91) {
                    var rawJson = String.fromCharCode.apply(null, new Uint8Array(this.result));
                    var json = JSON.parse(rawJson);
                    self.dataImported(json);
                }
                else {
                    var zip = new jszip(this.result);
                    var stacks = zip.file("stacktraces.txt");
                    if (stacks) {
                        var stacksText = stacks.asText();
                        var stacksJson = JSON.parse(stacksText);
                        self.dataImported(stacksJson);
                    }
                    else {
                        self.dataImported(null);
                    }
                }
            };
            reader.onerror = function (error) { return _this.importTask.reject(error); };
            reader.readAsArrayBuffer(file);
        };
        importPackageImport.prototype.dataImported = function (result) {
            this.importTask.resolve(result);
            dialog.close(this);
        };
        importPackageImport.prototype.cancel = function () {
            dialog.close(this);
        };
        importPackageImport.prototype.task = function () {
            return this.importTask.promise();
        };
        return importPackageImport;
    }(dialogViewModelBase));
    return importPackageImport;
});

//# sourceMappingURL=infoPackageImport.js.map
