var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "viewmodels/viewModelBase", "commands/auth/licenseCheckConnectivityCommand", "commands/auth/forceLicenseUpdate", "viewmodels/common/licensingStatus", "durandal/app", "models/auth/license", "commands/auth/getSupportCoverageCommand", "common/settingsAccessAuthorizer", "common/eventsCollector"], function (require, exports, viewModelBase, licenseCheckConnectivityCommand, forceLicenseUpdate, licensingStatus, app, license, getSupportCoverageCommand, settingsAccessAuthorizer, eventsCollector) {
    "use strict";
    var licenseInformation = (function (_super) {
        __extends(licenseInformation, _super);
        function licenseInformation() {
            var _this = _super.apply(this, arguments) || this;
            _this.settingsAccess = new settingsAccessAuthorizer();
            _this.connectivityStatus = ko.observable("pending");
            _this.forceButtonEnabled = ko.pureComputed(function () { return _this.connectivityStatus() === "success"; });
            _this.forceInProgress = ko.observable(false);
            return _this;
        }
        licenseInformation.prototype.attached = function () {
            var _this = this;
            _super.prototype.attached.call(this);
            if (settingsAccessAuthorizer.canReadOrWrite()) {
                this.checkConnectivity()
                    .done(function (result) {
                    _this.connectivityStatus(result ? "success" : "failed");
                })
                    .fail(function () { return _this.connectivityStatus("failed"); });
            }
        };
        licenseInformation.prototype.fetchLicenseStatus = function () {
            /* TODO
            return new getLicenseStatusCommand()
                .execute()
                .done((result: licenseStatusDto) => {
                if (result.Status.includes("AGPL")) {
                    result.Status = "Development Only";
                }
                license.licenseStatus(result);
            });*/
        };
        licenseInformation.prototype.fetchSupportCoverage = function () {
            return new getSupportCoverageCommand()
                .execute()
                .done(function (result) {
                license.supportCoverage(result);
            });
        };
        licenseInformation.prototype.forceUpdate = function () {
            var _this = this;
            eventsCollector.default.reportEvent("license-information", "force-update");
            this.forceInProgress(true);
            new forceLicenseUpdate().execute()
                .always(function () {
                $.when(_this.fetchLicenseStatus(), _this.fetchSupportCoverage())
                    .always(function () {
                    _this.forceInProgress(false);
                    _this.showLicenseDialog();
                });
            });
        };
        licenseInformation.prototype.showLicenseDialog = function () {
            var dialog = new licensingStatus(license.licenseStatus(), license.supportCoverage(), license.hotSpare());
            app.showBootstrapDialog(dialog);
        };
        licenseInformation.prototype.checkConnectivity = function () {
            return new licenseCheckConnectivityCommand().execute();
        };
        return licenseInformation;
    }(viewModelBase));
    return licenseInformation;
});

//# sourceMappingURL=licenseInformation.js.map
