var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "viewmodels/dialogViewModelBase", "forge"], function (require, exports, dialogViewModelBase, forge) {
    "use strict";
    var createResourceBase = (function (_super) {
        __extends(createResourceBase, _super);
        function createResourceBase() {
            var _this = _super.apply(this, arguments) || this;
            _this.advancedConfigurationVisible = ko.observable(false);
            _this.advancedBundleConfigurationVisible = ko.observable();
            return _this;
        }
        createResourceBase.prototype.activate = function () {
            this.initObservables();
            this.resetEncryptionKey();
        };
        createResourceBase.prototype.initObservables = function () {
            var _this = this;
            this.showWideDialog = ko.pureComputed(function () {
                var hasAdvancedOpened = _this.advancedConfigurationVisible();
                var hasAdvancedBundleOpened = !!_this.advancedBundleConfigurationVisible();
                return hasAdvancedBundleOpened || hasAdvancedOpened;
            });
            this.resourceModel.activeBundles.subscribe(function (changes) {
                // hide advanced if respononding bundle was unchecked
                if (!_this.advancedBundleConfigurationVisible()) {
                    return;
                }
                changes.forEach(function (change) {
                    if (change.status === "deleted" && change.value === _this.advancedBundleConfigurationVisible()) {
                        _this.advancedBundleConfigurationVisible(null);
                    }
                });
            }, null, "arrayChange");
            this.resourceModel.setupValidation(function (name) { return !_this.getResourceByName(name); });
        };
        createResourceBase.prototype.showAdvancedConfiguration = function () {
            if (this.advancedConfigurationVisible()) {
                this.advancedConfigurationVisible(false);
                return;
            }
            this.advancedBundleConfigurationVisible(null);
            this.advancedConfigurationVisible(true);
        };
        createResourceBase.prototype.showAdvancedConfigurationFor = function (bundleName) {
            if (this.advancedBundleConfigurationVisible() === bundleName) {
                this.advancedBundleConfigurationVisible(null);
                return;
            }
            if (!_.includes(this.resourceModel.activeBundles(), bundleName)) {
                this.resourceModel.activeBundles.push(bundleName);
            }
            this.advancedConfigurationVisible(false);
            this.advancedBundleConfigurationVisible(bundleName);
        };
        createResourceBase.prototype.isBundleActive = function (name) {
            //TODO: implement me!
            return true;
        };
        createResourceBase.prototype.resetEncryptionKey = function () {
            var rawKey = forge.random.getBytesSync(32);
            var generatedKey = forge.util.encode64(rawKey);
            this.resourceModel.encryption.key(generatedKey);
        };
        return createResourceBase;
    }(dialogViewModelBase));
    return createResourceBase;
});

//# sourceMappingURL=createResourceBase.js.map
