var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "viewmodels/viewModelBase", "viewmodels/shell", "models/auth/license", "viewmodels/shell/registration", "moment"], function (require, exports, viewModelBase, shell, license, registration, moment) {
    "use strict";
    var about = (function (_super) {
        __extends(about, _super);
        function about() {
            var _this = _super.apply(this, arguments) || this;
            _this.clientVersion = shell.clientVersion;
            _this.serverVersion = shell.serverBuildVersion;
            _this.licenseStatus = license.licenseStatus;
            _this.expiration = ko.pureComputed(function () {
                var licenseStatus = _this.licenseStatus();
                if (!licenseStatus) {
                    return null;
                }
                if (licenseStatus.LicenseType === "Commercial" || licenseStatus.LicenseType === "PreRelease" || licenseStatus.LicenseType === "Dev") {
                    var expiration = licenseStatus.Attributes["expiration"];
                    if (expiration) {
                        return moment(expiration).format("LL");
                    }
                }
                return null;
            });
            _this.licenseType = ko.pureComputed(function () {
                var licenseStatus = _this.licenseStatus();
                if (!licenseStatus || licenseStatus.LicenseType === "None") {
                    return "No license";
                }
                if (licenseStatus.LicenseType === "Invalid") {
                    return "Invalid license";
                }
                return licenseStatus.LicenseType + " License";
            });
            _this.registered = ko.pureComputed(function () {
                var licenseStatus = _this.licenseStatus();
                if (!licenseStatus) {
                    return false;
                }
                return licenseStatus.LicenseType === "PreRelease" ||
                    licenseStatus.LicenseType === "Commercial" ||
                    licenseStatus.LicenseType === "Dev";
            });
            return _this;
        }
        about.prototype.register = function () {
            registration.showRegistrationDialog(this.licenseStatus(), true);
        };
        return about;
    }(viewModelBase));
    return about;
});

//# sourceMappingURL=about.js.map
