var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "plugins/dialog", "commands/timeSeries/deleteKeyCommand", "viewmodels/dialogViewModelBase"], function (require, exports, dialog, deleteKeyCommand, dialogViewModelBase) {
    "use strict";
    var deleteKey = (function (_super) {
        __extends(deleteKey, _super);
        function deleteKey(type, key, ts) {
            var _this = _super.call(this) || this;
            _this.type = type;
            _this.key = key;
            _this.ts = ts;
            _this.deletionTask = $.Deferred();
            _this.deletionStarted = false;
            return _this;
        }
        deleteKey.prototype.deleteKey = function () {
            var _this = this;
            new deleteKeyCommand(this.type, this.key, this.ts)
                .execute()
                .done(function (result) { return _this.deletionTask.resolve(result); })
                .fail(function (response) { return _this.deletionTask.reject(response); });
            this.deletionStarted = true;
            dialog.close(this);
        };
        deleteKey.prototype.cancel = function () {
            dialog.close(this);
        };
        deleteKey.prototype.deactivate = function () {
            // If we were closed via X button or other dialog dismissal, reject the deletion task since
            // we never started it.
            if (!this.deletionStarted) {
                this.deletionTask.reject();
            }
        };
        return deleteKey;
    }(dialogViewModelBase));
    return deleteKey;
});

//# sourceMappingURL=deleteKey.js.map
