var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "plugins/dialog", "viewmodels/dialogViewModelBase"], function (require, exports, dialog, dialogViewModelBase) {
    "use strict";
    var editPointDialog = (function (_super) {
        __extends(editPointDialog, _super);
        function editPointDialog(editedPoint, isNew) {
            var _this = _super.call(this) || this;
            _this.updateTask = $.Deferred();
            _this.updateTaskStarted = false;
            _this.editedPoint = ko.observable();
            _this.editedPoint(editedPoint);
            _this.isNew = ko.computed(function () { return isNew && _this.editedPoint().isNew(); });
            return _this;
        }
        editPointDialog.prototype.cancel = function () {
            dialog.close(this);
        };
        editPointDialog.prototype.nextOrCreate = function () {
            this.updateTaskStarted = true;
            this.updateTask.resolve(this.editedPoint());
            dialog.close(this);
        };
        editPointDialog.prototype.deactivate = function () {
            // If we were closed via X button or other dialog dismissal, reject the deletion task since
            // we never started it.
            if (!this.updateTaskStarted) {
                this.updateTask.reject();
            }
        };
        return editPointDialog;
    }(dialogViewModelBase));
    return editPointDialog;
});

//# sourceMappingURL=editPointDialog.js.map
