define(["require", "exports"], function (require, exports) {
    "use strict";
    /**
     * Checked cell template used for toggling selection of a row in the virtual grid.
     */
    var checkedColumn = (function () {
        function checkedColumn() {
            this.cellClass = "checked-cell";
            this.dataMemberName = "__virtual-grid-isChecked";
            this.width = "32px";
            this.display = "<input class=\"checked-column-header\" type=\"checkbox\" />";
        }
        checkedColumn.prototype.renderCell = function (item, isSelected) {
            if (isSelected) {
                return "<input class=\"checked-cell-input\" type=\"checkbox\" checked />";
            }
            return "<input class=\"checked-cell-input\" type=\"checkbox\" />";
        };
        return checkedColumn;
    }());
    checkedColumn.columnWidth = 32;
    return checkedColumn;
});

//# sourceMappingURL=checkedColumn.js.map
