define(["require", "exports"], function (require, exports) {
    "use strict";
    /**
     * Virtual grid column that renders text in its cells.
     */
    var textColumn = (function () {
        function textColumn(dataMemberName, display, width) {
            this.dataMemberName = dataMemberName;
            this.display = display;
            this.width = width;
            this.cellClass = "text-cell";
        }
        textColumn.prototype.renderCell = function (item, isSelected) {
            var cellValue = item[this.dataMemberName];
            if (cellValue != null) {
                return cellValue.toString();
            }
            return "";
        };
        return textColumn;
    }());
    return textColumn;
});

//# sourceMappingURL=textColumn.js.map
