define(["require", "exports"], function (require, exports) {
    "use strict";
    var virtualGridConfigDefaults = (function () {
        function virtualGridConfigDefaults() {
            /**
             * Whether to show the header containing the column names.
             */
            this.showColumns = true;
            /**
             * Whether to show the row selection checkbox column. Defaults to true. If so, this will be the first column in the grid.
             */
            this.showRowSelectionCheckbox = true;
            /**
             * Optional. A list of columns to use. If not specified, the columns will be pulled from the first set of loaded items, with priority set on .Id and .Name columns.
             */
            this.columns = null;
            /**
             * Observable that, when changed, causes the grid to clear the current items and refetch.
             */
            this.resetItems = null;
        }
        return virtualGridConfigDefaults;
    }());
    return virtualGridConfigDefaults;
});

//# sourceMappingURL=virtualGridConfigDefaults.js.map
