/// <reference path="../../../typings/tsd.d.ts"/>
define(["require", "exports"], function (require, exports) {
    "use strict";
    var cell = (function () {
        function cell(data, templateName) {
            this.templateName = templateName;
            this.data = ko.observable();
            this.resetFlag = false;
            this.update(data);
        }
        cell.prototype.update = function (data) {
            if (this.isNumber(data)) {
                data = data.toLocaleString('en-US');
            }
            this.data(data);
        };
        cell.prototype.isNumber = function (o) {
            return typeof o === "number" && isFinite(o);
        };
        cell.prototype.reset = function () {
            this.data("");
            this.resetFlag = true;
        };
        return cell;
    }());
    cell.defaultTemplate = "defaultTemplate";
    cell.idTemplate = "idTemplate";
    cell.checkboxTemplate = "checkboxTemplate";
    cell.externalIdTemplate = "externalIdTemplate";
    cell.customTemplate = "customTemplate";
    cell.counterNameTemplate = "counterNameTemplate";
    cell.counterGroupTemplate = "counterGroupTemplate";
    cell.timeSeriesKeyTemplate = "timeSeriesKeyTemplate";
    return cell;
});

//# sourceMappingURL=cell.js.map
